CREATE DATABASE PARTITION GROUP IBMCATGROUP ON ALL DBPARTITIONNUMS;

CREATE DATABASE PARTITION GROUP IBMTEMPGROUP ON ALL DBPARTITIONNUMS;

CREATE DATABASE PARTITION GROUP IBMDEFAULTGROUP ON ALL DBPARTITIONNUMS;

CREATE BUFFERPOOL IBMDEFAULTBP
	ALL DBPARTITIONNUMS  SIZE 250
	NUMBLOCKPAGES 0
	PAGESIZE 4 K;

CREATE DISTINCT TYPE DM_CLASTESTRESULT AS BLOB(10485760) WITH COMPARISONS;

CREATE TYPE DM_LOGICALDATASPEC AS(
	XMLDATA CLOB(204800))
	MODE DB2SQL;

CREATE TYPE DM_REGBLDTASK AS(
	XMLDATA CLOB(512000))
	MODE DB2SQL;

CREATE DISTINCT TYPE DM_CLUSRESULT AS VARCHAR(2048) WITH COMPARISONS;

CREATE DISTINCT TYPE DM_REGRESULT AS VARCHAR(2048) WITH COMPARISONS;

CREATE DISTINCT TYPE DM_REGTESTRESULT AS BLOB(10485760) WITH COMPARISONS;

CREATE DISTINCT TYPE DM_APPLICATIONDATA AS CLOB(512000) WITH COMPARISONS;

CREATE DISTINCT TYPE DM_RULEMODEL AS BLOB(10485760) WITH COMPARISONS;

CREATE DISTINCT TYPE DM_CLUSTERINGMODEL AS BLOB(10485760) WITH COMPARISONS;

CREATE TYPE DM_CLUSBLDTASK AS(
	XMLDATA CLOB(512000))
	MODE DB2SQL;

CREATE DISTINCT TYPE DM_CLASRESULT AS VARCHAR(2048) WITH COMPARISONS;

CREATE TYPE DM_RULEFILTER AS(
	XMLDATA CLOB(153600))
	MODE DB2SQL;

CREATE TYPE DM_CLASTESTTASK AS(
	XMLDATA CLOB(512000))
	MODE DB2SQL;

CREATE DISTINCT TYPE DM_REGRESSIONMODEL AS BLOB(10485760) WITH COMPARISONS;

CREATE TYPE DM_MININGDATA AS(
	XMLDATA CLOB(153600))
	MODE DB2SQL;

CREATE TYPE DM_CLASBLDTASK AS(
	XMLDATA CLOB(512000))
	MODE DB2SQL;

CREATE TYPE DM_CLASRESULTSPEC AS(
	XMLDATA VARCHAR(2048))
	MODE DB2SQL;

CREATE TYPE DM_RULESETTINGS AS(
	XMLDATA CLOB(307200))
	MODE DB2SQL;

CREATE TYPE DM_RULEBLDTASK AS(
	XMLDATA CLOB(512000))
	MODE DB2SQL;

CREATE TYPE DM_REGSETTINGS AS(
	XMLDATA CLOB(307200))
	MODE DB2SQL;

CREATE TYPE DM_REGTESTTASK AS(
	XMLDATA CLOB(512000))
	MODE DB2SQL;

CREATE DISTINCT TYPE DM_CLASMODEL AS BLOB(10485760) WITH COMPARISONS;

CREATE TYPE DM_CLUSSETTINGS AS(
	XMLDATA CLOB(307200))
	MODE DB2SQL;

CREATE TYPE DM_CLASSETTINGS AS(
	XMLDATA CLOB(307200))
	MODE DB2SQL;

CREATE TYPE DM_CLUSRESULTSPEC AS(
	XMLDATA VARCHAR(2048))
	MODE DB2SQL;

CREATE TABLE SYSPARTITIONMAPS (
		PMAP_ID SMALLINT NOT NULL,
		PARTITIONMAP VARCHAR (32700) FOR BIT DATA NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE CLASTESTTASKS (
		ID VARCHAR(256) NOT NULL,
		TASK DM_CLASTESTTASK,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSSERVERS (
		WRAPNAME VARCHAR(128) NOT NULL,
		SERVERNAME VARCHAR(128) NOT NULL,
		SERVERTYPE VARCHAR(30),
		SERVERVERSION VARCHAR(18),
		SERVER_DESC BLOB(10485760),
		REMARKS VARCHAR(254)
	)
	IN SYSCATSPACE;

CREATE TABLE TEMP_RULES (
		BODYID INTEGER,
		HEAD VARCHAR(512),
		LENGTH SMALLINT,
		BODYTEXT VARCHAR(1024),
		SUPPORT DOUBLE,
		CONFIDENCE DOUBLE,
		LIFT REAL,
		BODYID_1 INTEGER,
		ITEMNAME VARCHAR(512),
		ITEM VARCHAR(512)
	)
	IN USERSPACE1;

CREATE TABLE SYSATTRIBUTES (
		TYPESCHEMA VARCHAR(128) NOT NULL,
		TYPENAME VARCHAR(128) NOT NULL,
		ATTR_NAME VARCHAR(128) NOT NULL,
		ATTR_TYPESCHEMA VARCHAR(128) NOT NULL,
		ATTR_TYPENAME VARCHAR(128) NOT NULL,
		ORDINAL SMALLINT NOT NULL,
		LENGTH INTEGER NOT NULL,
		SCALE SMALLINT NOT NULL,
		UNUSED1 VARCHAR(254),
		UNUSED2 CHAR(1) NOT NULL,
		CODEPAGE SMALLINT NOT NULL,
		LOGGED CHAR(1) NOT NULL,
		COMPACT CHAR(1) NOT NULL,
		TARGET_TYPESCHEMA VARCHAR(128),
		TARGET_TYPENAME VARCHAR(128),
		DL_FEATURES CHAR(10) NOT NULL,
		SOURCE_TYPESCHEMA VARCHAR(128) NOT NULL,
		SOURCE_TYPENAME VARCHAR(128) NOT NULL,
		JAVA_FIELDNAME VARCHAR(256)
	)
	IN SYSCATSPACE;

CREATE TABLE SFS (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE SYSSEQUENCEAUTH (
		GRANTOR VARCHAR(128) NOT NULL,
		GRANTEE VARCHAR(128) NOT NULL,
		GRANTEETYPE CHAR(1) NOT NULL,
		SEQID INTEGER NOT NULL,
		USAGEAUTH CHAR(1) NOT NULL,
		ALTERAUTH CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSINDEXAUTH (
		GRANTOR VARCHAR(128) NOT NULL,
		GRANTEE VARCHAR(128) NOT NULL,
		NAME VARCHAR(128) NOT NULL,
		CREATOR VARCHAR(128) NOT NULL,
		CONTROLAUTH CHAR(1) NOT NULL,
		GRANTEETYPE CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSCOLUMNS (
		NAME VARCHAR(128) NOT NULL,
		TBNAME VARCHAR(128) NOT NULL,
		TBCREATOR VARCHAR(128) NOT NULL,
		REMARKS VARCHAR(254),
		COLTYPE CHAR(8) NOT NULL,
		NULLS CHAR(1) NOT NULL,
		CODEPAGE SMALLINT NOT NULL,
		DBCSCODEPG SMALLINT NOT NULL,
		LENGTH SMALLINT NOT NULL,
		SCALE SMALLINT NOT NULL,
		COLNO SMALLINT NOT NULL,
		COLCARD BIGINT NOT NULL,
		HIGH2KEY VARCHAR(254),
		LOW2KEY VARCHAR(254),
		AVGCOLLEN INTEGER NOT NULL,
		KEYSEQ SMALLINT,
		TYPENAME VARCHAR(128) NOT NULL,
		TYPESCHEMA VARCHAR(128) NOT NULL,
		DEFAULT VARCHAR(254),
		LONGLENGTH INTEGER NOT NULL,
		LOGGED CHAR(1) NOT NULL,
		COMPACT CHAR(1) NOT NULL,
		NQUANTILES SMALLINT NOT NULL,
		NMOSTFREQ SMALLINT NOT NULL,
		COMPOSITE_CODEPAGE SMALLINT NOT NULL,
		PARTKEYSEQ SMALLINT,
		SOURCE_TABSCHEMA VARCHAR(128),
		SOURCE_TABNAME VARCHAR(128),
		HIDDEN CHAR(1) NOT NULL,
		GENERATED CHAR(1) NOT NULL,
		INLINE_LENGTH INTEGER NOT NULL,
		NUMNULLS BIGINT NOT NULL,
		DATAMODEL INTEGER NOT NULL,
		SUB_COUNT SMALLINT NOT NULL,
		SUB_DELIM_LENGTH SMALLINT NOT NULL,
		IDENTITY CHAR(1) NOT NULL,
		COMPRESS CHAR(1) NOT NULL,
		AVGDISTINCTPERPAGE DOUBLE,
		PAGEVARIANCERATIO DOUBLE
	)
	IN SYSCATSPACE;

CREATE TABLE IM_FINDRULES_015_IDMFRGIS (
		TRANSID CHAR(5) NOT NULL
	)
	IN USERSPACE1;

CREATE TABLE TEMP_CLUSTERS_RESULT (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL,
		CLUSTER_ID INTEGER,
		QUALITY DOUBLE,
		CONFIDENCE DOUBLE
	)
	IN USERSPACE1;

CREATE TABLE TEST4 (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE 3453 (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE INSURANCE (
		SALARY DOUBLE,
		RENEWAL_MONTH VARCHAR(3),
		SEX CHAR(1),
		MARITAL_STATUS CHAR(1),
		NUM_DEPENDENTS INTEGER,
		YEAR_1ST_POLICY INTEGER,
		NUM_CLAIMS INTEGER,
		CYCLES INTEGER,
		AGE DOUBLE,
		COMMUTE_DIST DOUBLE,
		RECORDID INTEGER NOT NULL
	)
	IN USERSPACE1;

CREATE TABLE SYSCHECKS (
		NAME VARCHAR(128) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		TBNAME VARCHAR(128) NOT NULL,
		TBCREATOR VARCHAR(128) NOT NULL,
		CREATE_TIME TIMESTAMP NOT NULL,
		FUNC_PATH VARCHAR(254) NOT NULL,
		TEXT CLOB(2097152) NOT NULL,
		QUALIFIER VARCHAR(128) NOT NULL,
		TYPE CHAR(1) NOT NULL,
		PERCENTVALID SMALLINT NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSPLANAUTH (
		GRANTOR VARCHAR(128) NOT NULL,
		GRANTEE VARCHAR(128) NOT NULL,
		NAME VARCHAR(128) NOT NULL,
		CREATOR VARCHAR(128) NOT NULL,
		CONTROLAUTH CHAR(1) NOT NULL,
		BINDAUTH CHAR(1) NOT NULL,
		EXECUTEAUTH CHAR(1) NOT NULL,
		GRANTEETYPE CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE HEART (
		AGE DOUBLE,
		SEX VARCHAR(3),
		PAIN_TYPE VARCHAR(3),
		BLOOD_PRESSURE DOUBLE,
		CHOLESTEROL DOUBLE,
		SUGAR VARCHAR(3),
		ECG VARCHAR(3),
		HEART_RATE DOUBLE,
		ANGINA VARCHAR(3),
		OLD_PEAK DOUBLE,
		SLOPE VARCHAR(3),
		NUM_VESSELS VARCHAR(3),
		THAL VARCHAR(3),
		DISEASED CHAR(1)
	)
	IN USERSPACE1;

CREATE TABLE SYSPLAN (
		NAME VARCHAR(128) NOT NULL,
		CREATOR VARCHAR(128) NOT NULL,
		BOUNDBY VARCHAR(128) NOT NULL,
		VALID CHAR(1) NOT NULL,
		UNIQUE_ID CHAR(8) NOT NULL,
		TOTALSECT SMALLINT NOT NULL,
		FORMAT CHAR(1) NOT NULL,
		SECT_INFO BLOB(1048576) NOT NULL,
		HOST_VARS BLOB(1048576),
		ISOLATION CHAR(2),
		BLOCK CHAR(1),
		STANDARDS_LEVEL CHAR(1),
		FUNC_PATH VARCHAR(254) NOT NULL,
		EXPLICIT_BIND_TIME TIMESTAMP NOT NULL,
		LAST_BIND_TIME TIMESTAMP NOT NULL,
		QUERYOPT INTEGER NOT NULL,
		EXPLAIN_LEVEL CHAR(1) NOT NULL,
		EXPLAIN_MODE CHAR(1) NOT NULL,
		EXPLAIN_SNAPSHOT CHAR(1) NOT NULL,
		SQLWARN CHAR(1) NOT NULL,
		CODEPAGE SMALLINT NOT NULL,
		REMARKS VARCHAR(254),
		SQLRULES CHAR(1) NOT NULL,
		SQLRULES_STRING VARCHAR(254) NOT NULL,
		INSERT_BUF CHAR(1) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		DEFAULT_SCHEMA VARCHAR(128) NOT NULL,
		MULTINODE_PLANS CHAR(1) NOT NULL,
		DEGREE CHAR(5) NOT NULL,
		RDS_LEVEL SMALLINT NOT NULL,
		SQLMATHWARN CHAR(1) NOT NULL,
		INTRA_PARALLEL CHAR(1) NOT NULL,
		VALIDATE CHAR(1) NOT NULL,
		DYNAMICRULES CHAR(1) NOT NULL,
		SQLERROR CHAR(1) NOT NULL,
		REFRESHAGE DECIMAL(20,6) NOT NULL,
		PKG_CREATE_TIME TIMESTAMP NOT NULL,
		FEDERATED CHAR(1) NOT NULL,
		TRANSFORMGROUP VARCHAR(1024),
		TRF_GRP_PACKED_DESC BLOB(2048),
		PKGVERSION VARCHAR(64) NOT NULL,
		REOPTVAR CHAR(1) NOT NULL,
		OS_PTR_SIZE INTEGER NOT NULL,
		PACKED_DESC BLOB(1048576)
	)
	IN SYSCATSPACE;

CREATE TABLE IM_FINDRULES_032_IDMFRGIS (
		TRANSID CHAR(5) NOT NULL
	)
	IN USERSPACE1;

CREATE TABLE RETAIL (
		CUSTOMER_ID CHAR(7),
		TRANSDATE DATE,
		ITEMID CHAR(3),
		STOREID CHAR(3),
		TRANSID CHAR(5)
	)
	IN USERSPACE1;

CREATE TABLE SYSROUTINEPARMS (
		ROUTINENAME VARCHAR(128) NOT NULL,
		ROUTINESCHEMA VARCHAR(128) NOT NULL,
		SPECIFICNAME VARCHAR(128) NOT NULL,
		ROWTYPE CHAR(1) NOT NULL,
		ORDINAL SMALLINT NOT NULL,
		TYPENAME VARCHAR(128) NOT NULL,
		TYPESCHEMA VARCHAR(128) NOT NULL,
		LENGTH INTEGER NOT NULL,
		SCALE SMALLINT NOT NULL,
		CODEPAGE SMALLINT NOT NULL,
		CAST_FUNCTION_ID INTEGER,
		PARMNAME VARCHAR(128),
		LOCATOR CHAR(1) NOT NULL,
		TARGET_TYPESCHEMA VARCHAR(128),
		TARGET_TYPENAME VARCHAR(128),
		SCOPE_TABSCHEMA VARCHAR(128),
		SCOPE_TABNAME VARCHAR(128),
		TRANSFORM_GRPNAME VARCHAR(128),
		ROUTINE_ID INTEGER NOT NULL,
		ROUTINETYPE CHAR(1) NOT NULL,
		TARGET_TYPEID SMALLINT,
		TYPEID SMALLINT,
		REMARKS VARCHAR(254)
	)
	IN SYSCATSPACE;

CREATE TABLE SYSINDEXOPTIONS (
		INDSCHEMA VARCHAR(128) NOT NULL,
		INDNAME VARCHAR(128) NOT NULL,
		OPTION VARCHAR(128) NOT NULL,
		SETTING VARCHAR(255) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSINDEXEXTENSIONMETHODS (
		METHODNAME VARCHAR(128) NOT NULL,
		METHODID SMALLINT NOT NULL,
		IESCHEMA VARCHAR(128) NOT NULL,
		IENAME VARCHAR(128) NOT NULL,
		RTFUNCSCHEMA VARCHAR(128) NOT NULL,
		RTFUNCNAME VARCHAR(18) NOT NULL,
		RTSPECIFICNAME VARCHAR(18) NOT NULL,
		CWFUNCSCHEMA VARCHAR(128),
		CWFUNCNAME VARCHAR(128),
		CWSPECIFICNAME VARCHAR(128),
		REMARKS VARCHAR(254)
	)
	IN SYSCATSPACE;

CREATE TABLE SYSVERSIONS (
		VERSIONNUMBER INTEGER NOT NULL,
		VERSION_TIMESTAMP TIMESTAMP NOT NULL,
		AUTHID VARCHAR(128) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE TEMP_CLUSTERS2 (
		ID INTEGER,
		NAME VARCHAR(128),
		SIZE BIGINT,
		HOMOGENEITY REAL,
		DESCRIPTION VARCHAR(1024)
	)
	IN USERSPACE1;

CREATE TABLE SYSUSERAUTH (
		GRANTEE VARCHAR(128) NOT NULL,
		GRANTEETYPE CHAR(1) NOT NULL,
		TABSCHEMA VARCHAR(128) NOT NULL,
		TABNAME VARCHAR(128) NOT NULL,
		AUTH_DESC BLOB(2097152) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE VERSION (
		V_KEY VARCHAR(20),
		V_VALUE VARCHAR(30),
		V_TIMESTAMP TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSRELS (
		CREATOR VARCHAR(128) NOT NULL,
		TBNAME VARCHAR(128) NOT NULL,
		RELNAME VARCHAR(128) NOT NULL,
		REFTBNAME VARCHAR(128) NOT NULL,
		REFTBCREATOR VARCHAR(128) NOT NULL,
		COLCOUNT SMALLINT NOT NULL,
		DELETERULE CHAR(1) NOT NULL,
		UPDATERULE CHAR(1) NOT NULL,
		TIMESTAMP TIMESTAMP NOT NULL,
		FKCOLNAMES VARCHAR(640) NOT NULL,
		PKCOLNAMES VARCHAR(640) NOT NULL,
		REFKEYNAME VARCHAR(128) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE PROGRESSTABLE (
		CALLID CHAR (19) FOR BIT DATA,
		PROCNAME VARCHAR(100),
		KERNELPHASEID INTEGER,
		KERNELPHASE VARCHAR(500),
		KERNELINFO CLOB(32768),
		ITERATIONNO INTEGER,
		PROGRESS REAL,
		QUALITYID INTEGER,
		QUALITYMEASURE VARCHAR(500),
		QUALITYVALUE REAL,
		TIMESTMP TIMESTAMP,
		MESSAGEID INTEGER,
		MESSAGE VARCHAR(1000),
		CANCELREQUEST INTEGER
	)
	IN USERSPACE1;

CREATE TABLE SYSJAROBJECTS (
		JARSCHEMA VARCHAR(128) NOT NULL,
		JAR_ID VARCHAR(128) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		JAR_DATA BLOB(104857600),
		ALTEREDTS TIMESTAMP NOT NULL,
		CREATEDTS TIMESTAMP NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE TEMP_CLUSTERS (
		ID INTEGER,
		NAME VARCHAR(128),
		SIZE BIGINT,
		HOMOGENEITY REAL,
		DESCRIPTION VARCHAR(1024)
	)
	IN USERSPACE1;

CREATE TABLE IM_FINDRULES_032_IDMFRTMP (
		CUSTOMER_ID CHAR(7),
		TRANSDATE CHAR(6),
		ITEMID CHAR(3),
		STOREID CHAR(3),
		TRANSID CHAR(5)
	)
	IN USERSPACE1;

CREATE TABLE RULEFILTERS (
		ID VARCHAR(256) NOT NULL,
		RULEFILTER DM_RULEFILTER,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE TEMP_FIELDS (
		COLNAME VARCHAR(128),
		FIELDNAME VARCHAR(128),
		MININGTYPE SMALLINT,
		IMPORTANCE REAL
	)
	IN USERSPACE1;

CREATE TABLE IM_CLUSTERTABLE_08_IDMCTTMP (
		CLIENT_ID CHAR(9) NOT NULL,
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE SYSCOLGROUPDISTCOUNTS (
		COLGROUPID INTEGER NOT NULL,
		TYPE CHAR(1) NOT NULL,
		SEQNO SMALLINT NOT NULL,
		VALCOUNT BIGINT NOT NULL,
		DISTCOUNT BIGINT NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSXMLOBJECTXMLDEP (
		OBJECTID BIGINT NOT NULL,
		DTYPE CHAR(2) NOT NULL,
		BTYPE CHAR(2) NOT NULL,
		BOBJECTID BIGINT NOT NULL,
		OBJECTAUTHS SMALLINT NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSINDEXCOLUSE (
		INDSCHEMA VARCHAR(128) NOT NULL,
		INDNAME VARCHAR(128) NOT NULL,
		COLNAME VARCHAR(128) NOT NULL,
		COLSEQ SMALLINT NOT NULL,
		COLORDER CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE REGTESTTASKS (
		ID VARCHAR(256) NOT NULL,
		TASK DM_REGTESTTASK,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE FSTTEST1 (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE IM_FINDRULES_015_IDMFRTMP (
		ITEMID CHAR(3),
		TRANSID CHAR(5)
	)
	IN USERSPACE1;

CREATE TABLE CLASSETTINGS (
		ID VARCHAR(256) NOT NULL,
		SETTINGS DM_CLASSETTINGS,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSPROCPARMOPTIONS (
		PROCSCHEMA VARCHAR(128) NOT NULL,
		PROCNAME VARCHAR(128) NOT NULL,
		ORDINAL SMALLINT NOT NULL,
		OPTION VARCHAR(128) NOT NULL,
		SETTING VARCHAR(255) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSUSEROPTIONS (
		SERVERNAME VARCHAR(128) NOT NULL,
		AUTHID VARCHAR(128) NOT NULL,
		OPTION VARCHAR(128) NOT NULL,
		SETTING VARCHAR(255) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSINDEXEXPLOITRULES (
		FUNCID INTEGER NOT NULL,
		SPECID SMALLINT NOT NULL,
		IESCHEMA VARCHAR(128) NOT NULL,
		IENAME VARCHAR(128) NOT NULL,
		RULEID SMALLINT NOT NULL,
		SEARCHMETHODID SMALLINT NOT NULL,
		SEARCHKEY VARCHAR(320) NOT NULL,
		SEARCHARGUMENT VARCHAR(1800) NOT NULL,
		EXACT CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSCODEPROPERTIES (
		OBJECT_TYPE CHAR(1) NOT NULL,
		OBJECT_ID INTEGER NOT NULL,
		LIB_ID INTEGER,
		LIBVERSION INTEGER,
		DEBUG_MODE CHAR(1) NOT NULL,
		TRACE_LEVEL CHAR(1) NOT NULL,
		DIAGNOSTIC_LEVEL CHAR(1) NOT NULL,
		DEBUG_DATA CLOB(1048576),
		CHECKOUT_USERID VARCHAR(128),
		PRECOMPILE_OPTIONS VARCHAR(1024),
		COMPILE_OPTIONS VARCHAR(1024),
		SQL_COMPILED_CODE BLOB(10485760)
	)
	IN SYSCATSPACE;

CREATE TABLE OUT1 (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE SYSCOLUSE (
		TABSCHEMA VARCHAR(128) NOT NULL,
		TABNAME VARCHAR(128) NOT NULL,
		COLNAME VARCHAR(128) NOT NULL,
		DIMENSION SMALLINT NOT NULL,
		COLSEQ SMALLINT NOT NULL,
		TYPE CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSHIERARCHIES (
		METATYPE CHAR(1) NOT NULL,
		SUB_SCHEMA VARCHAR(128) NOT NULL,
		SUB_NAME VARCHAR(128) NOT NULL,
		SUPER_SCHEMA VARCHAR(128) NOT NULL,
		SUPER_NAME VARCHAR(128) NOT NULL,
		ROOT_SCHEMA VARCHAR(128) NOT NULL,
		ROOT_NAME VARCHAR(128) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE AAA (
		CLIENT_ID CHAR(9) NOT NULL,
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE SYSTRIGGERS (
		NAME VARCHAR(128) NOT NULL,
		SCHEMA VARCHAR(128) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		TBNAME VARCHAR(128) NOT NULL,
		TBCREATOR VARCHAR(128) NOT NULL,
		TRIGTIME CHAR(1) NOT NULL,
		TRIGEVENT CHAR(1) NOT NULL,
		GRANULARITY CHAR(1) NOT NULL,
		VALID CHAR(1) NOT NULL,
		TEXT CLOB(2097152) NOT NULL,
		CREATE_TIME TIMESTAMP NOT NULL,
		FUNC_PATH VARCHAR(254) NOT NULL,
		REMARKS VARCHAR(254),
		QUALIFIER VARCHAR(128) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE LOGICALDATASPECS (
		ID VARCHAR(256) NOT NULL,
		DATASPEC DM_LOGICALDATASPEC,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSINDEXES (
		NAME VARCHAR(128) NOT NULL,
		CREATOR VARCHAR(128) NOT NULL,
		TBNAME VARCHAR(128) NOT NULL,
		TBCREATOR VARCHAR(128) NOT NULL,
		COLNAMES VARCHAR(640) NOT NULL,
		UNIQUERULE CHAR(1) NOT NULL,
		COLCOUNT SMALLINT NOT NULL,
		IID SMALLINT NOT NULL,
		NLEAF INTEGER NOT NULL,
		NLEVELS SMALLINT NOT NULL,
		FIRSTKEYCARD BIGINT NOT NULL,
		FULLKEYCARD BIGINT NOT NULL,
		CLUSTERRATIO SMALLINT NOT NULL,
		CLUSTERFACTOR DOUBLE NOT NULL,
		USER_DEFINED SMALLINT NOT NULL,
		SYSTEM_REQUIRED SMALLINT NOT NULL,
		CREATE_TIME TIMESTAMP NOT NULL,
		STATS_TIME TIMESTAMP,
		PAGE_FETCH_PAIRS VARCHAR(254) NOT NULL,
		REMARKS VARCHAR(254),
		DEFINER VARCHAR(128) NOT NULL,
		MADE_UNIQUE CHAR(1) NOT NULL,
		SEQUENTIAL_PAGES INTEGER NOT NULL,
		DENSITY INTEGER NOT NULL,
		FIRST2KEYCARD BIGINT NOT NULL,
		FIRST3KEYCARD BIGINT NOT NULL,
		FIRST4KEYCARD BIGINT NOT NULL,
		PCTFREE SMALLINT NOT NULL,
		UNIQUE_COLCOUNT SMALLINT NOT NULL,
		INDEXTYPE CHAR(4) NOT NULL,
		ENTRYTYPE CHAR(1) NOT NULL,
		MINPCTUSED SMALLINT NOT NULL,
		REVERSE_SCANS CHAR(1) NOT NULL,
		IESCHEMA VARCHAR(128),
		IENAME VARCHAR(128),
		IEARGUMENTS CLOB(32768),
		INDEX_DESC BLOB(1048576),
		INTERNAL_FORMAT SMALLINT NOT NULL,
		INDEX_OBJECTID INTEGER NOT NULL,
		TBSPACEID INTEGER NOT NULL,
		AVERAGE_SEQUENCE_GAP DOUBLE NOT NULL,
		AVERAGE_SEQUENCE_FETCH_GAP DOUBLE NOT NULL,
		AVERAGE_SEQUENCE_PAGES DOUBLE NOT NULL,
		AVERAGE_SEQUENCE_FETCH_PAGES DOUBLE NOT NULL,
		AVERAGE_RANDOM_PAGES DOUBLE NOT NULL,
		AVERAGE_RANDOM_FETCH_PAGES DOUBLE NOT NULL,
		NUMRIDS BIGINT NOT NULL,
		NUMRIDS_DELETED BIGINT NOT NULL,
		NUM_EMPTY_LEAFS BIGINT NOT NULL,
		OS_PTR_SIZE INTEGER NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSINDEXEXTENSIONS (
		IESCHEMA VARCHAR(128) NOT NULL,
		IENAME VARCHAR(128) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		CREATE_TIME TIMESTAMP NOT NULL,
		KTFUNCSCHEMA VARCHAR(128) NOT NULL,
		KTFUNCNAME VARCHAR(128) NOT NULL,
		KTSPECIFICNAME VARCHAR(128) NOT NULL,
		TEXT CLOB(2097152) NOT NULL,
		INDEX_DESC BLOB(10485760) NOT NULL,
		REMARKS VARCHAR(254)
	)
	IN SYSCATSPACE;

CREATE TABLE TEST (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE SYSTRANSFORMS (
		TYPEID SMALLINT NOT NULL,
		GROUPNAME VARCHAR(128) NOT NULL,
		FROMSQL_FUNCID INTEGER,
		TOSQL_FUNCID INTEGER,
		FROMSQL_FORMAT CHAR(1) NOT NULL,
		TOSQL_FORMAT CHAR(1) NOT NULL,
		FROMSQL_LENGTH INTEGER NOT NULL,
		ORIGIN CHAR(1) NOT NULL,
		REMARKS VARCHAR(254)
	)
	IN SYSCATSPACE;

CREATE TABLE OUT4 (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL,
		DEV_DEGREE DOUBLE,
		CLUSTER_ID INTEGER
	)
	IN USERSPACE1;

CREATE TABLE SYSXMLOBJECTAUTH (
		GRANTOR VARCHAR(128) NOT NULL,
		GRANTEE VARCHAR(128) NOT NULL,
		GRANTEETYPE CHAR(1) NOT NULL,
		OBJECTID BIGINT NOT NULL,
		PRIVILEGE_TYPE CHAR(30) NOT NULL,
		IS_GRANTABLE CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE IM_FINDRULES_07_IDMFRTMP (
		ITEMID CHAR(3),
		TRANSID CHAR(5)
	)
	IN USERSPACE1;

CREATE TABLE REGTASKS (
		ID VARCHAR(256) NOT NULL,
		TASK DM_REGBLDTASK,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSWRAPOPTIONS (
		WRAPNAME VARCHAR(128) NOT NULL,
		OPTION VARCHAR(128) NOT NULL,
		SETTING VARCHAR(255) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSDATATYPES (
		NAME VARCHAR(128) NOT NULL,
		SCHEMA VARCHAR(128) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		SOURCETYPE VARCHAR(128),
		SOURCESCHEMA VARCHAR(128),
		METATYPE CHAR(1) NOT NULL,
		TYPEID SMALLINT NOT NULL,
		SOURCETYPEID SMALLINT,
		LENGTH INTEGER NOT NULL,
		SCALE SMALLINT NOT NULL,
		CODEPAGE SMALLINT NOT NULL,
		CREATE_TIME TIMESTAMP NOT NULL,
		REMARKS VARCHAR(254),
		PACKED_DESC BLOB(2097152),
		TYPE_DESC BLOB(1048576),
		ATTRCOUNT SMALLINT NOT NULL,
		INSTANTIABLE CHAR(1) NOT NULL,
		WITH_FUNC_ACCESS CHAR(1) NOT NULL,
		FINAL CHAR(1) NOT NULL,
		INLINE_LENGTH INTEGER NOT NULL,
		JARSCHEMA VARCHAR(128),
		JAR_ID VARCHAR(128),
		CLASS VARCHAR(128),
		SQLJ_REPRESENTATION CHAR(1),
		NATURAL_INLINE_LENGTH INTEGER,
		ALTER_TIME TIMESTAMP NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSCOLDIST (
		NAME VARCHAR(128) NOT NULL,
		TBNAME VARCHAR(128) NOT NULL,
		SCHEMA VARCHAR(128) NOT NULL,
		TYPE CHAR(1) NOT NULL,
		SEQNO SMALLINT NOT NULL,
		COLVALUE VARCHAR(254),
		VALCOUNT BIGINT NOT NULL,
		DISTCOUNT BIGINT
	)
	IN SYSCATSPACE;

CREATE TABLE TEMP_QUALITY (
		MODELQUALITY REAL,
		RELIABILITY REAL,
		PREDICTIONACCURACY REAL,
		RANKQUALITY REAL
	)
	IN USERSPACE1;

CREATE TABLE SYSLIBRARYBINDFILES (
		LIB_ID INTEGER NOT NULL,
		LIBVERSION INTEGER NOT NULL,
		PACKAGE_SCHEMA VARCHAR(128) NOT NULL,
		PACKAGE_NAME VARCHAR(128) NOT NULL,
		PACKAGE_VERSION VARCHAR(64) NOT NULL,
		BINDFILE_PATH VARCHAR(255) NOT NULL,
		BINDFILE_BODY BLOB(10485760) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSEVENTMONITORS (
		NAME VARCHAR(128) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		TARGET_TYPE CHAR(1) NOT NULL,
		TARGET VARCHAR(256) NOT NULL,
		MAXFILES INTEGER,
		MAXFILESIZE INTEGER,
		BUFFERSIZE INTEGER,
		IO_MODE CHAR(1),
		WRITE_MODE CHAR(1),
		AUTOSTART CHAR(1) NOT NULL,
		REMARKS VARCHAR(254),
		PACKED_DESC BLOB(65536) NOT NULL,
		NODENUM SMALLINT NOT NULL,
		MONSCOPE CHAR(1) NOT NULL,
		EVMON_ACTIVATES INTEGER NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSBUFFERPOOLS (
		BPNAME VARCHAR(128) NOT NULL,
		BUFFERPOOLID INTEGER NOT NULL,
		NGNAME VARCHAR(128),
		NPAGES INTEGER NOT NULL,
		PAGESIZE INTEGER NOT NULL,
		ESTORE CHAR(1) NOT NULL,
		NUMBLOCKPAGES INTEGER NOT NULL,
		BLOCKSIZE INTEGER NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSTABAUTH (
		GRANTOR VARCHAR(128) NOT NULL,
		GRANTEE VARCHAR(128) NOT NULL,
		TCREATOR VARCHAR(128) NOT NULL,
		TTNAME VARCHAR(128) NOT NULL,
		TABAUTH SMALLINT NOT NULL,
		CONTROLAUTH CHAR(1) NOT NULL,
		ALTERAUTH CHAR(1) NOT NULL,
		DELETEAUTH CHAR(1) NOT NULL,
		INDEXAUTH CHAR(1) NOT NULL,
		INSERTAUTH CHAR(1) NOT NULL,
		SELECTAUTH CHAR(1) NOT NULL,
		UPDATEAUTH CHAR(1) NOT NULL,
		REFAUTH CHAR(1) NOT NULL,
		GRANTEETYPE CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE BANKCUSTOMERS (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE OUT2 (
		NODEID VARCHAR(128),
		ISLEAF SMALLINT,
		CLASS VARCHAR(256),
		CONFIDENCE REAL,
		SIZE BIGINT,
		DEPTH SMALLINT,
		CONDITION VARCHAR(3000)
	)
	IN USERSPACE1;

CREATE TABLE TEMP_RULEHEAD (
		BODYID INTEGER,
		ITEMNAME VARCHAR(1024),
		ITEM VARCHAR(1024)
	)
	IN USERSPACE1;

CREATE TABLE SYSTABLES (
		NAME VARCHAR(128) NOT NULL,
		CREATOR VARCHAR(128) NOT NULL,
		TYPE CHAR(1) NOT NULL,
		CTIME TIMESTAMP NOT NULL,
		REMARKS VARCHAR(254),
		PACKED_DESC BLOB(20971520),
		VIEW_DESC BLOB(131072),
		COLCOUNT SMALLINT NOT NULL,
		FID SMALLINT NOT NULL,
		TID SMALLINT NOT NULL,
		CARD BIGINT NOT NULL,
		NPAGES INTEGER NOT NULL,
		FPAGES INTEGER NOT NULL,
		OVERFLOW INTEGER NOT NULL,
		PARENTS SMALLINT,
		CHILDREN SMALLINT,
		SELFREFS SMALLINT,
		KEYCOLUMNS SMALLINT,
		KEYOBID SMALLINT,
		REL_DESC BLOB(262144),
		BASE_NAME VARCHAR(128),
		BASE_SCHEMA VARCHAR(128),
		TBSPACE VARCHAR(128),
		INDEX_TBSPACE VARCHAR(128),
		LONG_TBSPACE VARCHAR(128),
		KEYUNIQUE SMALLINT NOT NULL,
		CHECKCOUNT SMALLINT NOT NULL,
		CHECK_DESC BLOB(131072),
		STATS_TIME TIMESTAMP,
		DEFINER VARCHAR(128) NOT NULL,
		TRIG_DESC BLOB(3145728),
		DATA_CAPTURE CHAR(1) NOT NULL,
		STATUS CHAR(1) NOT NULL,
		CONST_CHECKED CHAR(32) NOT NULL,
		PMAP_ID SMALLINT,
		LOG_ATTRIBUTE CHAR(1) NOT NULL,
		PCTFREE SMALLINT NOT NULL,
		ROWTYPESCHEMA VARCHAR(128),
		ROWTYPENAME VARCHAR(128),
		APPEND_MODE CHAR(1) NOT NULL,
		PARTITION_MODE CHAR(1) NOT NULL,
		REFRESH CHAR(1) NOT NULL,
		REFRESH_TIME TIMESTAMP,
		LOCKSIZE CHAR(1) NOT NULL,
		VOLATILE CHAR(1) NOT NULL,
		REMOTE_DESC BLOB(10485760),
		CLUSTERED CHAR(1),
		AST_DESC BLOB(5242880),
		DROPRULE CHAR(1) NOT NULL,
		ROW_FORMAT CHAR(1) NOT NULL,
		PROPERTY VARCHAR(32) NOT NULL,
		STATISTICS_PROFILE CLOB(32768),
		COMPRESSION CHAR(1) NOT NULL,
		ACCESS_MODE CHAR(1) NOT NULL,
		ACTIVE_BLOCKS BIGINT NOT NULL,
		MAXFREESPACESEARCH SMALLINT NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSCOLGROUPSCOLS (
		COLGROUPID INTEGER NOT NULL,
		COLNAME VARCHAR(128) NOT NULL,
		TABSCHEMA VARCHAR(128) NOT NULL,
		TABNAME VARCHAR(128) NOT NULL,
		ORDINAL SMALLINT NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSSECTION (
		PLNAME VARCHAR(128) NOT NULL,
		PLCREATOR VARCHAR(128) NOT NULL,
		SECTNO SMALLINT NOT NULL,
		SECTION BLOB(10485760),
		VALID CHAR(1) NOT NULL,
		UNIQUE_ID CHAR(8) NOT NULL,
		SECTION_INFO BLOB(4190000)
	)
	IN SYSCATSPACE;

CREATE TABLE RETAIL_NAMES (
		ITEMID CHAR(3),
		DESCRIPTION CHAR(18)
	)
	IN USERSPACE1;

CREATE TABLE TEMP_CORRELATION (
		FIELDNAME1 VARCHAR(128),
		FIELDNAME2 VARCHAR(128),
		CORRELATION REAL
	)
	IN USERSPACE1;

CREATE TABLE RULESETTINGS (
		ID VARCHAR(256) NOT NULL,
		SETTINGS DM_RULESETTINGS,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSKEYCOLUSE (
		CONSTNAME VARCHAR(128) NOT NULL,
		TBNAME VARCHAR(128) NOT NULL,
		TBCREATOR VARCHAR(128) NOT NULL,
		COLNAME VARCHAR(128) NOT NULL,
		COLSEQ SMALLINT NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE CLUSTERMODELS (
		MODELNAME VARCHAR(256) NOT NULL,
		MODEL DM_CLUSTERINGMODEL,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSCOMMENTS (
		OBJECTID INTEGER NOT NULL,
		REMARKS VARCHAR(254) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE TEMP_BANKCUSTOMER2 (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL,
		DEV_DEGREE DOUBLE,
		CLUSTER_ID INTEGER
	)
	IN USERSPACE1;

CREATE TABLE SYSCOLPROPERTIES (
		COLNAME VARCHAR(128) NOT NULL,
		TABNAME VARCHAR(128) NOT NULL,
		TABSCHEMA VARCHAR(128) NOT NULL,
		TARGET_TYPESCHEMA VARCHAR(128),
		TARGET_TYPENAME VARCHAR(128),
		SCOPE_TABSCHEMA VARCHAR(128),
		SCOPE_TABNAME VARCHAR(128),
		DL_FEATURES CHAR(10) NOT NULL,
		SPECIAL_PROPS CHAR(8) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSCONSTDEP (
		BNAME VARCHAR(128) NOT NULL,
		BCREATOR VARCHAR(128) NOT NULL,
		BTYPE CHAR(1) NOT NULL,
		DTBNAME VARCHAR(128) NOT NULL,
		DTBCREATOR VARCHAR(128) NOT NULL,
		DCONSTNAME VARCHAR(128) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE CLASSIFMODELS (
		MODELNAME VARCHAR(256) NOT NULL,
		MODEL DM_CLASMODEL,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSXMLOBJECTS (
		OBJECTID BIGINT NOT NULL,
		OBJECTTYPE CHAR(2) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		CREATE_TIME TIMESTAMP NOT NULL,
		ALTER_TIME TIMESTAMP,
		LINKS_COUNT INTEGER NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE TEMP_DEVIATIONS (
		SALARY DOUBLE,
		RENEWAL_MONTH VARCHAR(3),
		SEX CHAR(1),
		MARITAL_STATUS CHAR(1),
		NUM_DEPENDENTS INTEGER,
		YEAR_1ST_POLICY INTEGER,
		NUM_CLAIMS INTEGER,
		CYCLES INTEGER,
		AGE DOUBLE,
		COMMUTE_DIST DOUBLE,
		RECORDID INTEGER,
		DEV_DEGREE DOUBLE,
		CLUSTER_ID INTEGER
	)
	IN USERSPACE1;

CREATE TABLE TEMP_CLUSTER_TABLE_RES (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL,
		CLUSTER_ID INTEGER,
		QUALITY DOUBLE,
		CONFIDENCE DOUBLE
	)
	IN USERSPACE1;

CREATE TABLE SYSJARCONTENTS (
		JARSCHEMA VARCHAR(128) NOT NULL,
		JAR_ID VARCHAR(128) NOT NULL,
		CLASS VARCHAR(128) NOT NULL,
		CLASS_SOURCE CLOB(10485760)
	)
	IN SYSCATSPACE;

CREATE TABLE SYSDEPENDENCIES (
		BNAME VARCHAR(128) NOT NULL,
		BSCHEMA VARCHAR(128) NOT NULL,
		BTYPE CHAR(1) NOT NULL,
		DNAME VARCHAR(128) NOT NULL,
		DSCHEMA VARCHAR(128) NOT NULL,
		TABAUTH SMALLINT,
		DTYPE CHAR(1) NOT NULL,
		BUNIQUE_ID CHAR(8)
	)
	IN SYSCATSPACE;

CREATE TABLE SYSXMLOBJECTAUTHPERF (
		GRANTEE VARCHAR(128) NOT NULL,
		GRANTEETYPE CHAR(1) NOT NULL,
		OBJECTID BIGINT NOT NULL,
		AUTH_DESC BLOB(1024) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE PROGRESSTABLE (
		CALLID CHAR (19) FOR BIT DATA,
		PROCNAME VARCHAR(100),
		KERNELPHASEID INTEGER,
		KERNELPHASE VARCHAR(500),
		KERNELINFO CLOB(32768),
		ITERATIONNO INTEGER,
		PROGRESS REAL,
		QUALITYID INTEGER,
		QUALITYMEASURE VARCHAR(500),
		QUALITYVALUE REAL,
		TIMESTMP TIMESTAMP,
		MESSAGEID INTEGER,
		MESSAGE VARCHAR(1000),
		CANCELREQUEST INTEGER
	)
	IN USERSPACE1;

CREATE TABLE RETAIL_TAX (
		CHILD CHAR(18),
		PARENT CHAR(18)
	)
	IN USERSPACE1;

CREATE TABLE TESTA (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE SYSXMLRSPROPERTIES (
		RELATIONSHIPID BIGINT NOT NULL,
		OPTION VARCHAR(128) NOT NULL,
		SETTING VARCHAR(1024)
	)
	IN SYSCATSPACE;

CREATE TABLE SYSFUNCMAPOPTIONS (
		FUNCTION_MAPPING VARCHAR(128) NOT NULL,
		OPTION VARCHAR(128) NOT NULL,
		SETTING VARCHAR(255) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE TEST0 (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE OUT7 (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL,
		DEV_DEGREE DOUBLE,
		CLUSTER_ID INTEGER
	)
	IN USERSPACE1;

CREATE TABLE CLUSTASKS (
		ID VARCHAR(256) NOT NULL,
		TASK DM_CLUSBLDTASK,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSVIEWS (
		NAME VARCHAR(128) NOT NULL,
		CREATOR VARCHAR(128) NOT NULL,
		CHECK CHAR(1) NOT NULL,
		TEXT CLOB(2097152) NOT NULL,
		FUNC_PATH VARCHAR(254) NOT NULL,
		VALID CHAR(1) NOT NULL,
		READONLY CHAR(1) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		QUALIFIER VARCHAR(128) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSXMLOBJECTRELDEP (
		OBJECTID BIGINT NOT NULL,
		DTYPE CHAR(2) NOT NULL,
		BTYPE CHAR(1) NOT NULL,
		BSCHEMA VARCHAR(128) NOT NULL,
		BNAME VARCHAR(128) NOT NULL,
		TABAUTH SMALLINT NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSCOLGROUPS (
		COLGROUPSCHEMA VARCHAR(128) NOT NULL,
		COLGROUPNAME VARCHAR(128) NOT NULL,
		COLGROUPID INTEGER NOT NULL,
		COLGROUPCARD BIGINT NOT NULL,
		NUMFREQ_VALUES SMALLINT NOT NULL,
		NUMQUANTILES SMALLINT NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSCOLCHECKS (
		CONSTNAME VARCHAR(128) NOT NULL,
		TBNAME VARCHAR(128) NOT NULL,
		TBCREATOR VARCHAR(128) NOT NULL,
		COLNAME VARCHAR(128) NOT NULL,
		USAGE CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE IM_FINDRULES_07_IDMFRGIS (
		TRANSID CHAR(5) NOT NULL
	)
	IN USERSPACE1;

CREATE TABLE @@SFSF44SFSFSDFS__4435#$$## (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE SYSBUFFERPOOLNODES (
		BUFFERPOOLID INTEGER NOT NULL,
		NODENUM SMALLINT NOT NULL,
		NPAGES INTEGER NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSROUTINES (
		ROUTINENAME VARCHAR(128) NOT NULL,
		ROUTINESCHEMA VARCHAR(128) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		SPECIFICNAME VARCHAR(128) NOT NULL,
		PARM_SIGNATURE VARCHAR (180) FOR BIT DATA NOT NULL,
		ROUTINE_ID INTEGER NOT NULL,
		RETURN_TYPE SMALLINT NOT NULL,
		ORIGIN CHAR(1) NOT NULL,
		FUNCTION_TYPE CHAR(1) NOT NULL,
		CREATEDTS TIMESTAMP NOT NULL,
		PARM_COUNT SMALLINT NOT NULL,
		DETERMINISTIC CHAR(1) NOT NULL,
		EXTERNAL_ACTION CHAR(1) NOT NULL,
		FENCED CHAR(1) NOT NULL,
		NULL_CALL CHAR(1) NOT NULL,
		CAST_FUNCTION CHAR(1) NOT NULL,
		ASSIGN_FUNCTION CHAR(1) NOT NULL,
		SCRATCHPAD CHAR(1) NOT NULL,
		FINAL_CALL CHAR(1) NOT NULL,
		LANGUAGE CHAR(8) NOT NULL,
		IMPLEMENTATION VARCHAR(254),
		SOURCESPECIFIC VARCHAR(128),
		SOURCESCHEMA VARCHAR(128),
		IOS_PER_INVOC DOUBLE NOT NULL,
		INSTS_PER_INVOC DOUBLE NOT NULL,
		IOS_PER_ARGBYTE DOUBLE NOT NULL,
		INSTS_PER_ARGBYTE DOUBLE NOT NULL,
		PERCENT_ARGBYTES SMALLINT NOT NULL,
		INITIAL_IOS DOUBLE NOT NULL,
		INITIAL_INSTS DOUBLE NOT NULL,
		INTERNAL_PREC1 INTEGER NOT NULL,
		INTERNAL_PREC2 DOUBLE NOT NULL,
		REMARKS VARCHAR(254),
		INTERNAL_DESC BLOB(20971520) NOT NULL,
		PARALLEL CHAR(1) NOT NULL,
		SQL_DATA_ACCESS CHAR(1) NOT NULL,
		DBINFO CHAR(1) NOT NULL,
		RESULT_COLS SMALLINT NOT NULL,
		TEXT CLOB(2097152),
		CARDINALITY BIGINT NOT NULL,
		PARAMETER_STYLE CHAR(8) NOT NULL,
		METHODIMPLEMENTED CHAR(1) NOT NULL,
		METHODEFFECT CHAR(2) NOT NULL,
		FUNC_PATH VARCHAR(254),
		TYPE_PRESERVING CHAR(1) NOT NULL,
		WITH_FUNC_ACCESS CHAR(1) NOT NULL,
		SELECTIVITY DOUBLE NOT NULL,
		OVERRIDDEN_METHODID INTEGER,
		SUBJECT_TYPESCHEMA VARCHAR(128),
		SUBJECT_TYPENAME VARCHAR(128),
		QUALIFIER VARCHAR(128) NOT NULL,
		SCRATCHPAD_LENGTH SMALLINT NOT NULL,
		LIB_ID INTEGER,
		SPEC_REG CHAR(1) NOT NULL,
		FEDERATED CHAR(1) NOT NULL,
		ALTEREDTS TIMESTAMP NOT NULL,
		SOURCEROUTINEID INTEGER,
		SUBJECT_TYPEID SMALLINT,
		ROUTINETYPE CHAR(1) NOT NULL,
		THREADSAFE CHAR(1) NOT NULL,
		RESULT_SETS SMALLINT NOT NULL,
		PROGRAM_TYPE CHAR(1) NOT NULL,
		VALID CHAR(1) NOT NULL,
		TEXT_BODY_OFFSET INTEGER NOT NULL,
		COMMIT_ON_RETURN CHAR(1) NOT NULL,
		NAMESPACE CHAR(1) NOT NULL,
		METHODPROPERTY CHAR(1) NOT NULL,
		NEWSAVEPOINTLEVEL CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSROUTINEAUTH (
		GRANTOR VARCHAR(128) NOT NULL,
		GRANTEE VARCHAR(128) NOT NULL,
		GRANTEETYPE CHAR(1) NOT NULL,
		SCHEMA VARCHAR(128) NOT NULL,
		SPECIFICNAME VARCHAR(128),
		TYPESCHEMA VARCHAR(128),
		TYPENAME VARCHAR(128),
		ROUTINETYPE CHAR(1) NOT NULL,
		EXECUTEAUTH CHAR(1) NOT NULL,
		GRANT_TIME TIMESTAMP NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE TEMP_DISCRETIZATION (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL,
		AGE2 VARCHAR(1024)
	)
	IN USERSPACE1;

CREATE TABLE SYSWRAPPERS (
		WRAPNAME VARCHAR(128) NOT NULL,
		WRAPTYPE CHAR(1) NOT NULL,
		WRAPVERSION INTEGER NOT NULL,
		LIBRARY VARCHAR(255) NOT NULL,
		REMARKS VARCHAR(254)
	)
	IN SYSCATSPACE;

CREATE TABLE SYSDBAUTH (
		GRANTOR VARCHAR(128) NOT NULL,
		GRANTEE VARCHAR(128) NOT NULL,
		DBADMAUTH CHAR(1) NOT NULL,
		CREATETABAUTH CHAR(1) NOT NULL,
		BINDADDAUTH CHAR(1) NOT NULL,
		CONNECTAUTH CHAR(1) NOT NULL,
		NOFENCEAUTH CHAR(1) NOT NULL,
		GRANTEETYPE CHAR(1) NOT NULL,
		IMPLSCHEMAAUTH CHAR(1) NOT NULL,
		LOADAUTH CHAR(1) NOT NULL,
		EXTERNALROUTINEAUTH CHAR(1) NOT NULL,
		QUIESCECONNECTAUTH CHAR(1) NOT NULL,
		SECURITYADMAUTH CHAR(1) NOT NULL,
		LIBRARYADMAUTH CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSEVENTS (
		NAME VARCHAR(128) NOT NULL,
		TYPE VARCHAR(18) NOT NULL,
		FILTER CLOB(32768)
	)
	IN SYSCATSPACE;

CREATE TABLE SYSPASSTHRUAUTH (
		GRANTOR VARCHAR(128) NOT NULL,
		GRANTEE VARCHAR(128) NOT NULL,
		GRANTEETYPE CHAR(1) NOT NULL,
		SERVERNAME VARCHAR(128) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSXMLQUERIES (
		OBJECTID BIGINT NOT NULL,
		XMLQUERYTEXT CLOB(1048576) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE TEST5 (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE REGRESSIONMODELS (
		MODELNAME VARCHAR(256) NOT NULL,
		MODEL DM_REGRESSIONMODEL,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSTBSPACEAUTH (
		GRANTOR VARCHAR(128) NOT NULL,
		GRANTEE VARCHAR(128) NOT NULL,
		GRANTEETYPE CHAR(1) NOT NULL,
		TBSPACEID INTEGER NOT NULL,
		USEAUTH CHAR(1) NOT NULL,
		TBSPACE VARCHAR(128) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSXMLRELATIONSHIPS (
		RELATIONSHIPID BIGINT NOT NULL,
		PARENTID BIGINT,
		CHILDID BIGINT NOT NULL,
		LINKEDNAME VARCHAR(128) NOT NULL,
		RELATIONSHIPTYPE CHAR(2) NOT NULL,
		REFERENCED_RELATIONSHIPID BIGINT,
		DEFINER VARCHAR(128) NOT NULL,
		CREATE_TIME TIMESTAMP NOT NULL,
		ALTER_TIME TIMESTAMP
	)
	IN SYSCATSPACE;

CREATE TABLE SYSTABOPTIONS (
		TABSCHEMA VARCHAR(128) NOT NULL,
		TABNAME VARCHAR(128) NOT NULL,
		OPTION VARCHAR(128) NOT NULL,
		SETTING VARCHAR(255) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE TEST2 (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE SYSFUNCMAPPINGS (
		FUNCTION_MAPPING VARCHAR(128) NOT NULL,
		FUNCSCHEMA VARCHAR(128),
		FUNCNAME VARCHAR(1024),
		FUNCID INTEGER,
		SPECIFICNAME VARCHAR(128),
		DEFINER VARCHAR(128) NOT NULL,
		SERVERNAME VARCHAR(128),
		SERVERTYPE VARCHAR(30),
		SERVERVERSION VARCHAR(18),
		WRAPNAME VARCHAR(128),
		CREATE_TIME TIMESTAMP NOT NULL,
		REMARKS VARCHAR(254)
	)
	IN SYSCATSPACE;

CREATE TABLE SYSLIBRARIES (
		LIBSCHEMA VARCHAR(128) NOT NULL,
		LIBNAME VARCHAR(128) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		LIB_ID INTEGER NOT NULL,
		LIBVERSION_COUNT INTEGER NOT NULL,
		ACTIVE_VERSION INTEGER NOT NULL,
		SYSTEM_REQUIRED SMALLINT NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE TEST3 (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE SYSSCHEMATA (
		NAME VARCHAR(128) NOT NULL,
		OWNER VARCHAR(128) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		CREATE_TIME TIMESTAMP NOT NULL,
		REMARKS VARCHAR(254)
	)
	IN SYSCATSPACE;

CREATE TABLE REGSETTINGS (
		ID VARCHAR(256) NOT NULL,
		SETTINGS DM_REGSETTINGS,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE IM_CLUSTERTABLE_016_IDMCTTMP (
		CLIENT_ID CHAR(9) NOT NULL,
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE SYSSERVEROPTIONS (
		WRAPNAME VARCHAR(128),
		SERVERNAME VARCHAR(128),
		SERVERTYPE VARCHAR(30),
		SERVERVERSION VARCHAR(18),
		CREATE_TIME TIMESTAMP NOT NULL,
		OPTION VARCHAR(128) NOT NULL,
		SETTING VARCHAR(2048) NOT NULL,
		SERVEROPTIONKEY VARCHAR(18) NOT NULL,
		REMARKS VARCHAR(254)
	)
	IN SYSCATSPACE;

CREATE TABLE SYSROUTINEPROPERTIESJAVA (
		ROUTINE_ID INTEGER NOT NULL,
		CLASS VARCHAR(128),
		JAR_ID VARCHAR(128),
		JARSCHEMA VARCHAR(128),
		JAR_SIGNATURE VARCHAR(1024)
	)
	IN SYSCATSPACE;

CREATE TABLE RULETASKS (
		ID VARCHAR(256) NOT NULL,
		TASK DM_RULEBLDTASK,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE RULEMODELS (
		MODELNAME VARCHAR(256) NOT NULL,
		MODEL DM_RULEMODEL,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSCOLOPTIONS (
		TABSCHEMA VARCHAR(128) NOT NULL,
		TABNAME VARCHAR(128) NOT NULL,
		COLNAME VARCHAR(128) NOT NULL,
		OPTION VARCHAR(128) NOT NULL,
		SETTING VARCHAR(255) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSTABCONST (
		NAME VARCHAR(128) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		CONSTRAINTYP CHAR(1) NOT NULL,
		TBNAME VARCHAR(128) NOT NULL,
		TBCREATOR VARCHAR(128) NOT NULL,
		REMARKS VARCHAR(254),
		ENFORCED CHAR(1) NOT NULL,
		CHECKEXISTINGDATA CHAR(1) NOT NULL,
		ENABLEQUERYOPT CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSXMLSTATS (
		OBJECTID BIGINT,
		OBJECTTYPE CHAR(2) NOT NULL,
		STATISTICTYPE VARCHAR(128) NOT NULL,
		VALUE VARCHAR(255)
	)
	IN SYSCATSPACE;

CREATE TABLE SYSPREDICATESPECS (
		FUNCID INTEGER NOT NULL,
		SPECID SMALLINT NOT NULL,
		CONTEXTOP CHAR(8) NOT NULL,
		CONTEXTEXP CLOB(32768) NOT NULL,
		FILTERTEXT CLOB(65536)
	)
	IN SYSCATSPACE;

CREATE TABLE TEMP_RULEBODY (
		BODYID INTEGER,
		HEAD VARCHAR(1024),
		LENGTH SMALLINT,
		BODYTEXT VARCHAR(2048),
		SUPPORT DOUBLE,
		CONFIDENCE DOUBLE,
		LIFT REAL
	)
	IN USERSPACE1;

CREATE TABLE CLUSSETTINGS (
		ID VARCHAR(256) NOT NULL,
		SETTINGS DM_CLUSSETTINGS,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSEVENTTABLES (
		EVMONNAME VARCHAR(128) NOT NULL,
		LOGICAL_GROUP VARCHAR(18) NOT NULL,
		TABNAME VARCHAR(128) NOT NULL,
		TABSCHEMA VARCHAR(128) NOT NULL,
		PCTDEACTIVATE SMALLINT NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSCOLGROUPDIST (
		COLGROUPID INTEGER NOT NULL,
		TYPE CHAR(1) NOT NULL,
		ORDINAL SMALLINT NOT NULL,
		SEQNO SMALLINT NOT NULL,
		COLVALUE VARCHAR(254) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE BANKCUSTOMERS (
		CLIENT_ID CHAR(9) NOT NULL,
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE SYSPROCOPTIONS (
		PROCSCHEMA VARCHAR(128) NOT NULL,
		PROCNAME VARCHAR(128) NOT NULL,
		OPTION VARCHAR(128) NOT NULL,
		SETTING VARCHAR(255) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE REGTESTRESULTS (
		ID VARCHAR(256) NOT NULL,
		RESULT DM_REGTESTRESULT,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSSTMT (
		PLNAME VARCHAR(128) NOT NULL,
		PLCREATOR VARCHAR(128) NOT NULL,
		STMTNO INTEGER NOT NULL,
		SECTNO SMALLINT NOT NULL,
		TEXT CLOB(2097152) NOT NULL,
		UNIQUE_ID CHAR(8) NOT NULL,
		HOST_VARS BLOB(4190000)
	)
	IN SYSCATSPACE;

CREATE TABLE TEST1 (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL
	)
	IN USERSPACE1;

CREATE TABLE SYSXMLOBJECTPROPERTIES (
		OBJECTID BIGINT NOT NULL,
		OPTION VARCHAR(128) NOT NULL,
		SETTING VARCHAR(1024)
	)
	IN SYSCATSPACE;

CREATE TABLE SYSVIEWDEP (
		BNAME VARCHAR(128) NOT NULL,
		BCREATOR VARCHAR(128) NOT NULL,
		BTYPE CHAR(1) NOT NULL,
		DNAME VARCHAR(128) NOT NULL,
		DCREATOR VARCHAR(128) NOT NULL,
		VCAUTHID VARCHAR(128),
		TABAUTH SMALLINT,
		DTYPE CHAR(1) NOT NULL,
		OUTER_FROM CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE ERRORTABLE (
		CALLID CHAR (19) FOR BIT DATA,
		RC CHAR(1),
		SQLSTATE CHAR(5),
		EXCID INTEGER,
		PROCNAME VARCHAR(100),
		COMPNAME VARCHAR(100),
		TIMESTMP TIMESTAMP,
		MESSAGE VARCHAR(1000)
	)
	IN USERSPACE1;

CREATE TABLE SYSFUNCMAPPARMOPTIONS (
		FUNCTION_MAPPING VARCHAR(128) NOT NULL,
		ORDINAL SMALLINT NOT NULL,
		LOCATION CHAR(1) NOT NULL,
		OPTION VARCHAR(128) NOT NULL,
		SETTING VARCHAR(255) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSNODEGROUPS (
		NAME VARCHAR(128) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		PMAP_ID SMALLINT NOT NULL,
		REBALANCE_PMAP_ID SMALLINT NOT NULL,
		CTIME TIMESTAMP NOT NULL,
		REMARKS VARCHAR(254)
	)
	IN SYSCATSPACE;

CREATE TABLE CALLIDS (
		MODELNAME VARCHAR(256) NOT NULL,
		TERMINATED CHAR(1) DEFAULT '0' NOT NULL,
		CALLID CHAR (19) FOR BIT DATA NOT NULL,
		STARTTIME TIMESTAMP,
		ENDTIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE CLASTESTRESULTS (
		ID VARCHAR(256) NOT NULL,
		RESULT DM_CLASTESTRESULT,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSNODEGROUPDEF (
		NGNAME VARCHAR(128) NOT NULL,
		NODENUM SMALLINT NOT NULL,
		IN_USE CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE MININGDATA (
		ID VARCHAR(256) NOT NULL,
		MININGDATA DM_MININGDATA,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE ERRORTABLE (
		CALLID CHAR (19) FOR BIT DATA,
		RC CHAR(1),
		SQLSTATE CHAR(5),
		EXCID INTEGER,
		PROCNAME VARCHAR(100),
		COMPNAME VARCHAR(100),
		TIMESTMP TIMESTAMP,
		MESSAGE VARCHAR(1000)
	)
	IN USERSPACE1;

CREATE TABLE SYSLIBRARYAUTH (
		GRANTOR VARCHAR(128) NOT NULL,
		GRANTEE VARCHAR(128) NOT NULL,
		GRANTEETYPE CHAR(1) NOT NULL,
		LIBSCHEMA VARCHAR(128) NOT NULL,
		LIBNAME VARCHAR(128) NOT NULL,
		USAGEAUTH CHAR(1) NOT NULL,
		ALTERAUTH CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSCOLAUTH (
		GRANTOR VARCHAR(128) NOT NULL,
		GRANTEE VARCHAR(128) NOT NULL,
		GRANTEETYPE CHAR(1) NOT NULL,
		CREATOR VARCHAR(128) NOT NULL,
		TNAME VARCHAR(128) NOT NULL,
		PRIVTYPE CHAR(1) NOT NULL,
		COLNAME VARCHAR(128) NOT NULL,
		GRANTABLE CHAR(1) NOT NULL,
		COLNO SMALLINT NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSTABLESPACES (
		TBSPACE VARCHAR(128) NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		CREATE_TIME TIMESTAMP NOT NULL,
		TBSPACEID INTEGER NOT NULL,
		TBSPACETYPE CHAR(1) NOT NULL,
		DATATYPE CHAR(1) NOT NULL,
		EXTENTSIZE INTEGER NOT NULL,
		PREFETCHSIZE INTEGER NOT NULL,
		OVERHEAD DOUBLE NOT NULL,
		TRANSFERRATE DOUBLE NOT NULL,
		REMARKS VARCHAR(254),
		NGNAME VARCHAR(128) NOT NULL,
		BUFFERPOOLID INTEGER NOT NULL,
		PAGESIZE INTEGER NOT NULL,
		DROP_RECOVERY CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSPLANDEP (
		BNAME VARCHAR(128) NOT NULL,
		BCREATOR VARCHAR(128) NOT NULL,
		BTYPE CHAR(1) NOT NULL,
		DNAME VARCHAR(128) NOT NULL,
		DCREATOR VARCHAR(128) NOT NULL,
		BINDER VARCHAR(128),
		TABAUTH SMALLINT,
		TABUSAGE SMALLINT NOT NULL,
		COLUSAGE BLOB(5120),
		DUNIQUE_ID CHAR(8)
	)
	IN SYSCATSPACE;

CREATE TABLE OUT6 (
		CLIENT_ID CHAR(9),
		AGE REAL,
		GENDER CHAR(2),
		MARITAL_STATUS CHAR(12),
		PROFESSION CHAR(24),
		NBR_YEARS_CLI REAL,
		SAVINGS_ACCOUNT CHAR(3),
		HAS_LIFE_INSURANCE CHAR(3),
		INT_CREDITCARD CHAR(3),
		ONLINE_ACCESS CHAR(3),
		JOINED_ACCOUNTS CHAR(3),
		BANKCARD CHAR(3),
		AVERAGE_BALANCE DECIMAL(10,2),
		NO_CRED_TRANS REAL,
		NO_DEBIT_TRANS REAL,
		PREDICTION VARCHAR(100),
		CONFIDENCE DOUBLE,
		DATA_SET VARCHAR(10)
	)
	IN USERSPACE1;

CREATE TABLE SYSNAMEMAPPINGS (
		TYPE CHAR(1) NOT NULL,
		LOGICAL_SCHEMA VARCHAR(128) NOT NULL,
		LOGICAL_NAME VARCHAR(128) NOT NULL,
		LOGICAL_COLNAME VARCHAR(128),
		IMPL_SCHEMA VARCHAR(128) NOT NULL,
		IMPL_NAME VARCHAR(128) NOT NULL,
		IMPL_COLNAME VARCHAR(128)
	)
	IN SYSCATSPACE;

CREATE TABLE SYSLIBRARYVERSIONS (
		LIB_ID INTEGER NOT NULL,
		LIBVERSION INTEGER NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		CREATE_TIME TIMESTAMP NOT NULL,
		VERSION_PATH VARCHAR(255) NOT NULL,
		BINDFILES_COUNT SMALLINT NOT NULL,
		VERSION_BODY BLOB(20971520) NOT NULL,
		CHECKSUM INTEGER NOT NULL,
		STALE CHAR(1)
	)
	IN SYSCATSPACE;

CREATE TABLE SYSTYPEMAPPINGS (
		TYPE_MAPPING VARCHAR(18) NOT NULL,
		TYPESCHEMA VARCHAR(128),
		TYPENAME VARCHAR(128) NOT NULL,
		TYPEID SMALLINT NOT NULL,
		SOURCETYPEID SMALLINT NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		UPPER_LEN INTEGER,
		UPPER_SCALE SMALLINT,
		BIT_DATA CHAR(1),
		WRAPNAME VARCHAR(128),
		SERVERNAME VARCHAR(128),
		SERVERTYPE VARCHAR(30),
		SERVERVERSION VARCHAR(18),
		REMOTE_TYPESCHEMA VARCHAR(128),
		REMOTE_TYPENAME VARCHAR(128) NOT NULL,
		REMOTE_META_TYPE CHAR(1),
		REMOTE_LOWER_LEN INTEGER,
		REMOTE_UPPER_LEN INTEGER,
		REMOTE_LOWER_SCALE SMALLINT,
		REMOTE_UPPER_SCALE SMALLINT,
		REMOTE_S_OPR_P CHAR(2),
		REMOTE_BIT_DATA CHAR(1),
		USER_DEFINED CHAR(1) NOT NULL,
		CREATE_TIME TIMESTAMP NOT NULL,
		REMARKS VARCHAR(254),
		MAPPINGDIRECTION CHAR(1) NOT NULL,
		LOWER_LEN INTEGER,
		LOWER_SCALE SMALLINT,
		S_OPR_P CHAR(2)
	)
	IN SYSCATSPACE;

CREATE TABLE SYSINDEXEXTENSIONPARMS (
		IESCHEMA VARCHAR(128) NOT NULL,
		IENAME VARCHAR(128) NOT NULL,
		ORDINAL SMALLINT NOT NULL,
		PARMNAME VARCHAR(128) NOT NULL,
		TYPESCHEMA VARCHAR(128) NOT NULL,
		TYPENAME VARCHAR(128) NOT NULL,
		LENGTH INTEGER NOT NULL,
		SCALE SMALLINT NOT NULL,
		PARMTYPE CHAR(1) NOT NULL,
		CODEPAGE SMALLINT NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSSCHEMAAUTH (
		GRANTOR VARCHAR(128) NOT NULL,
		GRANTEE VARCHAR(128) NOT NULL,
		GRANTEETYPE CHAR(1) NOT NULL,
		SCHEMANAME VARCHAR(128) NOT NULL,
		CREATEINAUTH CHAR(1) NOT NULL,
		DROPINAUTH CHAR(1) NOT NULL,
		ALTERINAUTH CHAR(1) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE SYSSEQUENCES (
		LASTASSIGNEDVAL DECIMAL(31,0),
		SEQID INTEGER NOT NULL,
		SEQSCHEMA VARCHAR(128) NOT NULL,
		SEQNAME VARCHAR(128) NOT NULL,
		INCREMENT DECIMAL(31,0) NOT NULL,
		START DECIMAL(31,0) NOT NULL,
		MAXVALUE DECIMAL(31,0) NOT NULL,
		MINVALUE DECIMAL(31,0) NOT NULL,
		CYCLE CHAR(1) NOT NULL,
		CACHE INTEGER NOT NULL,
		ORDER CHAR(1) NOT NULL,
		ORIGIN CHAR(1) NOT NULL,
		SEQTYPE CHAR(1) NOT NULL,
		DATATYPEID INTEGER NOT NULL,
		SEQ_DESC BLOB(65536),
		CREATE_TIME TIMESTAMP NOT NULL,
		ALTER_TIME TIMESTAMP NOT NULL,
		SOURCETYPEID INTEGER NOT NULL,
		PRECISION SMALLINT NOT NULL,
		DEFINER VARCHAR(128) NOT NULL,
		OWNER VARCHAR(128) NOT NULL
	)
	IN SYSCATSPACE;

CREATE TABLE CLASTASKS (
		ID VARCHAR(256) NOT NULL,
		TASK DM_CLASBLDTASK,
		DESCRIPTION VARCHAR(254),
		BUSINESS_NAME VARCHAR(128),
		CREATOR VARCHAR(128) DEFAULT USER,
		CREATE_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP,
		MODIFIER VARCHAR(128),
		MODIFY_TIME TIMESTAMP
	)
	IN USERSPACE1;

CREATE TABLE SYSXMLPHYSICALCOLLECTIONS (
		OBJECTID BIGINT NOT NULL,
		PRIMARYUSE CHAR(1) NOT NULL,
		STORAGE CHAR(1) NOT NULL,
		TBSPACEID INTEGER,
		COLLECTIONTYPE CHAR(1) NOT NULL,
		BUFFERPOOLID INTEGER,
		DBPGNAME VARCHAR(128)
	)
	IN SYSCATSPACE;

CREATE VIEW NODEGROUPS (NGNAME, DEFINER, PMAP_ID, REBALANCE_PMAP_ID, CREATE_TIME, REMARKS) AS
select      name, definer, pmap_id, rebalance_pmap_id, ctime,      remarks  from sysibm.sysnodegroups;

CREATE VIEW LIBRARIES (LIBSCHEMA, LIBNAME, DEFINER, LIB_ID, LIBVERSION_COUNT, ACTIVE_VERSION, SYSTEM_REQUIRED) AS
select       libschema, libname, definer, lib_id, libversion_count,       active_version, system_required  from sysibm.syslibraries;

CREATE VIEW USER_DEFINED_TYPES (USER_DEFINED_TYPE_CATALOG, USER_DEFINED_TYPE_SCHEMA, USER_DEFINED_TYPE_NAME, USER_DEFINED_TYPE_CATEGORY, IS_INSTANTIABLE, IS_FINAL, ORDERING_FORM, ORDERING_CATEGORY, ORDERING_ROUTINE_CATALOG, ORDERING_ROUTINE_SCHEMA, ORDERING_ROUTINE_NAME, REFERENCE_TYPE, DATA_TYPE, CHARACTER_MAXIMUM_LENGTH, CHARACTER_OCTET_LENGTH, CHARACTER_SET_CATALOG, CHARACTER_SET_SCHEMA, CHARACTER_SET_NAME, COLLATION_CATALOG, COLLATION_SCHEMA, COLLATION_NAME, NUMERIC_PRECISION, NUMERIC_PRECISION_RADIX, NUMERIC_SCALE, DATETIME_PRECISION, INTERVAL_TYPE, INTERVAL_PRECISION, SOURCE_DTD_IDENTIFIER, REF_DTD_IDENTIFIER) AS
SELECT CAST(CURRENT SERVER AS VARCHAR(128))  AS USER_DEFINED_TYPE_CATALOG,        D.SCHEMA  AS USER_DEFINED_TYPE_SCHEMA,        CAST(D.NAME AS VARCHAR(128))  AS USER_DEFINED_TYPE_NAME,        CASE D.METATYPE            WHEN 'T'  THEN 'DISTINCT'            WHEN 'R' THEN  'STRUCTURED'        END  AS USER_DEFINED_TYPE_CATEGORY,        CASE D.INSTANTIABLE            WHEN 'Y'  THEN 'YES'            WHEN 'N'  THEN 'NO'        END  AS IS_INSTANTIABLE,        CASE D.FINAL            WHEN 'Y'  THEN 'YES'            WHEN 'N' THEN 'NO'        END  AS IS_FINAL,        CASE            WHEN D.METATYPE='R' OR                 (D.METATYPE='T' AND                  D.SOURCETYPE IN ('BLOB','CLOB','DBCLOB','LONG VARCHAR',                                   'LONG VARGRAPHIC','DATALINK'))                 THEN CAST('NONE' AS VARCHAR(6))            ELSE 'FULL'        END  AS ORDERING_FORM,        CASE D.METATYPE            WHEN 'R' THEN 'STATE'            ELSE CAST('MAP' AS VARCHAR(5))        END  AS ORDERING_CATEGORY,        CASE            WHEN D.METATYPE='R' OR                 (D.METATYPE='T' AND                  D.SOURCETYPE IN ('BLOB','CLOB','DBCLOB','LONG VARCHAR',                                   'LONG VARGRAPHIC','DATALINK') )                 THEN CAST(NULL AS VARCHAR(128))            ELSE CURRENT SERVER        END  AS ORDERING_ROUTINE_CATALOG,        CASE            WHEN D.METATYPE='R' OR                 (D.METATYPE='T' AND                  D.SOURCETYPE IN ('BLOB','CLOB','DBCLOB','LONG VARCHAR',                                   'LONG VARGRAPHIC','DATALINK') )                 THEN CAST(NULL AS VARCHAR(128))            ELSE D.SOURCESCHEMA        END  AS ORDERING_ROUTINE_SCHEMA,        CASE            WHEN D.METATYPE='R' OR                 (D.METATYPE='T' AND                  D.SOURCETYPE IN ('BLOB','CLOB','DBCLOB','LONG VARCHAR',                                   'LONG VARGRAPHIC','DATALINK') )                 THEN CAST(NULL AS VARCHAR(128))            ELSE D.SOURCETYPE         END  AS ORDERING_ROUTINE_NAME,         CASE D.METATYPE             WHEN 'R'    THEN 'USER GENERATED'             ELSE CAST(NULL AS VARCHAR(16))         END  AS REFERENCE_TYPE,        CASE             WHEN D.SOURCETYPE ='CHARACTER'       THEN 'CHARACTER'             WHEN D.SOURCETYPE ='VARCHAR'         THEN 'CHARACTER VARYING'             WHEN D.SOURCETYPE ='LONG VARCHAR'    THEN 'LONG VARCHAR'             WHEN D.SOURCETYPE ='INTEGER'         THEN 'INTEGER'             WHEN D.SOURCETYPE ='SMALLINT'        THEN 'SMALLINT'             WHEN D.SOURCETYPE ='BIGINT'          THEN 'BIGINT'             WHEN D.SOURCETYPE ='REAL'            THEN 'REAL'             WHEN D.SOURCETYPE ='DOUBLE'          THEN 'DOUBLE PRECISION'             WHEN D.SOURCETYPE ='DECIMAL'         THEN 'DECIMAL'             WHEN D.SOURCETYPE ='BLOB'            THEN 'BINARY LARGE OBJECT'             WHEN D.SOURCETYPE ='CLOB'            THEN 'CHARACTER LARGE OBJECT'             WHEN D.SOURCETYPE ='DBCLOB'          THEN 'DOUBLE-BYTE CHARACTER LARGE OBJECT'             WHEN D.SOURCETYPE ='GRAPHIC'         THEN 'GRAPHIC'             WHEN D.SOURCETYPE ='VARGRAPHIC'      THEN 'GRAPHIC VARYING'             WHEN D.SOURCETYPE ='LONG VARGRAPHIC' THEN 'LONG VARGRAPHIC'             WHEN D.SOURCETYPE ='DATALINK'        THEN 'DATALINK'             WHEN D.SOURCETYPE ='TIME'            THEN 'TIME'             WHEN D.SOURCETYPE ='DATE'            THEN 'DATE'             WHEN D.SOURCETYPE ='TIMESTAMP'       THEN 'TIMESTAMP'             ELSE D.SOURCETYPE         END  AS DATA_TYPE,         CASE             WHEN D.SOURCETYPE IN ('CHARACTER', 'VARCHAR', 'LONG VARCHAR',                                    'CLOB', 'BLOB', 'DBCLOB',                                    'GRAPHIC', 'VARGRAPHIC', 'LONG VARGRAPHIC')                  THEN D.LENGTH             ELSE CAST(NULL AS INTEGER)         END  AS CHARACTER_MAXIMUM_LENGTH,         CASE             WHEN D.SOURCETYPE IN ('CHARACTER', 'VARCHAR', 'LONG VARCHAR',                                   'CLOB', 'BLOB')                  THEN D.LENGTH             WHEN D.SOURCETYPE IN ('DBCLOB', 'GRAPHIC',                                   'VARGRAPHIC', 'LONG VARGRAPHIC')                  THEN D.LENGTH*2             ELSE CAST(NULL AS INTEGER)         END  AS CHARACTER_OCTET_LENGTH,         CASE             WHEN D.SOURCETYPE IN ('CHARACTER', 'VARCHAR', 'LONG VARCHAR',                                   'CLOB', 'DBCLOB', 'GRAPHIC',                                   'VARGRAPHIC', 'LONG VARGRAPHIC')                  THEN CAST(CURRENT SERVER AS VARCHAR(128))             ELSE CAST(NULL AS VARCHAR(128))         END  AS CHARACTER_SET_CATALOG,         CASE             WHEN D.SOURCETYPE IN ('CHARACTER', 'VARCHAR', 'LONG VARCHAR',                                   'CLOB', 'DBCLOB', 'GRAPHIC',                                   'VARGRAPHIC', 'LONG VARGRAPHIC')                  THEN CAST('SYSIBM' AS VARCHAR(128))             ELSE CAST(NULL AS VARCHAR(128))         END  AS CHARACTER_SET_SCHEMA,         CASE             WHEN D.SOURCETYPE IN ('CHARACTER', 'VARCHAR', 'LONG VARCHAR',                                   'CLOB', 'DBCLOB', 'GRAPHIC',                                   'VARGRAPHIC', 'LONG VARGRAPHIC')                  THEN CAST(CONCAT('IBM', CHAR(D.CODEPAGE)) AS VARCHAR(128))             ELSE CAST( NULL AS VARCHAR(128))         END  AS CHARACTER_SET_NAME,         CASE             WHEN D.SOURCETYPE IN ('CHARACTER', 'VARCHAR', 'LONG VARCHAR',                                   'CLOB', 'DBCLOB', 'GRAPHIC',                                   'VARGRAPHIC', 'LONG VARGRAPHIC')                  THEN CAST(CURRENT SERVER AS VARCHAR(128))             ELSE NULL         END  AS COLLATION_CATALOG,         CASE             WHEN D.SOURCETYPE IN ('CHARACTER', 'VARCHAR', 'LONG VARCHAR',                                   'CLOB', 'DBCLOB', 'GRAPHIC',                                   'VARGRAPHIC', 'LONG VARGRAPHIC')                  THEN CAST('SYSIBM' AS VARCHAR(128))             ELSE NULL         END  AS COLLATION_SCHEMA,         CASE             WHEN D.SOURCETYPE IN ('CHARACTER', 'VARCHAR', 'LONG VARCHAR',                                   'CLOB', 'DBCLOB', 'GRAPHIC',                                   'VARGRAPHIC', 'LONG VARGRAPHIC')                  THEN CAST('IBMDEFAULT' AS VARCHAR(128))             ELSE NULL         END  AS COLLATION_NAME,         CASE             WHEN D.SOURCETYPE = 'INTEGER'  THEN 10             WHEN D.SOURCETYPE = 'BIGINT'   THEN 19             WHEN D.SOURCETYPE = 'SMALLINT' THEN 5             WHEN D.SOURCETYPE = 'REAL'     THEN 24             WHEN D.SOURCETYPE = 'DOUBLE'   THEN 53             WHEN D.SOURCETYPE = 'DECIMAL'  THEN D.LENGTH             ELSE CAST(NULL AS INTEGER)         END  AS NUMERIC_PRECISION,         CASE             WHEN D.SOURCETYPE IN ('INTEGER', 'BIGINT', 'SMALLINT', 'DECIMAL')                  THEN 10             WHEN D.SOURCETYPE IN('REAL', 'DOUBLE')                  THEN 2             ELSE CAST(NULL AS INTEGER)         END  AS NUMERIC_PRECISION_RADIX,         CASE             WHEN D.SOURCETYPE ='DECIMAL' THEN  CAST(D.SCALE AS INTEGER)             WHEN D.SOURCETYPE IN ('INTEGER', 'SMALLINT')  THEN 0             ELSE CAST(NULL AS INTEGER)         END  AS NUMERIC_SCALE,         CASE             WHEN D.SOURCETYPE IN ('DATE','TIME') THEN 0             WHEN D.SOURCETYPE = 'TIMESTAMP'      THEN 6             ELSE CAST(NULL AS INTEGER)         END  AS DATETIME_PRECISION,         CAST(NULL AS VARCHAR(128))  AS INTERVAL_TYPE,         CAST(NULL AS INTEGER)  AS INTERVAL_PRECISION,         CASE             WHEN D.METATYPE='T'                  THEN CAST(CONCAT('D',HEX(D.TYPEID)) AS VARCHAR(128))             ELSE CAST(NULL AS VARCHAR(128))         END  AS SOURCE_DTD_IDENTIFIER,         CASE             WHEN D.METATYPE='R'                  THEN CAST(CONCAT('D',HEX(D.TYPEID)) AS VARCHAR(128))             ELSE CAST(NULL AS VARCHAR(128))         END  AS REF_DTD_IDENTIFIER FROM SYSIBM.SYSDATATYPES D WHERE D.METATYPE IN ('T', 'R');

CREATE VIEW ROUTINES_S (SPECIFIC_CATALOG, SPECIFIC_SCHEMA, SPECIFIC_NAME, ROUTINE_CATALOG, ROUTINE_SCHEMA, ROUTINE_NAME, ROUTINE_TYPE, MODULE_CATALOG, MODULE_SCHEMA, MODULE_NAME, UDT_CATALOG, UDT_SCHEMA, UDT_NAME, DATA_TYPE, CHAR_MAX_LENGTH, CHAR_OCTET_LENGTH, CHAR_SET_CATALOG, CHAR_SET_SCHEMA, CHARACTER_SET_NAME, COLLATION_CATALOG, COLLATION_SCHEMA, COLLATION_NAME, NUMERIC_PRECISION, NUMERIC_PREC_RADIX, NUMERIC_SCALE, DATETIME_PRECISION, INTERVAL_TYPE, INTERVAL_PRECISION, TYPE_UDT_CATALOG, TYPE_UDT_SCHEMA, TYPE_UDT_NAME, SCOPE_CATALOG, SCOPE_SCHEMA, SCOPE_NAME, MAX_CARDINALITY, DTD_IDENTIFIER, ROUTINE_BODY, ROUTINE_DEFINITION, EXTERNAL_NAME, EXTERNAL_LANGUAGE, PARAMETER_STYLE, IS_DETERMINISTIC, SQL_DATA_ACCESS, IS_NULL_CALL, SQL_PATH, SCH_LEVEL_ROUTINE, MAX_DYN_RESLT_SETS, IS_USER_DEFND_CAST, IS_IMP_INVOCABLE, SECURITY_TYPE, TO_SQL_SPEC_CAT, TO_SQL_SPEC_SCHEMA, TO_SQL_SPEC_NAME, AS_LOCATOR, CREATED, LAST_ALTERED) AS
SELECT  SPECIFIC_CATALOG, SPECIFIC_SCHEMA, SPECIFIC_NAME, ROUTINE_CATALOG,  ROUTINE_SCHEMA, ROUTINE_NAME, ROUTINE_TYPE, MODULE_CATALOG,  MODULE_SCHEMA, MODULE_NAME, UDT_CATALOG, UDT_SCHEMA,  UDT_NAME, DATA_TYPE, CHARACTER_MAXIMUM_LENGTH, CHARACTER_OCTET_LENGTH,  CHARACTER_SET_CATALOG, CHARACTER_SET_SCHEMA, CHARACTER_SET_NAME, COLLATION_CATALOG,  COLLATION_SCHEMA, COLLATION_NAME, NUMERIC_PRECISION, NUMERIC_PRECISION_RADIX,  NUMERIC_SCALE, DATETIME_PRECISION, INTERVAL_TYPE, INTERVAL_PRECISION,  TYPE_UDT_CATALOG, TYPE_UDT_SCHEMA, TYPE_UDT_NAME, SCOPE_CATALOG,  SCOPE_SCHEMA, SCOPE_NAME, MAXIMUM_CARDINALITY, DTD_IDENTIFIER,  ROUTINE_BODY, ROUTINE_DEFINITION, EXTERNAL_NAME, EXTERNAL_LANGUAGE,  PARAMETER_STYLE, IS_DETERMINISTIC, SQL_DATA_ACCESS, IS_NULL_CALL,  SQL_PATH, SCHEMA_LEVEL_ROUTINE, MAX_DYNAMIC_RESULT_SETS, IS_USER_DEFINED_CAST, IS_IMPLICITLY_INVOCABLE, SECURITY_TYPE, TO_SQL_SPECIFIC_CATALOG, TO_SQL_SPECIFIC_SCHEMA,  TO_SQL_SPECIFIC_NAME, AS_LOCATOR, CREATED, LAST_ALTERED FROM SYSIBM.ROUTINES;

--CREATE VIEW FULLHIERARCHIES (METATYPE, SUB_SCHEMA, SUB_NAME, SUPER_SCHEMA, SUPER_NAME, ROOT_SCHEMA, ROOT_NAME) AS
--     (select metatype, sub_schema, sub_name,              super_schema, super_name,              root_schema, root_name       from sysibm.syshierarchies)   union all      (select h.metatype, h.sub_schema, h.sub_name,              f.super_schema, f.super_name,              h.root_schema, h.root_name       from syscat.fullhierarchies as f,            sysibm.syshierarchies as h       where f.sub_schema = h.super_schema       and f.sub_name = h.super_name);

CREATE VIEW ATTRIBUTES (TYPESCHEMA, TYPENAME, ATTR_NAME, ATTR_TYPESCHEMA, ATTR_TYPENAME, TARGET_TYPESCHEMA, TARGET_TYPENAME, SOURCE_TYPESCHEMA, SOURCE_TYPENAME, ORDINAL, LENGTH, SCALE, CODEPAGE, LOGGED, COMPACT, DL_FEATURES, JAVA_FIELDNAME) AS
select      typeschema, typename, attr_name, attr_typeschema,      attr_typename, target_typeschema, target_typename,      source_typeschema, source_typename, ordinal, length,      scale, codepage, logged, compact, dl_features,      java_fieldname  from sysibm.sysattributes;

CREATE VIEW SQLSPECIALCOLUMNS (SCOPE, COLUMN_NAME, DATA_TYPE, TYPE_NAME, COLUMN_SIZE, BUFFER_LENGTH, DECIMAL_DIGITS, PSEUDO_COLUMN, TABLE_CAT, TABLE_SCHEM, TABLE_NAME, NULLABLE, JDBC_DATA_TYPE) AS
 WITH IDTABLES ( A, B )  AS  ( SELECT TBCREATOR AS  A, TBNAME AS  B   FROM SYSIBM.SYSCOLUMNS   WHERE IDENTITY = 'Y' ), SUBINDEXES ( NAME, CREATOR, TBNAME, TBCREATOR, UNIQUERULE, COLCOUNT, IID )  AS  (   SELECT I.NAME, I.CREATOR, I.TBNAME, I.TBCREATOR,    I.UNIQUERULE, I.COLCOUNT, I.IID    FROM SYSIBM.SYSINDEXES I    WHERE I.UNIQUERULE IN ( 'P', 'U' )     AND (I.TBCREATOR, I.TBNAME)      NOT IN (SELECT A, B FROM IDTABLES) ), OPTIMALINDEXES ( NAME, CREATOR ) AS  (   SELECT NAME AS  A, CREATOR AS  B     FROM SUBINDEXES I     WHERE I.UNIQUERULE = 'P'   UNION ALL   SELECT NAME AS  A, CREATOR AS  B    FROM SUBINDEXES    WHERE UNIQUERULE = 'U'    AND (TBCREATOR, TBNAME) NOT IN (     SELECT TBCREATOR, TBNAME     FROM SUBINDEXES WHERE UNIQUERULE = 'P' )    AND ( TBNAME, TBCREATOR, IID)     IN ( SELECT TBNAME, TBCREATOR, MIN(IID)      FROM SUBINDEXES      WHERE (TBNAME, TBCREATOR, COLCOUNT)      IN ( SELECT TBNAME, TBCREATOR, MIN(COLCOUNT)       FROM SUBINDEXES       GROUP BY TBNAME, TBCREATOR )      GROUP BY TBNAME, TBCREATOR ) )   SELECT    SMALLINT(0),    Q.COLUMN_NAME,    Q.DATA_TYPE,    Q.TYPE_NAME,    Q.COLUMN_SIZE,    Q.BUFFER_LENGTH,    Q.DECIMAL_DIGITS,    Q.PSEUDO_COLUMN,    CAST( NULL AS  VARCHAR(128) ),    RTRIM(Q.TABLE_SCHEM),    Q.TABLE_NAME,    Q.NULLABLE,    Q.JDBC_DATA_TYPE  FROM    OPTIMALINDEXES O,    SYSIBM.SYSINDEXES I,    SYSIBM.SYSINDEXCOLUSE U,    SYSIBM.SQLCOLUMNS Q  WHERE    I.NAME = O.NAME    AND I.CREATOR = O.CREATOR    AND Q.DATA_TYPE <> 20    AND Q.TABLE_SCHEM = I.TBCREATOR    AND Q.TABLE_NAME = I.TBNAME    AND I.CREATOR = U.INDSCHEMA    AND I.NAME = U.INDNAME    AND Q.COLUMN_NAME = U.COLNAME UNION ALL SELECT    SMALLINT(0),    Q.COLUMN_NAME,    20,    Q.TYPE_NAME,    Q.COLUMN_SIZE,    Q.BUFFER_LENGTH,    Q.DECIMAL_DIGITS,    Q.PSEUDO_COLUMN,    CAST( NULL AS  VARCHAR(128) ),    RTRIM(Q.TABLE_SCHEM),    Q.TABLE_NAME,    Q.NULLABLE,    Q.JDBC_DATA_TYPE   FROM    OPTIMALINDEXES O,    SYSIBM.SYSINDEXES I,    SYSIBM.SYSINDEXCOLUSE U,    SYSIBM.SQLCOLUMNS Q   WHERE     I.NAME = O.NAME    AND I.CREATOR = O.CREATOR    AND Q.DATA_TYPE = 20    AND Q.TABLE_SCHEM = I.TBCREATOR    AND Q.TABLE_NAME = I.TBNAME    AND I.CREATOR = U.INDSCHEMA    AND I.NAME = U.INDNAME    AND Q.COLUMN_NAME = U.COLNAME UNION ALL  SELECT    SMALLINT(0),    Q.COLUMN_NAME,    Q.DATA_TYPE,    Q.TYPE_NAME,    Q.COLUMN_SIZE,    Q.BUFFER_LENGTH,    Q.DECIMAL_DIGITS,    Q.PSEUDO_COLUMN,    CAST( NULL AS  VARCHAR(128) ),    RTRIM(Q.TABLE_SCHEM),    Q.TABLE_NAME,    Q.NULLABLE,    Q.JDBC_DATA_TYPE  FROM     SYSIBM.SYSCOLUMNS C,    SYSIBM.SQLCOLUMNS Q  WHERE    C.TBCREATOR = Q.TABLE_SCHEM    AND C.TBNAME = Q.TABLE_NAME    AND C.NAME = Q.COLUMN_NAME    AND C.IDENTITY = 'Y' UNION ALL SELECT    SMALLINT(0),    Q.COLUMN_NAME,    Q.DATA_TYPE,    Q.TYPE_NAME,    Q.COLUMN_SIZE,    Q.BUFFER_LENGTH,    Q.DECIMAL_DIGITS,    Q.PSEUDO_COLUMN,    CAST( NULL AS  VARCHAR(128) ),    RTRIM(T.CREATOR),    T.NAME,    Q.NULLABLE,    Q.JDBC_DATA_TYPE   FROM    OPTIMALINDEXES O,    SYSIBM.SYSINDEXES I,    SYSIBM.SYSINDEXCOLUSE U,    SYSIBM.SYSTABLES T,    SYSIBM.SQLCOLUMNS Q  WHERE    I.NAME = O.NAME    AND I.CREATOR = O.CREATOR    AND Q.DATA_TYPE <> 20    AND Q.TABLE_SCHEM = I.TBCREATOR    AND Q.TABLE_NAME = I.TBNAME    AND I.CREATOR = U.INDSCHEMA    AND I.NAME = U.INDNAME    AND Q.COLUMN_NAME = U.COLNAME    AND T.TYPE = 'A'    AND TABLE_SCHEMA(T.NAME, T.CREATOR) = Q.TABLE_SCHEM    AND TABLE_NAME(T.NAME, T.CREATOR) = Q.TABLE_NAME  UNION ALL SELECT    SMALLINT(0),    Q.COLUMN_NAME,    20,    Q.TYPE_NAME,    Q.COLUMN_SIZE,    Q.BUFFER_LENGTH,    Q.DECIMAL_DIGITS,    Q.PSEUDO_COLUMN,    CAST( NULL AS  VARCHAR(128) ),    RTRIM(T.CREATOR),    T.NAME,    Q.NULLABLE,    Q.JDBC_DATA_TYPE FROM    OPTIMALINDEXES O,    SYSIBM.SYSINDEXES I,    SYSIBM.SYSINDEXCOLUSE U,    SYSIBM.SYSTABLES T,    SYSIBM.SQLCOLUMNS Q  WHERE    I.NAME = O.NAME    AND I.CREATOR = O.CREATOR    AND Q.DATA_TYPE = 20     AND Q.TABLE_SCHEM = I.TBCREATOR    AND Q.TABLE_NAME = I.TBNAME    AND I.CREATOR = U.INDSCHEMA    AND I.NAME = U.INDNAME    AND Q.COLUMN_NAME = U.COLNAME    AND T.TYPE = 'A'    AND TABLE_SCHEMA(T.NAME, T.CREATOR) = Q.TABLE_SCHEM    AND TABLE_NAME(T.NAME, T.CREATOR) = Q.TABLE_NAME UNION ALL  SELECT    SMALLINT(0),    C.NAME,    Q.DATA_TYPE,    Q.TYPE_NAME,    Q.COLUMN_SIZE,    Q.BUFFER_LENGTH,    Q.DECIMAL_DIGITS,    Q.PSEUDO_COLUMN,    CAST( NULL AS  VARCHAR(128) ),    RTRIM(T.CREATOR),    T.NAME,    Q.NULLABLE,    Q.JDBC_DATA_TYPE  FROM    SYSIBM.SYSCOLUMNS C,    SYSIBM.SQLCOLUMNS Q,    SYSIBM.SYSTABLES T  WHERE    C.TBCREATOR = Q.TABLE_SCHEM    AND C.TBNAME = Q.TABLE_NAME    AND C.NAME = Q.COLUMN_NAME    AND C.IDENTITY = 'Y'     AND T.TYPE = 'A'    AND TABLE_SCHEMA(T.NAME, T.CREATOR) = C.TBCREATOR    AND TABLE_NAME(T.NAME, T.CREATOR) = C.TBNAME;



CREATE VIEW COLGROUPDIST (COLGROUPID, TYPE, ORDINAL, SEQNO, COLVALUE) AS
select      colgroupid, type, ordinal, seqno, colvalue  from sysibm.syscolgroupdist;

CREATE VIEW SQLPROCEDURECOLS (PROCEDURE_CAT, PROCEDURE_SCHEM, PROCEDURE_NAME, COLUMN_NAME, COLUMN_TYPE, DATA_TYPE, TYPE_NAME, COLUMN_SIZE, BUFFER_LENGTH, DECIMAL_DIGITS, NUM_PREC_RADIX, NULLABLE, REMARKS, COLUMN_DEF, SQL_DATA_TYPE, SQL_DATETIME_SUB, CHAR_OCTET_LENGTH, ORDINAL_POSITION, IS_NULLABLE, JDBC_DATA_TYPE) AS
 SELECT CAST( NULL AS VARCHAR(128) ),  RTRIM(PARM.PROCSCHEMA),  PARM.PROCNAME,  PARM.PARMNAME,  SMALLINT( CASE      WHEN PARM_MODE = 'IN'    THEN 1      WHEN PARM_MODE = 'OUT'   THEN 4      WHEN PARM_MODE = 'INOUT' THEN 2      ELSE 0  END), SMALLINT( CASE     WHEN TYPENAME='INTEGER' THEN 4     WHEN TYPENAME='SMALLINT' THEN 5     WHEN TYPENAME='BIGINT' THEN -5     WHEN TYPENAME='FLOAT' AND LENGTH=4 THEN 7     WHEN TYPENAME='FLOAT' AND LENGTH=8 THEN 8     WHEN TYPENAME='REAL' THEN 7     WHEN TYPENAME='DOUBLE' THEN 8     WHEN TYPENAME='CHARACTER' AND CODEPAGE <> 0 then 1     WHEN TYPENAME='CHARACTER' AND CODEPAGE = 0 then -2     WHEN TYPENAME='VARCHAR' AND CODEPAGE <> 0 THEN 12     WHEN TYPENAME='VARCHAR' AND CODEPAGE = 0 THEN -3     WHEN TYPENAME='LONGVAR' AND CODEPAGE <> 0 THEN -1     WHEN TYPENAME='LONGVAR' AND CODEPAGE = 0 THEN -4     WHEN TYPENAME='DECIMAL' THEN 3     WHEN TYPENAME='GRAPHIC' THEN -95     WHEN TYPENAME='VARG' THEN -96     WHEN TYPENAME='LONGVARG' THEN -97     WHEN TYPENAME='BLOB' THEN -98     WHEN TYPENAME='CLOB' THEN -99     WHEN TYPENAME='DBCLOB' THEN -350     WHEN TYPENAME='DATE' THEN 91     WHEN TYPENAME='TIME' THEN 92     WHEN TYPENAME='TIMESTMP' THEN 93     WHEN TYPENAME='DATALINK' THEN -400     ELSE 0 END),  CAST( CASE     WHEN TYPENAME='INTEGER' THEN 'INTEGER'     WHEN TYPENAME='SMALLINT' THEN 'SMALLINT'     WHEN TYPENAME='BIGINT' THEN 'BIGINT'     WHEN TYPENAME='FLOAT' AND LENGTH=4 THEN 'REAL'     WHEN TYPENAME='FLOAT' AND LENGTH=8 THEN 'DOUBLE'     WHEN TYPENAME='REAL' THEN 'REAL'     WHEN TYPENAME='DOUBLE' THEN 'DOUBLE'     WHEN TYPENAME='CHARACTER' AND CODEPAGE <> 0 THEN 'CHAR'     WHEN TYPENAME='CHARACTER' AND CODEPAGE = 0 THEN 'CHAR () FOR BIT DATA'     WHEN TYPENAME='VARCHAR' AND CODEPAGE <> 0 THEN 'VARCHAR'     WHEN TYPENAME='VARCHAR' AND CODEPAGE = 0 THEN 'VARCHAR () FOR BIT DATA'     WHEN TYPENAME='LONGVAR' AND CODEPAGE <> 0 THEN 'LONG VARCHAR'     WHEN TYPENAME='LONGVAR' AND CODEPAGE = 0 THEN 'LONG VARCHAR FOR BIT DATA'     WHEN TYPENAME='DECIMAL' THEN 'DECIMAL'     WHEN TYPENAME='GRAPHIC' THEN 'GRAPHIC'     WHEN TYPENAME='VARG' THEN 'VARGRAPHIC'     WHEN TYPENAME='LONGVARG' THEN 'LONG VARGRAPHIC'     WHEN TYPENAME='BLOB' THEN 'BLOB'     WHEN TYPENAME='CLOB' THEN 'CLOB'     WHEN TYPENAME='DBCLOB' THEN 'DBCLOB'     WHEN TYPENAME='DATE' THEN 'DATE'     WHEN TYPENAME='TIME' THEN 'TIME'     WHEN TYPENAME='TIMESTMP' THEN 'TIMESTAMP'     WHEN TYPENAME='DATALINK' THEN 'DATALINK'     ELSE TYPENAME END AS VARCHAR(261) ),  CASE     WHEN TYPENAME='INTEGER' THEN 10     WHEN TYPENAME='SMALLINT' THEN 5     WHEN TYPENAME='BIGINT' THEN 19     WHEN TYPENAME='FLOAT' AND LENGTH=4 THEN 7     WHEN TYPENAME='FLOAT' AND LENGTH=8 THEN 15     WHEN TYPENAME='REAL' THEN 7     WHEN TYPENAME='DOUBLE' THEN 15     WHEN TYPENAME='CHARACTER' THEN LENGTH     WHEN TYPENAME='VARCHAR' THEN LENGTH     WHEN TYPENAME='LONGVAR' THEN LENGTH     WHEN TYPENAME='DECIMAL' THEN LENGTH     WHEN TYPENAME='GRAPHIC' THEN LENGTH     WHEN TYPENAME='VARG' THEN LENGTH     WHEN TYPENAME='LONGVARG' THEN LENGTH     WHEN TYPENAME='BLOB' THEN LENGTH     WHEN TYPENAME='CLOB' THEN LENGTH     WHEN TYPENAME='DBCLOB' THEN LENGTH     WHEN TYPENAME='DATE' THEN 10     WHEN TYPENAME='TIME' THEN 8     WHEN TYPENAME='TIMESTMP' THEN 26     ELSE LENGTH END, CASE     WHEN TYPENAME='INTEGER' THEN 4     WHEN TYPENAME='SMALLINT' THEN 2     WHEN TYPENAME='BIGINT' THEN 8     WHEN TYPENAME='FLOAT' AND LENGTH=4 THEN 4     WHEN TYPENAME='FLOAT' AND LENGTH=8 THEN 8     WHEN TYPENAME='REAL' THEN 4     WHEN TYPENAME='DOUBLE' THEN 8     WHEN TYPENAME='CHARACTER' THEN LENGTH     WHEN TYPENAME='VARCHAR' THEN LENGTH     WHEN TYPENAME='LONGVAR' THEN LENGTH     WHEN TYPENAME='DECIMAL' THEN LENGTH + 2     WHEN TYPENAME='GRAPHIC' THEN LENGTH * 2     WHEN TYPENAME='VARG' THEN LENGTH * 2     WHEN TYPENAME='LONGVARG' THEN LENGTH * 2     WHEN TYPENAME='BLOB' THEN LENGTH     WHEN TYPENAME='CLOB' THEN LENGTH     WHEN TYPENAME='DBCLOB' THEN LENGTH * 2     WHEN TYPENAME='DATE' THEN 6     WHEN TYPENAME='TIME' THEN 6     WHEN TYPENAME='TIMESTMP' THEN 16     ELSE LENGTH END, CASE     WHEN TYPENAME='DECIMAL' THEN SCALE     WHEN TYPENAME='INTEGER' THEN 0     WHEN TYPENAME='SMALLINT' THEN 0     WHEN TYPENAME='BIGINT' THEN 0     WHEN TYPENAME='TIMESTMP' THEN 6     ELSE NULL END,          CASE     WHEN TYPENAME='DECIMAL' THEN 10     WHEN TYPENAME='INTEGER' THEN 10     WHEN TYPENAME='SMALLINT' THEN 10     WHEN TYPENAME='BIGINT' THEN 10     WHEN TYPENAME='REAL' THEN 10     WHEN TYPENAME='FLOAT' THEN 10     WHEN TYPENAME='DOUBLE' THEN 10     ELSE NULL END, CASE WHEN NULLS='Y' THEN 1 ELSE 0 END, REMARKS, CAST( NULL AS VARCHAR(254) ), CASE     WHEN TYPENAME='INTEGER' THEN 4     WHEN TYPENAME='SMALLINT' THEN 5     WHEN TYPENAME='BIGINT' THEN -5     WHEN TYPENAME='FLOAT' AND LENGTH=4 THEN 7     WHEN TYPENAME='FLOAT' AND LENGTH=8 THEN 8     WHEN TYPENAME='REAL' THEN 7     WHEN TYPENAME='DOUBLE' THEN 8     WHEN TYPENAME='CHARACTER' THEN 1     WHEN TYPENAME='VARCHAR' THEN 12     WHEN TYPENAME='LONGVAR' THEN -1     WHEN TYPENAME='DECIMAL' THEN 3     WHEN TYPENAME='GRAPHIC' THEN -95     WHEN TYPENAME='VARG' THEN -96     WHEN TYPENAME='LONGVARG' THEN -97     WHEN TYPENAME='BLOB' THEN -98     WHEN TYPENAME='CLOB' THEN -99     WHEN TYPENAME='DBCLOB' THEN -350     WHEN TYPENAME='DATE' THEN 9     WHEN TYPENAME='TIME' THEN 9     WHEN TYPENAME='TIMESTMP' THEN 9     ELSE 0 END,  CASE     WHEN TYPENAME='DATE' THEN 1     WHEN TYPENAME='TIME' THEN 2     WHEN TYPENAME='TIMESTMP' THEN 3     ELSE NULL END, CASE     WHEN TYPENAME='CHARACTER' THEN LENGTH     WHEN TYPENAME='VARCHAR' THEN LENGTH     WHEN TYPENAME='LONGVAR' THEN LENGTH     WHEN TYPENAME='GRAPHIC' THEN LENGTH * 2     WHEN TYPENAME='VARG' THEN LENGTH * 2     WHEN TYPENAME='LONGVARG' THEN LENGTH * 2     WHEN TYPENAME='BLOB' THEN LENGTH     WHEN TYPENAME='CLOB' THEN LENGTH     WHEN TYPENAME='DBCLOB' THEN LENGTH * 2     ELSE NULL END, ORDINAL, CASE WHEN NULLS='Y' THEN 'YES' ELSE 'NO' END,  SMALLINT( CASE   WHEN TYPENAME='INTEGER' THEN 4   WHEN TYPENAME='SMALLINT' THEN 5   WHEN TYPENAME='BIGINT' THEN -5   WHEN TYPENAME='FLOAT' AND LENGTH=4 THEN 7    WHEN TYPENAME='FLOAT' AND LENGTH=8 THEN 8   WHEN TYPENAME='REAL' THEN 7   WHEN TYPENAME='DOUBLE' THEN 8   WHEN TYPENAME='CHAR' AND CODEPAGE <> 0 then 1   WHEN TYPENAME='CHAR' AND CODEPAGE = 0 then -2   WHEN TYPENAME='VARCHAR' AND CODEPAGE <> 0 THEN 12   WHEN TYPENAME='VARCHAR' AND CODEPAGE = 0 THEN -3   WHEN TYPENAME='LONGVAR' AND CODEPAGE <> 0 THEN -1   WHEN TYPENAME='LONGVAR' AND CODEPAGE = 0 THEN -4   WHEN TYPENAME='DECIMAL' THEN 3   WHEN TYPENAME='GRAPHIC' THEN 1   WHEN TYPENAME='VARG' THEN 12   WHEN TYPENAME='LONGVARG' THEN -1   WHEN TYPENAME='BLOB' THEN 2004   WHEN TYPENAME='CLOB' THEN 2005   WHEN TYPENAME='DBCLOB' THEN 2005   WHEN TYPENAME='DATE' THEN 91   WHEN TYPENAME='TIME' THEN 92   WHEN TYPENAME='TIMESTMP' THEN 93   ELSE 0 END) FROM     SYSIBM.SYSPROCPARMS PARM, SYSIBM.SYSPROCEDURES PROC WHERE     PARM.PROCSCHEMA = PROC.PROCSCHEMA     AND PARM.PROCNAME = PROC.PROCNAME;

CREATE VIEW PARAMETERS (SPECIFIC_CATALOG, SPECIFIC_SCHEMA, SPECIFIC_NAME, ORDINAL_POSITION, PARAMETER_MODE, IS_RESULT, AS_LOCATOR, PARAMETER_NAME, FROM_SQL_SPECIFIC_CATALOG, FROM_SQL_SPECIFIC_SCHEMA, FROM_SQL_SPECIFIC_NAME, TO_SQL_SPECIFIC_CATALOG, TO_SQL_SPECIFIC_SCHEMA, TO_SQL_SPECIFIC_NAME, DATA_TYPE, CHARACTER_MAXIMUM_LENGTH, CHARACTER_OCTET_LENGTH, CHARACTER_SET_CATALOG, CHARACTER_SET_SCHEMA, CHARACTER_SET_NAME, COLLATION_CATALOG, COLLATION_SCHEMA, COLLATION_NAME, NUMERIC_PRECISION, NUMERIC_PRECISION_RADIX, NUMERIC_SCALE, DATETIME_PRECISION, INTERVAL_TYPE, INTERVAL_PRECISION, UDT_CATALOG, UDT_SCHEMA, UDT_NAME, SCOPE_CATALOG, SCOPE_SCHEMA, SCOPE_NAME, MAXIMUM_CARDINALITY, DTD_IDENTIFIER) AS
 WITH FROM_SQL(FROM_CATALOG, FROM_SCHEMA, FROM_NAME, FROM_GRPNAME,          FROM_ROUTINE_ID) AS  ( SELECT CURRENT SERVER, R.ROUTINESCHEMA, R.SPECIFICNAME, P.TRANSFORM_GRPNAME,          R.ROUTINE_ID     FROM SYSIBM.SYSROUTINEPARMS P,          SYSIBM.SYSROUTINES R,          SYSIBM.SYSTRANSFORMS T WHERE  P.TRANSFORM_GRPNAME = T.GROUPNAME   AND  T.FROMSQL_FUNCID = R.ROUTINE_ID ) SELECT CAST(CURRENT SERVER AS  VARCHAR(128)),        ROUTINESCHEMA, SPECIFICNAME,         CASE ROWTYPE WHEN 'P'      THEN CAST(ORDINAL AS  INTEGER)                   WHEN 'B'      THEN CAST(ORDINAL AS  INTEGER)                  WHEN 'O'   THEN  CAST(ORDINAL AS  INTEGER)         END,         CASE ROWTYPE                 WHEN 'P'        THEN 'IN'                 WHEN 'O'        THEN 'OUT'                 WHEN 'B'        THEN 'INOUT'         END,         'NO',         CASE P.LOCATOR                  WHEN 'Y'       THEN 'YES'                  WHEN 'N'       THEN 'NO'         END,         PARMNAME,         CASE                  WHEN P.ROWTYPE='P'  AND (P.ROUTINETYPE ='F' OR P.ROUTINETYPE='M')                                         THEN CAST(FROM_CATALOG AS  VARCHAR(128))                   ELSE CAST(NULL AS  VARCHAR(128))         END,         CASE              WHEN P.ROWTYPE='P'  AND (P.ROUTINETYPE ='F' OR P.ROUTINETYPE='M')                                         THEN  FROM_SCHEMA                   ELSE CAST(NULL AS  VARCHAR(128))         END,         CASE              WHEN P.ROWTYPE='P'  AND (P.ROUTINETYPE ='F' OR P.ROUTINETYPE='M')                                         THEN CAST(FROM_NAME AS  VARCHAR(128))                   ELSE CAST(NULL AS  VARCHAR(128))         END,         CAST(NULL AS  VARCHAR(128)),         CAST(NULL AS  VARCHAR(128)),         CAST(NULL AS  VARCHAR(128)), CASE                WHEN P.TYPENAME='CHARACTER'       THEN 'CHARACTER'                WHEN P.TYPENAME='VARCHAR'         THEN 'CHARACTER VARYING'                WHEN P.TYPENAME='LONG VARCHAR'    THEN 'LONG VARCHAR'                WHEN P.TYPENAME='INTEGER'         THEN 'INTEGER'                WHEN P.TYPENAME='SMALLINT'        THEN 'SMALLINT'                WHEN P.TYPENAME='BIGINT'          THEN 'BIGINT'                WHEN P.TYPENAME='REAL'            THEN 'REAL'                WHEN P.TYPENAME='DOUBLE'          THEN 'DOUBLE PRECISION'                WHEN P.TYPENAME='DECIMAL'         THEN 'DECIMAL'                WHEN P.TYPENAME='BLOB'            THEN 'BINARY LARGE OBJECT'                WHEN P.TYPENAME='CLOB'            THEN 'CHARACTER LARGE OBJECT'                WHEN P.TYPENAME='DBCLOB'          THEN 'DOUBLE-BYTE CHARACTER LARGE OBJECT'                WHEN P.TYPENAME='GRAPHIC'         THEN 'GRAPHIC'                WHEN P.TYPENAME='VARGRAPHIC'      THEN 'GRAPHIC VARYING'                WHEN P.TYPENAME='LONG VARGRAPHIC' THEN 'LONG VARGRAPHIC'                WHEN P.TYPENAME='DATALINK'        THEN 'DATALINK'                WHEN P.TYPENAME='TIME'            THEN 'TIME'                WHEN P.TYPENAME='DATE'            THEN 'DATE'                WHEN P.TYPENAME='TIMESTAMP'       THEN 'TIMESTAMP'                WHEN P.TYPENAME='REFERENCE'       THEN 'REF'                WHEN P.TYPESCHEMA<>'SYSIBM'       THEN 'USER-DEFINED'                ELSE P.TYPENAME             END, CASE                WHEN P.TYPENAME IN                        ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB'  ,                         'GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                   THEN P.LENGTH                WHEN P.TYPENAME='BLOB'            THEN P.LENGTH                WHEN P.TYPENAME='REFERENCE'       THEN P.LENGTH                ELSE  CAST(NULL AS  INTEGER)             END,             CASE                WHEN P.TYPENAME IN                        ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB')                                                   THEN P.LENGTH                WHEN P.TYPENAME IN                        ('GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                                                  THEN P.LENGTH * 2                WHEN P.TYPENAME='BLOB'            THEN P.LENGTH                WHEN P.TYPENAME='REFERENCE'       THEN P.LENGTH                ELSE CAST(NULL AS  INTEGER)             END,             CASE                WHEN P.TYPENAME IN                        ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB'  ,                         'GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                   THEN CAST(CURRENT SERVER AS  VARCHAR(128))                ELSE CAST(NULL AS  VARCHAR(128))             END,             CASE                WHEN P.TYPENAME IN                        ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB'  ,                         'GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                   THEN CAST('SYSIBM' AS  VARCHAR(128))                ELSE CAST(NULL AS  VARCHAR(128)) END,             CASE                WHEN P.TYPENAME IN                        ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB'  ,                         'GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                   THEN CAST(CONCAT('IBM', CHAR(P.CODEPAGE)) AS  VARCHAR(128))                ELSE CAST(NULL AS  VARCHAR(128))             END,             CASE                WHEN P.TYPENAME IN                        ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB'  ,                         'GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                   THEN CAST(CURRENT SERVER AS  VARCHAR(128))                ELSE CAST(NULL AS  VARCHAR(128))             END,             CASE                WHEN P.TYPENAME IN                        ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB'  ,                         'GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                   THEN CAST('SYSIBM' AS  VARCHAR(128))                ELSE CAST(NULL AS  VARCHAR(128))             END,             CASE                WHEN P.TYPENAME IN                        ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB'  ,                         'GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                   THEN CAST('IBMDEFAULT' AS  VARCHAR(128))                ELSE CAST(NULL AS  VARCHAR(128))             END,             CASE P.TYPENAME                WHEN 'INTEGER'      THEN 10                WHEN 'BIGINT'       THEN 19                WHEN 'SMALLINT'     THEN 5                WHEN 'REAL'         THEN 24                WHEN 'DOUBLE'       THEN 53                WHEN 'DECIMAL'      THEN P.LENGTH ELSE CAST(NULL AS  INTEGER)             END,             CASE  P.TYPENAME                WHEN 'INTEGER'      THEN 10                WHEN 'BIGINT'       THEN 10                WHEN 'SMALLINT'     THEN 10                WHEN 'REAL'         THEN 2                WHEN 'DOUBLE'       THEN 2                WHEN 'DECIMAL'      THEN 10                ELSE CAST(NULL AS  INTEGER)             END,             CASE P.TYPENAME                WHEN 'DECIMAL'      THEN CAST(P.SCALE AS  INTEGER)                WHEN 'INTEGER'      THEN 0                WHEN 'SMALLINT'     THEN 0                ELSE CAST(NULL AS  INTEGER)             END,             CASE P.TYPENAME                WHEN 'DATE'         THEN 0                WHEN 'TIME'         THEN 0                WHEN 'TIMESTAMP'    THEN 6                ELSE CAST(NULL AS  INTEGER)             END,             CAST(NULL AS  VARCHAR(128)) ,             CAST(NULL AS  INTEGER) ,             CASE                WHEN P.TYPENAME = 'REFERENCE'                   THEN CAST(CURRENT SERVER AS  VARCHAR(128))                WHEN P.TYPESCHEMA <> 'SYSIBM'                   THEN CAST(CURRENT SERVER AS  VARCHAR(128))                ELSE CAST(NULL AS  VARCHAR(128))             END, CASE                WHEN P.TYPENAME = 'REFERENCE' THEN P.TARGET_TYPESCHEMA                WHEN P.TYPESCHEMA <> 'SYSIBM' THEN TYPESCHEMA                ELSE CAST(NULL AS  VARCHAR(128))             END ,             CASE                WHEN P.TYPENAME = 'REFERENCE'                   THEN CAST(P.TARGET_TYPENAME AS  VARCHAR(128))                WHEN P.TYPESCHEMA <> 'SYSIBM'                   THEN CAST(P.TYPENAME AS  VARCHAR(128))                ELSE CAST(NULL AS  VARCHAR(128))             END,             CASE                WHEN  P.TYPENAME ='REFERENCE' AND P.SCOPE_TABSCHEMA IS NOT NULL                   THEN CAST(CURRENT SERVER AS  VARCHAR(128))                ELSE CAST(NULL AS  VARCHAR(128))             END,             CASE WHEN  P.TYPENAME='REFERENCE' THEN P.SCOPE_TABSCHEMA                ELSE CAST(NULL AS  VARCHAR(128))             END,             CASE                WHEN  P.TYPENAME ='REFERENCE' THEN P.SCOPE_TABNAME                ELSE CAST(NULL AS  VARCHAR(128))             END,             CAST(NULL AS  INTEGER),             CAST(CONCAT('P',CONCAT(HEX(FROM_ROUTINE_ID),CONCAT(P.ROWTYPE,                HEX(P.ORDINAL)))) AS  VARCHAR(128)) FROM  SYSIBM.SYSROUTINEPARMS  P     LEFT OUTER JOIN              FROM_SQL    ON P.TRANSFORM_GRPNAME = FROM_SQL.FROM_GRPNAME WHERE P.ROWTYPE IN  ('P', 'O', 'B') AND P.ORDINAL > 0 AND FROM_SQL.FROM_SCHEMA <> 'SYSFUN';


 
CREATE VIEW WRAPOPTIONS (WRAPNAME, OPTION, SETTING) AS
select      wrapname, option, setting  from sysibm.syswrapoptions;

--CREATE VIEW HEART_TEST (AGE, SEX, PAIN_TYPE, BLOOD_PRESSURE, CHOLESTEROL, SUGAR, ECG, HEART_RATE, ANGINA, OLD_PEAK, SLOPE, NUM_VESSELS, THAL, DISEASED) AS
--SELECT * FROM HEART TABLESAMPLE SYSTEM(40) REPEATABLE(3);

CREATE VIEW SYSDUMMY1 (IBMREQD) AS
values (char('Y'));

CREATE VIEW XMLOBJECTAUTH (GRANTOR, GRANTEE, GRANTEETYPE, OBJECTID, PRIVILEGE_TYPE, IS_GRANTABLE) AS
select grantor,grantee,granteetype,objectid,privilege_type,  cast (case when is_grantable='N' then 'NO'  when is_grantable='Y' then 'YES' else is_grantable end as varchar(3))  from sysibm.sysxmlobjectauth;

CREATE VIEW FUNCDEP (FUNCSCHEMA, FUNCNAME, BTYPE, BSCHEMA, BNAME, TABAUTH) AS
select      dschema, dname, btype, bschema, bname, tabauth  from sysibm.sysdependencies  where dtype = 'F';

CREATE VIEW COLUMNS (TABSCHEMA, TABNAME, COLNAME, COLCARD, HIGH2KEY, LOW2KEY, AVGCOLLEN, NUMNULLS, SUB_COUNT, SUB_DELIM_LENGTH) AS
select        tbcreator, tbname, name, colcard, high2key, low2key,        avgcollen, numnulls, sub_count, sub_delim_length     from sysibm.syscolumns X     where( (source_tabschema = tbcreator and             source_tabname = tbname) or            (source_tabschema IS NULL and             source_tabname IS NULL) )       and exists              (select 1               from   sysibm.systables               where  name = X.tbname               and    creator = X.tbcreator               and    type not in ('A', 'V', 'W', 'H', 'K') )      and (exists             (select 1              from   sysibm.systabauth              where  ttname = X.tbname              and    tcreator = X.tbcreator              and    grantee = USER              and    controlauth = 'Y')          or exists             (select 1              from   sysibm.sysdbauth              where  grantee = USER              and    dbadmauth = 'Y') );

CREATE VIEW SQLUDTS (TYPE_CAT, TYPE_SCHEM, TYPE_NAME, CLASS_NAME, DATA_TYPE, BASE_TYPE, REMARKS) AS
   SELECT      CAST( NULL AS VARCHAR(128) ),     RTRIM(schema),     name,     CAST( CASE      WHEN sourcetype='INTEGER' THEN 'java.lang.Integer'      WHEN sourcetype='SMALLINT' THEN 'java.lang.Short'      WHEN sourcetype='BIGINT' THEN 'java.lang.Long'      WHEN sourcetype='FLOAT' AND b.length=4 THEN 'java.lang.Float'      WHEN sourcetype='FLOAT' AND b.length=8 THEN 'java.lang.Double'      WHEN sourcetype='CHARACTER' AND b.CODEPAGE <> 0 THEN 'java.lang.String'      WHEN sourcetype='CHARACTER' AND b.CODEPAGE = 0  THEN 'byte[]'      WHEN sourcetype='VARCHAR' AND b.CODEPAGE <> 0 THEN 'java.lang.String'      WHEN sourcetype='VARCHAR' AND b.CODEPAGE = 0 THEN 'byte[]'      WHEN sourcetype='DECIMAL' THEN 'java.math.BigDecimal'      WHEN sourcetype='NUMERIC' THEN 'java.math.BigDecimal'      WHEN sourcetype='GRAPHIC' THEN 'java.lang.String'      WHEN sourcetype='VARGRAPHIC'  THEN 'java.lang.String'      WHEN sourcetype='BLOB' THEN 'java.sql.Blob'      WHEN sourcetype='CLOB' THEN 'java.sql.Clob'      WHEN sourcetype='DBCLOB' THEN 'java.sql.Clob'      WHEN sourcetype='DATE' THEN 'java.sql.Date'      WHEN sourcetype='TIME' THEN 'java.sql.Time'      WHEN sourcetype='TIMESTAMP' THEN 'java.sql.Timestamp'      WHEN sourcetype='ROWID'   THEN 'byte[]'      WHEN sourcetype='DATALINK' THEN 'java.net.URL'      ELSE ''    END AS VARCHAR(30)),    SMALLINT( CASE      WHEN metatype='T' THEN 2001      WHEN metatype='R' THEN 2002    END),     SMALLINT(CASE       WHEN sourcetype='INTEGER'  THEN 4       WHEN sourcetype='SMALLINT' THEN 5      WHEN sourcetype='BIGINT' THEN -5      WHEN sourcetype='FLOAT' AND b.length=4 THEN 7      WHEN sourcetype='FLOAT' AND b.length=8 THEN 8      WHEN sourcetype='CHARACTER' AND b.CODEPAGE <> 0 THEN 1      WHEN sourcetype='CHARACTER' AND b.CODEPAGE = 0 THEN -2      WHEN sourcetype='VARCHAR' AND b.CODEPAGE <> 0 THEN 12      WHEN sourcetype='VARCHAR' AND b.CODEPAGE = 0 THEN -3      WHEN sourcetype='DECIMAL' THEN 3      WHEN sourcetype='NUMERIC' THEN 2      WHEN sourcetype='GRAPHIC' THEN 1      WHEN sourcetype='VARGRAPHIC' THEN 12      WHEN sourcetype='BLOB' THEN 2004      WHEN sourcetype='CLOB' THEN 2005      WHEN sourcetype='DBCLOB' THEN 2005      WHEN sourcetype='DATE' THEN 91      WHEN sourcetype='TIME' THEN 92      WHEN sourcetype='TIMESTAMP' THEN 93      WHEN sourcetype='ROWID' THEN 1111      WHEN sourcetype='DATALINK' THEN 70      ELSE 0    END),    remarks   FROM     SYSIBM.SYSDATATYPES B   WHERE     sourcetype IS NOT NULL;

CREATE VIEW BUFFERPOOLDBPARTITIONS (BUFFERPOOLID, DBPARTITIONNUM, NPAGES) AS
select      bufferpoolid, nodenum, npages  from sysibm.sysbufferpoolnodes;

CREATE VIEW COLIDENTATTRIBUTES (TABSCHEMA, TABNAME, COLNAME, START, INCREMENT, MINVALUE, MAXVALUE, CYCLE, CACHE, SEQID) AS
select       c.tbcreator, c.tbname, c.name, s.start,       s.increment, s.minvalue, s.maxvalue, s.cycle,       s.cache, s.seqid  from sysibm.syscolumns as c, sysibm.sysdependencies as d,       sysibm.syssequences as s  where c.tbcreator = d.dschema and        c.tbname = d.dname and        d.bname = s.seqname and        d.bschema = s.seqschema and        c.identity = 'Y' and        d.dtype = 'T' and        d.btype = 'Q' and        s.seqtype = 'I';

CREATE VIEW PROCPARMS (PROCSCHEMA, PROCNAME, SPECIFICNAME, SERVERNAME, ORDINAL, PARMNAME, TYPESCHEMA, TYPENAME, TYPEID, SOURCETYPEID, NULLS, LENGTH, SCALE, PARM_MODE, CODEPAGE, DBCS_CODEPAGE, AS_LOCATOR, TARGET_TYPESCHEMA, TARGET_TYPENAME, SCOPE_TABSCHEMA, SCOPE_TABNAME) AS
select      routineschema, routinename, specificname, cast(null as varchar(128)), ordinal,      parmname, typeschema, typename, typeid,      cast(null as smallint), cast ('Y' as char(1)),      length, scale,      CAST (CASE rowtype            WHEN 'P' THEN 'IN'            WHEN 'O' THEN 'OUT'            ELSE 'INOUT' END AS VARCHAR(5)),      codepage, cast(null as smallint), locator, target_typeschema, target_typename,      scope_tabschema, scope_tabname from sysibm.sysroutineparms where routinetype in ('P');

CREATE VIEW COLUSE (TABSCHEMA, TABNAME, COLNAME, DIMENSION, COLSEQ, TYPE) AS
select      tabschema, tabname, colname, dimension, colseq, type  from sysibm.syscoluse;

CREATE VIEW EVENTMONITORS (EVMONNAME, DEFINER, TARGET_TYPE, TARGET, MAXFILES, MAXFILESIZE, BUFFERSIZE, IO_MODE, WRITE_MODE, AUTOSTART, DBPARTITIONNUM, REMARKS, MONSCOPE, EVMON_ACTIVATES, NODENUM) AS
select      name, definer, target_type, target, maxfiles,      maxfilesize, buffersize, io_mode, write_mode, autostart,      nodenum, remarks, monscope, evmon_activates, nodenum from sysibm.syseventmonitors;

CREATE VIEW TABDEP (TABSCHEMA, TABNAME, DTYPE, DEFINER, BTYPE, BSCHEMA, BNAME, TABAUTH) AS
select      dcreator, dname, dtype, vcauthid, btype, bcreator, bname,      tabauth  from sysibm.sysviewdep;

CREATE VIEW REVTYPEMAPPINGS (TYPE_MAPPING, TYPESCHEMA, TYPENAME, TYPEID, SOURCETYPEID, DEFINER, LOWER_LEN, UPPER_LEN, LOWER_SCALE, UPPER_SCALE, S_OPR_P, BIT_DATA, WRAPNAME, SERVERNAME, SERVERTYPE, SERVERVERSION, REMOTE_TYPESCHEMA, REMOTE_TYPENAME, REMOTE_META_TYPE, REMOTE_LENGTH, REMOTE_SCALE, REMOTE_BIT_DATA, USER_DEFINED, CREATE_TIME, REMARKS) AS
select      type_mapping, typeschema, typename, typeid, sourcetypeid,      definer, lower_len, upper_len, lower_scale, upper_scale,      s_opr_p, bit_data, wrapname,      servername, servertype, serverversion, remote_typeschema,      remote_typename, remote_meta_type, remote_lower_len,      remote_lower_scale,      remote_bit_data, user_defined, create_time,      remarks  from sysibm.systypemappings;

CREATE VIEW VIEWDEP (VIEWSCHEMA, VIEWNAME, DTYPE, DEFINER, BTYPE, BSCHEMA, BNAME, TABAUTH) AS
select      dcreator, dname, dtype, vcauthid, btype, bcreator, bname,      tabauth  from sysibm.sysviewdep;

CREATE VIEW TABLESPACES (TBSPACE, DEFINER, CREATE_TIME, TBSPACEID, TBSPACETYPE, DATATYPE, EXTENTSIZE, PREFETCHSIZE, OVERHEAD, TRANSFERRATE, PAGESIZE, DBPGNAME, BUFFERPOOLID, DROP_RECOVERY, REMARKS, NGNAME) AS
select      tbspace, definer, create_time, tbspaceid, tbspacetype,      datatype, extentsize, prefetchsize, overhead, transferrate,      pagesize, ngname, bufferpoolid, drop_recovery, remarks, ngname  from sysibm.systablespaces;

CREATE VIEW DBPARTITIONGROUPDEF (DBPGNAME, DBPARTITIONNUM, IN_USE) AS
select      ngname, nodenum, in_use  from sysibm.sysnodegroupdef;

CREATE VIEW COLGROUPDISTCOUNTS (COLGROUPID, TYPE, SEQNO, VALCOUNT, DISTCOUNT) AS
select      colgroupid, type, seqno, valcount, distcount  from sysibm.syscolgroupdistcounts;

CREATE VIEW FUNCMAPPINGS (FUNCTION_MAPPING, FUNCSCHEMA, FUNCNAME, FUNCID, SPECIFICNAME, DEFINER, WRAPNAME, SERVERNAME, SERVERTYPE, SERVERVERSION, CREATE_TIME, REMARKS) AS
select      function_mapping, funcschema, funcname, funcid,      specificname, definer, wrapname, servername, servertype,      serverversion, create_time, remarks  from sysibm.sysfuncmappings;

CREATE VIEW COLGROUPCOLS (COLGROUPID, COLNAME, TABSCHEMA, TABNAME, ORIDNAL) AS
select      colgroupid, colname, tabschema, tabname, ordinal  from sysibm.syscolgroupscols;

CREATE VIEW XMLOBJECTS (OBJECTID, OBJECTTYPE, DEFINER, CREATE_TIME, ALTER_TIME, LINKS_COUNT) AS
select objectid,objecttype,definer,create_time,alter_time,links_count  from sysibm.sysxmlobjects;

CREATE VIEW INDEXEXTENSIONDEP (IESCHEMA, IENAME, BTYPE, BSCHEMA, BNAME, TABAUTH) AS
select      dschema, dname, btype, bschema, bname, tabauth   from sysibm.sysdependencies  where dtype = 'X';

CREATE VIEW COLUMNS (TABSCHEMA, TABNAME, COLNAME, COLNO, TYPESCHEMA, TYPENAME, LENGTH, SCALE, DEFAULT, NULLS, CODEPAGE, LOGGED, COMPACT, COLCARD, HIGH2KEY, LOW2KEY, AVGCOLLEN, KEYSEQ, PARTKEYSEQ, NQUANTILES, NMOSTFREQ, NUMNULLS, TARGET_TYPESCHEMA, TARGET_TYPENAME, SCOPE_TABSCHEMA, SCOPE_TABNAME, SOURCE_TABSCHEMA, SOURCE_TABNAME, DL_FEATURES, SPECIAL_PROPS, HIDDEN, INLINE_LENGTH, IDENTITY, GENERATED, TEXT, REMARKS, COMPRESS, AVGDISTINCTPERPAGE, PAGEVARIANCERATIO, SUB_COUNT, SUB_DELIM_LENGTH) AS
select      c.tbcreator, c.tbname, c.name, c.colno, c.typeschema,      c.typename, c.longlength, c.scale, c.default, c.nulls,      c.composite_codepage, c.logged, c.compact, c.colcard,      c.high2key, c.low2key, c.avgcollen,      c.keyseq, c.partkeyseq, c.nquantiles, c.nmostfreq,      c.numnulls,      (select p.target_typeschema       from sysibm.syscolproperties p       where c.tbcreator = p.tabschema         and c.tbname = p.tabname         and c.name = p.colname),      (select p.target_typename       from sysibm.syscolproperties p       where c.tbcreator = p.tabschema         and c.tbname = p.tabname         and c.name = p.colname),      (select p.scope_tabschema       from sysibm.syscolproperties p       where c.tbcreator = p.tabschema         and c.tbname = p.tabname         and c.name = p.colname),      (select p.scope_tabname       from sysibm.syscolproperties p       where c.tbcreator = p.tabschema         and c.tbname = p.tabname         and c.name = p.colname),      c.source_tabschema, c.source_tabname,      case         when c.coltype = 'DATALINK' or              c.coltype = 'DISTINCT' then           (select p.dl_features            from sysibm.syscolproperties p            where c.tbcreator = p.tabschema              and c.tbname = p.tabname              and c.name = p.colname)         else null      end,      case         when c.coltype = 'REF' then         (select p.special_props           from sysibm.syscolproperties p            where c.tbcreator = p.tabschema              and c.tbname = p.tabname              and c.name = p.colname)         else null      end,      c.hidden, c.inline_length, c.identity, c.generated,      case         when c.generated = ' ' then null         else           (select case                      when posstr(ch.text, ' =  ') = 0                           then ch.text                      else 'AS' concat                           substr(ch.text,                                  posstr(ch.text, ' =  ') + 3)                   end            from sysibm.syschecks ch, sysibm.syscolchecks cc            where c.tbcreator = cc.tbcreator              and c.tbname = cc.tbname              and c.name = cc.colname              and cc.usage = 'T'              and cc.constname = ch.name              and cc.tbcreator = ch.tbcreator              and cc.tbname = ch.tbname)      end,      c.remarks, c.compress, c.avgdistinctperpage, c.pagevarianceratio,      sub_count, sub_delim_length  from sysibm.syscolumns c;

CREATE VIEW PROCPARMOPTIONS (PROCSCHEMA, PROCNAME, ORDINAL, OPTION, SETTING) AS
select      procschema, procname, ordinal, option, setting  from sysibm.sysprocparmoptions;

CREATE VIEW COLGROUPDISTCOUNTS (COLGROUPID, TYPE, SEQNO, VALCOUNT, DISTCOUNT) AS
select      colgroupid, type, seqno, valcount, distcount  from sysibm.syscolgroupdistcounts;

CREATE VIEW TYPEMAPPINGS (TYPE_MAPPING, TYPESCHEMA, TYPENAME, TYPEID, SOURCETYPEID, DEFINER, LENGTH, SCALE, BIT_DATA, WRAPNAME, SERVERNAME, SERVERTYPE, SERVERVERSION, REMOTE_TYPESCHEMA, REMOTE_TYPENAME, REMOTE_META_TYPE, REMOTE_LOWER_LEN, REMOTE_UPPER_LEN, REMOTE_LOWER_SCALE, REMOTE_UPPER_SCALE, REMOTE_S_OPR_P, REMOTE_BIT_DATA, USER_DEFINED, CREATE_TIME, REMARKS, UPPER_LEN, UPPER_SCALE, LOWER_LEN, LOWER_SCALE, MAPPINGDIRECTION, S_OPR_P) AS
select      type_mapping, typeschema, typename, typeid, sourcetypeid,      definer, upper_len, upper_scale,      bit_data, wrapname,      servername, servertype, serverversion, remote_typeschema,      remote_typename, remote_meta_type, remote_lower_len,      remote_upper_len, remote_lower_scale, remote_upper_scale,      remote_s_opr_p, remote_bit_data, user_defined, create_time,      remarks, upper_len, upper_scale, lower_len, lower_scale,      mappingdirection, s_opr_p  from sysibm.systypemappings;

CREATE VIEW INDEXES (INDSCHEMA, INDNAME, TABSCHEMA, TABNAME, COLNAMES, NLEAF, NLEVELS, FIRSTKEYCARD, FIRST2KEYCARD, FIRST3KEYCARD, FIRST4KEYCARD, FULLKEYCARD, CLUSTERRATIO, CLUSTERFACTOR, SEQUENTIAL_PAGES, DENSITY, PAGE_FETCH_PAIRS, NUMRIDS, NUMRIDS_DELETED, NUM_EMPTY_LEAFS, AVERAGE_RANDOM_FETCH_PAGES, AVERAGE_RANDOM_PAGES, AVERAGE_SEQUENCE_GAP, AVERAGE_SEQUENCE_FETCH_GAP, AVERAGE_SEQUENCE_PAGES, AVERAGE_SEQUENCE_FETCH_PAGES) AS
select        creator, name, tbcreator, tbname, colnames, nleaf,        nlevels, firstkeycard, first2keycard, first3keycard,        first4keycard, fullkeycard, clusterratio, clusterfactor,        sequential_pages, density, page_fetch_pairs,        numrids, numrids_deleted, num_empty_leafs,        average_random_fetch_pages, average_random_pages,        average_sequence_gap, average_sequence_fetch_gap,        average_sequence_pages, average_sequence_fetch_pages     from sysibm.sysindexes X     where x.entrytype <> 'H'     and (exists           (select 1            from   sysibm.sysindexauth            where  creator = X.creator            and    name = X.name            and    grantee = USER            and    controlauth = 'Y' )       or exists           (select 1            from   sysibm.sysdbauth            where  grantee = USER            and    dbadmauth = 'Y') );

CREATE VIEW XLICOLUMNS (TABLE_CAT, TABLE_SCHEM, TABLE_NAME, COLUMN_NAME, DATA_TYPE, TYPE_NAME, COLUMN_SIZE, BUFFER_LENGTH, DECIMAL_DIGITS, NUM_PREC_RADIX, NULLABLE, REMARKS, COLUMN_DEF, SQL_DATA_TYPE, SQL_DATETIME_SUB, CHAR_OCTET_LENGTH, ORDINAL_POSITION, IS_NULLABLE, JDBC_DATA_TYPE, SCOPE_CATLOG, SCOPE_SCHEMA, SCOPE_TABLE, SOURCE_DATA_TYPE, DBNAME, PSEUDO_COLUMN) AS
 WITH TYPEINTS ( TYPEINT, COLTYPE ) AS  (  VALUES  ( SMALLINT(1 ), CHAR( 'INTEGER',  8) ),  ( SMALLINT(2 ), CHAR( 'SMALLINT', 8) ),  ( SMALLINT(3 ), CHAR( 'BIGINT',   8) ),  ( SMALLINT(4 ), CHAR( 'REAL',     8) ),  ( SMALLINT(5 ), CHAR( 'DOUBLE',   8) ),  ( SMALLINT(6 ), CHAR( 'CHAR',     8) ),  ( SMALLINT(7 ), CHAR( 'VARCHAR',  8) ),  ( SMALLINT(8 ), CHAR( 'LONGVAR',  8) ),  ( SMALLINT(9 ), CHAR( 'DECIMAL',  8) ),  ( SMALLINT(10), CHAR( 'GRAPHIC',  8) ),  ( SMALLINT(11), CHAR( 'VARGRAPH', 8) ),  ( SMALLINT(12), CHAR( 'LONGVARG', 8) ),  ( SMALLINT(13), CHAR( 'BLOB',     8) ),  ( SMALLINT(14), CHAR( 'CLOB',     8) ),  ( SMALLINT(15), CHAR( 'DBCLOB',   8) ),  ( SMALLINT(16), CHAR( 'DATE',     8) ),  ( SMALLINT(17), CHAR( 'TIME',     8) ),  ( SMALLINT(18), CHAR( 'TIMESTMP', 8) ),  ( SMALLINT(19), CHAR( 'DATALINK', 8) ),  ( SMALLINT(20), CHAR( 'STRUCT',   8) ),  ( SMALLINT(21), CHAR( 'DISTINCT', 8) ),  ( SMALLINT(22), CHAR( 'REF',      8) ) )   SELECT CAST( NULL AS  VARCHAR(128) ), RTRIM(C.TBCREATOR), C.TBNAME, C.NAME, SMALLINT( CASE   WHEN I.TYPEINT=1 THEN 4   WHEN I.TYPEINT=2 THEN 5   WHEN I.TYPEINT=3 THEN -5   WHEN I.TYPEINT=4 THEN 7   WHEN I.TYPEINT=5 THEN 8    WHEN I.TYPEINT=6 AND C.CODEPAGE <> 0 then 1   WHEN I.TYPEINT=6 AND C.CODEPAGE = 0 then -2   WHEN I.TYPEINT=7 AND C.CODEPAGE <> 0 THEN 12   WHEN I.TYPEINT=7 AND C.CODEPAGE = 0 THEN -3   WHEN I.TYPEINT=8 AND C.CODEPAGE <> 0 THEN -1   WHEN I.TYPEINT=8 AND C.CODEPAGE = 0 THEN -4   WHEN I.TYPEINT=9 THEN 3   WHEN I.TYPEINT=10 THEN -95   WHEN I.TYPEINT=11 THEN -96   WHEN I.TYPEINT=12 THEN -97   WHEN I.TYPEINT=13 THEN -98   WHEN I.TYPEINT=14 THEN -99   WHEN I.TYPEINT=15 THEN -350   WHEN I.TYPEINT=16 THEN 91   WHEN I.TYPEINT=17 THEN 92   WHEN I.TYPEINT=18 THEN 93   WHEN I.TYPEINT=19 THEN -400   WHEN I.TYPEINT=20 THEN 17   WHEN I.TYPEINT=21 THEN 17   ELSE 0 END),  CAST( CASE   WHEN I.TYPEINT=1 THEN 'INTEGER'   WHEN I.TYPEINT=2 THEN 'SMALLINT'   WHEN I.TYPEINT=3 THEN 'BIGINT'   WHEN I.TYPEINT=4 THEN 'REAL'   WHEN I.TYPEINT=5 THEN 'DOUBLE'   WHEN I.TYPEINT=6 AND C.CODEPAGE <> 0 THEN 'CHAR'   WHEN I.TYPEINT=6 AND C.CODEPAGE = 0 THEN 'CHAR () FOR BIT DATA'   WHEN I.TYPEINT=7 AND C.CODEPAGE <> 0 THEN 'VARCHAR'   WHEN I.TYPEINT=7 AND C.CODEPAGE = 0 THEN 'VARCHAR () FOR BIT DATA'   WHEN I.TYPEINT=8 AND C.CODEPAGE <> 0 THEN 'LONG VARCHAR'   WHEN I.TYPEINT=8 AND C.CODEPAGE = 0 THEN 'LONG VARCHAR FOR BIT DATA'   WHEN I.TYPEINT=9 THEN 'DECIMAL'   WHEN I.TYPEINT=10 THEN 'GRAPHIC'   WHEN I.TYPEINT=11 THEN 'VARGRAPHIC'   WHEN I.TYPEINT=12 THEN 'LONG VARGRAPHIC'   WHEN I.TYPEINT=13 THEN 'BLOB'   WHEN I.TYPEINT=14 THEN 'CLOB'   WHEN I.TYPEINT=15 THEN 'DBCLOB'   WHEN I.TYPEINT=16 THEN 'DATE'   WHEN I.TYPEINT=17 THEN 'TIME'   WHEN I.TYPEINT=18 THEN 'TIMESTAMP'   WHEN I.TYPEINT=19 THEN 'DATALINK'   WHEN I.TYPEINT=20 THEN '"' || RTRIM(D.SCHEMA) || '"."' || D.NAME || '"'   WHEN I.TYPEINT=21 THEN '"' || RTRIM(D.SCHEMA) || '"."' || D.NAME || '"'   ELSE '' END AS  VARCHAR(261) ),  CASE   WHEN I.TYPEINT=1 THEN 10   WHEN I.TYPEINT=2 THEN 5   WHEN I.TYPEINT=3 THEN 19   WHEN I.TYPEINT=4 THEN 24   WHEN I.TYPEINT=5 THEN 53   WHEN I.TYPEINT=6 THEN C.LENGTH   WHEN I.TYPEINT=7 THEN C.LENGTH   WHEN I.TYPEINT=8 THEN C.LENGTH   WHEN I.TYPEINT=9 THEN C.LENGTH   WHEN I.TYPEINT=10 THEN C.LENGTH   WHEN I.TYPEINT=11 THEN C.LENGTH   WHEN I.TYPEINT=12 THEN C.LENGTH   WHEN I.TYPEINT=13 THEN C.LONGLENGTH   WHEN I.TYPEINT=14 THEN C.LONGLENGTH   WHEN I.TYPEINT=15 THEN C.LONGLENGTH   WHEN I.TYPEINT=16 THEN 10   WHEN I.TYPEINT=17 THEN 8    WHEN I.TYPEINT=18 THEN 26    WHEN I.TYPEINT=20 THEN D.LENGTH   WHEN I.TYPEINT=21 THEN D.LENGTH   ELSE C.LENGTH END,  CASE   WHEN I.TYPEINT=1 THEN 4   WHEN I.TYPEINT=2 THEN 2   WHEN I.TYPEINT=3 THEN 8   WHEN I.TYPEINT=4 THEN 4   WHEN I.TYPEINT=5 THEN 8   WHEN I.TYPEINT=6 THEN C.LENGTH   WHEN I.TYPEINT=7 THEN C.LENGTH   WHEN I.TYPEINT=8 THEN C.LENGTH   WHEN I.TYPEINT=9 THEN C.LENGTH + 2   WHEN I.TYPEINT=10 THEN C.LENGTH * 2   WHEN I.TYPEINT=11 THEN C.LENGTH * 2   WHEN I.TYPEINT=12 THEN C.LENGTH * 2   WHEN I.TYPEINT=13 THEN C.LONGLENGTH   WHEN I.TYPEINT=14 THEN C.LONGLENGTH   WHEN I.TYPEINT=15 THEN C.LONGLENGTH * 2   WHEN I.TYPEINT=16 THEN 6   WHEN I.TYPEINT=17 THEN 6   WHEN I.TYPEINT=18 THEN 16   WHEN I.TYPEINT=19 THEN C.LENGTH   WHEN I.TYPEINT=20        AND D.SOURCETYPE          NOT IN ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')        THEN D.LENGTH   WHEN I.TYPEINT=20        AND D.SOURCETYPE          IN ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')        THEN D.LENGTH * 2   WHEN I.TYPEINT=21        AND D.SOURCETYPE          NOT IN ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')        THEN D.LENGTH   WHEN I.TYPEINT=21        AND D.SOURCETYPE          IN ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')        THEN D.LENGTH * 2    ELSE C.LENGTH END,  SMALLINT( CASE   WHEN I.TYPEINT=1 THEN 0   WHEN I.TYPEINT=2 THEN 0   WHEN I.TYPEINT=3 THEN 0   WHEN I.TYPEINT=4 THEN NULL   WHEN I.TYPEINT=5 THEN NULL   WHEN I.TYPEINT=6 THEN NULL   WHEN I.TYPEINT=7 THEN NULL   WHEN I.TYPEINT=8 THEN NULL   WHEN I.TYPEINT=9 THEN C.SCALE   WHEN I.TYPEINT=10 THEN NULL   WHEN I.TYPEINT=11 THEN NULL   WHEN I.TYPEINT=12 THEN NULL   WHEN I.TYPEINT=13 THEN NULL   WHEN I.TYPEINT=14 THEN NULL   WHEN I.TYPEINT=15 THEN NULL   WHEN I.TYPEINT=16 THEN NULL   WHEN I.TYPEINT=17 THEN 0   WHEN I.TYPEINT=18 THEN 6   WHEN I.TYPEINT=19 THEN NULL   WHEN I.TYPEINT=20         AND D.SOURCETYPE='DECIMAL'        THEN D.SCALE   WHEN I.TYPEINT=20        AND D.SOURCETYPE IN ('INTEGER','SMALLINT','BIGINT','TIME')        THEN 0   WHEN I.TYPEINT=20        AND D.SOURCETYPE='TIMESTAMP'        THEN 6    WHEN I.TYPEINT=21        AND D.SOURCETYPE='DECIMAL'        THEN D.SCALE    WHEN I.TYPEINT=21        AND D.SOURCETYPE IN ('INTEGER','SMALLINT','BIGINT','TIME')        THEN 0    WHEN I.TYPEINT=21        AND D.SOURCETYPE='TIMESTAMP'        THEN 6   ELSE NULL END ),     SMALLINT(CASE   WHEN I.TYPEINT=1 THEN 10    WHEN I.TYPEINT=2 THEN 10   WHEN I.TYPEINT=3 THEN 10   WHEN I.TYPEINT=4 THEN 2   WHEN I.TYPEINT=5 THEN 2   WHEN I.TYPEINT=6 THEN NULL   WHEN I.TYPEINT=7 THEN NULL   WHEN I.TYPEINT=8 THEN NULL   WHEN I.TYPEINT=9 THEN 10   WHEN I.TYPEINT=10 THEN NULL   WHEN I.TYPEINT=11 THEN NULL   WHEN I.TYPEINT=12 THEN NULL   WHEN I.TYPEINT=13 THEN NULL   WHEN I.TYPEINT=14 THEN NULL   WHEN I.TYPEINT=15 THEN NULL   WHEN I.TYPEINT=16 THEN NULL   WHEN I.TYPEINT=17 THEN NULL   WHEN I.TYPEINT=18 THEN NULL   WHEN I.TYPEINT=19 THEN NULL   WHEN I.TYPEINT=20        AND D.SOURCETYPE IN ('DECIMAL','INTEGER','SMALLINT','BIGINT')        THEN 10   WHEN I.TYPEINT=20        AND D.SOURCETYPE IN ('REAL','FLOAT','DOUBLE')        THEN 2   WHEN I.TYPEINT=21        AND D.SOURCETYPE IN ('DECIMAL','INTEGER','SMALLINT','BIGINT')        THEN 10   WHEN I.TYPEINT=21         AND D.SOURCETYPE IN ('REAL','FLOAT','DOUBLE')        THEN 2   ELSE NULL END),    SMALLINT(CASE    WHEN C.NULLS='Y' THEN 1 ELSE 0 END), C.REMARKS, C.DEFAULT, SMALLINT(CASE   WHEN I.TYPEINT=1 THEN 4   WHEN I.TYPEINT=2 THEN 5    WHEN I.TYPEINT=3 THEN -5   WHEN I.TYPEINT=4 THEN 7   WHEN I.TYPEINT=5 THEN 8   WHEN I.TYPEINT=6 AND C.CODEPAGE <> 0 then 1    WHEN I.TYPEINT=6 AND C.CODEPAGE = 0 then -2    WHEN I.TYPEINT=7 AND C.CODEPAGE <> 0 THEN 12   WHEN I.TYPEINT=7 AND C.CODEPAGE = 0 THEN -3   WHEN I.TYPEINT=8 AND C.CODEPAGE <> 0 THEN -1   WHEN I.TYPEINT=8 AND C.CODEPAGE = 0 THEN -4   WHEN I.TYPEINT=9 THEN 3   WHEN I.TYPEINT=10 THEN -95   WHEN I.TYPEINT=11 THEN -96   WHEN I.TYPEINT=12 THEN -97   WHEN I.TYPEINT=13 THEN -98   WHEN I.TYPEINT=14 THEN -99   WHEN I.TYPEINT=15 THEN -350   WHEN I.TYPEINT=16 THEN 9   WHEN I.TYPEINT=17 THEN 9   WHEN I.TYPEINT=18 THEN 9   WHEN I.TYPEINT=19 THEN -400   WHEN I.TYPEINT=20 THEN 17   WHEN I.TYPEINT=21 THEN 17   ELSE 0 END),    SMALLINT(CASE   WHEN I.TYPEINT=1 THEN NULL   WHEN I.TYPEINT=2 THEN NULL   WHEN I.TYPEINT=3 THEN NULL   WHEN I.TYPEINT=4 THEN NULL   WHEN I.TYPEINT=5 THEN NULL   WHEN I.TYPEINT=6 THEN NULL   WHEN I.TYPEINT=7 THEN NULL   WHEN I.TYPEINT=8 THEN NULL   WHEN I.TYPEINT=9 THEN NULL   WHEN I.TYPEINT=10 THEN NULL   WHEN I.TYPEINT=11 THEN NULL   WHEN I.TYPEINT=12 THEN NULL   WHEN I.TYPEINT=13 THEN NULL   WHEN I.TYPEINT=14 THEN NULL   WHEN I.TYPEINT=15 THEN NULL   WHEN I.TYPEINT=16 THEN 1   WHEN I.TYPEINT=17 THEN 2   WHEN I.TYPEINT=18 THEN 3   WHEN I.TYPEINT=19 THEN NULL   WHEN I.TYPEINT=20        AND D.SOURCETYPE='DATE' THEN 1   WHEN I.TYPEINT=20        AND D.SOURCETYPE='TIME' THEN 2   WHEN I.TYPEINT=20        AND D.SOURCETYPE='TIMESTAMP' THEN 3   WHEN I.TYPEINT=21        AND D.SOURCETYPE='DATE' THEN 1    WHEN I.TYPEINT=21        AND D.SOURCETYPE='TIME' THEN 2   WHEN I.TYPEINT=21        AND D.SOURCETYPE='TIMESTAMP' THEN 3   ELSE NULL END),     CASE WHEN I.TYPEINT=1 THEN NULL WHEN I.TYPEINT=2 THEN NULL WHEN I.TYPEINT=3 THEN NULL WHEN I.TYPEINT=4 THEN NULL WHEN I.TYPEINT=5 THEN NULL WHEN I.TYPEINT=6 THEN C.LENGTH WHEN I.TYPEINT=7 THEN C.LENGTH WHEN I.TYPEINT=8 THEN C.LENGTH WHEN I.TYPEINT=9 THEN NULL WHEN I.TYPEINT=10 THEN C.LENGTH * 2 WHEN I.TYPEINT=11 THEN C.LENGTH * 2 WHEN I.TYPEINT=12 THEN C.LENGTH * 2 WHEN I.TYPEINT=13 THEN C.LONGLENGTH WHEN I.TYPEINT=14 THEN C.LONGLENGTH WHEN I.TYPEINT=15 THEN C.LONGLENGTH * 2  WHEN I.TYPEINT=16 THEN NULL WHEN I.TYPEINT=17 THEN NULL WHEN I.TYPEINT=18 THEN NULL WHEN I.TYPEINT=19 THEN NULL WHEN I.TYPEINT=20      AND D.SOURCETYPE IN      ('CHARACTER','VARCHAR','LONG VARCHAR','BLOB','CLOB')      THEN D.LENGTH WHEN I.TYPEINT=20      AND D.SOURCETYPE IN      ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')      THEN D.LENGTH * 2 WHEN I.TYPEINT=21      AND D.SOURCETYPE IN      ('CHARACTER','VARCHAR','LONG VARCHAR','BLOB','CLOB')      THEN D.LENGTH    WHEN I.TYPEINT=21        AND D.SOURCETYPE IN        ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')        THEN D.LENGTH * 2   ELSE NULL END, C.COLNO + 1, CASE   WHEN C.NULLS='Y' THEN 'YES' ELSE 'NO' END, SMALLINT( CASE   WHEN I.TYPEINT=1 THEN 4   WHEN I.TYPEINT=2 THEN 5   WHEN I.TYPEINT=3 THEN -5   WHEN I.TYPEINT=4 THEN 7   WHEN I.TYPEINT=5 THEN 8   WHEN I.TYPEINT=6 AND C.CODEPAGE <> 0 then 1   WHEN I.TYPEINT=6 AND C.CODEPAGE = 0 then -2   WHEN I.TYPEINT=7 AND C.CODEPAGE <> 0 THEN 12   WHEN I.TYPEINT=7 AND C.CODEPAGE = 0 THEN -3   WHEN I.TYPEINT=8 AND C.CODEPAGE <> 0 THEN -1   WHEN I.TYPEINT=8 AND C.CODEPAGE = 0 THEN -4   WHEN I.TYPEINT=9 THEN 3   WHEN I.TYPEINT=10 THEN 1   WHEN I.TYPEINT=11 THEN 12   WHEN I.TYPEINT=12 THEN -1   WHEN I.TYPEINT=13 THEN 2004   WHEN I.TYPEINT=14 THEN 2005   WHEN I.TYPEINT=15 THEN 2005   WHEN I.TYPEINT=16 THEN 91  WHEN I.TYPEINT=17 THEN 92   WHEN I.TYPEINT=18 THEN 93   WHEN I.TYPEINT=19 THEN 70   WHEN I.TYPEINT=20 THEN 2002   WHEN I.TYPEINT=21 THEN 2001   ELSE 0 END), CAST( NULL AS  VARCHAR(128) ), CAST( NULL AS  VARCHAR(128) ), CAST( NULL AS  VARCHAR(128) ), SMALLINT( CASE   WHEN D.SOURCETYPE IS NULL THEN NULL   WHEN D.SOURCETYPE='INTEGER' THEN 4   WHEN D.SOURCETYPE='SMALLINT' THEN 5   WHEN D.SOURCETYPE='BIGINT' THEN -5   WHEN D.SOURCETYPE='FLOAT' AND C.LENGTH=4 THEN 7   WHEN D.SOURCETYPE='FLOAT' AND C.LENGTH=8 THEN 8   WHEN D.SOURCETYPE='REAL' THEN 7   WHEN D.SOURCETYPE='DOUBLE' THEN 8   WHEN D.SOURCETYPE='CHARACTER' AND C.CODEPAGE <> 0 then 1   WHEN D.SOURCETYPE='CHARACTER' AND C.CODEPAGE = 0 then -2   WHEN D.SOURCETYPE='VARCHAR' AND C.CODEPAGE <> 0 THEN 12   WHEN D.SOURCETYPE='VARCHAR' AND C.CODEPAGE = 0 THEN -3   WHEN D.SOURCETYPE='LONG VARCHAR' AND C.CODEPAGE <> 0 THEN -1   WHEN D.SOURCETYPE='LONG VARCHAR' AND C.CODEPAGE = 0 THEN -4   WHEN D.SOURCETYPE='DECIMAL' THEN 3   WHEN D.SOURCETYPE='GRAPHIC' THEN -95   WHEN D.SOURCETYPE='VARGRAPHIC' THEN -96   WHEN D.SOURCETYPE='LONG VARGRAPHIC' THEN -97   WHEN D.SOURCETYPE='BLOB' THEN -98   WHEN D.SOURCETYPE='CLOB' THEN -99   WHEN D.SOURCETYPE='DBCLOB' THEN -350   WHEN D.SOURCETYPE='DATE' THEN 91   WHEN D.SOURCETYPE='TIME' THEN 92   WHEN D.SOURCETYPE='TIMESTAMP' THEN 93   WHEN D.SOURCETYPE='DATALINK' THEN -400   ELSE 0     END), CAST( NULL AS  VARCHAR(8) ), SMALLINT(CASE   WHEN C.IDENTITY = 'Y' THEN 2   ELSE 1 END ) FROM   SYSIBM.SYSCOLUMNS C,   SYSIBM.SYSDATATYPES D,   TYPEINTS I WHERE   C.COLTYPE <> 'REF'   AND I.TYPEINT <> 22   AND C.TYPENAME = D.NAME   AND C.TYPESCHEMA = D.SCHEMA   AND C.COLTYPE = I.COLTYPE    UNION ALL SELECT   CAST( NULL AS  VARCHAR(128) ),   RTRIM(C.TBCREATOR),   C.TBNAME,   C.NAME,   SMALLINT(20),   CAST( '"' || RTRIM(D.SCHEMA) || '"."' || D.NAME || '"'         AS  VARCHAR(261) ),   CASE     WHEN D.SOURCETYPE = 'REAL' THEN 24     WHEN D.SOURCETYPE = 'DOUBLE' THEN 53     ELSE D.LENGTH   END,   CASE     WHEN D.SOURCETYPE            NOT IN ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')          THEN D.LENGTH     WHEN D.SOURCETYPE            IN ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')          THEN D.LENGTH * 2     ELSE NULL   END,   SMALLINT( CASE     WHEN D.SOURCETYPE='DECIMAL'          THEN D.SCALE     WHEN D.SOURCETYPE IN ('INTEGER','SMALLINT','BIGINT','TIME')          THEN 0     WHEN D.SOURCETYPE='TIMESTAMP'          THEN 6     ELSE NULL   END ),   SMALLINT( CASE     WHEN D.SOURCETYPE IN ('DECIMAL','INTEGER','SMALLINT','BIGINT')          THEN 10     WHEN D.SOURCETYPE IN ('REAL','FLOAT','DOUBLE')          THEN 2     ELSE NULL   END),    SMALLINT(CASE    WHEN C.NULLS='Y' THEN 1 ELSE 0 END), C.REMARKS, C.DEFAULT, SMALLINT( 20 ), SMALLINT( CASE   WHEN D.SOURCETYPE='DATE' THEN 1   WHEN D.SOURCETYPE='TIME' THEN 2   WHEN D.SOURCETYPE='TIMESTAMP' THEN 3   ELSE NULL END), CASE   WHEN D.SOURCETYPE IN        ('CHARACTER','VARCHAR','LONG VARCHAR','BLOB','CLOB')        THEN D.LENGTH   WHEN D.SOURCETYPE IN        ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')        THEN D.LENGTH * 2   ELSE NULL END, C.COLNO + 1, CASE   WHEN C.NULLS='Y' THEN 'YES' ELSE 'NO' END, SMALLINT( 2006 ), CAST( NULL AS  VARCHAR(128) ), CAST( NULL AS  VARCHAR(128) ), CAST( NULL AS  VARCHAR(128) ), SMALLINT( CASE   WHEN D.SOURCETYPE IS NULL THEN NULL   WHEN D.SOURCETYPE='INTEGER' THEN 4   WHEN D.SOURCETYPE='SMALLINT' THEN 5   WHEN D.SOURCETYPE='BIGINT' THEN -5   WHEN D.SOURCETYPE='FLOAT' AND C.LENGTH=4 THEN 7   WHEN D.SOURCETYPE='FLOAT' AND C.LENGTH=8 THEN 8   WHEN D.SOURCETYPE='REAL' THEN 7   WHEN D.SOURCETYPE='DOUBLE' THEN 8   WHEN D.SOURCETYPE='CHARACTER' AND C.CODEPAGE <> 0 then 1   WHEN D.SOURCETYPE='CHARACTER' AND C.CODEPAGE = 0 then -2   WHEN D.SOURCETYPE='VARCHAR' AND C.CODEPAGE <> 0 THEN 12   WHEN D.SOURCETYPE='VARCHAR' AND C.CODEPAGE = 0 THEN -3   WHEN D.SOURCETYPE='LONG VARCHAR' AND C.CODEPAGE <> 0 THEN -1   WHEN D.SOURCETYPE='LONG VARCHAR' AND C.CODEPAGE = 0 THEN -4   WHEN D.SOURCETYPE='DECIMAL' THEN 3   WHEN D.SOURCETYPE='GRAPHIC' THEN -95   WHEN D.SOURCETYPE='VARGRAPHIC' THEN -96   WHEN D.SOURCETYPE='LONG VARGRAPHIC' THEN -97   WHEN D.SOURCETYPE='BLOB' THEN -98   WHEN D.SOURCETYPE='CLOB' THEN -99   WHEN D.SOURCETYPE='DBCLOB' THEN -350   WHEN D.SOURCETYPE='DATE' THEN 91   WHEN D.SOURCETYPE='TIME' THEN 92   WHEN D.SOURCETYPE='TIMESTAMP' THEN 93   WHEN D.SOURCETYPE='DATALINK' THEN -400   ELSE 0 END ), CAST( NULL AS  VARCHAR(8) ), SMALLINT(1) FROM   SYSIBM.SYSCOLUMNS C,   SYSIBM.SYSDATATYPES D,   SYSIBM.SYSCOLPROPERTIES P,   TYPEINTS I WHERE   C.COLTYPE = 'REF'   AND I.TYPEINT = 22   AND P.COLNAME = C.NAME   AND P.TABSCHEMA = C.TBCREATOR    AND P.TABNAME = C.TBNAME   AND P.TARGET_TYPENAME = D.NAME   AND P.TARGET_TYPESCHEMA = D.SCHEMA   AND C.COLTYPE = I.COLTYPE  UNION ALL  SELECT CAST( NULL AS  VARCHAR(128) ), RTRIM(T.CREATOR), T.NAME, C.NAME, SMALLINT( CASE   WHEN I.TYPEINT=1 THEN 4   WHEN I.TYPEINT=2 THEN 5   WHEN I.TYPEINT=3 THEN -5   WHEN I.TYPEINT=4 THEN 7   WHEN I.TYPEINT=5 THEN 8   WHEN I.TYPEINT=6 AND C.CODEPAGE <> 0 then 1   WHEN I.TYPEINT=6 AND C.CODEPAGE = 0 then -2   WHEN I.TYPEINT=7 AND C.CODEPAGE <> 0 THEN 12   WHEN I.TYPEINT=7 AND C.CODEPAGE = 0 THEN -3   WHEN I.TYPEINT=8 AND C.CODEPAGE <> 0 THEN -1   WHEN I.TYPEINT=8 AND C.CODEPAGE = 0 THEN -4   WHEN I.TYPEINT=9 THEN 3   WHEN I.TYPEINT=10 THEN -95   WHEN I.TYPEINT=11 THEN -96   WHEN I.TYPEINT=12 THEN -97   WHEN I.TYPEINT=13 THEN -98   WHEN I.TYPEINT=14 THEN -99   WHEN I.TYPEINT=15 THEN -350   WHEN I.TYPEINT=16 THEN 91   WHEN I.TYPEINT=17 THEN 92   WHEN I.TYPEINT=18 THEN 93   WHEN I.TYPEINT=19 THEN -400   WHEN I.TYPEINT=20 THEN 17   WHEN I.TYPEINT=21 THEN 17   ELSE 0 END),    CAST( CASE   WHEN I.TYPEINT=1 THEN 'INTEGER'   WHEN I.TYPEINT=2 THEN 'SMALLINT'   WHEN I.TYPEINT=3 THEN 'BIGINT'   WHEN I.TYPEINT=4 THEN 'REAL'   WHEN I.TYPEINT=5 THEN 'DOUBLE'   WHEN I.TYPEINT=6 AND C.CODEPAGE <> 0 THEN 'CHAR'   WHEN I.TYPEINT=6 AND C.CODEPAGE = 0 THEN 'CHAR () FOR BIT DATA'   WHEN I.TYPEINT=7 AND C.CODEPAGE <> 0 THEN 'VARCHAR'   WHEN I.TYPEINT=7 AND C.CODEPAGE = 0 THEN 'VARCHAR () FOR BIT DATA'   WHEN I.TYPEINT=8 AND C.CODEPAGE <> 0 THEN 'LONG VARCHAR'   WHEN I.TYPEINT=8 AND C.CODEPAGE = 0 THEN 'LONG VARCHAR FOR BIT DATA'   WHEN I.TYPEINT=9 THEN 'DECIMAL'   WHEN I.TYPEINT=10 THEN 'GRAPHIC'   WHEN I.TYPEINT=11 THEN 'VARGRAPHIC'   WHEN I.TYPEINT=12 THEN 'LONG VARGRAPHIC'   WHEN I.TYPEINT=13 THEN 'BLOB'   WHEN I.TYPEINT=14 THEN 'CLOB'   WHEN I.TYPEINT=15 THEN 'DBCLOB'   WHEN I.TYPEINT=16 THEN 'DATE'   WHEN I.TYPEINT=17 THEN 'TIME'   WHEN I.TYPEINT=18 THEN 'TIMESTAMP'   WHEN I.TYPEINT=19 THEN 'DATALINK'   WHEN I.TYPEINT=20 THEN '"' || RTRIM(D.SCHEMA) || '"."' || D.NAME || '"'   WHEN I.TYPEINT=21 THEN '"' || RTRIM(D.SCHEMA) || '"."' || D.NAME || '"'   ELSE '' END  AS  VARCHAR(261) ),  CASE   WHEN I.TYPEINT=1 THEN 10   WHEN I.TYPEINT=2 THEN 5   WHEN I.TYPEINT=3 THEN 19    WHEN I.TYPEINT=4 THEN 24   WHEN I.TYPEINT=5 THEN 53   WHEN I.TYPEINT=6 THEN C.LENGTH   WHEN I.TYPEINT=7 THEN C.LENGTH   WHEN I.TYPEINT=8 THEN C.LENGTH   WHEN I.TYPEINT=9 THEN C.LENGTH   WHEN I.TYPEINT=10 THEN C.LENGTH   WHEN I.TYPEINT=11 THEN C.LENGTH   WHEN I.TYPEINT=12 THEN C.LENGTH   WHEN I.TYPEINT=13 THEN C.LONGLENGTH   WHEN I.TYPEINT=14 THEN C.LONGLENGTH   WHEN I.TYPEINT=15 THEN C.LONGLENGTH   WHEN I.TYPEINT=16 THEN 10   WHEN I.TYPEINT=17 THEN 8    WHEN I.TYPEINT=18 THEN 26   WHEN I.TYPEINT=20 THEN D.LENGTH   WHEN I.TYPEINT=21 THEN D.LENGTH   ELSE C.LENGTH END,  CASE WHEN I.TYPEINT=1 THEN 4 WHEN I.TYPEINT=2 THEN 2 WHEN I.TYPEINT=3 THEN 8 WHEN I.TYPEINT=4 THEN 4 WHEN I.TYPEINT=5 THEN 8 WHEN I.TYPEINT=6 THEN C.LENGTH WHEN I.TYPEINT=7 THEN C.LENGTH WHEN I.TYPEINT=8 THEN C.LENGTH WHEN I.TYPEINT=9 THEN C.LENGTH + 2 WHEN I.TYPEINT=10 THEN C.LENGTH * 2 WHEN I.TYPEINT=11 THEN C.LENGTH * 2 WHEN I.TYPEINT=12 THEN C.LENGTH * 2 WHEN I.TYPEINT=13 THEN C.LONGLENGTH WHEN I.TYPEINT=14 THEN C.LONGLENGTH WHEN I.TYPEINT=15 THEN C.LONGLENGTH * 2 WHEN I.TYPEINT=16 THEN 6 WHEN I.TYPEINT=17 THEN 6 WHEN I.TYPEINT=18 THEN 16 WHEN I.TYPEINT=19 THEN C.LENGTH WHEN I.TYPEINT=20      AND D.SOURCETYPE        NOT IN ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')      THEN D.LENGTH WHEN I.TYPEINT=20      AND D.SOURCETYPE        IN ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')      THEN D.LENGTH * 2 WHEN I.TYPEINT=21      AND D.SOURCETYPE        NOT IN ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')      THEN D.LENGTH  WHEN I.TYPEINT=21        AND D.SOURCETYPE          IN ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')        THEN D.LENGTH * 2   ELSE C.LENGTH END, SMALLINT( CASE   WHEN I.TYPEINT=1 THEN 0   WHEN I.TYPEINT=2 THEN 0   WHEN I.TYPEINT=3 THEN 0   WHEN I.TYPEINT=4 THEN NULL   WHEN I.TYPEINT=5 THEN NULL   WHEN I.TYPEINT=6 THEN NULL   WHEN I.TYPEINT=7 THEN NULL   WHEN I.TYPEINT=8 THEN NULL   WHEN I.TYPEINT=9 THEN C.SCALE   WHEN I.TYPEINT=10 THEN NULL   WHEN I.TYPEINT=11 THEN NULL   WHEN I.TYPEINT=12 THEN NULL   WHEN I.TYPEINT=13 THEN NULL   WHEN I.TYPEINT=14 THEN NULL   WHEN I.TYPEINT=15 THEN NULL   WHEN I.TYPEINT=16 THEN NULL    WHEN I.TYPEINT=17 THEN 0   WHEN I.TYPEINT=18 THEN 6   WHEN I.TYPEINT=19 THEN NULL   WHEN I.TYPEINT=20        AND D.SOURCETYPE='DECIMAL'        THEN D.SCALE   WHEN I.TYPEINT=20        AND D.SOURCETYPE IN ('INTEGER','SMALLINT','BIGINT','TIME')        THEN 0  WHEN I.TYPEINT=20        AND D.SOURCETYPE='TIMESTAMP'        THEN 6    WHEN I.TYPEINT=21        AND D.SOURCETYPE='DECIMAL'        THEN D.SCALE   WHEN I.TYPEINT=21        AND D.SOURCETYPE IN ('INTEGER','SMALLINT','BIGINT','TIME')        THEN 0   WHEN I.TYPEINT=21        AND D.SOURCETYPE='TIMESTAMP'        THEN 6   ELSE NULL END ), SMALLINT(CASE   WHEN I.TYPEINT=1 THEN 10   WHEN I.TYPEINT=2 THEN 10   WHEN I.TYPEINT=3 THEN 10   WHEN I.TYPEINT=4 THEN 2   WHEN I.TYPEINT=5 THEN 2   WHEN I.TYPEINT=6 THEN NULL   WHEN I.TYPEINT=7 THEN NULL   WHEN I.TYPEINT=8 THEN NULL   WHEN I.TYPEINT=9 THEN 10   WHEN I.TYPEINT=10 THEN NULL   WHEN I.TYPEINT=11 THEN NULL   WHEN I.TYPEINT=12 THEN NULL   WHEN I.TYPEINT=13 THEN NULL   WHEN I.TYPEINT=14 THEN NULL   WHEN I.TYPEINT=15 THEN NULL   WHEN I.TYPEINT=16 THEN NULL   WHEN I.TYPEINT=17 THEN NULL   WHEN I.TYPEINT=18 THEN NULL   WHEN I.TYPEINT=19 THEN NULL  WHEN I.TYPEINT=20         AND D.SOURCETYPE IN ('DECIMAL','INTEGER','SMALLINT','BIGINT')         THEN 10    WHEN I.TYPEINT=20         AND D.SOURCETYPE IN ('REAL','FLOAT','DOUBLE')         THEN 2    WHEN I.TYPEINT=21         AND D.SOURCETYPE IN ('DECIMAL','INTEGER','SMALLINT','BIGINT')         THEN 10    WHEN I.TYPEINT=21         AND D.SOURCETYPE IN ('REAL','FLOAT','DOUBLE')         THEN 2    ELSE NULL  END),  SMALLINT(CASE     WHEN C.NULLS='Y' THEN 1 ELSE 0  END),  C.REMARKS,  C.DEFAULT,  SMALLINT(CASE    WHEN I.TYPEINT=1 THEN 4    WHEN I.TYPEINT=2 THEN 5    WHEN I.TYPEINT=3 THEN -5    WHEN I.TYPEINT=4 THEN 7    WHEN I.TYPEINT=5 THEN 8     WHEN I.TYPEINT=6 AND C.CODEPAGE <> 0 then 1    WHEN I.TYPEINT=6 AND C.CODEPAGE = 0 then -2    WHEN I.TYPEINT=7 AND C.CODEPAGE <> 0 THEN 12    WHEN I.TYPEINT=7 AND C.CODEPAGE = 0 THEN -3    WHEN I.TYPEINT=8 AND C.CODEPAGE <> 0 THEN -1    WHEN I.TYPEINT=8 AND C.CODEPAGE = 0 THEN -4    WHEN I.TYPEINT=9 THEN 3  WHEN I.TYPEINT=10 THEN -95   WHEN I.TYPEINT=11 THEN -96   WHEN I.TYPEINT=12 THEN -97   WHEN I.TYPEINT=13 THEN -98   WHEN I.TYPEINT=14 THEN -99   WHEN I.TYPEINT=15 THEN -350   WHEN I.TYPEINT=16 THEN 9   WHEN I.TYPEINT=17 THEN 9   WHEN I.TYPEINT=18 THEN 9   WHEN I.TYPEINT=19 THEN -400   WHEN I.TYPEINT=20 THEN 17   WHEN I.TYPEINT=21 THEN 17   ELSE 0 END), SMALLINT(CASE   WHEN I.TYPEINT=1 THEN NULL   WHEN I.TYPEINT=2 THEN NULL   WHEN I.TYPEINT=3 THEN NULL   WHEN I.TYPEINT=4 THEN NULL   WHEN I.TYPEINT=5 THEN NULL   WHEN I.TYPEINT=6 THEN NULL   WHEN I.TYPEINT=7 THEN NULL   WHEN I.TYPEINT=8 THEN NULL   WHEN I.TYPEINT=9 THEN NULL   WHEN I.TYPEINT=10 THEN NULL   WHEN I.TYPEINT=11 THEN NULL   WHEN I.TYPEINT=12 THEN NULL   WHEN I.TYPEINT=13 THEN NULL   WHEN I.TYPEINT=14 THEN NULL   WHEN I.TYPEINT=15 THEN NULL   WHEN I.TYPEINT=16 THEN 1   WHEN I.TYPEINT=17 THEN 2   WHEN I.TYPEINT=18 THEN 3   WHEN I.TYPEINT=19 THEN NULL  WHEN I.TYPEINT=20        AND D.SOURCETYPE='DATE' THEN 1   WHEN I.TYPEINT=20        AND D.SOURCETYPE='TIME' THEN 2   WHEN I.TYPEINT=20        AND D.SOURCETYPE='TIMESTAMP' THEN 3   WHEN I.TYPEINT=21        AND D.SOURCETYPE='DATE' THEN 1   WHEN I.TYPEINT=21        AND D.SOURCETYPE='TIME' THEN 2   WHEN I.TYPEINT=21        AND D.SOURCETYPE='TIMESTAMP' THEN 3   ELSE NULL END), CASE    WHEN I.TYPEINT=6 THEN C.LENGTH   WHEN I.TYPEINT=7 THEN C.LENGTH   WHEN I.TYPEINT=8 THEN C.LENGTH   WHEN I.TYPEINT=10 THEN C.LENGTH * 2   WHEN I.TYPEINT=11 THEN C.LENGTH * 2   WHEN I.TYPEINT=12 THEN C.LENGTH * 2   WHEN I.TYPEINT=13 THEN C.LONGLENGTH   WHEN I.TYPEINT=14 THEN C.LONGLENGTH   WHEN I.TYPEINT=15 THEN C.LONGLENGTH * 2   WHEN I.TYPEINT=20        AND D.SOURCETYPE IN        ('CHARACTER','VARCHAR','LONG VARCHAR','BLOB','CLOB')        THEN D.LENGTH       WHEN I.TYPEINT=20        AND D.SOURCETYPE IN        ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')        THEN D.LENGTH * 2   WHEN I.TYPEINT=21        AND D.SOURCETYPE IN        ('CHARACTER','VARCHAR','LONG VARCHAR','BLOB','CLOB')        THEN D.LENGTH   WHEN I.TYPEINT=21        AND D.SOURCETYPE IN        ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')        THEN D.LENGTH * 2   ELSE NULL END, C.COLNO + 1, CASE    WHEN C.NULLS='Y' THEN 'YES' ELSE 'NO' END, SMALLINT( CASE   WHEN I.TYPEINT=1 THEN 4   WHEN I.TYPEINT=2 THEN 5   WHEN I.TYPEINT=3 THEN -5   WHEN I.TYPEINT=4 THEN 7   WHEN I.TYPEINT=5 THEN 8   WHEN I.TYPEINT=6 AND C.CODEPAGE <> 0 then 1   WHEN I.TYPEINT=6 AND C.CODEPAGE = 0 then -2   WHEN I.TYPEINT=7 AND C.CODEPAGE <> 0 THEN 12   WHEN I.TYPEINT=7 AND C.CODEPAGE = 0 THEN -3   WHEN I.TYPEINT=8 AND C.CODEPAGE <> 0 THEN -1  WHEN I.TYPEINT=8 AND C.CODEPAGE = 0 THEN -4   WHEN I.TYPEINT=9 THEN 3   WHEN I.TYPEINT=10 THEN 1   WHEN I.TYPEINT=11 THEN 12   WHEN I.TYPEINT=12 THEN -1   WHEN I.TYPEINT=13 THEN 2004   WHEN I.TYPEINT=14 THEN 2005   WHEN I.TYPEINT=15 THEN 2005   WHEN I.TYPEINT=16 THEN 91   WHEN I.TYPEINT=17 THEN 92   WHEN I.TYPEINT=18 THEN 93   WHEN I.TYPEINT=19 THEN 70   WHEN I.TYPEINT=20 THEN 2002   WHEN I.TYPEINT=21 THEN 2001   ELSE 0  END), CAST( NULL AS  VARCHAR(128) ), CAST( NULL AS  VARCHAR(128) ), CAST( NULL AS  VARCHAR(128) ), SMALLINT( CASE   WHEN D.SOURCETYPE IS NULL THEN NULL   WHEN D.SOURCETYPE='INTEGER' THEN 4   WHEN D.SOURCETYPE='SMALLINT' THEN 5   WHEN D.SOURCETYPE='BIGINT' THEN -5   WHEN D.SOURCETYPE='FLOAT' AND C.LENGTH=4 THEN 7   WHEN D.SOURCETYPE='FLOAT' AND C.LENGTH=8 THEN 8   WHEN D.SOURCETYPE='REAL' THEN 7   WHEN D.SOURCETYPE='DOUBLE' THEN 8   WHEN D.SOURCETYPE='CHARACTER' AND C.CODEPAGE <> 0 then 1   WHEN D.SOURCETYPE='CHARACTER' AND C.CODEPAGE = 0 then -2   WHEN D.SOURCETYPE='VARCHAR' AND C.CODEPAGE <> 0 THEN 12   WHEN D.SOURCETYPE='VARCHAR' AND C.CODEPAGE = 0 THEN -3   WHEN D.SOURCETYPE='LONG VARCHAR' AND C.CODEPAGE <> 0 THEN -1   WHEN D.SOURCETYPE='LONG VARCHAR' AND C.CODEPAGE = 0 THEN -4   WHEN D.SOURCETYPE='DECIMAL' THEN 3   WHEN D.SOURCETYPE='GRAPHIC' THEN -95   WHEN D.SOURCETYPE='VARGRAPHIC' THEN -96   WHEN D.SOURCETYPE='LONG VARGRAPHIC' THEN -97   WHEN D.SOURCETYPE='BLOB' THEN -98   WHEN D.SOURCETYPE='CLOB' THEN -99   WHEN D.SOURCETYPE='DBCLOB' THEN -350   WHEN D.SOURCETYPE='DATE' THEN 91   WHEN D.SOURCETYPE='TIME' THEN 92   WHEN D.SOURCETYPE='TIMESTAMP' THEN 93   WHEN D.SOURCETYPE='DATALINK' THEN -400   ELSE 0 END ), CAST( NULL AS  VARCHAR(8) ), SMALLINT(CASE   WHEN C.IDENTITY = 'Y' THEN 2   ELSE 1 END ) FROM   SYSIBM.SYSCOLUMNS C,   SYSIBM.SYSDATATYPES D,   SYSIBM.SYSTABLES T,   TYPEINTS I WHERE   C.COLTYPE <> 'REF'   AND I.TYPEINT <> 22    AND C.TYPENAME = D.NAME   AND C.TYPESCHEMA = D.SCHEMA   AND T.TYPE = 'A'   AND TABLE_SCHEMA(T.NAME, T.CREATOR) = C.TBCREATOR   AND TABLE_NAME(T.NAME, T.CREATOR) = C.TBNAME   AND C.COLTYPE = I.COLTYPE UNION ALL  SELECT    CAST( NULL AS  VARCHAR(128) ),    RTRIM(T.CREATOR),    T.NAME,    C.NAME,    SMALLINT(20),    CAST( '"' || RTRIM(D.SCHEMA) || '"."' || D.NAME || '"'          AS  VARCHAR(261) ),    CASE      WHEN D.SOURCETYPE = 'REAL' THEN 24      WHEN D.SOURCETYPE = 'DOUBLE' THEN 53      ELSE D.LENGTH    END,    CASE      WHEN D.SOURCETYPE             NOT IN ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')           THEN D.LENGTH      WHEN D.SOURCETYPE             IN ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')           THEN D.LENGTH * 2      ELSE NULL    END,    SMALLINT( CASE      WHEN D.SOURCETYPE='DECIMAL'           THEN D.SCALE      WHEN D.SOURCETYPE IN ('INTEGER','SMALLINT','BIGINT','TIME')           THEN 0      WHEN D.SOURCETYPE='TIMESTAMP'           THEN 6      ELSE NULL    END ),     SMALLINT( CASE      WHEN D.SOURCETYPE IN ('DECIMAL','INTEGER','SMALLINT','BIGINT')           THEN 10      WHEN D.SOURCETYPE IN ('REAL','FLOAT','DOUBLE')           THEN 2      ELSE NULL    END),   SMALLINT(CASE       WHEN C.NULLS='Y' THEN 1 ELSE 0     END),    C.REMARKS,    C.DEFAULT,    SMALLINT( 20 ),   SMALLINT( CASE      WHEN D.SOURCETYPE='DATE' THEN 1      WHEN D.SOURCETYPE='TIME' THEN 2      WHEN D.SOURCETYPE='TIMESTAMP' THEN 3      ELSE NULL    END),    CASE      WHEN D.SOURCETYPE IN           ('CHARACTER','VARCHAR','LONG VARCHAR','BLOB','CLOB')           THEN D.LENGTH      WHEN D.SOURCETYPE IN           ('GRAPHIC','VARGRAPHIC','LONG VARGRAPHIC','DBCLOB')           THEN D.LENGTH * 2      ELSE NULL    END,    C.COLNO + 1,  CASE      WHEN C.NULLS='Y' THEN 'YES' ELSE 'NO'    END,    SMALLINT( 2006 ),    CAST( NULL AS  VARCHAR(128) ),    CAST( NULL AS  VARCHAR(128) ),    CAST( NULL AS  VARCHAR(128) ),    SMALLINT( CASE      WHEN D.SOURCETYPE IS NULL THEN NULL      WHEN D.SOURCETYPE='INTEGER' THEN 4      WHEN D.SOURCETYPE='SMALLINT' THEN 5      WHEN D.SOURCETYPE='BIGINT' THEN -5      WHEN D.SOURCETYPE='FLOAT' AND C.LENGTH=4 THEN 7      WHEN D.SOURCETYPE='FLOAT' AND C.LENGTH=8 THEN 8      WHEN D.SOURCETYPE='REAL' THEN 7      WHEN D.SOURCETYPE='DOUBLE' THEN 8      WHEN D.SOURCETYPE='CHARACTER' AND C.CODEPAGE <> 0 then 1      WHEN D.SOURCETYPE='CHARACTER' AND C.CODEPAGE = 0 then -2      WHEN D.SOURCETYPE='VARCHAR' AND C.CODEPAGE <> 0 THEN 12      WHEN D.SOURCETYPE='VARCHAR' AND C.CODEPAGE = 0 THEN -3      WHEN D.SOURCETYPE='LONG VARCHAR' AND C.CODEPAGE <> 0 THEN -1      WHEN D.SOURCETYPE='LONG VARCHAR' AND C.CODEPAGE = 0 THEN -4      WHEN D.SOURCETYPE='DECIMAL' THEN 3      WHEN D.SOURCETYPE='GRAPHIC' THEN -95      WHEN D.SOURCETYPE='VARGRAPHIC' THEN -96      WHEN D.SOURCETYPE='LONG VARGRAPHIC' THEN -97      WHEN D.SOURCETYPE='BLOB' THEN -98      WHEN D.SOURCETYPE='CLOB' THEN -99      WHEN D.SOURCETYPE='DBCLOB' THEN -350      WHEN D.SOURCETYPE='DATE' THEN 91      WHEN D.SOURCETYPE='TIME' THEN 92      WHEN D.SOURCETYPE='TIMESTAMP' THEN 93      WHEN D.SOURCETYPE='DATALINK' THEN -400      ELSE 0    END ),    CAST( NULL AS  VARCHAR(8) ),    SMALLINT( 1 )    FROM      SYSIBM.SYSCOLUMNS C,      SYSIBM.SYSDATATYPES D,      SYSIBM.SYSCOLPROPERTIES P,      SYSIBM.SYSTABLES T,      TYPEINTS I    WHERE      C.COLTYPE = 'REF'      AND I.TYPEINT = 22      AND P.COLNAME = C.NAME      AND P.TABSCHEMA = C.TBCREATOR      AND P.TABNAME = C.TBNAME      AND P.TARGET_TYPENAME = D.NAME      AND P.TARGET_TYPESCHEMA = D.SCHEMA      AND T.TYPE = 'A'      AND TABLE_SCHEMA(T.NAME, T.CREATOR) = C.TBCREATOR      AND TABLE_NAME(T.NAME, T.CREATOR) = C.TBNAME      AND C.COLTYPE = I.COLTYPE;

  
CREATE VIEW TRIGGERS (TRIGSCHEMA, TRIGNAME, DEFINER, TABSCHEMA, TABNAME, TRIGTIME, TRIGEVENT, GRANULARITY, VALID, CREATE_TIME, QUALIFIER, FUNC_PATH, TEXT, REMARKS) AS
select      schema, name, definer, tbcreator, tbname,      trigtime, trigevent, granularity, valid,      create_time, qualifier, func_path, text,      remarks  from sysibm.systriggers;

CREATE VIEW PROCOPTIONS (PROCSCHEMA, PROCNAME, OPTION, SETTING) AS
select      procschema, procname, option, setting  from sysibm.sysprocoptions;

CREATE VIEW PACKAGEDEP (PKGSCHEMA, PKGNAME, BINDER, BTYPE, BSCHEMA, BNAME, TABAUTH, UNIQUE_ID, PKGVERSION) AS
select      d.dcreator, d.dname, d.binder, d.btype,      d.bcreator, d.bname, d.tabauth, d.dunique_id,      (select p.pkgversion from sysibm.sysplan p       where d.dcreator = p.creator       and d.dname = p.name       and d.dunique_id = p.unique_id)  from sysibm.sysplandep d;

CREATE VIEW DBPARTITIONGROUPS (DBPGNAME, DEFINER, PMAP_ID, REDISTRIBUTE_PMAP_ID, CREATE_TIME, REMARKS) AS
select      name, definer, pmap_id, rebalance_pmap_id, ctime,      remarks  from sysibm.sysnodegroups;

CREATE VIEW NODEGROUPDEF (NGNAME, NODENUM, IN_USE) AS
select      ngname, nodenum, in_use  from sysibm.sysnodegroupdef;

CREATE VIEW EVENTS (EVMONNAME, TYPE, FILTER) AS
select      name, type, filter  from sysibm.sysevents;

CREATE VIEW CASTFUNCTIONS (FROM_TYPESCHEMA, FROM_TYPENAME, TO_TYPESCHEMA, TO_TYPENAME, FUNCSCHEMA, FUNCNAME, SPECIFICNAME, ASSIGN_FUNCTION) AS
select      p1.typeschema, p1.typename, p2.typeschema, p2.typename,      f.schema, f.name, f.specific, f.assign_function  from      sysibm.sysfunctions as f,      sysibm.sysfuncparms as p1,      sysibm.sysfuncparms as p2  where      f.cast_function = 'Y'      and f.schema = p1.fschema      and f.specific = p1.fspecific      and f.schema = p2.fschema      and f.specific = p2.fspecific      and p1.rowtype = 'P'      and p1.ordinal = 1      and p2.rowtype = 'C'      and p2.ordinal = 0;

CREATE VIEW REFERENCES (CONSTNAME, TABSCHEMA, TABNAME, DEFINER, REFKEYNAME, REFTABSCHEMA, REFTABNAME, COLCOUNT, DELETERULE, UPDATERULE, CREATE_TIME, FK_COLNAMES, PK_COLNAMES) AS
select      relname, creator, tbname, definer, refkeyname,      reftbcreator, reftbname, colcount, deleterule, updaterule,      timestamp, fkcolnames, pkcolnames  from sysibm.sysrels;

CREATE VIEW INDEXAUTH (GRANTOR, GRANTEE, GRANTEETYPE, INDSCHEMA, INDNAME, CONTROLAUTH) AS
select      grantor, grantee, granteetype, creator, name,      controlauth  from sysibm.sysindexauth;

CREATE VIEW TBSPACEAUTH (GRANTOR, GRANTEE, GRANTEETYPE, TBSPACE, USEAUTH) AS
select      grantor, grantee, granteetype, tbspace, useauth  from sysibm.systbspaceauth;

CREATE VIEW SYSFUNCPARMS (FNAME, FSCHEMA, FSPECIFIC, ROWTYPE, ORDINAL, TYPENAME, TYPESCHEMA, LENGTH, SCALE, CODEPAGE, CAST_FUNCTION_ID, PARMNAME, AS_LOCATOR, TARGET_TYPESCHEMA, TARGET_TYPENAME, SCOPE_TABSCHEMA, SCOPE_TABNAME, TRANSFORM_GRPNAME) AS
select      routinename, routineschema, specificname, rowtype, ordinal,      typename, typeschema, length, scale, codepage, cast_function_id,      parmname, locator, target_typeschema, target_typename,      scope_tabschema, scope_tabname, transform_grpname   from sysibm.sysroutineparms   where routinetype in ('F', 'M');

CREATE VIEW SCHEMAAUTH (GRANTOR, GRANTEE, GRANTEETYPE, SCHEMANAME, ALTERINAUTH, CREATEINAUTH, DROPINAUTH) AS
select      grantor, grantee, granteetype, schemaname, alterinauth,      createinauth, dropinauth  from sysibm.sysschemaauth;

CREATE VIEW XMLOBJECTXMLDEP (OBJECTID, DTYPE, BTYPE, BOBJECTID, OBJECTAUTHS) AS
select objectid,dtype,btype,bobjectid,objectauths  from sysibm.sysxmlobjectxmldep;

CREATE VIEW COLGROUPS (COLGROUPSCHEMA, COLGROUPNAME, COLGROUPID, COLGROUPCARD, NUMFREQ_VALUES, NUMQUANTILE) AS
select      colgroupschema, colgroupname, colgroupid, colgroupcard,      numfreq_values, numquantiles  from sysibm.syscolgroups;

CREATE VIEW LIBRARYBINDFILES (LIBSCHEMA, LIBNAME, LIBVERSION, PACKAGE_SCHEMA, PACKAGE_NAME, PACKAGE_VERSION, BINDFILE_PATH) AS
select      l.libschema, l.libname, b.libversion, b.package_schema,      b.package_name, b.package_version,      b.bindfile_path  from sysibm.syslibrarybindfiles as b,       sysibm.syslibraries as l  where b.lib_id = l.lib_id;

CREATE VIEW DATATYPES (TYPESCHEMA, TYPENAME, DEFINER, SOURCESCHEMA, SOURCENAME, METATYPE, TYPEID, SOURCETYPEID, LENGTH, SCALE, CODEPAGE, CREATE_TIME, ATTRCOUNT, INSTANTIABLE, WITH_FUNC_ACCESS, FINAL, INLINE_LENGTH, REMARKS, JARSCHEMA, JAR_ID, CLASS, SQLJ_REPRESENTATION, NATURAL_INLINE_LENGTH, ALTER_TIME) AS
select      schema, name, definer, sourceschema,      sourcetype, metatype, typeid, sourcetypeid, length, scale,      codepage, create_time, attrcount, instantiable,      with_func_access, final, inline_length, remarks,      jarschema, jar_id, class, sqlj_representation,      natural_inline_length, alter_time  from sysibm.sysdatatypes;

CREATE VIEW COLDIST (TABSCHEMA, TABNAME, COLNAME, TYPE, SEQNO, COLVALUE, VALCOUNT, DISTCOUNT) AS
select     schema, tbname, name, type, seqno, colvalue, valcount,     distcount     from sysibm.syscoldist X     where exists           (select 1            from sysibm.systabauth            where ttname = X.tbname            and tcreator = X.schema            and grantee = USER            and controlauth = 'Y')         or exists            (select 1             from sysibm.sysdbauth             where grantee = USER             and dbadmauth = 'Y');

CREATE VIEW ERRORMESSAGES (MODELNAME, RC, SQLSTATE, EXCID, PROCNAME, COMPNAME, TIMESTMP, MESSAGE) AS
select MODELNAME, RC, SQLSTATE, EXCID, PROCNAME, COMPNAME, TIMESTMP, MESSAGE from IDMMX.CALLIDS c, IDMMX.ERRORTABLE e where c.CALLID = e.CALLID;

CREATE VIEW INPUT_06 (CLIENT_ID, AGE, GENDER, MARITAL_STATUS, PROFESSION, NBR_YEARS_CLI, SAVINGS_ACCOUNT, HAS_LIFE_INSURANCE, INT_CREDITCARD, ONLINE_ACCESS, JOINED_ACCOUNTS, BANKCARD, AVERAGE_BALANCE, NO_CRED_TRANS, NO_DEBIT_TRANS, DEV_DEGREE, CLUSTER_ID) AS
SELECT    "CLIENT_ID" AS "CLIENT_ID",    "AGE" AS "AGE",    "GENDER" AS "GENDER",    "MARITAL_STATUS" AS "MARITAL_STATUS",    "PROFESSION" AS "PROFESSION",    "NBR_YEARS_CLI" AS "NBR_YEARS_CLI",    "SAVINGS_ACCOUNT" AS "SAVINGS_ACCOUNT",    "HAS_LIFE_INSURANCE" AS "HAS_LIFE_INSURANCE",    "INT_CREDITCARD" AS "INT_CREDITCARD",    "ONLINE_ACCESS" AS "ONLINE_ACCESS",    "JOINED_ACCOUNTS" AS "JOINED_ACCOUNTS",    "BANKCARD" AS "BANKCARD",    "AVERAGE_BALANCE" AS "AVERAGE_BALANCE",    "NO_CRED_TRANS" AS "NO_CRED_TRANS",    "NO_DEBIT_TRANS" AS "NO_DEBIT_TRANS",    "DEV_DEGREE" AS "DEV_DEGREE",    "CLUSTER_ID" AS "CLUSTER_ID"  FROM IDMMX."IM_FINDDEVIATIONS_03";

CREATE VIEW SQLFOREIGNKEYS (PKTABLE_CAT, PKTABLE_SCHEM, PKTABLE_NAME, PKCOLUMN_NAME, FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, FKCOLUMN_NAME, KEY_SEQ, UPDATE_RULE, DELETE_RULE, FK_NAME, PK_NAME, DEFERRABILITY, UNIQUE_OR_PRIMARY) AS
 SELECT     CAST( NULL AS VARCHAR(128) ),     RTRIM(T1.CREATOR),     T1.NAME,     PK.COLNAME,     CAST( NULL AS VARCHAR(128) ),     RTRIM(T2.CREATOR),     T2.NAME,     FK.COLNAME,     PK.COLSEQ,     SMALLINT(       CASE R.UPDATERULE         WHEN 'C' THEN 0         WHEN 'R' THEN 1         WHEN 'N' THEN 2         WHEN 'A' THEN 3       END), SMALLINT(       CASE R.DELETERULE         WHEN 'C' THEN 0         WHEN 'R' THEN 1         WHEN 'N' THEN 2         WHEN 'A' THEN 3       END),     FK.CONSTNAME,     PK.CONSTNAME,     SMALLINT(7),     CASE TC.CONSTRAINTYP         WHEN 'P' THEN CAST( 'PRIMARY' AS CHAR(7) )         WHEN 'U' THEN CAST( 'UNIQUE' AS CHAR(7) )     END   FROM     SYSIBM.SYSTABLES T1,     SYSIBM.SYSTABLES T2,     SYSIBM.SYSRELS R,     SYSIBM.SYSKEYCOLUSE PK,     SYSIBM.SYSKEYCOLUSE FK,     SYSIBM.SYSTABCONST TC   WHERE     PK.COLSEQ        = FK.COLSEQ     AND PK.TBNAME    = R.REFTBNAME     AND PK.TBCREATOR = R.REFTBCREATOR     AND FK.TBNAME    = R.TBNAME      AND FK.TBCREATOR = R.CREATOR     AND PK.CONSTNAME = R.REFKEYNAME     AND FK.CONSTNAME = R.RELNAME     AND TC.NAME = R.REFKEYNAME     AND TC.TBNAME    = PK.TBNAME     AND TC.TBCREATOR = PK.TBCREATOR     AND TABLE_SCHEMA( T1.NAME, T1.CREATOR ) = R.REFTBCREATOR     AND TABLE_NAME( T1.NAME, T1.CREATOR )   = R.REFTBNAME     AND TABLE_SCHEMA( T2.NAME, T2.CREATOR ) = R.CREATOR     AND TABLE_NAME( T2.NAME, T2.CREATOR )   = R.TBNAME     AND T1.TYPE IN ('A', 'T')     AND T2.TYPE IN ('A', 'T');

CREATE VIEW SQLTABLES (TABLE_CAT, TABLE_SCHEM, TABLE_NAME, TABLE_TYPE, REMARKS, TYPE_CAT, TYPE_SCHEM, TYPE_NAME, SELF_REF_COL_NAME, REF_GENERATION, DBNAME) AS
  SELECT     CAST( NULL AS VARCHAR(128) ),     RTRIM(T.CREATOR),     T.NAME,     CASE       WHEN T.TYPE='T' AND T.CREATOR='SYSIBM' THEN 'SYSTEM TABLE'       WHEN T.TYPE='T' AND T.CREATOR<>'SYSIBM' THEN 'TABLE'       WHEN T.TYPE='V' AND T.STATUS<>'X' THEN 'VIEW'       WHEN T.TYPE='V' AND T.STATUS='X' THEN 'INOPERATIVE VIEW'       WHEN T.TYPE='X' THEN NULL       ELSE TT.TABLE_TYPE     END,     T.REMARKS,     CAST( NULL AS VARCHAR(128) ),     CAST( NULL AS VARCHAR(128) ),     CAST( NULL AS VARCHAR(128) ),     CAST( NULL AS VARCHAR(128) ),     CAST( NULL AS VARCHAR(128) ),     CAST( NULL AS VARCHAR(8) )   FROM     SYSIBM.SYSTABLES T,     SYSIBM.SQLTABLETYPES TT   WHERE     T.TYPE = TT.TYPE;

CREATE VIEW XMLOBJECTPROPERTIES (OBJECTID, OPTION, SETTING) AS
select  objectid,option,setting  from sysibm.sysxmlobjectproperties;

CREATE VIEW HIERARCHIES (METATYPE, SUB_SCHEMA, SUB_NAME, SUPER_SCHEMA, SUPER_NAME, ROOT_SCHEMA, ROOT_NAME) AS
select      metatype, sub_schema, sub_name, super_schema, super_name, root_schema, root_name  from sysibm.syshierarchies;

CREATE VIEW SQLTYPEINFO (TYPE_NAME, DATA_TYPE, COLUMN_SIZE, LITERAL_PREFIX, LITERAL_SUFFIX, CREATE_PARAMS, NULLABLE, CASE_SENSITIVE, SEARCHABLE, UNSIGNED_ATTRIBUTE, FIXED_PREC_SCALE, AUTO_UNIQUE_VALUE, LOCAL_TYPE_NAME, MINIMUM_SCALE, MAXIMUM_SCALE, SQL_DATA_TYPE, SQL_DATETIME_SUB, NUM_PREC_RADIX, INTERVAL_PRECISION, JDBC_DATA_TYPE) AS
 VALUES   ( VARCHAR( 'INTEGER', 128 ),     SMALLINT(4),     10,     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(2),     SMALLINT(0),     SMALLINT(1),     SMALLINT(0),     CAST(NULL AS VARCHAR(128)),     SMALLINT(0),     SMALLINT(0),     4,     CAST(NULL AS INTEGER),     10,     CAST(NULL AS SMALLINT),     SMALLINT(4) ),   ( 'SMALLINT',     SMALLINT(5),     5,     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(2),     SMALLINT(0),     SMALLINT(1),     SMALLINT(0),     CAST(NULL AS VARCHAR(128)),     SMALLINT(0),     SMALLINT(0),     5,     CAST(NULL AS INTEGER),     10,     CAST(NULL AS SMALLINT),     SMALLINT(5) ),   ( 'BIGINT',     SMALLINT(-5),     20,     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(2),     SMALLINT(0),     SMALLINT(1),     SMALLINT(0),     CAST(NULL AS VARCHAR(128)),     SMALLINT(0),     SMALLINT(0),     -5,     CAST(NULL AS INTEGER),     10,     CAST(NULL AS SMALLINT),     SMALLINT(-5) ),   ( 'REAL',     SMALLINT(7),     24,     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(2),     SMALLINT(0),     SMALLINT(0),     SMALLINT(0),     CAST(NULL AS VARCHAR(128)),     SMALLINT(0),     SMALLINT(0),     7,     CAST(NULL AS INTEGER),     2,     CAST(NULL AS SMALLINT),     SMALLINT(7) ),   ( 'DOUBLE',     SMALLINT(8),     53,     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(2),     SMALLINT(0),     SMALLINT(0),     SMALLINT(0),     CAST(NULL AS VARCHAR(128)),     SMALLINT(0),     SMALLINT(0),     8,     CAST(NULL AS INTEGER),     2,     CAST(NULL AS SMALLINT),     SMALLINT(8) ),   ( 'CHAR',     SMALLINT(1),     254,     CAST('''' AS VARCHAR(128)),     CAST('''' AS VARCHAR(128)),     CAST('LENGTH' AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(1),     SMALLINT(3),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     1,     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(1) ),   ( 'VARCHAR',     SMALLINT(12),     4000,     CAST('''' AS VARCHAR(128)),     CAST('''' AS VARCHAR(128)),     CAST('LENGTH' AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(1),     SMALLINT(3),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     12,     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(12) ),   ( 'LONG VARCHAR',     SMALLINT(-1),     32700,     CAST('''' AS VARCHAR(128)),     CAST('''' AS VARCHAR(128)),     CAST('LENGTH' AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(1),     SMALLINT(1),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     -1,     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(-1) ),   ( 'DECIMAL',     SMALLINT(3),     31,     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     CAST('PRECISION,SCALE' AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(2),     SMALLINT(0),     SMALLINT(0),     SMALLINT(0),     CAST(NULL AS VARCHAR(128)),     SMALLINT(0),     SMALLINT(31),     3,     CAST(NULL AS INTEGER),     10,     CAST(NULL AS SMALLINT),     SMALLINT(3) ),   ( 'GRAPHIC',     SMALLINT(-95),     127,     CAST('G''' AS VARCHAR(128)),     CAST('''' AS VARCHAR(128)),     CAST('LENGTH' AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(3),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     -95,     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(1) ),   ( 'VARGRAPHIC',     SMALLINT(-96),     16336,     CAST('G''' AS VARCHAR(128)),     CAST('''' AS VARCHAR(128)),     CAST('LENGTH' AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(3),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     -96,     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(12) ),   ( 'LONG VARGRAPHIC',     SMALLINT(-97),     16350,     CAST('G''' AS VARCHAR(128)),     CAST('''' AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(1),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     -97,     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(-1) ),   ( 'BLOB',     SMALLINT(-98),     2147483647,     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     CAST('LENGTH' AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(1),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     -98,     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(2004) ),   ( 'CLOB',     SMALLINT(-99),     2147483647,     CAST('''' AS VARCHAR(128)),     CAST('''' AS VARCHAR(128)),     CAST('LENGTH' AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(1),     SMALLINT(1),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     -99,     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(2005) ),   ( 'DBCLOB',     SMALLINT(-350),     1073741823,     CAST('''' AS VARCHAR(128)),     CAST('''' AS VARCHAR(128)),     CAST('LENGTH' AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(1),     SMALLINT(1),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     -350,     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(2005) ),   ( 'DATE',     SMALLINT(91),     10,     CAST('''' AS VARCHAR(128)),     CAST('''' AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(2),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     9,     1,     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(91) ),   ( 'TIME',     SMALLINT(92),     8,     CAST('''' AS VARCHAR(128)),     CAST('''' AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(2),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(0 AS SMALLINT),     CAST(0 AS SMALLINT),     9,     2,     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(92) ),   ( 'TIMESTAMP',     SMALLINT(93),     26,     CAST('''' AS VARCHAR(128)),     CAST('''' AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(2),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(6 AS SMALLINT),     CAST(6 AS SMALLINT),     9,     3,     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(93) ),   ( 'DATALINK',     SMALLINT(-400),     254,     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(0),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     -400,     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(70) ),   ( 'LONG VARCHAR FOR BIT DATA',     SMALLINT(-4),     32700,     CAST('''' AS VARCHAR(128)),     CAST('''' AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(0),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     -4,     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(-4) ),   ( 'VARCHAR () FOR BIT DATA',     SMALLINT(-3),     32762,     CAST('''' AS VARCHAR(128)),     CAST('''' AS VARCHAR(128)),     CAST('LENGTH' AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(3),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     -3,     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(-3) ),   ( 'CHAR () FOR BIT DATA',     SMALLINT(-2),     254,     CAST('''' AS VARCHAR(128)),     CAST('''' AS VARCHAR(128)),     CAST('LENGTH' AS VARCHAR(128)),     SMALLINT(1),     SMALLINT(0),     SMALLINT(3),     CAST(NULL AS SMALLINT),     SMALLINT(0),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     -2,     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(-2) ),   ( 'DISTINCT',     SMALLINT(2001),     CAST(NULL AS INTEGER),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     CAST(NULL AS VARCHAR(128)),     CAST(NULL AS SMALLINT),     CAST(NULL AS SMALLINT),     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS INTEGER),     CAST(NULL AS SMALLINT),     SMALLINT(2001) );

CREATE VIEW NAMEMAPPINGS (TYPE, LOGICAL_SCHEMA, LOGICAL_NAME, LOGICAL_COLNAME, IMPL_SCHEMA, IMPL_NAME, IMPL_COLNAME) AS
select      type, logical_schema, logical_name, logical_colname,      impl_schema, impl_name, impl_colname  from sysibm.sysnamemappings;

CREATE VIEW ROUTINEPARMS (ROUTINESCHEMA, ROUTINENAME, SPECIFICNAME, PARMNAME, ROWTYPE, ORDINAL, TYPESCHEMA, TYPENAME, LOCATOR, LENGTH, SCALE, CODEPAGE, CAST_FUNCSCHEMA, CAST_FUNCSPECIFIC, TARGET_TYPESCHEMA, TARGET_TYPENAME, SCOPE_TABSCHEMA, SCOPE_TABNAME, TRANSFORMGRPNAME, REMARKS) AS
select      (select routineschema from sysibm.sysroutines as b       where b.routine_id = a.routine_id),      (select routinename from sysibm.sysroutines as b       where b.routine_id = a.routine_id),      (select specificname from sysibm.sysroutines as b       where b.routine_id = a.routine_id),      parmname, rowtype, ordinal,      (select schema from sysibm.sysdatatypes as b       where b.typeid = a.typeid),      (select name from sysibm.sysdatatypes as b       where b.typeid = a.typeid),      locator, length, scale, codepage,      (select routineschema from sysibm.sysroutines as b       where b.routine_id = a.cast_function_id),      (select specificname from sysibm.sysroutines as b       where b.routine_id = a.cast_function_id),      (select schema from sysibm.sysdatatypes as b       where b.typeid = a.target_typeid ),      (select name from sysibm.sysdatatypes as b       where b.typeid = a.target_typeid ),      scope_tabschema, scope_tabname, transform_grpname, remarks from sysibm.sysroutineparms as a;

CREATE VIEW SYSPROCPARMS (PROCSCHEMA, PROCNAME, SPECIFICNAME, ORDINAL, PARMNAME, TYPESCHEMA, TYPENAME, LENGTH, SCALE, CODEPAGE, PARM_MODE, AS_LOCATOR, TARGET_TYPESCHEMA, TARGET_TYPENAME, SCOPE_TABSCHEMA, SCOPE_TABNAME, TYPEID, SOURCETYPEID, SERVERNAME, DBCS_CODEPAGE, NULLS) AS
select      routineschema, routinename, specificname, ordinal, parmname,      typeschema, typename, length, scale, codepage,      CAST (CASE rowtype            WHEN 'P' THEN 'IN'            WHEN 'O' THEN 'OUT'            ELSE 'INOUT' END AS VARCHAR(5)) ,      locator, target_typeschema, target_typename,      scope_tabschema, scope_tabname, typeid,      cast(null as smallint), cast(null as varchar(128)),      cast(null as smallint), cast('Y' as char(1))   from sysibm.sysroutineparms   where routinetype in ('P');

CREATE VIEW COLOPTIONS (TABSCHEMA, TABNAME, COLNAME, OPTION, SETTING) AS
select      tabschema, tabname, colname, option, setting  from sysibm.syscoloptions;

CREATE VIEW INPUT_03 (CLIENT_ID, AGE, GENDER, MARITAL_STATUS, PROFESSION, NBR_YEARS_CLI, SAVINGS_ACCOUNT, HAS_LIFE_INSURANCE, INT_CREDITCARD, ONLINE_ACCESS, JOINED_ACCOUNTS, BANKCARD, AVERAGE_BALANCE, NO_CRED_TRANS, NO_DEBIT_TRANS) AS
   SELECT      CLIENT_ID AS CLIENT_ID,     AGE AS AGE,     GENDER AS GENDER,     MARITAL_STATUS AS MARITAL_STATUS,     PROFESSION AS PROFESSION,     NBR_YEARS_CLI AS NBR_YEARS_CLI,     SAVINGS_ACCOUNT AS SAVINGS_ACCOUNT,     HAS_LIFE_INSURANCE AS HAS_LIFE_INSURANCE,     INT_CREDITCARD AS INT_CREDITCARD,     ONLINE_ACCESS AS ONLINE_ACCESS,     JOINED_ACCOUNTS AS JOINED_ACCOUNTS,     BANKCARD AS BANKCARD,     AVERAGE_BALANCE AS AVERAGE_BALANCE,     NO_CRED_TRANS AS NO_CRED_TRANS,     NO_DEBIT_TRANS AS NO_DEBIT_TRANS   FROM YSAILLET.BANKCUSTOMERS;

CREATE VIEW EVENTTABLES (EVMONNAME, LOGICAL_GROUP, TABSCHEMA, TABNAME, PCTDEACTIVATE) AS
select      evmonname, logical_group, tabschema, tabname, pctdeactivate  from sysibm.syseventtables;

CREATE VIEW SEQUENCEAUTH (GRANTOR, GRANTEE, GRANTEETYPE, SEQSCHEMA, SEQNAME, USAGEAUTH, ALTERAUTH) AS
select      a.grantor, a.grantee, a.granteetype,      b.seqschema, b.seqname, a.usageauth, a.alterauth  from sysibm.syssequenceauth as a, sysibm.syssequences as b  where a.seqid = b.seqid;

CREATE VIEW INDEXEXTENSIONS (IESCHEMA, IENAME, DEFINER, CREATE_TIME, KEYGENFUNCSCHEMA, KEYGENFUNCNAME, KEYGENSPECIFICNAME, TEXT, REMARKS) AS
select      ieschema, iename, definer, create_time, ktfuncschema,      ktfuncname, ktspecificname, text, remarks   from sysibm.sysindexextensions;

CREATE VIEW VIEWS (VIEWSCHEMA, VIEWNAME, DEFINER, SEQNO, VIEWCHECK, READONLY, VALID, QUALIFIER, FUNC_PATH, TEXT) AS
select      creator, name, definer, 1, check, readonly,      valid, qualifier, func_path, text  from sysibm.sysviews;

CREATE VIEW COLCHECKS (CONSTNAME, TABSCHEMA, TABNAME, COLNAME, USAGE) AS
select      constname,tbcreator, tbname, colname, usage  from sysibm.syscolchecks;

CREATE VIEW FUNCMAPOPTIONS (FUNCTION_MAPPING, OPTION, SETTING) AS
select      function_mapping, option, setting  from sysibm.sysfuncmapoptions;

CREATE VIEW INDEXEXPLOITRULES (FUNCID, SPECID, IESCHEMA, IENAME, RULEID, SEARCHMETHODID, SEARCHKEY, SEARCHARGUMENT, EXACT) AS
select      funcid, specid, ieschema, iename, ruleid, searchmethodid,      searchkey, searchargument, exact  from sysibm.sysindexexploitrules;

CREATE VIEW FUNCPARMS (FUNCSCHEMA, FUNCNAME, SPECIFICNAME, ROWTYPE, ORDINAL, PARMNAME, TYPESCHEMA, TYPENAME, LENGTH, SCALE, CODEPAGE, CAST_FUNCID, AS_LOCATOR, TARGET_TYPESCHEMA, TARGET_TYPENAME, SCOPE_TABSCHEMA, SCOPE_TABNAME, TRANSFORM_GRPNAME) AS
select      routineschema, routinename, specificname, rowtype, ordinal,      parmname, typeschema, typename, length, scale, codepage,      cast_function_id, locator, target_typeschema,      target_typename, scope_tabschema, scope_tabname,      transform_grpname  from sysibm.sysroutineparms  where routinetype in ('F', 'M');

CREATE VIEW XMLPHYSICALCOLLECTIONS (OBJECTID, LINKEDNAME, CREATE_TIME, DEFINER, LINKS_COUNT, PRIMARYUSE, STORAGE, TBSPACEID, COLLECTIONTYPE, BUFFERPOOLID, DBPGNAME, OBJECTCOUNT, AVGOBJECTSIZE, MINOBJECTSIZE, MAXOBJECTSIZE) AS
select pc.objectid,  (select r.linkedname from sysibm.sysxmlrelationships r where r.childid=pc.objectid and r.parentid IS NULL and r.referenced_relationshipid IS NULL),  o.create_time,o.definer,o.links_count,pc.primaryuse,pc.storage,pc.tbspaceid,pc.collectiontype,pc.bufferpoolid,pc.dbpgname,  (select s.value from sysibm.sysxmlstats s where s.statistictype='OBJECTCOUNT' and s.objectid=pc.objectid),  (select s.value from sysibm.sysxmlstats s where s.statistictype='AVGOBJECTSIZE' and s.objectid=pc.objectid),  (select s.value from sysibm.sysxmlstats s where s.statistictype='MINOBJECTSIZE' and s.objectid=pc.objectid),  (select s.value from sysibm.sysxmlstats s where s.statistictype='MAXOBJECTSIZE' and s.objectid=pc.objectid)  from sysibm.sysxmlphysicalcollections pc,sysibm.sysxmlobjects o  where o.objectid=pc.objectid;

CREATE VIEW TABOPTIONS (TABSCHEMA, TABNAME, OPTION, SETTING) AS
select       tabschema, tabname, option, setting  from sysibm.systaboptions;

--CREATE VIEW XLITABLES (TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, TABLE_TYPE, SELF_REFERENCING_COLUMN_NAME, REFERENCE_GENERATION, USER_DEFINED_TYPE_CATALOG, USER_DEFINED_TYPE_SCHEMA, USER_DEFINED_TYPE_NAME, IS_INSERTABLE_INTO) AS
-- WITH T_ALIAS (A_SCHEMA, A_NAME, B_SCHEMA, B_NAME, NUM) AS  (     SELECT CREATOR, NAME, BASE_SCHEMA, BASE_NAME, 1     FROM        SYSIBM.SYSTABLES T     WHERE  T.TYPE='A' UNION ALL     SELECT  A_SCHEMA, A_NAME, BASE_SCHEMA, BASE_NAME, NUM+1     FROM T_ALIAS,         SYSIBM.SYSTABLES     WHERE B_SCHEMA = CREATOR       AND B_NAME = NAME       AND NUM <= 128 ), T_ALIAS2 (A2_SCHEMA, A2_NAME, READONLY) AS  (     SELECT A_SCHEMA, A_NAME, READONLY     FROM     T_ALIAS, SYSIBM.SYSVIEWS     WHERE B_SCHEMA = CREATOR       AND B_NAME = NAME )  SELECT CAST(CURRENT SERVER AS  VARCHAR(128)),         T.CREATOR ,         T.NAME ,         CASE  TYPE           WHEN 'A' THEN 'ALIAS'           WHEN 'H' THEN 'HIERARCHY TABLE'           WHEN 'J' THEN 'HIERARCHY VIEW'           WHEN 'S' THEN 'MATERIALIZED QUERY TABLE'           WHEN 'T' THEN 'BASE TABLE'           WHEN 'U' THEN 'TYPED TABLE'           WHEN 'V' THEN 'VIEW'           WHEN 'W' THEN 'TYPED VIEW'           ELSE CAST('' AS  VARCHAR(128))         END ,         P.COLNAME,         CASE SUBSTR(P.SPECIAL_PROPS,2,1)            WHEN 'U' THEN  'USER GENERATED'            WHEN 'S' THEN  'SYSTEM GENERATED'            ELSE CAST(NULL AS  VARCHAR(16))         END, CASE   WHEN T.TYPE IN ('U', 'W') THEN CAST(CURRENT SERVER AS  VARCHAR(128))   ELSE CAST(NULL AS  VARCHAR(128)) END, CASE   WHEN T.TYPE IN ('U', 'W') THEN  ROWTYPESCHEMA   ELSE CAST(NULL AS  VARCHAR(128)) END, CASE   WHEN T.TYPE IN ('U', 'W') THEN CAST(ROWTYPENAME AS  VARCHAR(128))   ELSE CAST(NULL AS  VARCHAR(128)) END, CASE   WHEN TYPE='A' AND (A2.READONLY='N' OR A2.READONLY  IS NULL)     THEN 'YES'   WHEN TYPE='A' AND A2.READONLY='Y'     THEN 'NO'   WHEN TYPE='G' THEN 'YES'   WHEN TYPE='H' THEN 'NO'   WHEN TYPE='J' THEN 'NO'   WHEN TYPE='S' AND SUBSTR(PROPERTY,1,1)<>'Y' THEN 'NO'   WHEN TYPE='S' AND SUBSTR(PROPERTY,1,1) ='Y' THEN 'YES'   WHEN TYPE='T' THEN 'YES'   WHEN TYPE='U' THEN 'YES'   WHEN TYPE IN ('V','W') AND V.READONLY='Y' THEN 'NO'   WHEN TYPE IN ('V','W') AND V.READONLY='N' THEN 'YES'   ELSE 'NO' END FROM ( SYSIBM.SYSTABLES  T       LEFT OUTER JOIN         SYSIBM.SYSCOLPROPERTIES P        ON (T.CREATOR, T.NAME) = (P.TABSCHEMA, P.TABNAME)            AND SUBSTR(P.SPECIAL_PROPS,1,1) = 'Y'      )      LEFT OUTER JOIN        SYSIBM.SYSVIEWS V       ON (T.CREATOR, T.NAME) = (V.CREATOR, V.NAME)      LEFT OUTER JOIN        T_ALIAS2 A2       ON (T.CREATOR, T.NAME) = (A2_SCHEMA, A2_NAME);


CREATE VIEW PROCEDURES (PROCSCHEMA, PROCNAME, SPECIFICNAME, PROCEDURE_ID, DEFINER, PARM_COUNT, PARM_SIGNATURE, ORIGIN, CREATE_TIME, DETERMINISTIC, FENCED, NULLCALL, LANGUAGE, IMPLEMENTATION, CLASS, JAR_ID, PARM_STYLE, CONTAINS_SQL, DBINFO, PROGRAM_TYPE, RESULT_SETS, VALID, TEXT_BODY_OFFSET, TEXT, REMARKS) AS
select      a.routineschema, a.routinename, a.specificname, a.routine_id,      a.definer, a.parm_count, a.parm_signature, a.origin, a.createdts,      a.deterministic, a.fenced, a.null_call, a.language, a.implementation,      CASE WHEN a.language <> 'JAVA'        THEN NULL      ELSE        (SELECT pj.class FROM         SYSIBM.SYSROUTINEPROPERTIESJAVA AS pj         WHERE pj.routine_id = a.routine_id)      END,      CASE WHEN a.language <> 'JAVA'        THEN NULL      ELSE        (SELECT pj.jar_id FROM         SYSIBM.SYSROUTINEPROPERTIESJAVA AS pj         WHERE pj.routine_id = a.routine_id)      END,      a.parameter_style, a.sql_data_access, a.dbinfo,      a.program_type, a.result_sets, a.valid, a.text_body_offset, a.text,      a.remarks  from sysibm.sysroutines as a  where a.routinetype in ('P');

CREATE VIEW SYSPROCEDURES (PROCSCHEMA, PROCNAME, SPECIFICNAME, PROCEDURE_ID, DEFINER, PARM_COUNT, PARM_SIGNATURE, ORIGIN, CREATE_TIME, FENCED, NULLCALL, LANGUAGE, IMPLEMENTATION, PARM_STYLE, RESULT_SETS, REMARKS, DETERMINISTIC, PACKED_DESC, CONTAINS_SQL, DBINFO, PROGRAM_TYPE, VALID, CLASS, JAR_ID, TEXT_BODY_OFFSET, TEXT) AS
select      a.routineschema, a.routinename, a.specificname, a.routine_id, a.definer,      a.parm_count, a.parm_signature, a.origin, a.createdts, a.fenced,      a.null_call, a.language, a.implementation, a.parameter_style, a.result_sets, a.remarks,      a.deterministic, a.internal_desc, a.sql_data_access, a.dbinfo, a.program_type,      a.valid,      CASE WHEN a.language <> 'JAVA'        THEN NULL      ELSE        (SELECT pj.class FROM         SYSIBM.SYSROUTINEPROPERTIESJAVA AS pj         WHERE pj.routine_id = a.routine_id)      END,      CASE WHEN a.language <> 'JAVA'        THEN NULL      ELSE         (SELECT pj.jar_id FROM         SYSIBM.SYSROUTINEPROPERTIESJAVA AS pj         WHERE pj.routine_id = a.routine_id)      END,  a.text_body_offset, a.text  from sysibm.sysroutines as a  where a.routinetype in ('P');

CREATE VIEW SQLTABLETYPES (TABLE_CAT, TABLE_SCHEM, TABLE_NAME, TABLE_TYPE, REMARKS, TYPE_CAT, TYPE_SCHEM, TYPE_NAME, SELF_REF_COL_NAME, REF_GENERATION, DBNAME, TYPE) AS
  VALUES     ( CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       VARCHAR( 'ALIAS', 128),       CAST( NULL AS VARCHAR(254) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(8) ),       CHAR( 'A', 1 ) ),  ( CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       VARCHAR( 'HIERARCHY TABLE', 128),       CAST( NULL AS VARCHAR(254) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(8) ),       CHAR( 'H', 1 ) ),     ( CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       VARCHAR( 'INOPERATIVE VIEW', 128),       CAST( NULL AS VARCHAR(254) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(8) ),       CHAR( '?', 1 ) ),  ( CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       VARCHAR( 'NICKNAME', 128 ),       CAST( NULL AS VARCHAR(254) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(8) ),       CHAR( 'N', 1 ) ),     ( CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       VARCHAR( 'MATERIALIZED QUERY TABLE', 128),       CAST( NULL AS VARCHAR(254) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(8) ),       CHAR( 'S', 1 ) ),     ( CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       VARCHAR( 'SYSTEM TABLE', 128),       CAST( NULL AS VARCHAR(254) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(8) ),       CHAR( '?', 1 ) ),     ( CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       VARCHAR( 'TABLE', 128),       CAST( NULL AS VARCHAR(254) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(8) ),       CHAR( 'T', 1 ) ),     ( CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       VARCHAR( 'TYPED TABLE', 128),       CAST( NULL AS VARCHAR(254) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(8) ),       CHAR( 'U', 1 ) ),  ( CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       VARCHAR( 'TYPED VIEW', 128),       CAST( NULL AS VARCHAR(254) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(8) ),       CHAR( 'W', 1 ) ),     ( CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       VARCHAR( 'VIEW', 128),       CAST( NULL AS VARCHAR(254) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(128) ),       CAST( NULL AS VARCHAR(8) ),       CHAR( 'V', 1 ) );

CREATE VIEW CHECK_CONSTRAINTS (CONSTRAINT_CATALOG, CONSTRAINT_SCHEMA, CONSTRAINT_NAME, CHECK_CLAUSE) AS
SELECT CAST(CURRENT SERVER AS VARCHAR(128)), TBCREATOR, CAST(NAME AS VARCHAR(128)), TEXT FROM SYSIBM.SYSCHECKS WHERE TYPE='C' UNION ALL SELECT CAST(CURRENT SERVER AS VARCHAR(128)), TBCREATOR, CAST(CONCAT(RTRIM(CONCAT(CHAR(CTIME), CHAR(FID) ) ), RTRIM(CHAR(COLNO)) ) AS VARCHAR(128) ), CAST(CONCAT(CONCAT('CHECK (', C.NAME), 'IS NOT NULL)') AS CLOB(64K) ) FROM SYSIBM.SYSCOLUMNS C, SYSIBM.SYSTABLES T WHERE C.TBCREATOR = T.CREATOR AND C.TBNAME = T.NAME AND TYPE IN ('U', 'T') AND NULLS ='N';

CREATE VIEW INDEXOPTIONS (INDSCHEMA, INDNAME, OPTION, SETTING) AS
select      indschema, indname, option, setting  from sysibm.sysindexoptions;

CREATE VIEW ROUTINES (ROUTINESCHEMA, ROUTINENAME, ROUTINETYPE, SPECIFICNAME, IOS_PER_INVOC, INSTS_PER_INVOC, IOS_PER_ARGBYTE, INSTS_PER_ARGBYTE, PERCENT_ARGBYTES, INITIAL_IOS, INITIAL_INSTS, CARDINALITY, SELECTIVITY) AS
select      routineschema, routinename, routinetype, specificname, ios_per_invoc,     insts_per_invoc, ios_per_argbyte, insts_per_argbyte, percent_argbytes,      initial_ios, initial_insts, cardinality, selectivity  from sysibm.sysroutines  where  (  routineschema = USER OR     exists     (        select 1        from sysibm.sysdbauth        where grantee = USER and dbadmauth = 'Y'      ) );

CREATE VIEW SQLSTATISTICS (TABLE_CAT, TABLE_SCHEM, TABLE_NAME, NON_UNIQUE, INDEX_QUALIFIER, INDEX_NAME, TYPE, ORDINAL_POSITION, COLUMN_NAME, ASC_OR_DESC, CARDINALITY, PAGES, FILTER_CONDITION) AS
 SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(I.TBCREATOR),    I.TBNAME,    SMALLINT( CASE     WHEN I.UNIQUERULE='D' THEN 1     WHEN I.UNIQUERULE='P' THEN 0     WHEN I.UNIQUERULE='U' THEN 0     ELSE 0    END),    RTRIM(I.CREATOR),    I.NAME,    SMALLINT(CASE     WHEN I.INDEXTYPE='CLUS' THEN 1     WHEN I.INDEXTYPE='REG'  THEN 3     ELSE 3    END),    SMALLINT(U.COLSEQ),    U.COLNAME,    U.COLORDER,    CASE WHEN I.FULLKEYCARD=-1 THEN NULL ELSE I.FULLKEYCARD END,    CASE WHEN I.NLEAF=-1 THEN NULL ELSE I.NLEAF END,    CAST( NULL AS VARCHAR(128) )  FROM    SYSIBM.SYSINDEXES I,    SYSIBM.SYSINDEXCOLUSE U  WHERE    U.INDSCHEMA = I.CREATOR    AND U.INDNAME = I.NAME  UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(CREATOR),    NAME,    CAST( NULL AS SMALLINT ),    CAST( NULL AS VARCHAR(128) ),    CAST( NULL AS VARCHAR(128) ),    CAST( 0 AS SMALLINT ),    CAST( NULL AS SMALLINT ),     CAST( NULL AS VARCHAR(128) ),    CAST( NULL AS CHAR(1) ),    CASE WHEN CARD=-1 THEN NULL ELSE CARD END,    CASE      WHEN NPAGES=-1 THEN NULL      WHEN NPAGES=-2 THEN NULL      ELSE NPAGES    END,    CAST( NULL AS VARCHAR(128) )  FROM    SYSIBM.SYSTABLES UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(T.CREATOR),    T.NAME,    SMALLINT( CASE     WHEN I.UNIQUERULE='D' THEN 1     WHEN I.UNIQUERULE='P' THEN 0     WHEN I.UNIQUERULE='U' THEN 0     ELSE 0    END),    RTRIM(I.CREATOR),    I.NAME,    SMALLINT( CASE     WHEN I.INDEXTYPE='CLUS' THEN 1     WHEN I.INDEXTYPE='REG'  THEN 3     ELSE 3    END),    SMALLINT(U.COLSEQ),    U.COLNAME,    U.COLORDER,    CASE WHEN I.FULLKEYCARD=-1 THEN NULL ELSE I.FULLKEYCARD END,    CASE WHEN I.NLEAF=-1 THEN NULL ELSE I.NLEAF END,    CAST( NULL AS VARCHAR(128) )  FROM    SYSIBM.SYSINDEXES I,    SYSIBM.SYSINDEXCOLUSE U,    SYSIBM.SYSTABLES T  WHERE    U.INDSCHEMA = I.CREATOR    AND U.INDNAME = I.NAME    AND T.TYPE = 'A'    AND TABLE_SCHEMA(T.NAME, T.CREATOR) = I.TBCREATOR    AND TABLE_NAME(T.NAME, T.CREATOR) = I.TBNAME;

CREATE VIEW PARTITIONMAPS (PMAP_ID, PARTITIONMAP) AS
select      pmap_id, partitionmap  from sysibm.syspartitionmaps  where pmap_id <> -2;

CREATE VIEW BUFFERPOOLNODES (BUFFERPOOLID, NODENUM, NPAGES) AS
select      bufferpoolid, nodenum, npages  from sysibm.sysbufferpoolnodes;

CREATE VIEW FUNCTIONS (FUNCSCHEMA, FUNCNAME, SPECIFICNAME, DEFINER, FUNCID, RETURN_TYPE, ORIGIN, TYPE, METHOD, EFFECT, PARM_COUNT, PARM_SIGNATURE, CREATE_TIME, QUALIFIER, WITH_FUNC_ACCESS, TYPE_PRESERVING, VARIANT, SIDE_EFFECTS, FENCED, NULLCALL, CAST_FUNCTION, ASSIGN_FUNCTION, SCRATCHPAD, FINAL_CALL, PARALLELIZABLE, CONTAINS_SQL, DBINFO, RESULT_COLS, LANGUAGE, IMPLEMENTATION, CLASS, JAR_ID, PARM_STYLE, SOURCE_SCHEMA, SOURCE_SPECIFIC, IOS_PER_INVOC, INSTS_PER_INVOC, IOS_PER_ARGBYTE, INSTS_PER_ARGBYTE, PERCENT_ARGBYTES, INITIAL_IOS, INITIAL_INSTS, CARDINALITY, IMPLEMENTED, SELECTIVITY, OVERRIDDEN_FUNCID, SUBJECT_TYPESCHEMA, SUBJECT_TYPENAME, FUNC_PATH, BODY, REMARKS) AS
select      a.routineschema, a.routinename, a.specificname, a.definer, a.routine_id,      a.return_type, a.origin, a.function_type,      CAST (CASE a.routinetype            WHEN 'M' THEN 'Y'            ELSE 'N' END AS CHAR(1)),      a.methodeffect, a.parm_count,      a.parm_signature, a.createdts, a.qualifier, a.with_func_access,      CAST (CASE         WHEN a.type_preserving = 'Y'              THEN 'Y'         ELSE 'N'      END AS CHAR(1)),      CAST (CASE a.deterministic            WHEN 'Y' THEN 'N'            WHEN 'N' THEN 'Y'            ELSE ' ' END AS CHAR(1)),      a.external_action, a.fenced, a.null_call,      a.cast_function, a.assign_function, a.scratchpad,      a.final_call, a.parallel, a.sql_data_access, a.dbinfo, a.result_cols,      a.language, a.implementation, CASE WHEN a.language <> 'JAVA'        THEN NULL      ELSE        (SELECT pj.class FROM         SYSIBM.SYSROUTINEPROPERTIESJAVA AS pj         WHERE pj.routine_id = a.routine_id)      END,      CASE WHEN a.language <> 'JAVA'        THEN NULL      ELSE        (SELECT pj.jar_id FROM         SYSIBM.SYSROUTINEPROPERTIESJAVA AS pj         WHERE pj.routine_id = a.routine_id)      END,      a.parameter_style, a.sourceschema, a.sourcespecific, a.ios_per_invoc,      a.insts_per_invoc, a.ios_per_argbyte, a.insts_per_argbyte,      a.percent_argbytes, a.initial_ios, a.initial_insts, a.cardinality,      a.methodimplemented, a.selectivity, a.overridden_methodid,      a.subject_typeschema, a.subject_typename, a.func_path, a.text,      a.remarks  from sysibm.sysroutines as a  where a.routinetype in ('F', 'M');

CREATE VIEW TABLES (TABSCHEMA, TABNAME, CARD, NPAGES, FPAGES, OVERFLOW, CLUSTERED, ACTIVE_BLOCKS) AS
select        creator, name, card, npages, fpages, overflow,        clustered, active_blocks     from sysibm.systables X     where X.type not in ('A', 'V', 'W', 'H', 'K')     and (exists           (select 1            from   sysibm.systabauth            where  creator = X.creator            and    name = X.name            and    grantee = USER            and    controlauth = 'Y' )       or exists           (select 1            from   sysibm.sysdbauth            where  grantee = USER            and    dbadmauth = 'Y') );

CREATE VIEW XMLRSPROPERTIES (RELATIONSHIPID, OPTION, SETTING) AS
select relationshipid,option,setting from sysibm.sysxmlrsproperties;

CREATE VIEW SQLPRIMARYKEYS (TABLE_CAT, TABLE_SCHEM, TABLE_NAME, COLUMN_NAME, KEY_SEQ, PK_NAME) AS
   SELECT     CAST( NULL AS VARCHAR(128) ),     RTRIM(C.TBCREATOR),     C.TBNAME,     C.NAME,     C.KEYSEQ,     T.NAME   FROM     SYSIBM.SYSCOLUMNS C,     SYSIBM.SYSTABCONST T   WHERE     C.KEYSEQ > 0     AND T.CONSTRAINTYP = 'P'     AND T.TBCREATOR = C.TBCREATOR     AND T.TBNAME = C.TBNAME UNION   SELECT     CAST( NULL AS VARCHAR(128) ),     RTRIM(C.TBCREATOR),     T.NAME,     C.NAME,     C.KEYSEQ,     TC.NAME   FROM     SYSIBM.SYSCOLUMNS C,     SYSIBM.SYSTABLES  T,     SYSIBM.SYSTABCONST TC   WHERE     C.KEYSEQ > 0     AND T.TYPE = 'A'     AND TABLE_NAME(T.NAME, T.CREATOR) = C.TBNAME     AND TABLE_SCHEMA(T.NAME, T.CREATOR) = C.TBCREATOR     AND TC.CONSTRAINTYP = 'P'     AND TC.TBCREATOR = C.TBCREATOR     AND TC.TBNAME = C.TBNAME;

CREATE VIEW USEROPTIONS (AUTHID, SERVERNAME, OPTION, SETTING) AS
select      authid, servername, option, setting  from sysibm.sysuseroptions;

--CREATE VIEW SQLPROCEDURES (PROCEDURE_CAT, PROCEDURE_SCHEM, PROCEDURE_NAME, NUM_INPUT_PARAMS, NUM_OUTPUT_PARAMS, NUM_RESULT_SETS, REMARKS, PROCEDURE_TYPE, NUM_INOUT_PARAMS) AS
--( SELECT PROCSCHEMA, PROCNAME, COUNT(*)          FROM SYSIBM.SYSPROCPARMS          WHERE PARM_MODE = 'INOUT'          GROUP BY PROCSCHEMA, PROCNAME        UNION ALL        SELECT PROCSCHEMA, PROCNAME, 0          FROM SYSIBM.SYSPROCEDURES          WHERE (PROCSCHEMA, PROCNAME)            NOT IN ( SELECT PROCSCHEMA, PROCNAME                     FROM SYSIBM.SYSPROCPARMS                     WHERE PARM_MODE = 'INOUT' ) )   SELECT DISTINCT    CAST( NULL AS VARCHAR(128) ),     RTRIM(P.PROCSCHEMA),     P.PROCNAME,     I.INCOUNT,     O.OUTCOUNT,     P.RESULT_SETS,     P.REMARKS,     SMALLINT(1),     IO.INOUTCOUNT   FROM     SYSIBM.SYSPROCEDURES P,     IN I,     OUT O,     INOUT IO   WHERE P.PROCSCHEMA = I.PROCSCHEMA     AND P.PROCNAME   = I.PROCNAME     AND P.PROCSCHEMA = O.PROCSCHEMA     AND P.PROCNAME   = O.PROCNAME     AND P.PROCSCHEMA = IO.PROCSCHEMA     AND P.PROCNAME   = IO.PROCNAME);

CREATE VIEW INDEXEXTENSIONMETHODS (METHODNAME, METHODID, IESCHEMA, IENAME, RANGEFUNCSCHEMA, RANGEFUNCNAME, RANGESPECIFICNAME, FILTERFUNCSCHEMA, FILTERFUNCNAME, FILTERSPECIFICNAME, REMARKS) AS
select      methodname, methodid, ieschema, iename, rtfuncschema,      rtfuncname, rtspecificname, cwfuncschema, cwfuncname,      cwspecificname, remarks  from sysibm.sysindexextensionmethods;

CREATE VIEW SEQUENCES (SEQSCHEMA, SEQNAME, DEFINER, OWNER, SEQID, SEQTYPE, INCREMENT, START, MAXVALUE, MINVALUE, CYCLE, CACHE, ORDER, DATATYPEID, SOURCETYPEID, CREATE_TIME, ALTER_TIME, PRECISION, ORIGIN, REMARKS) AS
select      a.seqschema, a.seqname, a.definer, a.owner,      a.seqid, a.seqtype, a.increment, a.start,      a.maxvalue, a.minvalue, a.cycle, a.cache,      a.order, a.datatypeid, a.sourcetypeid, a.create_time,      a.alter_time, a.precision, a.origin, b.remarks  from sysibm.syssequences as a left outer join      sysibm.syscomments as b  on a.seqid = b.objectid;

CREATE VIEW REFERENTIAL_CONSTRAINTS (CONSTRAINT_CATALOG, CONSTRAINT_SCHEMA, CONSTRAINT_NAME, UNIQUE_CONSTRAINT_CATALOG, UNIQUE_CONSTRAINT_SCHEMA, UNIQUE_CONSTRAINT_NAME, MATCH_OPTION, UPDATE_RULE, DELETE_RULE) AS
SELECT CAST(CURRENT SERVER  AS VARCHAR(128)),                 CREATOR ,                 CAST(RELNAME            AS VARCHAR(128)),                 CAST(CURRENT SERVER     AS VARCHAR(128)),                 REFTBCREATOR  ,                 CAST(REFKEYNAME     AS VARCHAR(128)),                  'NONE' ,                 CASE UPDATERULE                       WHEN 'N'      THEN  'RESTRICT'                       WHEN 'A'      THEN 'NO ACTION'                 END ,                 CASE DELETERULE                       WHEN 'C'      THEN  'CASCADE'                       WHEN 'N'      THEN 'SET NULL'                       WHEN 'R'      THEN 'RESTRICT'                       WHEN 'A'      THEN 'NO ACTION'                 END FROM SYSIBM.SYSRELS;

CREATE VIEW TABCONST (CONSTNAME, TABSCHEMA, TABNAME, DEFINER, TYPE, REMARKS, ENFORCED, CHECKEXISTINGDATA, ENABLEQUERYOPT) AS
select      name, tbcreator, tbname, definer, constraintyp, remarks,      enforced, checkexistingdata, enablequeryopt  from sysibm.systabconst;

CREATE VIEW INDEXES (INDSCHEMA, INDNAME, DEFINER, TABSCHEMA, TABNAME, COLNAMES, UNIQUERULE, MADE_UNIQUE, COLCOUNT, UNIQUE_COLCOUNT, INDEXTYPE, ENTRYTYPE, PCTFREE, IID, NLEAF, NLEVELS, FIRSTKEYCARD, FIRST2KEYCARD, FIRST3KEYCARD, FIRST4KEYCARD, FULLKEYCARD, CLUSTERRATIO, CLUSTERFACTOR, SEQUENTIAL_PAGES, DENSITY, USER_DEFINED, SYSTEM_REQUIRED, CREATE_TIME, STATS_TIME, PAGE_FETCH_PAIRS, MINPCTUSED, REVERSE_SCANS, INTERNAL_FORMAT, REMARKS, IESCHEMA, IENAME, IEARGUMENTS, INDEX_OBJECTID, NUMRIDS, NUMRIDS_DELETED, NUM_EMPTY_LEAFS, AVERAGE_RANDOM_FETCH_PAGES, AVERAGE_RANDOM_PAGES, AVERAGE_SEQUENCE_GAP, AVERAGE_SEQUENCE_FETCH_GAP, AVERAGE_SEQUENCE_PAGES, AVERAGE_SEQUENCE_FETCH_PAGES, TBSPACEID) AS
select      creator, name, definer, tbcreator, tbname, colnames,      uniquerule, made_unique, colcount,      unique_colcount,indextype, entrytype, pctfree,      iid, nleaf, nlevels,      firstkeycard, first2keycard, first3keycard, first4keycard,      fullkeycard, clusterratio, clusterfactor, sequential_pages,      density, user_defined, system_required, create_time,      stats_time, page_fetch_pairs, minpctused, reverse_scans,      internal_format, remarks,      ieschema, iename, iearguments, index_objectid,      numrids, numrids_deleted, num_empty_leafs,      average_random_fetch_pages, average_random_pages,      average_sequence_gap, average_sequence_fetch_gap,      average_sequence_pages, average_sequence_fetch_pages,      tbspaceid  from sysibm.sysindexes;

CREATE VIEW ROUTINES (ROUTINESCHEMA, ROUTINENAME, ROUTINETYPE, DEFINER, SPECIFICNAME, ROUTINEID, RETURN_TYPESCHEMA, RETURN_TYPENAME, ORIGIN, FUNCTIONTYPE, PARM_COUNT, LANGUAGE, SOURCESCHEMA, SOURCESPECIFIC, DETERMINISTIC, EXTERNAL_ACTION, NULLCALL, CAST_FUNCTION, ASSIGN_FUNCTION, SCRATCHPAD, SCRATCHPAD_LENGTH, FINALCALL, PARALLEL, PARAMETER_STYLE, FENCED, SQL_DATA_ACCESS, DBINFO, PROGRAMTYPE, COMMIT_ON_RETURN, RESULT_SETS, SPEC_REG, FEDERATED, THREADSAFE, VALID, METHODIMPLEMENTED, METHODEFFECT, TYPE_PRESERVING, WITH_FUNC_ACCESS, OVERRIDDEN_METHODID, SUBJECT_TYPESCHEMA, SUBJECT_TYPENAME, CLASS, JAR_ID, JARSCHEMA, JAR_SIGNATURE, CREATE_TIME, ALTER_TIME, FUNC_PATH, QUALIFIER, IOS_PER_INVOC, INSTS_PER_INVOC, IOS_PER_ARGBYTE, INSTS_PER_ARGBYTE, PERCENT_ARGBYTES, INITIAL_IOS, INITIAL_INSTS, CARDINALITY, SELECTIVITY, RESULT_COLS, IMPLEMENTATION, LIB_ID, TEXT_BODY_OFFSET, TEXT, NEWSAVEPOINTLEVEL, DEBUG_MODE, TRACE_LEVEL, DIAGNOSTIC_LEVEL, CHECKOUT_USERID, PRECOMPILE_OPTIONS, COMPILE_OPTIONS, REMARKS) AS
select      a.routineschema, a.routinename, a.routinetype, a.definer,      a.specificname, a.routine_id,      ( select schema from sysibm.sysdatatypes        where return_type = typeid ),      ( select name from sysibm.sysdatatypes        where return_type = typeid ),      a.origin, a.function_type,      a.parm_count, a.language, a.sourceschema, a.sourcespecific,      a.deterministic, a.external_action, a.null_call, a.cast_function,      a.assign_function, a.scratchpad, a.scratchpad_length,      a.final_call, a.parallel, a.parameter_style, a.fenced,      a.sql_data_access, a.dbinfo, a.program_type, a.commit_on_return,      a.result_sets, a.spec_reg, a.federated, a.threadsafe, a.valid,      a.methodimplemented, a.methodeffect, a.type_preserving,      a.with_func_access, a.overridden_methodid, a.subject_typeschema,      a.subject_typename, b.class, b.jar_id, b.jarschema, b.jar_signature,      a.createdts, a.alteredts, a.func_path, a.qualifier, a.ios_per_invoc,      a.insts_per_invoc, a.ios_per_argbyte, a.insts_per_argbyte,      a.percent_argbytes, a.initial_ios, a.initial_insts, a.cardinality,      a.selectivity, a.result_cols, a.implementation, a.lib_id,      a.text_body_offset, a.text, a.newsavepointlevel,      cast (case            when c.debug_mode = '0' then 'OFF'            when c.debug_mode = '1' then 'ON'            when c.debug_mode is null then 'OFF'            else c.debug_mode end as char(3)),      case when c.trace_level is null then '0'           else c.trace_level end,      case when c.diagnostic_level is null then '0'           else c.diagnostic_level end,      c.checkout_userid, c.precompile_options,      c.compile_options, a.remarks      from (sysibm.sysroutines as a left outer join            sysibm.sysroutinepropertiesjava as b            on a.routine_id = b.routine_id )           left outer join sysibm.syscodeproperties as c            on a.routine_id = c.object_id            and c.object_type = 'F';

CREATE VIEW PACKAGEAUTH (GRANTOR, GRANTEE, GRANTEETYPE, PKGSCHEMA, PKGNAME, CONTROLAUTH, BINDAUTH, EXECUTEAUTH) AS
select      grantor, grantee, granteetype, creator, name,      controlauth, bindauth, executeauth  from sysibm.sysplanauth;

CREATE VIEW STATEMENTS (PKGSCHEMA, PKGNAME, STMTNO, SECTNO, SEQNO, TEXT, UNIQUE_ID, VERSION) AS
select      s.plcreator, s.plname,      s.stmtno, s.sectno, 1, s.text, s.unique_id,      (select p.pkgversion from sysibm.sysplan p       where s.plcreator = p.creator       and s.plname = p.name       and s.unique_id = p.unique_id)  from sysibm.sysstmt s;

CREATE VIEW INPUT_014 (CLIENT_ID, AGE, GENDER, MARITAL_STATUS, PROFESSION, NBR_YEARS_CLI, SAVINGS_ACCOUNT, HAS_LIFE_INSURANCE, INT_CREDITCARD, ONLINE_ACCESS, JOINED_ACCOUNTS, BANKCARD, AVERAGE_BALANCE, NO_CRED_TRANS, NO_DEBIT_TRANS, DEV_DEGREE, CLUSTER_ID) AS
SELECT "CLIENT_ID" AS "CLIENT_ID", "AGE" AS "AGE", "GENDER" AS "GENDER", "MARITAL_STATUS" AS "MARITAL_STATUS", "PROFESSION" AS "PROFESSION", "NBR_YEARS_CLI" AS "NBR_YEARS_CLI", "SAVINGS_ACCOUNT" AS "SAVINGS_ACCOUNT", "HAS_LIFE_INSURANCE" AS "HAS_LIFE_INSURANCE", "INT_CREDITCARD" AS "INT_CREDITCARD", "ONLINE_ACCESS" AS "ONLINE_ACCESS", "JOINED_ACCOUNTS" AS "JOINED_ACCOUNTS", "BANKCARD" AS "BANKCARD", "AVERAGE_BALANCE" AS "AVERAGE_BALANCE", "NO_CRED_TRANS" AS "NO_CRED_TRANS", "NO_DEBIT_TRANS" AS "NO_DEBIT_TRANS", "DEV_DEGREE" AS "DEV_DEGREE", "CLUSTER_ID" AS "CLUSTER_ID" FROM IDMMX."IM_FINDDEVIATIONS_012";

CREATE VIEW LIBRARYVERSIONS (LIBSCHEMA, LIBNAME, LIBVERSION, DEFINER, VERSIONID, CREATE_TIME, VERSION_PATH, BINDFILES_COUNT) AS
select      l.libschema, l.libname, v.libversion, v.definer,      'L' || digits (v.lib_id) || 'V' || digits (v.libversion),      v.create_time, v.version_path, v.bindfiles_count  from sysibm.syslibraryversions as v,       sysibm.syslibraries as l  where v.lib_id = l.lib_id;

CREATE VIEW SQLCOLPRIVILEGES (TABLE_CAT, TABLE_SCHEM, TABLE_NAME, COLUMN_NAME, GRANTOR, GRANTEE, PRIVILEGE, IS_GRANTABLE, DBNAME) AS
  SELECT     CAST( NULL AS VARCHAR(128) ),     RTRIM(T.TCREATOR),     T.TTNAME,     C.NAME,     RTRIM(T.GRANTOR),     RTRIM(T.GRANTEE),     'REFERENCES',     CASE WHEN T.REFAUTH = 'G' THEN 'YES' ELSE 'NO' END,     CAST( NULL AS VARCHAR(8) )   FROM     SYSIBM.SYSTABAUTH T,     SYSIBM.SYSCOLUMNS C   WHERE     T.TCREATOR = C.TBCREATOR     AND T.TTNAME = C.TBNAME     AND T.REFAUTH IN ('Y', 'G') UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(A.CREATOR),    A.TNAME,    C.NAME,    RTRIM(A.GRANTOR),    RTRIM(A.GRANTEE),    'REFERENCES',    CASE WHEN A.GRANTABLE='G' THEN 'YES' ELSE 'NO' END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSCOLAUTH A,    SYSIBM.SYSCOLUMNS C  WHERE    A.CREATOR=C.TBCREATOR    AND A.TNAME=C.TBNAME    AND A.COLNAME=C.NAME    AND A.PRIVTYPE='R' UNION   SELECT     CAST( NULL AS VARCHAR(128) ),     RTRIM(T.TCREATOR),     T.TTNAME,     C.NAME,     RTRIM(T.GRANTOR),     RTRIM(T.GRANTEE),     'UPDATE',     CASE WHEN T.UPDATEAUTH = 'G' THEN 'YES' ELSE 'NO' END,     CAST( NULL AS VARCHAR(8) )   FROM     SYSIBM.SYSTABAUTH T,     SYSIBM.SYSCOLUMNS C   WHERE     T.TCREATOR = C.TBCREATOR     AND T.TTNAME = C.TBNAME     AND T.UPDATEAUTH IN ('Y', 'G') UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(A.CREATOR),    A.TNAME,    C.NAME,    RTRIM(A.GRANTOR),    RTRIM(A.GRANTEE),    'UPDATE',    CASE WHEN A.GRANTABLE='G' THEN 'YES' ELSE 'NO' END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSCOLAUTH A,    SYSIBM.SYSCOLUMNS C  WHERE    A.CREATOR=C.TBCREATOR    AND A.TNAME=C.TBNAME    AND A.COLNAME=C.NAME    AND A.PRIVTYPE='U' UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(T.TCREATOR),    T.TTNAME,    C.NAME,    RTRIM(GRANTOR),    RTRIM(T.GRANTEE),    'SELECT',    CASE WHEN T.SELECTAUTH='G' THEN 'YES' ELSE 'NO' END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH T,    SYSIBM.SYSCOLUMNS C  WHERE    T.TCREATOR=C.TBCREATOR    AND T.TTNAME=C.TBNAME    AND T.SELECTAUTH IN ('Y', 'G') UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(T.TCREATOR),    T.TTNAME,    C.NAME,    RTRIM(GRANTOR),    RTRIM(T.GRANTEE),    'INSERT',    CASE WHEN T.INSERTAUTH='G' THEN 'YES' ELSE 'NO' END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH T,    SYSIBM.SYSCOLUMNS C  WHERE    T.TCREATOR=C.TBCREATOR    AND T.TTNAME=C.TBNAME    AND T.INSERTAUTH IN ('Y', 'G') UNION   SELECT     CAST( NULL AS VARCHAR(128) ),     RTRIM(Z.CREATOR),     Z.NAME,     C.NAME,     RTRIM(T.GRANTOR),     RTRIM(T.GRANTEE),     'REFERENCES',     CASE WHEN T.REFAUTH = 'G' THEN 'YES' ELSE 'NO' END,     CAST( NULL AS VARCHAR(8) )   FROM     SYSIBM.SYSTABAUTH T,     SYSIBM.SYSCOLUMNS C,     SYSIBM.SYSTABLES  Z   WHERE     T.TCREATOR = C.TBCREATOR     AND T.TTNAME = C.TBNAME     AND T.REFAUTH IN ('Y', 'G')     AND Z.TYPE = 'A'     AND TABLE_NAME(Z.NAME, Z.CREATOR) = T.TTNAME     AND TABLE_SCHEMA(Z.NAME, Z.CREATOR) = T.TCREATOR UNION   SELECT     CAST( NULL AS VARCHAR(128) ),     RTRIM(Z.CREATOR),     Z.NAME,     C.NAME,     RTRIM(A.GRANTOR),     RTRIM(A.GRANTEE),     'REFERENCES',     CASE WHEN A.GRANTABLE = 'G' THEN 'YES' ELSE 'NO' END,     CAST( NULL AS VARCHAR(8) )   FROM     SYSIBM.SYSCOLAUTH A,     SYSIBM.SYSCOLUMNS C,     SYSIBM.SYSTABLES  Z   WHERE     A.CREATOR = C.TBCREATOR     AND A.TNAME = C.TBNAME     AND A.COLNAME=C.NAME     AND A.PRIVTYPE ='R'     AND Z.TYPE = 'A'     AND TABLE_NAME(Z.NAME, Z.CREATOR) = A.TNAME     AND TABLE_SCHEMA(Z.NAME, Z.CREATOR) = A.CREATOR UNION   SELECT     CAST( NULL AS VARCHAR(128) ),     RTRIM(Z.CREATOR),     Z.NAME,     C.NAME,     RTRIM(T.GRANTOR),     RTRIM(T.GRANTEE),     'UPDATE',     CASE WHEN T.UPDATEAUTH = 'G' THEN 'YES' ELSE 'NO' END,     CAST( NULL AS VARCHAR(8) )   FROM     SYSIBM.SYSTABAUTH T,     SYSIBM.SYSCOLUMNS C,     SYSIBM.SYSTABLES  Z   WHERE     T.TCREATOR = C.TBCREATOR     AND T.TTNAME = C.TBNAME     AND T.UPDATEAUTH IN ('Y', 'G')     AND Z.TYPE = 'A'     AND TABLE_NAME(Z.NAME, Z.CREATOR) = T.TTNAME     AND TABLE_SCHEMA(Z.NAME, Z.CREATOR) = T.TCREATOR UNION   SELECT     CAST( NULL AS VARCHAR(128) ),     RTRIM(Z.CREATOR),     Z.NAME,     C.NAME,     RTRIM(A.GRANTOR),     RTRIM(A.GRANTEE),     'UPDATE',     CASE WHEN A.GRANTABLE = 'G' THEN 'YES' ELSE 'NO' END,     CAST( NULL AS VARCHAR(8) )   FROM     SYSIBM.SYSCOLAUTH A,     SYSIBM.SYSCOLUMNS C,     SYSIBM.SYSTABLES  Z   WHERE     A.CREATOR = C.TBCREATOR     AND A.TNAME = C.TBNAME     AND A.COLNAME=C.NAME     AND A.PRIVTYPE ='U'     AND Z.TYPE = 'A'     AND TABLE_NAME(Z.NAME, Z.CREATOR) = A.TNAME     AND TABLE_SCHEMA(Z.NAME, Z.CREATOR) = A.CREATOR UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(Z.CREATOR),    Z.NAME,    C.NAME,    RTRIM(GRANTOR),    RTRIM(T.GRANTEE),    'SELECT',    CASE WHEN T.SELECTAUTH='G' THEN 'YES' ELSE 'NO' END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH T,    SYSIBM.SYSCOLUMNS C,    SYSIBM.SYSTABLES  Z  WHERE    T.TCREATOR=C.TBCREATOR    AND T.TTNAME=C.TBNAME    AND T.SELECTAUTH IN ('Y', 'G')    AND Z.TYPE = 'A'    AND TABLE_NAME(Z.NAME, Z.CREATOR) = T.TTNAME    AND TABLE_SCHEMA(Z.NAME, Z.CREATOR) = T.TCREATOR UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(Z.CREATOR),    Z.NAME,    C.NAME,    RTRIM(GRANTOR),    RTRIM(T.GRANTEE),    'INSERT',    CASE WHEN T.INSERTAUTH='G' THEN 'YES' ELSE 'NO' END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH T,    SYSIBM.SYSCOLUMNS C,    SYSIBM.SYSTABLES  Z  WHERE    T.TCREATOR=C.TBCREATOR    AND T.TTNAME=C.TBNAME    AND T.INSERTAUTH IN ('Y', 'G')    AND Z.TYPE = 'A'    AND TABLE_NAME(Z.NAME, Z.CREATOR) = T.TTNAME    AND TABLE_SCHEMA(Z.NAME, Z.CREATOR) = T.TCREATOR;

CREATE VIEW INPUT_012 (CLIENT_ID, AGE, GENDER, MARITAL_STATUS, PROFESSION, NBR_YEARS_CLI, SAVINGS_ACCOUNT, HAS_LIFE_INSURANCE, INT_CREDITCARD, ONLINE_ACCESS, JOINED_ACCOUNTS, BANKCARD, AVERAGE_BALANCE, NO_CRED_TRANS, NO_DEBIT_TRANS) AS
SELECT CLIENT_ID AS CLIENT_ID, AGE AS AGE, GENDER AS GENDER, MARITAL_STATUS AS MARITAL_STATUS, PROFESSION AS PROFESSION, NBR_YEARS_CLI AS NBR_YEARS_CLI, SAVINGS_ACCOUNT AS SAVINGS_ACCOUNT, HAS_LIFE_INSURANCE AS HAS_LIFE_INSURANCE, INT_CREDITCARD AS INT_CREDITCARD, ONLINE_ACCESS AS ONLINE_ACCESS, JOINED_ACCOUNTS AS JOINED_ACCOUNTS, BANKCARD AS BANKCARD, AVERAGE_BALANCE AS AVERAGE_BALANCE, NO_CRED_TRANS AS NO_CRED_TRANS, NO_DEBIT_TRANS AS NO_DEBIT_TRANS FROM YSAILLET.BANKCUSTOMERS;

CREATE VIEW COLGROUPS (COLGROUPSCHEMA, COLGROUPNAME, COLGROUPID, COLGROUPCARD, NUMFREQ_VALUES, NUMQUANTILES) AS
select      colgroupschema, colgroupname, colgroupid, colgroupcard,      numfreq_values, numquantiles  from sysibm.syscolgroups;

CREATE VIEW PACKAGES (PKGSCHEMA, PKGNAME, BOUNDBY, DEFINER, DEFAULT_SCHEMA, VALID, UNIQUE_ID, TOTAL_SECT, FORMAT, ISOLATION, BLOCKING, INSERT_BUF, LANG_LEVEL, FUNC_PATH, QUERYOPT, EXPLAIN_LEVEL, EXPLAIN_MODE, EXPLAIN_SNAPSHOT, SQLWARN, SQLMATHWARN, EXPLICIT_BIND_TIME, LAST_BIND_TIME, CODEPAGE, DEGREE, MULTINODE_PLANS, INTRA_PARALLEL, VALIDATE, DYNAMICRULES, SQLERROR, REFRESHAGE, REMARKS, FEDERATED, TRANSFORMGROUP, REOPTVAR, OS_PTR_SIZE, PKGVERSION, PKG_CREATE_TIME) AS
select      creator, name, boundby, definer, default_schema, valid,      unique_id, totalsect, format, isolation, block,      insert_buf, standards_level, func_path, queryopt,      explain_level, explain_mode, explain_snapshot, sqlwarn,      sqlmathwarn, explicit_bind_time, last_bind_time,      codepage,      degree, multinode_plans, intra_parallel, validate,      dynamicrules, sqlerror, refreshage, remarks,      federated, transformgroup, reoptvar, os_ptr_size,      pkgversion, pkg_create_time  from sysibm.sysplan;

CREATE VIEW SQLTABLEPRIVILEGES (TABLE_CAT, TABLE_SCHEM, TABLE_NAME, GRANTOR, GRANTEE, PRIVILEGE, IS_GRANTABLE, DBNAME) AS
 SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(TCREATOR),    TTNAME,    RTRIM(GRANTOR),    RTRIM(GRANTEE),    'ALTER',    CASE      WHEN ALTERAUTH='G' THEN 'YES' ELSE 'NO'    END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH  WHERE    ALTERAUTH IN ('Y', 'G')  UNION SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(TCREATOR),    TTNAME,    RTRIM(GRANTOR),    RTRIM(GRANTEE),    'DELETE',    CASE      WHEN DELETEAUTH='G' THEN 'YES' ELSE 'NO'    END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH  WHERE    DELETEAUTH IN ('Y', 'G')  UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(TCREATOR),    TTNAME,    RTRIM(GRANTOR),    RTRIM(GRANTEE),    'CONTROL',    'NO',    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH  WHERE    CONTROLAUTH='Y'  UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(TCREATOR),    TTNAME,    RTRIM(GRANTOR),    RTRIM(GRANTEE),    'INDEX',    CASE      WHEN INDEXAUTH='G' THEN 'YES' ELSE 'NO'    END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH  WHERE    INDEXAUTH IN ('Y', 'G') UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(TCREATOR),    TTNAME,    RTRIM(GRANTOR),    RTRIM(GRANTEE),    'INSERT',    CASE      WHEN INSERTAUTH='G' THEN 'YES' ELSE 'NO'    END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH  WHERE    INSERTAUTH IN ('Y', 'G')  UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(TCREATOR),    TTNAME,    RTRIM(GRANTOR),    RTRIM(GRANTEE),    'REFERENCES',    CASE      WHEN REFAUTH='G' THEN 'YES' ELSE 'NO'    END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH  WHERE    REFAUTH IN ('Y', 'G') UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(TCREATOR),    TTNAME,    RTRIM(GRANTOR),    RTRIM(GRANTEE),    'SELECT',    CASE      WHEN SELECTAUTH='G' THEN 'YES' ELSE 'NO'    END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH  WHERE    SELECTAUTH IN ('Y', 'G')  UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(TCREATOR),    TTNAME,    RTRIM(GRANTOR),    RTRIM(GRANTEE),    'UPDATE',    CASE      WHEN UPDATEAUTH='G' THEN 'YES' ELSE 'NO'    END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH  WHERE      UPDATEAUTH IN ('Y', 'G') UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(T.CREATOR),    T.NAME,    RTRIM(A.GRANTOR),    RTRIM(A.GRANTEE),    'ALTER',    CASE      WHEN A.ALTERAUTH='G' THEN 'YES' ELSE 'NO'    END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH A,    SYSIBM.SYSTABLES T  WHERE      A.ALTERAUTH IN ('Y', 'G')      AND T.TYPE = 'A'      AND TABLE_SCHEMA(T.NAME, T.CREATOR) = A.TCREATOR      AND TABLE_NAME(T.NAME, T.CREATOR) = A.TTNAME UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(T.CREATOR),    T.NAME,    RTRIM(A.GRANTOR),    RTRIM(A.GRANTEE),    'CONTROL',    'NO',    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH A,    SYSIBM.SYSTABLES T  WHERE      A.CONTROLAUTH='Y'      AND T.TYPE = 'A'      AND TABLE_SCHEMA(T.NAME, T.CREATOR) = A.TCREATOR      AND TABLE_NAME(T.NAME, T.CREATOR) = A.TTNAME UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(T.CREATOR),    T.NAME,    RTRIM(A.GRANTOR),    RTRIM(A.GRANTEE),    'DELETE',    CASE      WHEN A.DELETEAUTH='G' THEN 'YES' ELSE 'NO'    END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH A,    SYSIBM.SYSTABLES T  WHERE      A.DELETEAUTH IN ('Y','G')      AND T.TYPE = 'A'      AND TABLE_SCHEMA(T.NAME, T.CREATOR) = A.TCREATOR      AND TABLE_NAME(T.NAME, T.CREATOR) = A.TTNAME UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(T.CREATOR),    T.NAME,    RTRIM(A.GRANTOR),    RTRIM(A.GRANTEE),    'INDEX',    CASE      WHEN A.INDEXAUTH='G' THEN 'YES' ELSE 'NO'    END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH A,    SYSIBM.SYSTABLES T  WHERE      A.INDEXAUTH IN ('Y', 'G')      AND T.TYPE = 'A'      AND TABLE_SCHEMA(T.NAME, T.CREATOR) = A.TCREATOR      AND TABLE_NAME(T.NAME, T.CREATOR) = A.TTNAME UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(T.CREATOR),    T.NAME,    RTRIM(A.GRANTOR),    RTRIM(A.GRANTEE),    'INSERT',    CASE      WHEN A.INSERTAUTH='G' THEN 'YES' ELSE 'NO'    END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH A,    SYSIBM.SYSTABLES T  WHERE      A.INSERTAUTH IN ('Y', 'G')   AND T.TYPE = 'A'      AND TABLE_SCHEMA(T.NAME, T.CREATOR) = A.TCREATOR      AND TABLE_NAME(T.NAME, T.CREATOR) = A.TTNAME UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(T.CREATOR),    T.NAME,    RTRIM(A.GRANTOR),    RTRIM(A.GRANTEE),    'REFERENCES',    CASE      WHEN A.REFAUTH='G' THEN 'YES' ELSE 'NO'    END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH A,    SYSIBM.SYSTABLES T  WHERE      A.REFAUTH IN ('Y', 'G')    AND T.TYPE = 'A'      AND TABLE_SCHEMA(T.NAME, T.CREATOR) = A.TCREATOR      AND TABLE_NAME(T.NAME, T.CREATOR) = A.TTNAME UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(T.CREATOR),    T.NAME,    RTRIM(A.GRANTOR),    RTRIM(A.GRANTEE),    'SELECT',    CASE      WHEN A.SELECTAUTH='G' THEN 'YES' ELSE 'NO'    END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH A,    SYSIBM.SYSTABLES T  WHERE      A.SELECTAUTH IN ('Y', 'G')      AND T.TYPE = 'A'      AND TABLE_SCHEMA(T.NAME, T.CREATOR) = A.TCREATOR      AND TABLE_NAME(T.NAME, T.CREATOR) = A.TTNAME UNION  SELECT    CAST( NULL AS VARCHAR(128) ),    RTRIM(T.CREATOR),    T.NAME,    RTRIM(A.GRANTOR),    RTRIM(A.GRANTEE),    'UPDATE',    CASE      WHEN A.UPDATEAUTH='G' THEN 'YES' ELSE 'NO'    END,    CAST( NULL AS VARCHAR(8) )  FROM    SYSIBM.SYSTABAUTH A,    SYSIBM.SYSTABLES T  WHERE      A.UPDATEAUTH IN ('Y', 'G')      AND T.TYPE = 'A'      AND TABLE_SCHEMA(T.NAME, T.CREATOR) = A.TCREATOR      AND TABLE_NAME(T.NAME, T.CREATOR) = A.TTNAME;

CREATE VIEW INDEXCOLUSE (INDSCHEMA, INDNAME, COLNAME, COLSEQ, COLORDER) AS
select       indschema, indname, colname, colseq, colorder  from sysibm.sysindexcoluse;

--CREATE VIEW IM_FINDRULES_015 (ID, HEADNAME, HEAD, BODYID, LENGTH, BODYTEXT, SUPPORT, CONFIDENCE, LIFT) AS
--select ID, HEADNAME, HEAD, BODYID, LENGTH, BODYTEXT,  SUPPORT*100 as SUPPORT, CONFIDENCE*100 as CONFIDENCE, LIFT  from table(IDMMX.DM_getRules((select MODEL from IDMMX.RuleModels where ModelName = 'IDMMX.IM_FINDRULES_015'))) as R;

CREATE VIEW SERVEROPTIONS (WRAPNAME, SERVERNAME, SERVERTYPE, SERVERVERSION, CREATE_TIME, OPTION, SETTING, SERVEROPTIONKEY, REMARKS) AS
select      wrapname, servername, servertype, serverversion,      create_time, option, setting, serveroptionkey, remarks  from sysibm.sysserveroptions;

CREATE VIEW SERVERS (WRAPNAME, SERVERNAME, SERVERTYPE, SERVERVERSION, REMARKS) AS
select      wrapname, servername, servertype, serverversion, remarks  from sysibm.sysservers;

CREATE VIEW REF_CONSTRAINTS (CONSTRAINT_CATALOG, CONSTRAINT_SCHEMA, CONSTRAINT_NAME, UNIQUE_CONSTR_CAT, UNIQUE_CONSTR_SCH, UNIQUE_CONSTR_NAME, MATCH_OPTION, UPDATE_RULE, DELETE_RULE) AS
SELECT CONSTRAINT_CATALOG, CONSTRAINT_SCHEMA, CONSTRAINT_NAME,         UNIQUE_CONSTRAINT_CATALOG, UNIQUE_CONSTRAINT_SCHEMA,         UNIQUE_CONSTRAINT_NAME, MATCH_OPTION, UPDATE_RULE, DELETE_RULE FROM     SYSIBM.REFERENTIAL_CONSTRAINTS;

CREATE VIEW XMLSTATS (OBJECTID, OBJECTTYPE, STATISTICTYPE, VALUE) AS
select objectid,objecttype,statistictype,value       from sysibm.sysxmlstats;

CREATE VIEW XMLSTATS (OBJECTID, OBJECTTYPE, STATISTICTYPE, VALUE) AS
select  objectid,objecttype,statistictype,value  from sysibm.sysxmlstats;

CREATE VIEW TABAUTH (GRANTOR, GRANTEE, GRANTEETYPE, TABSCHEMA, TABNAME, CONTROLAUTH, ALTERAUTH, DELETEAUTH, INDEXAUTH, INSERTAUTH, SELECTAUTH, REFAUTH, UPDATEAUTH) AS
select      grantor, grantee, granteetype, tcreator, ttname,      controlauth, alterauth, deleteauth, indexauth, insertauth,      selectauth, refauth, updateauth  from sysibm.systabauth;

CREATE VIEW TABLES_S (TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, TABLE_TYPE, SELF_REF_COL_NAME, REF_GENERATION, UDT_CATALOG, UDT_SCHEMA, UDT_NAME, IS_INSERTABLE_INTO) AS
    SELECT TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, TABLE_TYPE,             SELF_REFERENCING_COLUMN_NAME, REFERENCE_GENERATION,              USER_DEFINED_TYPE_CATALOG, USER_DEFINED_TYPE_SCHEMA,             USER_DEFINED_TYPE_NAME ,  IS_INSERTABLE_INTO     FROM SYSIBM.TABLES;

CREATE VIEW TESTVIEW (CLIENT_ID, AGE, GENDER, MARITAL_STATUS, PROFESSION, NBR_YEARS_CLI, SAVINGS_ACCOUNT, HAS_LIFE_INSURANCE, INT_CREDITCARD, ONLINE_ACCESS, JOINED_ACCOUNTS, BANKCARD, AVERAGE_BALANCE, NO_CRED_TRANS, NO_DEBIT_TRANS) AS
select * from BANKCUSTOMERS;

CREATE VIEW PREDICATESPECS (FUNCSCHEMA, FUNCNAME, SPECIFICNAME, FUNCID, SPECID, CONTEXTOP, CONTEXTEXP, FILTERTEXT) AS
select      f.schema, f.name, f.specific, p.funcid, p.specid,      p.contextop, p.contextexp, CAST(p.filtertext as CLOB(32K))  from sysibm.sysfunctions as f,       sysibm.syspredicatespecs as p  where f.function_id=p.funcid;

CREATE VIEW XMLOBJECTRELDEP (OBJECTID, DTYPE, BTYPE, BSCHEMA, BNAME, TABAUTH) AS
select objectid,dtype,btype,bschema,bname,tabauth  from sysibm.sysxmlobjectreldep;

CREATE VIEW ROUTINEAUTH (GRANTOR, GRANTEE, GRANTEETYPE, SCHEMA, SPECIFICNAME, TYPESCHEMA, TYPENAME, ROUTINETYPE, EXECUTEAUTH, GRANT_TIME) AS
select      grantor, grantee, granteetype, schema, specificname,      typeschema, typename, routinetype, executeauth, grant_time  from sysibm.sysroutineauth;

CREATE VIEW INDEXEXTENSIONPARMS (IESCHEMA, IENAME, ORDINAL, PARMNAME, TYPESCHEMA, TYPENAME, LENGTH, SCALE, PARMTYPE, CODEPAGE) AS
select      ieschema, iename, ordinal, parmname, typeschema, typename,      length, scale, parmtype, codepage  from sysibm.sysindexextensionparms;

CREATE VIEW TRIGDEP (TRIGSCHEMA, TRIGNAME, BTYPE, BSCHEMA, BNAME, TABAUTH) AS
select      dschema, dname, btype, bschema, bname, tabauth  from sysibm.sysdependencies  where dtype = 'B';

CREATE VIEW COLDIST (TABSCHEMA, TABNAME, COLNAME, TYPE, SEQNO, COLVALUE, VALCOUNT, DISTCOUNT) AS
select      schema, tbname, name, type, seqno, colvalue,      valcount, distcount  from sysibm.syscoldist;

CREATE VIEW ROUTINEDEP (ROUTINESCHEMA, ROUTINENAME, BTYPE, BSCHEMA, BNAME, TABAUTH) AS
select    dschema, dname, btype, bschema, bname, tabauth  from sysibm.sysdependencies  where dtype = 'F';

CREATE VIEW LIBRARYAUTH (GRANTOR, GRANTEE, GRANTEETYPE, LIBSCHEMA, LIBNAME, USAGEAUTH, ALTERAUTH) AS
select      grantor, grantee, granteetype, libschema, libname,      usageauth, alterauth  from sysibm.syslibraryauth;

CREATE VIEW CHECKS (CONSTNAME, DEFINER, TABSCHEMA, TABNAME, CREATE_TIME, QUALIFIER, TYPE, FUNC_PATH, TEXT, PERCENTVALID) AS
select      name, definer, tbcreator, tbname, create_time,      qualifier, type,  func_path, text, percentvalid  from sysibm.syschecks;

CREATE VIEW INDEXDEP (INDSCHEMA, INDNAME, BTYPE, BSCHEMA, BNAME, TABAUTH) AS
select      dschema, dname, btype, bschema, bname, tabauth  from sysibm.sysdependencies  where dtype = 'I';

CREATE VIEW SCHEMATA (SCHEMANAME, OWNER, DEFINER, CREATE_TIME, REMARKS) AS
select      name, owner, definer, create_time, remarks  from sysibm.sysschemata;

--CREATE VIEW IM_FINDDEVIATIONS_012 (NBR_YEARS_CLI, AVERAGE_BALANCE, ONLINE_ACCESS, INT_CREDITCARD, PROFESSION, AGE, GENDER, MARITAL_STATUS, HAS_LIFE_INSURANCE, CLIENT_ID, SAVINGS_ACCOUNT, NO_DEBIT_TRANS, NO_CRED_TRANS, BANKCARD, JOINED_ACCOUNTS, CLUSTER_ID, DEV_DEGREE) AS
--( select (totalSize*1.0)/SIZE as DEV_DEGREE, ID  from table(IDMMX.DM_getClusters((select MODEL from IDMMX.ClusterModels where ModelName = 'IDMMX.IM_FINDDEVIATIONS_012'))) as C, TotalSize )  SELECT T."NBR_YEARS_CLI",T."AVERAGE_BALANCE",T."ONLINE_ACCESS",T."INT_CREDITCARD",T."PROFESSION",T."AGE",T."GENDER",T."MARITAL_STATUS",T."HAS_LIFE_INSURANCE",T."CLIENT_ID",T."SAVINGS_ACCOUNT",T."NO_DEBIT_TRANS",T."NO_CRED_TRANS",T."BANKCARD",T."JOINED_ACCOUNTS",  D.CLUSTER_ID as CLUSTER_ID, D.DEV_DEGREE  as DEV_DEGREE FROM ScoreView T, DevDegrees D  where T.CLUSTER_ID = D.CLUSTER_ID;

CREATE VIEW CONSTDEP (CONSTNAME, TABSCHEMA, TABNAME, BTYPE, BSCHEMA, BNAME) AS
select      dconstname, dtbcreator, dtbname, btype, bcreator, bname  from sysibm.sysconstdep;

CREATE VIEW COLAUTH (GRANTOR, GRANTEE, GRANTEETYPE, TABSCHEMA, TABNAME, COLNAME, COLNO, PRIVTYPE, GRANTABLE) AS
select      grantor, grantee, granteetype, creator, tname, colname,      colno, privtype, grantable  from sysibm.syscolauth;

CREATE VIEW PARAMETERS_S (SPECIFIC_CATALOG, SPECIFIC_SCHEMA, SPECIFIC_NAME, ORDINAL_POSITION, PARAMETER_MODE, IS_RESULT, AS_LOCATOR, PARAMETER_NAME, FROM_SQL_SPEC_CAT, FROM_SQL_SPEC_SCH, FROM_SQL_SPEC_NAME, TO_SQL_SPEC_CAT, TO_SQL_SPEC_SCHEMA, TO_SQL_SPEC_NAME, DATA_TYPE, CHAR_MAX_LENGTH, CHAR_OCTET_LENGTH, CHAR_SET_CATALOG, CHAR_SET_SCHEMA, CHARACTER_SET_NAME, COLLATION_CATALOG, COLLATION_SCHEMA, COLLATION_NAME, NUMERIC_PRECISION, NUMERIC_PREC_RADIX, NUMERIC_SCALE, DATETIME_PRECISION, INTERVAL_TYPE, INTERVAL_PRECISION, UDT_CATALOG, UDT_SCHEMA, UDT_NAME, SCOPE_CATALOG, SCOPE_SCHEMA, SCOPE_NAME, MAX_CARDINALITY, DTD_IDENTIFIER) AS
SELECT  SPECIFIC_CATALOG, SPECIFIC_SCHEMA, SPECIFIC_NAME, ORDINAL_POSITION,  PARAMETER_MODE, IS_RESULT, AS_LOCATOR, PARAMETER_NAME,  FROM_SQL_SPECIFIC_CATALOG, FROM_SQL_SPECIFIC_SCHEMA, FROM_SQL_SPECIFIC_NAME, TO_SQL_SPECIFIC_CATALOG,  TO_SQL_SPECIFIC_SCHEMA, TO_SQL_SPECIFIC_NAME, DATA_TYPE, CHARACTER_MAXIMUM_LENGTH,  CHARACTER_OCTET_LENGTH, CHARACTER_SET_CATALOG, CHARACTER_SET_SCHEMA, CHARACTER_SET_NAME,  COLLATION_CATALOG, COLLATION_SCHEMA, COLLATION_NAME, NUMERIC_PRECISION,  NUMERIC_PRECISION_RADIX, NUMERIC_SCALE, DATETIME_PRECISION, INTERVAL_TYPE,  INTERVAL_PRECISION, UDT_CATALOG, UDT_SCHEMA, UDT_NAME,  SCOPE_CATALOG, SCOPE_SCHEMA, SCOPE_NAME, MAXIMUM_CARDINALITY,  DTD_IDENTIFIER FROM SYSIBM.PARAMETERS;

CREATE VIEW TRANSFORMS (TYPEID, TYPESCHEMA, TYPENAME, GROUPNAME, FUNCID, FUNCSCHEMA, FUNCNAME, SPECIFICNAME, TRANSFORMTYPE, FORMAT, MAXLENGTH, ORIGIN, REMARKS) AS
select      d.typeid, d.schema, d.name, t.groupname, f.function_id,      f.schema, f.name, f.specific, 'FROM SQL',      t.fromsql_format, t.fromsql_length, t.origin, t.remarks  from sysibm.systransforms as t,       sysibm.sysdatatypes as d,       sysibm.sysfunctions as f  where t.typeid = d.typeid        and t.fromsql_funcid = f.function_id  union all        select d.typeid, d.schema, d.name, t.groupname,               f.function_id, f.schema, f.name, f.specific,               'TO SQL', t.tosql_format, cast(NULL as integer),               t.origin, t.remarks        from sysibm.systransforms as t,             sysibm.sysdatatypes as d,             sysibm.sysfunctions as f        where t.typeid = d.typeid        and t.tosql_funcid = f.function_id;

CREATE VIEW COLGROUPDIST (COLGROUPID, TYPE, ORDINAL, SEQNO, COLVALUE) AS
select      colgroupid, type, ordinal, seqno, colvalue  from sysibm.syscolgroupdist;

CREATE VIEW VIEWS (TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, VIEW_DEFINITION, CHECK_OPTION, IS_UPDATABLE) AS
SELECT CAST(CURRENT SERVER AS VARCHAR(128)), V.CREATOR , V.NAME , V.TEXT, CASE V.CHECK WHEN 'N' THEN 'NONE' WHEN 'L' THEN 'LOCAL' WHEN 'C' THEN 'CASCADED' END , CASE V.READONLY WHEN 'Y' THEN 'NO' WHEN 'N' THEN 'YES' END FROM SYSIBM.SYSVIEWS V,SYSIBM.SYSTABLES T WHERE V.CREATOR=T.CREATOR AND V.NAME=T.NAME AND T.TYPE='V';

CREATE VIEW FUNCTIONS (FUNCSCHEMA, FUNCNAME, SPECIFICNAME, IOS_PER_INVOC, INSTS_PER_INVOC, IOS_PER_ARGBYTE, INSTS_PER_ARGBYTE, PERCENT_ARGBYTES, INITIAL_IOS, INITIAL_INSTS, CARDINALITY, SELECTIVITY) AS
select        routineschema, routinename, specificname, ios_per_invoc,        insts_per_invoc, ios_per_argbyte, insts_per_argbyte,        percent_argbytes, initial_ios, initial_insts,        cardinality, selectivity     from sysibm.sysroutines     where     ( routinetype in ('F', 'M') and       ( routineschema = USER or         EXISTS         ( select 1           from sysibm.sysdbauth           where grantee = USER and dbadmauth  ='Y'         )        )      );

CREATE VIEW XMLRELATIONSHIPS (RELATIONSHIPID, RELATIONSHIPTYPE, PARENTID, PARENTTYPE, CHILDID, CHILDTYPE, LINKEDNAME, REFERENCED_RELATIONSHIPID, DEFINER, CREATE_TIME, ALTER_TIME) AS
select r.relationshipid,r.relationshiptype,r.parentid,  (select o.objecttype from sysibm.sysxmlobjects o where r.parentid=o.objectid),  r.childid,  (select o.objecttype from sysibm.sysxmlobjects o where r.childid=o.objectid),  r.linkedname,r.referenced_relationshipid,r.definer,r.create_time,r.alter_time  from sysibm.sysxmlrelationships r;

--CREATE VIEW CUSTSAMPLE (CLIENT_ID, AGE, GENDER, MARITAL_STATUS, PROFESSION, NBR_YEARS_CLI, SAVINGS_ACCOUNT, HAS_LIFE_INSURANCE, INT_CREDITCARD, ONLINE_ACCESS, JOINED_ACCOUNTS, BANKCARD, AVERAGE_BALANCE, NO_CRED_TRANS, NO_DEBIT_TRANS) AS
--SELECT * FROM "BANKCUSTOMERS" TABLESAMPLE SYSTEM(10) REPEATABLE(3);

CREATE VIEW PASSTHRUAUTH (GRANTOR, GRANTEE, GRANTEETYPE, SERVERNAME) AS
select      grantor, grantee, granteetype, servername  from sysibm.syspassthruauth;

CREATE VIEW WRAPPERS (WRAPNAME, WRAPTYPE, WRAPVERSION, LIBRARY, REMARKS) AS
select      wrapname, wraptype, wrapversion, library, remarks  from sysibm.syswrappers;

CREATE VIEW BUFFERPOOLS (BPNAME, BUFFERPOOLID, DBPGNAME, NPAGES, PAGESIZE, ESTORE, NUMBLOCKPAGES, BLOCKSIZE, NGNAME) AS
select      bpname, bufferpoolid, ngname, npages, pagesize, estore,      numblockpages, blocksize, ngname  from sysibm.sysbufferpools;

--CREATE VIEW IM_FINDDEVIATIONS_03 (NBR_YEARS_CLI, AVERAGE_BALANCE, ONLINE_ACCESS, INT_CREDITCARD, PROFESSION, AGE, GENDER, MARITAL_STATUS, HAS_LIFE_INSURANCE, CLIENT_ID, SAVINGS_ACCOUNT, NO_DEBIT_TRANS, NO_CRED_TRANS, BANKCARD, JOINED_ACCOUNTS, CLUSTER_ID, DEV_DEGREE) AS
--( select (totalSize*1.0)/SIZE as DEV_DEGREE, ID  from table(IDMMX.DM_getClusters((select MODEL from IDMMX.ClusterModels where ModelName = 'IDMMX.IM_FINDDEVIATIONS_03'))) as C, TotalSize )  SELECT T."NBR_YEARS_CLI",T."AVERAGE_BALANCE",T."ONLINE_ACCESS",T."INT_CREDITCARD",T."PROFESSION",T."AGE",T."GENDER",T."MARITAL_STATUS",T."HAS_LIFE_INSURANCE",T."CLIENT_ID",T."SAVINGS_ACCOUNT",T."NO_DEBIT_TRANS",T."NO_CRED_TRANS",T."BANKCARD",T."JOINED_ACCOUNTS",  D.CLUSTER_ID as CLUSTER_ID, D.DEV_DEGREE  as DEV_DEGREE FROM ScoreView T, DevDegrees D  where T.CLUSTER_ID = D.CLUSTER_ID;

CREATE VIEW FUNCMAPPARMOPTIONS (FUNCTION_MAPPING, ORDINAL, LOCATION, OPTION, SETTING) AS
select      function_mapping, ordinal, location, option, setting  from sysibm.sysfuncmapparmoptions;

CREATE VIEW DBAUTH (GRANTOR, GRANTEE, GRANTEETYPE, DBADMAUTH, CREATETABAUTH, BINDADDAUTH, CONNECTAUTH, NOFENCEAUTH, IMPLSCHEMAAUTH, LOADAUTH, EXTERNALROUTINEAUTH, QUIESCECONNECTAUTH, LIBRARYADMAUTH, SECURITYADMAUTH) AS
select      grantor, grantee, granteetype, dbadmauth, createtabauth,      bindaddauth, connectauth, nofenceauth, implschemaauth,      loadauth, externalroutineauth, quiesceconnectauth,      libraryadmauth, securityadmauth  from sysibm.sysdbauth;

CREATE VIEW XMLQUERIES (OBJECTID, XMLQUERYTEXT) AS
select  objectid,xmlquerytext  from sysibm.sysxmlqueries;

CREATE VIEW UDT_S (UDT_CATALOG, UDT_SCHEMA, UDT_NAME, UDT_CATEGORY, IS_INSTANTIABLE, IS_FINAL, ORDERING_FORM, ORDERING_CATEGORY, ORDERING_ROUT_CAT, ORDERING_ROUT_SCH, ORDERING_ROUT_NAME, REFERENCE_TYPE, DATA_TYPE, CHAR_MAX_LENGTH, CHAR_OCTET_LENGTH, CHAR_SET_CATALOG, CHAR_SET_SCHEMA, CHARACTER_SET_NAME, COLLATION_CATALOG, COLLATION_SCHEMA, COLLATION_NAME, NUMERIC_PRECISION, NUMERIC_PREC_RADIX, NUMERIC_SCALE, DATETIME_PRECISION, INTERVAL_TYPE, INTERVAL_PRECISION, SOURCE_DTD_ID, REF_DTD_IDENTIFIER) AS
SELECT USER_DEFINED_TYPE_CATALOG, USER_DEFINED_TYPE_SCHEMA,     USER_DEFINED_TYPE_NAME, USER_DEFINED_TYPE_CATEGORY,     IS_INSTANTIABLE, IS_FINAL, ORDERING_FORM, ORDERING_CATEGORY,     ORDERING_ROUTINE_CATALOG, ORDERING_ROUTINE_SCHEMA,     ORDERING_ROUTINE_NAME, REFERENCE_TYPE, DATA_TYPE,     CHARACTER_MAXIMUM_LENGTH, CHARACTER_OCTET_LENGTH,     CHARACTER_SET_CATALOG, CHARACTER_SET_SCHEMA,     CHARACTER_SET_NAME, COLLATION_CATALOG, COLLATION_SCHEMA,     COLLATION_NAME, NUMERIC_PRECISION, NUMERIC_PRECISION_RADIX,     NUMERIC_SCALE, DATETIME_PRECISION, INTERVAL_TYPE,     INTERVAL_PRECISION, SOURCE_DTD_IDENTIFIER, REF_DTD_IDENTIFIER FROM SYSIBM.USER_DEFINED_TYPES;

CREATE VIEW COLUMNS_S (TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, ORDINAL_POSITION, COLUMN_DEFAULT, IS_NULLABLE, DATA_TYPE, CHAR_MAX_LENGTH, CHAR_OCTET_LENGTH, NUMERIC_PRECISION, NUMERIC_PREC_RADIX, NUMERIC_SCALE, DATETIME_PRECISION, INTERVAL_TYPE, INTERVAL_PRECISION, CHAR_SET_CATALOG, CHAR_SET_SCHEMA, CHARACTER_SET_NAME, COLLATION_CATALOG, COLLATION_SCHEMA, COLLATION_NAME, DOMAIN_CATALOG, DOMAIN_SCHEMA, DOMAIN_NAME, UDT_CATALOG, UDT_SCHEMA, UDT_NAME, SCOPE_CATALOG, SCOPE_SCHEMA, SCOPE_NAME, MAX_CARDINALITY, DTD_IDENTIFIER, IS_SELF_REF) AS
SELECT  TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME,  ORDINAL_POSITION, COLUMN_DEFAULT, IS_NULLABLE, DATA_TYPE,  CHARACTER_MAXIMUM_LENGTH, CHARACTER_OCTET_LENGTH, NUMERIC_PRECISION, NUMERIC_PRECISION_RADIX,  NUMERIC_SCALE, DATETIME_PRECISION, INTERVAL_TYPE, INTERVAL_PRECISION,  CHARACTER_SET_CATALOG, CHARACTER_SET_SCHEMA, CHARACTER_SET_NAME, COLLATION_CATALOG,  COLLATION_SCHEMA, COLLATION_NAME, DOMAIN_CATALOG, DOMAIN_SCHEMA,  DOMAIN_NAME, UDT_CATALOG, UDT_SCHEMA, UDT_NAME,  SCOPE_CATALOG, SCOPE_SCHEMA, SCOPE_NAME, MAXIMUM_CARDINALITY,  DTD_IDENTIFIER, IS_SELF_REFERENCING FROM SYSIBM.COLUMNS;

CREATE VIEW TABLES (TABSCHEMA, TABNAME, DEFINER, TYPE, STATUS, BASE_TABSCHEMA, BASE_TABNAME, ROWTYPESCHEMA, ROWTYPENAME, CREATE_TIME, STATS_TIME, COLCOUNT, TABLEID, TBSPACEID, CARD, NPAGES, FPAGES, OVERFLOW, TBSPACE, INDEX_TBSPACE, LONG_TBSPACE, PARENTS, CHILDREN, SELFREFS, KEYCOLUMNS, KEYINDEXID, KEYUNIQUE, CHECKCOUNT, DATACAPTURE, CONST_CHECKED, PMAP_ID, PARTITION_MODE, LOG_ATTRIBUTE, PCTFREE, APPEND_MODE, REFRESH, REFRESH_TIME, LOCKSIZE, VOLATILE, REMARKS, ROW_FORMAT, PROPERTY, STATISTICS_PROFILE, COMPRESSION, ACCESS_MODE, CLUSTERED, ACTIVE_BLOCKS, DROPRULE, MAXFREESPACESEARCH) AS
select      creator, name, definer, type, status,      base_schema, base_name, rowtypeschema, rowtypename,      ctime, stats_time, colcount, fid,      tid, card, npages, fpages, overflow, tbspace,      index_tbspace, long_tbspace, parents, children, selfrefs,      keycolumns, keyobid, keyunique, checkcount,      data_capture, const_checked, pmap_id, partition_mode,      log_attribute, pctfree, append_mode, refresh,      refresh_time, locksize, volatile, remarks, row_format,      property,      statistics_profile, compression,      access_mode, clustered, active_blocks, droprule, maxfreespacesearch  from sysibm.systables;

CREATE VIEW KEYCOLUSE (CONSTNAME, TABSCHEMA, TABNAME, COLNAME, COLSEQ) AS
select      constname, tbcreator, tbname, colname, colseq  from sysibm.syskeycoluse;

CREATE VIEW SYSFUNCTIONS (NAME, SCHEMA, DEFINER, SPECIFIC, PARM_SIGNATURE, FUNCTION_ID, RETURN_TYPE, ORIGIN, TYPE, CREATE_TIME, PARM_COUNT, VARIANT, SIDE_EFFECTS, FENCED, NULLCALL, CAST_FUNCTION, ASSIGN_FUNCTION, SCRATCHPAD, FINAL_CALL, LANGUAGE, IMPLEMENTATION, SOURCE_SPECIFIC, SOURCE_SCHEMA, IOS_PER_INVOC, INSTS_PER_INVOC, IOS_PER_ARGBYTE, INSTS_PER_ARGBYTE, PERCENT_ARGBYTES, INITIAL_IOS, INITIAL_INSTS, INTERNAL_PREC1, INTERNAL_PREC2, REMARKS, INTERNAL_DESC, PARALLELIZABLE, CONTAINS_SQL, DBINFO, RESULT_COLS, BODY, CARDINALITY, PARM_STYLE, METHOD, IMPLEMENTED, EFFECT, FUNC_PATH, TYPE_PRESERVING, WITH_FUNC_ACCESS, SELECTIVITY, OVERRIDDEN_FUNCID, SUBJECT_TYPESCHEMA, SUBJECT_TYPENAME, QUALIFIER, CLASS, JAR_ID) AS
select      a.routinename, a.routineschema, a.definer, a.specificname, a.parm_signature, a.routine_id,      a.return_type, a.origin, a.function_type, a.createdts, a.parm_count,      CAST (CASE a.deterministic            WHEN 'Y' THEN 'N'            WHEN 'N' THEN 'Y'            ELSE ' ' END AS CHAR(1)),      a.external_action, a.fenced, a.null_call, a.cast_function,      a.assign_function, a.scratchpad, a.final_call, a.language,      a.implementation, a.sourcespecific, a.sourceschema, a.ios_per_invoc,      a.insts_per_invoc, a.ios_per_argbyte, a.insts_per_argbyte,      a.percent_argbytes, a.initial_ios, a.initial_insts, a.internal_prec1,      a.internal_prec2, a.remarks, a.internal_desc, a.parallel,      a.sql_data_access, a.dbinfo, a.result_cols, a.text, a.cardinality,      a.parameter_style, CAST (CASE a.routinetype            WHEN 'M' THEN 'Y'            ELSE 'N' END AS CHAR(1)),      CASE         WHEN a.routinetype = 'F'              THEN 'Y'         WHEN a.methodimplemented = 'N' AND a.with_func_access = 'N'              THEN 'A'         WHEN a.methodimplemented = 'Y' AND a.with_func_access = 'Y'              THEN 'H'         WHEN a.methodimplemented = 'Y' AND a.with_func_access = 'N'              THEN 'M'         ELSE ' '     END as methodimplemented,      a.methodeffect, a.func_path,      CAST (CASE         WHEN a.type_preserving = 'Y'              THEN 'Y'         ELSE 'N'      END AS CHAR(1)),      CASE a.routinetype         WHEN 'F' THEN 'Y'         ELSE a.routinetype      END as with_func_access,      a.selectivity, a.overridden_methodid,      a.subject_typeschema, a.subject_typename, a.qualifier,      CASE WHEN a.language <> 'JAVA'        THEN NULL      ELSE        (SELECT pj.class FROM         SYSIBM.SYSROUTINEPROPERTIESJAVA AS pj         WHERE pj.routine_id = a.routine_id)      END,      CASE WHEN a.language <> 'JAVA'        THEN NULL      ELSE        (SELECT pj.jar_id FROM         SYSIBM.SYSROUTINEPROPERTIESJAVA AS pj         WHERE pj.routine_id = a.routine_id)      END  from sysibm.sysroutines as a  where a.routinetype in ('F', 'M');

CREATE VIEW TABLE_CONSTRAINTS (CONSTRAINT_CATALOG, CONSTRAINT_SCHEMA, CONSTRAINT_NAME, TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, CONSTRAINT_TYPE, IS_DEFERRABLE, INITIALLY_DEFERRED) AS
SELECT CAST(CURRENT SERVER  AS VARCHAR(128)),                TBCREATOR ,                CAST(NAME    AS VARCHAR(128)),                CAST(CURRENT SERVER AS VARCHAR(128)),                TBCREATOR ,                TBNAME,                CASE CONSTRAINTYP                           WHEN 'K' THEN  'CHECK'                           WHEN 'P' THEN ' PRIMARY KEY'                           WHEN 'F' THEN ' FOREIGN KEY'                           WHEN 'U' THEN ' UNIQUE'                END ,                'NO'  ,  'NO' FROM   SYSIBM.SYSTABCONST  UNION ALL  SELECT  CAST(CURRENT SERVER AS VARCHAR(128)),          TBCREATOR,           CAST(CONCAT(SUBSTR(HEX(CTIME),5),                       CONCAT(HEX(COLNO),                              CONCAT(HEX(FID),HEX(TID))))                AS VARCHAR(128) ),           CAST(CURRENT SERVER AS VARCHAR(128)),                   TBCREATOR,                   TBNAME,                    'CHECK',             'NO', 'NO' FROM          SYSIBM.SYSCOLUMNS C,           SYSIBM.SYSTABLES T WHERE   C.TBCREATOR = T.CREATOR      AND C.TBNAME = T.NAME      AND TYPE IN ('U', 'T')      AND NULLS ='N';

--CREATE VIEW ROUTINES (SPECIFIC_CATALOG, SPECIFIC_SCHEMA, SPECIFIC_NAME, ROUTINE_CATALOG, ROUTINE_SCHEMA, ROUTINE_NAME, ROUTINE_TYPE, MODULE_CATALOG, MODULE_SCHEMA, MODULE_NAME, UDT_CATALOG, UDT_SCHEMA, UDT_NAME, DATA_TYPE, CHARACTER_MAXIMUM_LENGTH, CHARACTER_OCTET_LENGTH, CHARACTER_SET_CATALOG, CHARACTER_SET_SCHEMA, CHARACTER_SET_NAME, COLLATION_CATALOG, COLLATION_SCHEMA, COLLATION_NAME, NUMERIC_PRECISION, NUMERIC_PRECISION_RADIX, NUMERIC_SCALE, DATETIME_PRECISION, INTERVAL_TYPE, INTERVAL_PRECISION, TYPE_UDT_CATALOG, TYPE_UDT_SCHEMA, TYPE_UDT_NAME, SCOPE_CATALOG, SCOPE_SCHEMA, SCOPE_NAME, MAXIMUM_CARDINALITY, DTD_IDENTIFIER, ROUTINE_BODY, ROUTINE_DEFINITION, EXTERNAL_NAME, EXTERNAL_LANGUAGE, PARAMETER_STYLE, IS_DETERMINISTIC, SQL_DATA_ACCESS, IS_NULL_CALL, SQL_PATH, SCHEMA_LEVEL_ROUTINE, MAX_DYNAMIC_RESULT_SETS, IS_USER_DEFINED_CAST, IS_IMPLICITLY_INVOCABLE, SECURITY_TYPE, TO_SQL_SPECIFIC_CATALOG, TO_SQL_SPECIFIC_SCHEMA, TO_SQL_SPECIFIC_NAME, AS_LOCATOR, CREATED, LAST_ALTERED) AS
--( SELECT CURRENT SERVER, R.ROUTINESCHEMA, R.SPECIFICNAME,                    P.TRANSFORM_GRPNAME     FROM SYSIBM.SYSROUTINEPARMS P,                 SYSIBM.SYSROUTINES R,                 SYSIBM.SYSTRANSFORMS T WHERE  P. TRANSFORM_GRPNAME = T.GROUPNAME   AND       T.TOSQL_FUNCID = R.ROUTINE_ID )      SELECT CAST(CURRENT SERVER AS VARCHAR(128)),         R.ROUTINESCHEMA,         CAST(R.SPECIFICNAME     AS VARCHAR(128)),         CAST(CURRENT SERVER     AS VARCHAR(128)),         R.ROUTINESCHEMA,         CAST(R.ROUTINENAME AS VARCHAR(128)),            CASE WHEN R.ROUTINETYPE='P'  THEN 'PROCEDURE'               WHEN R.ROUTINETYPE='M' AND METHODPROPERTY ='S'                                            THEN 'STATIC METHOD'               WHEN R.ROUTINETYPE='M' AND METHODPROPERTY='I'                                             THEN 'INSTANCE METHOD'               WHEN R.ROUTINETYPE='M' AND METHODPROPERTY='C'                                            THEN 'CONSTRUCTOR METHOD'               WHEN R.ROUTINETYPE='F'  THEN 'FUNCTION'            END,            CAST(NULL AS VARCHAR(128)),            CAST(NULL AS VARCHAR(128)),            CAST(NULL AS VARCHAR(128)),            CASE R.ROUTINETYPE  WHEN 'M'   THEN CAST(CURRENT SERVER AS VARCHAR(128))               ELSE CAST(NULL AS VARCHAR(128))            END,            CASE R.ROUTINETYPE               WHEN 'M'  THEN SUBJECT_TYPESCHEMA               ELSE CAST(NULL AS VARCHAR(128))            END,            CASE R.ROUTINETYPE               WHEN 'M'    THEN CAST(SUBJECT_TYPENAME AS VARCHAR(128))               ELSE CAST(NULL AS VARCHAR(128))            END,            CASE               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='CHARACTER' THEN 'CHARACTER'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='VARCHAR'   THEN 'CHARACTER VARYING' WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='LONG VARCHAR' THEN 'LONG VARCHAR'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='INTEGER'   THEN 'INTEGER'               WHEN  (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='SMALLINT'  THEN 'SMALLINT'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='BIGINT'    THEN 'BIGINT'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='REAL'  THEN 'REAL'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='DOUBLE'    THEN 'DOUBLE PRECISION'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='DECIMAL'   THEN 'DECIMAL'   WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME = 'BLOB'     THEN 'BINARY LARGE OBJECT'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='CLOB'      THEN 'CHARACTER LARGE OBJECT'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='DBCLOB'    THEN 'DOUBLE-BYTE CHARACTER LARGE OBJECT'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='GRAPHIC'   THEN 'GRAPHIC'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='VARGRAPHIC' THEN 'GRAPHIC VARYING'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='LONG VARGRAPHIC'   THEN 'LONG VARGRAPHIC'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='DATALINK'      THEN 'DATALINK' WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='TIME'      THEN 'TIME'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='DATE'      THEN 'DATE'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='TIMESTAMP'     THEN 'TIMESTAMP'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='REFERENCE'     THEN 'REF'               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPESCHEMA <> 'SYSIBM'    THEN 'USER-DEFINED'               WHEN (R.ROUTINETYPE ='P')            THEN CAST(NULL AS VARCHAR(128))               ELSE P.TYPENAME  END,            CASE               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME IN                       ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB'  ,                        'GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                                                    THEN P.LENGTH               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='BLOB'          THEN P.LENGTH               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='REFERENCE'     THEN P.LENGTH               ELSE CAST (NULL AS INTEGER)            END, CASE               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME IN                       ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB')                                                    THEN P.LENGTH               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME IN                       ('GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                                                    THEN P.LENGTH*2               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME = 'BLOB'         THEN P.LENGTH   WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME='REFERENCE'      THEN P.LENGTH               ELSE CAST(NULL AS INTEGER)            END,            CASE               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME IN                       ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB'  ,                        'GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                  THEN CAST(CURRENT SERVER AS VARCHAR(128))               ELSE CAST(NULL AS VARCHAR(128))            END, CASE               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME IN                       ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB'  ,                        'GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                  THEN CAST( 'SYSIBM' AS VARCHAR(128))               ELSE CAST( NULL  AS VARCHAR(128))            END,            CASE               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME IN                       ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB'  ,                        'GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')  THEN CAST(CONCAT('IBM',CHAR(P.CODEPAGE)) AS VARCHAR(128))               ELSE CAST(NULL AS VARCHAR(128))            END,            CASE               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME IN                       ('CHARACTRE', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB'  ,                        'GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                  THEN CAST(CURRENT SERVER AS VARCHAR(128))               ELSE CAST(NULL AS VARCHAR(128))            END, CASE               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME IN                       ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB'  ,                        'GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                  THEN CAST( 'SYSIBM' AS VARCHAR(128))               ELSE CAST( NULL  AS VARCHAR(128))  END,            CASE               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME IN                       ('CHARACTER', 'VARCHAR'   , 'LONG VARCHAR'   , 'CLOB'  ,                        'GRAPHIC'  , 'VARGRAPHIC', 'LONG VARGRAPHIC', 'DBCLOB')                  THEN CAST('IBMDEFAULT' AS VARCHAR(128))               ELSE CAST(NULL AS VARCHAR(128))            END,            CASE WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='INTEGER'   THEN 10               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='BIGINT'    THEN 19               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='SMALLINT'  THEN 5               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='REAL'      THEN 24               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='DOUBLE'    THEN 53               WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                    AND P.TYPENAME ='DECIMAL'   THEN P.LENGTH               ELSE CAST(NULL AS INTEGER)  END,            CASE                        WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                             AND P.TYPENAME ='INTEGER'   THEN 10                       WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                             AND P.TYPENAME ='BIGINT'    THEN 10                       WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                             AND P.TYPENAME ='SMALLINT'  THEN 10                        WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                             AND P.TYPENAME ='REAL'      THEN  2                        WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                             AND P.TYPENAME ='DOUBLE'    THEN 2                        WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                             AND P.TYPENAME ='DECIMAL'   THEN  10                       ELSE CAST(NULL AS INTEGER) END,                  CASE                          WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                             AND P.TYPENAME ='DECIMAL'   THEN  CAST(P.SCALE AS INTEGER)                          WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                             AND P.TYPENAME ='INTEGER'   THEN  0                          WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                             AND P.TYPENAME ='SMALLINT'  THEN  0                          ELSE CAST(NULL AS INTEGER)                  END,                  CASE                          WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )  AND P.TYPENAME ='DATE'      THEN  0                          WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                             AND P.TYPENAME ='TIME'      THEN 0                          WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                             AND P.TYPENAME ='TIMESTAMP' THEN 6                          ELSE CAST(NULL AS INTEGER)                  END,                  CAST(NULL AS VARCHAR(128)) ,                  CAST(NULL AS INTEGER) ,                  CASE                     WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                          AND P.TYPENAME ='REFERENCE'     THEN                         CAST(CURRENT SERVER AS VARCHAR(128))                     WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                          AND P.TYPESCHEMA <> 'SYSIBM'    THEN                         CAST(CURRENT SERVER AS VARCHAR(128)) ELSE CAST(NULL AS VARCHAR(128))                  END,                  CASE                     WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                          AND P.TYPENAME ='REFERENCE'    THEN TARGET_TYPESCHEMA                     WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                          AND P.TYPESCHEMA <> 'SYSIBM'   THEN TYPESCHEMA                     ELSE CAST(NULL AS VARCHAR(128))                  END,                  CASE                     WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                          AND P.TYPENAME ='REFERENCE'    THEN                        CAST(TARGET_TYPENAME AS VARCHAR(128))                     WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )  AND P.TYPESCHEMA <>'SYSIBM'      THEN                         CAST(TYPENAME AS VARCHAR(128))                     ELSE CAST(NULL AS VARCHAR(128))                  END,                  CASE                     WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                          AND P.TYPENAME ='REFERENCE'  THEN                        CAST(CURRENT SERVER AS VARCHAR(128))                     ELSE CAST(NULL AS VARCHAR(128))                  END,                  CASE                     WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                          AND P.TYPENAME ='REFERENCE'    THEN P.SCOPE_TABSCHEMA                     ELSE CAST(NULL AS VARCHAR(128)) END,                  CASE                     WHEN (R.ROUTINETYPE ='M' OR R.ROUTINETYPE='F' )                          AND P.TYPENAME ='REFERENCE'  THEN P.SCOPE_TABNAME                     ELSE CAST(NULL AS VARCHAR(128))                  END,                  CAST(NULL AS INTEGER),                  CAST(CONCAT('R',HEX(R.ROUTINE_ID)) AS VARCHAR(128)),                  CASE LANGUAGE                     WHEN 'SQL'   THEN 'SQL'  ELSE 'EXTERNAL'                  END,                  CASE LANGUAGE                     WHEN 'SQL'      THEN TEXT                      ELSE CAST(NULL AS CLOB(1M))                  END,                  CAST(CASE                          WHEN LANGUAGE  <>  'SQL'  THEN  IMPLEMENTATION                          ELSE   NULL                       END AS VARCHAR(279) ),                  CASE WHEN LANGUAGE <>' SQL'                        THEN CAST(LANGUAGE AS VARCHAR(22))                     ELSE CAST(NULL AS VARCHAR(22))                  END,                  CASE PARAMETER_STYLE                     WHEN 'DB2GENRL'     THEN CAST('DB2GENERAL' AS VARCHAR(22))                     WHEN 'DB2DARI'      THEN CAST('DB2DARI'    AS VARCHAR(22))                     WHEN 'DB2SQL'       THEN CAST('DB2SQL'     AS VARCHAR(22))                     WHEN 'JAVA'         THEN CAST('JAVA'       AS VARCHAR(22))                     WHEN 'GENERAL'      THEN CAST('GENERAL'    AS VARCHAR(22))                     WHEN 'GNRLNULL'     THEN                        CAST('GENERAL;

CREATE VIEW SQLSCHEMAS (TABLE_CAT, TABLE_SCHEM, TABLE_NAME, TABLE_TYPE, REMARKS, TYPE_CAT, TYPE_SCHEM, TYPE_NAME, SELF_REF_COL_NAME, REF_GENERATION, DBNAME) AS
  SELECT     CAST( NULL AS VARCHAR(128) ),     RTRIM(NAME),     CAST( NULL AS VARCHAR(128) ),     CAST( NULL AS VARCHAR(128) ),     CAST( NULL AS VARCHAR(254) ),     CAST( NULL AS VARCHAR(128) ),     CAST( NULL AS VARCHAR(128) ),     CAST( NULL AS VARCHAR(128) ),     CAST( NULL AS VARCHAR(128) ),     CAST( NULL AS VARCHAR(128) ),     CAST( NULL AS VARCHAR(8) )   FROM     SYSIBM.SYSSCHEMATA;

CREATE VIEW COLUMNS (TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, ORDINAL_POSITION, COLUMN_DEFAULT, IS_NULLABLE, DATA_TYPE, CHARACTER_MAXIMUM_LENGTH, CHARACTER_OCTET_LENGTH, NUMERIC_PRECISION, NUMERIC_PRECISION_RADIX, NUMERIC_SCALE, DATETIME_PRECISION, INTERVAL_TYPE, INTERVAL_PRECISION, CHARACTER_SET_CATALOG, CHARACTER_SET_SCHEMA, CHARACTER_SET_NAME, COLLATION_CATALOG, COLLATION_SCHEMA, COLLATION_NAME, DOMAIN_CATALOG, DOMAIN_SCHEMA, DOMAIN_NAME, UDT_CATALOG, UDT_SCHEMA, UDT_NAME, SCOPE_CATALOG, SCOPE_SCHEMA, SCOPE_NAME, MAXIMUM_CARDINALITY, DTD_IDENTIFIER, IS_SELF_REFERENCING) AS
SELECT  CAST(CURRENT SERVER AS VARCHAR(128)),         C.TBCREATOR,  C.TBNAME,  C.NAME ,                 CAST(C.COLNO+1  AS INTEGER),                 CAST(C.DEFAULT AS VARCHAR(2000)),                 CASE C.NULLS                        WHEN 'Y'     THEN 'YES'                        ELSE 'NO'                  END ,                CASE                       WHEN C.COLTYPE='CHAR'     THEN 'CHARACTER'                       WHEN C.COLTYPE='VARCHAR'  THEN 'CHARACTER VARYING'                       WHEN C.COLTYPE='LONGVAR'  THEN 'LONG VARCHAR'                       WHEN C.COLTYPE='INTEGER'  THEN 'INTEGER'                       WHEN C.COLTYPE='SMALLINT' THEN 'SMALLINT'                       WHEN C.COLTYPE='BIGINT'   THEN 'BIGINT'                       WHEN C.COLTYPE='REAL'     THEN 'REAL'                       WHEN C.COLTYPE='DOUBLE'   THEN 'DOUBLE PRECISION'                       WHEN C.COLTYPE='DECIMAL'  THEN 'DECIMAL'                       WHEN C.COLTYPE='BLOB'     THEN 'BINARY LARGE OBJECT'                       WHEN C.COLTYPE='CLOB'     THEN 'CHARACTER LARGE OBJECT'                       WHEN C.COLTYPE='DBCLOB'   THEN 'DOUBLE-BYTE CHARACTER LARGE OBJECT'                       WHEN C.COLTYPE='GRAPHIC'  THEN 'GRAPHIC' WHEN C.COLTYPE='VARGRAPH' THEN 'GRAPHIC VARYING'                       WHEN C.COLTYPE='LONGVARG' THEN 'LONG VARGRAPHIC'                       WHEN C.COLTYPE='DATALINK' THEN 'DATALINK'                       WHEN C.COLTYPE='TIME'     THEN 'TIME'                       WHEN C.COLTYPE='DATE'     THEN 'DATE'                       WHEN C.COLTYPE='TIMESTMP' THEN 'TIMESTAMP'                       WHEN C.COLTYPE='DATALINK' THEN 'DATALINK'                       WHEN C.COLTYPE='REF'      THEN 'REF'                       WHEN C.COLTYPE='DISTINCT' THEN 'USER-DEFINED'                       WHEN C.COLTYPE='STRUCT'   THEN 'USER-DEFINED'                       ELSE C.TYPENAME                END,               CASE                      WHEN  C.COLTYPE ='CHAR'    THEN CAST(C.LENGTH AS INTEGER)                      WHEN  C.COLTYPE='VARCHAR'  AND C.LENGTH= -1             THEN C.LONGLENGTH                      WHEN  C.COLTYPE ='VARCHAR' AND C.LENGTH <> -1             THEN  CAST(C.LENGTH AS INTEGER)                      WHEN  C.COLTYPE='LONGVAR'  AND C.LENGTH= -1              THEN C.LONGLENGTH                      WHEN  C.COLTYPE ='LONGVAR' AND C.LENGTH <> -1             THEN  CAST(C.LENGTH AS INTEGER)                      WHEN  C.COLTYPE= 'CLOB' AND C.LENGTH=-1             THEN C.LONGLENGTH                      WHEN  C.COLTYPE='CLOB' AND C.LENGTH <>-1             THEN CAST(C.LENGTH AS INTEGER)                      WHEN  C.COLTYPE ='BLOB'  AND  C.LENGTH =-1             THEN C.LONGLENGTH                      WHEN  C.COLTYPE='BLOB' AND C.LENGTH <> -1             THEN CAST(C.LENGTH AS INTEGER)                      WHEN  C.COLTYPE='DBCLOB'  AND C.LENGTH =-1             THEN C.LONGLENGTH                      WHEN  C.COLTYPE='DBCLOB' AND C.LENGTH <> -1             THEN  CAST(C.LENGTH AS INTEGER) WHEN  C.COLTYPE='GRAPHIC'         THEN  CAST(C.LENGTH AS INTEGER)                      WHEN  C.COLTYPE='VARGRAPH'     THEN CAST(C.LENGTH AS INTEGER)                      WHEN  C.COLTYPE='LONGVARG'             THEN CAST(C.LENGTH AS INTEGER)                      WHEN  C.COLTYPE='REF'               THEN CAST(C.LENGTH AS INTEGER)                      ELSE CAST(NULL AS INTEGER)               END,               CASE                      WHEN  C.COLTYPE ='CHAR'             THEN  CAST(C.LENGTH AS INTEGER)                      WHEN   C.COLTYPE='VARCHAR'  AND C.LENGTH= -1 THEN C.LONGLENGTH                      WHEN  C.COLTYPE ='VARCHAR' AND C.LENGTH <> -1             THEN  CAST(C.LENGTH AS INTEGER)                       WHEN C.COLTYPE='LONGVAR'  AND C.LENGTH= -1             THEN C.LONGLENGTH                      WHEN  C.COLTYPE ='LONGVAR'  AND C.LENGTH <> -1             THEN  CAST(C.LENGTH AS INTEGER)                      WHEN C.COLTYPE= 'CLOB' AND C.LENGTH=-1              THEN C.LONGLENGTH                      WHEN C.COLTYPE='CLOB' AND C.LENGTH <>-1             THEN CAST(C.LENGTH AS INTEGER)                      WHEN C.COLTYPE ='BLOB'  AND  C.LENGTH =-1             THEN C.LONGLENGTH                      WHEN C.COLTYPE='BLOB' AND C.LENGTH <> -1             THEN CAST(C.LENGTH AS INTEGER)                      WHEN C.COLTYPE='DBCLOB'  AND C.LENGTH =-1              THEN C.LONGLENGTH*2                      WHEN C.COLTYPE='DBCLOB' AND C.LENGTH <> -1              THEN  CAST(C.LENGTH*2  AS INTEGER)                     WHEN  C.COLTYPE='GRAPHIC'       THEN  CAST(C.LENGTH*2 AS INTEGER)                     WHEN  C.COLTYPE='VARGRAPH'  THEN  CAST(C.LENGTH*2 AS INTEGER)                     WHEN  C.COLTYPE='LONGVARG'             THEN CAST(C.LENGTH*2 AS INTEGER)                     WHEN  C.COLTYPE='REF'         THEN  CAST(C.LENGTH AS INTEGER)                     ELSE CAST(NULL AS INTEGER)               END, CASE C.COLTYPE                 WHEN 'INTEGER'  THEN 10                 WHEN 'BIGINT'          THEN 19                 WHEN 'SMALLINT'        THEN 5                 WHEN 'REAL'            THEN 24                 WHEN 'DOUBLE'          THEN 53                 WHEN 'DECIMAL'         THEN CAST(C.LENGTH AS INTEGER)                 ELSE CAST(NULL AS INTEGER)              END,              CASE   C.COLTYPE                 WHEN 'INTEGER'        THEN 10                 WHEN 'BIGINT'         THEN 10                 WHEN 'SMALLINT'       THEN 10                 WHEN 'REAL'           THEN 2                 WHEN 'DOUBLE'         THEN 2                 WHEN 'DECIMAL'        THEN 10                 ELSE CAST(NULL AS INTEGER)              END  ,              CASE  C.COLTYPE                 WHEN 'DECIMAL'     THEN CAST(C.SCALE AS INTEGER)                 WHEN 'INTEGER'     THEN 0                 WHEN 'SMALLINT'    THEN 0                 ELSE CAST(NULL AS INTEGER)              END,              CASE  C.COLTYPE                 WHEN 'DATE'          THEN 0                 WHEN 'TIME'          THEN 0                 WHEN 'TIMESTMP'      THEN 6                 ELSE  CAST(NULL AS INTEGER)              END,              CAST(NULL AS VARCHAR(128)) ,              CAST(NULL AS INTEGER) ,              CASE                 WHEN C.COLTYPE IN ('CHAR'   ,'VARCHAR' ,'LONGVAR' ,'CLOB',                                      'GRAPHIC','VARGRAPH','LONGVARG','DBCLOB')                    THEN CAST(CURRENT SERVER AS VARCHAR(128))              ELSE CAST(NULL AS VARCHAR(128))              END,              CASE                 WHEN C.COLTYPE IN ('CHAR'   ,'VARCHAR' ,'LONGVAR' ,'CLOB',                                      'GRAPHIC','VARGRAPH','LONGVARG','DBCLOB')                    THEN CAST('SYSIBM' AS VARCHAR(128))                 ELSE CAST(NULL AS VARCHAR(128)) END,              CASE                 WHEN C.COLTYPE IN ('CHAR'   ,'VARCHAR' ,'LONGVAR' ,'CLOB',                                      'GRAPHIC','VARGRAPH','LONGVARG','DBCLOB')                    THEN CAST(CONCAT('IBM',CHAR(C.CODEPAGE)) AS VARCHAR(128))                 ELSE CAST(NULL AS VARCHAR(128))              END,              CASE                 WHEN C.COLTYPE IN ('CHAR'   ,'VARCHAR' ,'LONGVAR' ,'CLOB',                                      'GRAPHIC','VARGRAPH','LONGVARG','DBCLOB')                    THEN CAST(CURRENT SERVER AS VARCHAR(128))                 ELSE CAST(NULL AS VARCHAR(128))              END,              CASE                 WHEN C.COLTYPE IN ('CHAR'   ,'VARCHAR' ,'LONGVAR' ,'CLOB',                                      'GRAPHIC','VARGRAPH','LONGVARG','DBCLOB')                    THEN CAST('SYSIBM' AS VARCHAR(128))                 ELSE CAST(NULL AS VARCHAR(128))              END,              CASE                 WHEN C.COLTYPE IN ('CHAR'   ,'VARCHAR' ,'LONGVAR' ,'CLOB',                                      'GRAPHIC','VARGRAPH','LONGVARG','DBCLOB')                    THEN CAST('IBMDEFAULT' AS VARCHAR(128))                 ELSE CAST(NULL AS VARCHAR(128))              END,              CAST (NULL AS VARCHAR(128)),              CAST (NULL AS VARCHAR(128)),              CAST (NULL AS VARCHAR(128)),              CASE C.COLTYPE                 WHEN 'DISTINCT'  THEN CAST(CURRENT SERVER AS VARCHAR(128))                 WHEN 'REF'       THEN CAST(CURRENT SERVER AS VARCHAR(128))                 WHEN 'STRUCT'    THEN CAST(CURRENT SERVER AS VARCHAR(128))                 ELSE CAST(NULL AS VARCHAR(128))              END ,              CASE  C.COLTYPE                 WHEN 'DISTINCT'  THEN TYPESCHEMA                 WHEN 'REF'       THEN P.TARGET_TYPESCHEMA                 WHEN 'STRUCT'    THEN TYPESCHEMA                 ELSE CAST(NULL AS VARCHAR(128))              END , CASE C.COLTYPE                 WHEN 'DISTINCT'  THEN CAST(TYPENAME AS VARCHAR(128))                 WHEN 'REF'       THEN CAST(P.TARGET_TYPENAME AS VARCHAR(128))                 WHEN 'STRUCT'    THEN CAST(TYPENAME AS VARCHAR(128))                 ELSE CAST(NULL AS VARCHAR(128))              END,              CASE C.COLTYPE                 WHEN  'REF'      THEN CAST(CURRENT SERVER AS VARCHAR(128))                 ELSE CAST(NULL AS VARCHAR(128))              END,              CASE C.COLTYPE                 WHEN 'REF'       THEN P.SCOPE_TABSCHEMA                 ELSE CAST(NULL AS VARCHAR(128))              END,              CASE C.COLTYPE                 WHEN  'REF'      THEN P.SCOPE_TABNAME                 ELSE CAST(NULL AS VARCHAR(128))              END,              CAST(NULL AS INTEGER),              CONCAT('C',CONCAT(HEX(T.CTIME),                 CONCAT(HEX(C.COLNO), SUBSTR(C.TBNAME,1,103)))),              CASE                 WHEN C.COLTYPE='REF' AND SUBSTR(P.SPECIAL_PROPS,1,1)='Y'                    THEN 'YES'                 ELSE 'NO'              END   FROM  (SYSIBM.SYSTABLES T INNER JOIN          SYSIBM.SYSCOLUMNS C on         C.TBCREATOR = T.CREATOR AND C.TBNAME = T.NAME)  LEFT OUTER JOIN               SYSIBM.SYSCOLPROPERTIES P    ON   C.TBCREATOR = P.TABSCHEMA    AND C.TBNAME = P.TABNAME    AND C.NAME = P.COLNAME;


CREATE UNIQUE INDEX IBM74 ON SYSSEQUENCEAUTH (GRANTEE ASC, SEQID ASC, GRANTEETYPE ASC, GRANTOR ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM55 ON SYSROUTINES (ROUTINESCHEMA ASC, SPECIFICNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM15 ON SYSTABAUTH (GRANTEE ASC, TCREATOR ASC, TTNAME ASC, GRANTEETYPE ASC, GRANTOR ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM159 ON SYSLIBRARYAUTH (GRANTOR ASC, GRANTEE ASC, GRANTEETYPE ASC, LIBSCHEMA ASC, LIBNAME ASC) PCTFREE 10;

CREATE INDEX IBM31 ON SYSROUTINEPARMS (SPECIFICNAME ASC, ROUTINESCHEMA ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM150 ON SYSLIBRARYVERSIONS (LIB_ID ASC, LIBVERSION ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM56 ON SYSDATATYPES (SCHEMA ASC, NAME ASC) PCTFREE 10;

CREATE INDEX ERRORTABLEINDEX ON ERRORTABLE (CALLID ASC) PCTFREE 10;

CREATE INDEX IBM160 ON SYSLIBRARYAUTH (GRANTEE ASC, GRANTEETYPE ASC, LIBSCHEMA ASC, LIBNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM78 ON SYSTABLES (ROWTYPESCHEMA ASC, ROWTYPENAME ASC, CREATOR ASC, NAME ASC) PCTFREE 10;

CREATE INDEX IBM176 ON SYSXMLPHYSICALCOLLECTIONS (DBPGNAME ASC) PCTFREE 10;

CREATE INDEX IBM177 ON SYSXMLPHYSICALCOLLECTIONS (BUFFERPOOLID ASC) PCTFREE 10;

CREATE INDEX IBM115 ON SYSSERVEROPTIONS (SERVERNAME ASC, OPTION ASC) PCTFREE 10;

CREATE INDEX IBM146 ON SYSCOLUSE (TABSCHEMA ASC, TABNAME ASC, DIMENSION ASC, COLSEQ ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM141 ON SYSLIBRARIES (LIB_ID ASC) PCTFREE 10;

CREATE INDEX IBM09 ON SYSPLANDEP (DCREATOR ASC, DNAME ASC, DUNIQUE_ID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM46 ON SYSCOLDIST (SCHEMA ASC, TBNAME ASC, NAME ASC, TYPE ASC, SEQNO ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM67 ON SYSBUFFERPOOLS (BPNAME ASC, NGNAME ASC) PCTFREE 10;

CREATE INDEX IBM96 ON SYSFUNCMAPPINGS (SERVERTYPE ASC, SERVERVERSION ASC, WRAPNAME ASC) PCTFREE 10;

CREATE INDEX IBM189 ON SYSROUTINES (ROUTINETYPE ASC, ROUTINENAME ASC, PARM_COUNT ASC, ROUTINESCHEMA ASC) PCTFREE 10;

CREATE INDEX IBM36 ON SYSKEYCOLUSE (TBCREATOR ASC, TBNAME ASC, CONSTNAME ASC) PCTFREE 10;

CREATE INDEX IBM85 ON SYSATTRIBUTES (TARGET_TYPESCHEMA ASC, TARGET_TYPENAME ASC, TYPESCHEMA ASC, TYPENAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM179 ON SYSXMLOBJECTAUTH (GRANTEE ASC, OBJECTID ASC, GRANTEETYPE ASC, GRANTOR ASC, PRIVILEGE_TYPE ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM110 ON SYSLIBRARIES (LIBSCHEMA ASC, LIBNAME ASC) PCTFREE 10;

CREATE INDEX IBM114 ON SYSTYPEMAPPINGS (SERVERTYPE ASC, SERVERVERSION ASC, WRAPNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM125 ON SYSWRAPPERS (WRAPNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM53 ON SYSTRIGGERS (SCHEMA ASC, NAME ASC) PCTFREE 10;

CREATE INDEX IBM156 ON SYSCOLGROUPSCOLS (COLGROUPID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM98 ON SYSINDEXEXTENSIONPARMS (IESCHEMA ASC, IENAME ASC, PARMNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM155 ON SYSCOLGROUPS (COLGROUPID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM68 ON SYSBUFFERPOOLS (BUFFERPOOLID ASC, NGNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM102 ON SYSINDEXOPTIONS (INDSCHEMA ASC, INDNAME ASC, OPTION ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM47 ON SYSEVENTMONITORS (NAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM127 ON SYSROUTINES (RETURN_TYPE ASC, CAST_FUNCTION ASC, PARM_COUNT ASC, INTERNAL_PREC1 DESC, ROUTINE_ID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM29 ON SYSROUTINES (ROUTINE_ID DESC) PCTFREE 10;

CREATE INDEX IBM145 ON SYSTABOPTIONS (OPTION ASC, SETTING ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM89 ON SYSCOLOPTIONS (TABSCHEMA ASC, TABNAME ASC, COLNAME ASC, OPTION ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM183 ON SYSXMLOBJECTXMLDEP (OBJECTID ASC, DTYPE ASC, BTYPE ASC, BOBJECTID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM169 ON SYSXMLOBJECTPROPERTIES (OBJECTID ASC, OPTION ASC) PCTFREE 10;

CREATE INDEX IBM144 ON SYSSERVERS (WRAPNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM30 ON SYSROUTINES (NAMESPACE ASC, ROUTINENAME ASC, PARM_COUNT ASC, INTERNAL_PREC1 DESC, INTERNAL_PREC2 DESC, ROUTINESCHEMA ASC, PARM_SIGNATURE ASC, CREATEDTS ASC, RETURN_TYPE ASC, CAST_FUNCTION ASC, ASSIGN_FUNCTION ASC, METHODIMPLEMENTED ASC) PCTFREE 10;

CREATE INDEX IBM157 ON SYSCOLGROUPDIST (COLGROUPID ASC, ORDINAL ASC, TYPE ASC, SEQNO ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM152 ON SYSROUTINEPARMS (SPECIFICNAME ASC, ROUTINESCHEMA ASC, ORDINAL ASC, ROWTYPE ASC) PCTFREE 10;

CREATE INDEX IBM58 ON SYSSCHEMAAUTH (SCHEMANAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM25 ON SYSROUTINES (SPECIFICNAME ASC, ROUTINESCHEMA ASC, NAMESPACE ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM00 ON SYSTABLES (CREATOR ASC, NAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM154 ON SYSCOLGROUPS (COLGROUPSCHEMA ASC, COLGROUPNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM57 ON SYSSCHEMAAUTH (GRANTEE ASC, SCHEMANAME ASC, GRANTEETYPE ASC, GRANTOR ASC) PCTFREE 10;

CREATE INDEX IBM22 ON SYSTABLES (INDEX_TBSPACE ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM41 ON SYSDATATYPES (TYPEID DESC) PCTFREE 10;

CREATE UNIQUE INDEX IBM139 ON SYSINDEXCOLUSE (INDSCHEMA ASC, INDNAME ASC, COLNAME ASC, COLSEQ ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM168 ON SYSXMLOBJECTS (OBJECTID DESC) PCTFREE 10;

CREATE UNIQUE INDEX IBM26 ON SYSROUTINES (ROUTINENAME ASC, PARM_COUNT ASC, PARM_SIGNATURE DESC, ROUTINESCHEMA ASC, NAMESPACE ASC) PCTFREE 10;

CREATE INDEX IBM39 ON SYSCOLCHECKS (TBCREATOR ASC, TBNAME ASC, CONSTNAME ASC) PCTFREE 10;

CREATE INDEX IBM116 ON SYSSERVEROPTIONS (SERVERTYPE ASC, SERVERVERSION ASC, WRAPNAME ASC, OPTION ASC) PCTFREE 10;

CREATE INDEX IBM04 ON SYSVIEWS (CREATOR ASC, NAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM62 ON SYSNODEGROUPS (NAME ASC) PCTFREE 10;

CREATE INDEX IBM180 ON SYSXMLOBJECTAUTH (OBJECTID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM51 ON SYSDEPENDENCIES (BSCHEMA ASC, BNAME ASC, BTYPE ASC, DTYPE ASC, DSCHEMA ASC, DNAME ASC, BUNIQUE_ID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM181 ON SYSXMLOBJECTAUTHPERF (OBJECTID ASC, GRANTEE ASC, GRANTEETYPE ASC) PCTFREE 10;

CREATE INDEX IBM108 ON SYSROUTINEAUTH (GRANTEE ASC, GRANTEETYPE ASC, ROUTINETYPE ASC, SCHEMA ASC, SPECIFICNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM106 ON SYSPROCPARMOPTIONS (PROCSCHEMA ASC, PROCNAME ASC, ORDINAL ASC, OPTION ASC) PCTFREE 10;

CREATE INDEX IBM21 ON SYSTABLES (TBSPACE ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM161 ON SYSCODEPROPERTIES (OBJECT_TYPE ASC, OBJECT_ID ASC, LIB_ID ASC, LIBVERSION ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM117 ON SYSSERVEROPTIONS (SERVEROPTIONKEY ASC) PCTFREE 10;

CREATE INDEX IBM72 ON SYSROUTINEAUTH (ROUTINETYPE ASC, SCHEMA ASC, SPECIFICNAME ASC) PCTFREE 10;

CREATE INDEX IBM142 ON SYSTYPEMAPPINGS (WRAPNAME ASC) PCTFREE 10;

CREATE INDEX IBM173 ON SYSXMLRELATIONSHIPS (LINKEDNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM120 ON SYSTRANSFORMS (TYPEID ASC, GROUPNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM153 ON SYSPLAN (CREATOR ASC, NAME ASC, PKGVERSION ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM119 ON SYSTABOPTIONS (TABSCHEMA ASC, TABNAME ASC, OPTION ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM63 ON SYSPARTITIONMAPS (PMAP_ID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM92 ON SYSFUNCMAPPINGS (FUNCTION_MAPPING ASC) PCTFREE 10;

CREATE INDEX IBM45 ON SYSCONSTDEP (DTBCREATOR ASC, DTBNAME ASC, DCONSTNAME ASC, BTYPE ASC) PCTFREE 10;

CREATE INDEX IBM23 ON SYSTABLES (LONG_TBSPACE ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM91 ON SYSFUNCMAPPARMOPTIONS (FUNCTION_MAPPING ASC, ORDINAL ASC, LOCATION ASC, OPTION ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM111 ON SYSTYPEMAPPINGS (TYPE_MAPPING ASC) PCTFREE 10;

CREATE INDEX IBM27 ON SYSROUTINES (ROUTINENAME ASC, ROUTINESCHEMA ASC, ROUTINETYPE ASC, PARM_COUNT ASC) PCTFREE 10;

CREATE INDEX IBM06 ON SYSVIEWDEP (DCREATOR ASC, DNAME ASC) PCTFREE 10;

CREATE INDEX IBM134 ON SYSNAMEMAPPINGS (TYPE ASC, IMPL_SCHEMA ASC, IMPL_NAME ASC, IMPL_COLNAME ASC) PCTFREE 10;

CREATE INDEX IBM65 ON SYSTABLESPACES (NGNAME ASC) PCTFREE 10;

CREATE INDEX IBM16 ON SYSTABAUTH (TCREATOR ASC, TTNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM35 ON SYSKEYCOLUSE (TBCREATOR ASC, TBNAME ASC, COLNAME ASC, CONSTNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM37 ON SYSCHECKS (TBCREATOR ASC, TBNAME ASC, NAME ASC) PCTFREE 10;

CREATE INDEX IBM171 ON SYSXMLRELATIONSHIPS (PARENTID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM79 ON SYSCOLPROPERTIES (TABSCHEMA ASC, TABNAME ASC, COLNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM17 ON SYSINDEXAUTH (GRANTEE ASC, CREATOR ASC, NAME ASC, GRANTEETYPE ASC, GRANTOR ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM40 ON SYSDATATYPES (NAME ASC, SCHEMA ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM118 ON SYSSERVERS (SERVERNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM12 ON SYSDBAUTH (GRANTEE ASC, GRANTEETYPE ASC, GRANTOR ASC) PCTFREE 10;

CREATE INDEX IBM112 ON SYSTYPEMAPPINGS (TYPENAME ASC, TYPESCHEMA ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM149 ON SYSLIBRARYBINDFILES (LIB_ID ASC, LIBVERSION ASC, PACKAGE_NAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM97 ON SYSINDEXEXPLOITRULES (FUNCID ASC, SPECID ASC, RULEID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM01 ON SYSCOLUMNS (TBCREATOR ASC, TBNAME ASC, NAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM84 ON SYSATTRIBUTES (ATTR_TYPESCHEMA ASC, ATTR_TYPENAME ASC, TYPESCHEMA ASC, TYPENAME ASC, ATTR_NAME ASC) PCTFREE 10;

CREATE INDEX IBM158 ON SYSCOLGROUPDISTCOUNTS (COLGROUPID ASC, TYPE ASC, SEQNO ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM99 ON SYSINDEXEXTENSIONS (IESCHEMA ASC, IENAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM05 ON SYSVIEWDEP (BCREATOR ASC, BNAME ASC, BTYPE ASC, DCREATOR ASC, DNAME ASC) PCTFREE 10;

CREATE INDEX PROGTABLEINDEX ON PROGRESSTABLE (CALLID ASC, CANCELREQUEST ASC) PCTFREE 10;

CREATE INDEX IBM164 ON SYSROUTINEPROPERTIESJAVA (JARSCHEMA ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM105 ON SYSPROCOPTIONS (PROCSCHEMA ASC, PROCNAME ASC, OPTION ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM175 ON SYSXMLPHYSICALCOLLECTIONS (OBJECTID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM73 ON SYSCOMMENTS (OBJECTID ASC) PCTFREE 10;

CREATE INDEX ERRORTABLEINDEX ON ERRORTABLE (CALLID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM07 ON SYSPLAN (CREATOR ASC, NAME ASC, UNIQUE_ID ASC) PCTFREE 10;

CREATE INDEX IBM82 ON SYSCOLPROPERTIES (SCOPE_TABSCHEMA ASC, SCOPE_TABNAME ASC) PCTFREE 10;

CREATE INDEX IBM18 ON SYSINDEXAUTH (CREATOR ASC, NAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM11 ON SYSSTMT (PLCREATOR ASC, PLNAME ASC, UNIQUE_ID ASC, SECTNO ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM86 ON SYSHIERARCHIES (METATYPE ASC, SUB_SCHEMA ASC, SUB_NAME ASC, SUPER_SCHEMA ASC, SUPER_NAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM123 ON SYSUSEROPTIONS (SERVERNAME ASC, AUTHID ASC, OPTION ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM90 ON SYSFUNCMAPOPTIONS (FUNCTION_MAPPING ASC, OPTION ASC) PCTFREE 10;

CREATE INDEX IBM54 ON SYSTRIGGERS (TBCREATOR ASC, TBNAME ASC) PCTFREE 10;

CREATE INDEX IBM64 ON SYSCOLAUTH (CREATOR ASC, TNAME ASC, GRANTEE ASC, GRANTEETYPE ASC, COLNO ASC, PRIVTYPE ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM02 ON SYSINDEXES (CREATOR ASC, NAME ASC) PCTFREE 10;

CREATE INDEX IBM52 ON SYSDEPENDENCIES (DTYPE ASC, DSCHEMA ASC, DNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM83 ON SYSATTRIBUTES (TYPESCHEMA ASC, TYPENAME ASC, ATTR_NAME ASC) PCTFREE 10;

CREATE INDEX PROGTABLEINDEX ON PROGRESSTABLE (CALLID ASC, CANCELREQUEST ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM124 ON SYSWRAPOPTIONS (WRAPNAME ASC, OPTION ASC) PCTFREE 10;

CREATE INDEX IBM133 ON SYSNAMEMAPPINGS (TYPE ASC, LOGICAL_SCHEMA ASC, LOGICAL_NAME ASC, LOGICAL_COLNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM49 ON SYSTABLESPACES (TBSPACE ASC) PCTFREE 10;

CREATE INDEX IBM19 ON SYSPLAN (BOUNDBY ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM185 ON SYSXMLQUERIES (OBJECTID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM182 ON SYSXMLOBJECTRELDEP (OBJECTID ASC, DTYPE ASC, BTYPE ASC, BSCHEMA ASC, BNAME ASC) PCTFREE 10;

CREATE INDEX IBM93 ON SYSFUNCMAPPINGS (FUNCID ASC) PCTFREE 10;

CREATE INDEX IBM33 ON SYSROUTINEPARMS (CAST_FUNCTION_ID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM20 ON SYSRELS (CREATOR ASC, TBNAME ASC, RELNAME ASC) PCTFREE 10;

CREATE INDEX IBM128 ON SYSROUTINEPARMS (TRANSFORM_GRPNAME ASC, TYPENAME ASC, TYPESCHEMA ASC) PCTFREE 10;

CREATE INDEX IBM121 ON SYSTRANSFORMS (FROMSQL_FUNCID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM71 ON SYSROUTINEPROPERTIESJAVA (ROUTINE_ID ASC) PCTFREE 10;

CREATE INDEX IBM172 ON SYSXMLRELATIONSHIPS (CHILDID ASC) PCTFREE 10;

CREATE INDEX IBM166 ON SYSROUTINEAUTH (TYPESCHEMA ASC, TYPENAME ASC) PCTFREE 10;

CREATE INDEX IBM113 ON SYSTYPEMAPPINGS (SERVERNAME ASC) PCTFREE 10;

CREATE INDEX IBM81 ON SYSROUTINEPARMS (TARGET_TYPESCHEMA ASC, TARGET_TYPENAME ASC, ROUTINESCHEMA ASC, SPECIFICNAME ASC) PCTFREE 10;

CREATE INDEX IBM48 ON SYSEVENTS (NAME ASC) PCTFREE 10;

CREATE INDEX IBM130 ON SYSPASSTHRUAUTH (GRANTEE ASC, SERVERNAME ASC) PCTFREE 10;

CREATE INDEX IBM24 ON SYSCOLUMNS (TYPENAME ASC, TYPESCHEMA ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM69 ON SYSBUFFERPOOLNODES (BUFFERPOOLID ASC, NODENUM ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM136 ON SYSSEQUENCES (SEQSCHEMA ASC, SEQNAME ASC) PCTFREE 10;

CREATE INDEX IBM109 ON SYSROUTINEAUTH (GRANTEE ASC, GRANTEETYPE ASC, ROUTINETYPE ASC, SCHEMA ASC, TYPESCHEMA ASC, TYPENAME ASC, SPECIFICNAME ASC) PCTFREE 10;

CREATE INDEX IBM43 ON SYSCOLAUTH (GRANTOR ASC, CREATOR ASC, TNAME ASC, PRIVTYPE ASC, COLNAME ASC) PCTFREE 10;

CREATE INDEX IBM75 ON SYSSEQUENCEAUTH (SEQID ASC) PCTFREE 10;

CREATE INDEX IBM137 ON SYSTABLES (TID ASC, FID ASC) PCTFREE 10;

CREATE INDEX IBM80 ON SYSCOLPROPERTIES (TARGET_TYPESCHEMA ASC, TARGET_TYPENAME ASC, TABSCHEMA ASC, TABNAME ASC) PCTFREE 10;

CREATE INDEX IBM126 ON SYSINDEXES (IENAME ASC, IESCHEMA ASC) PCTFREE 10;

CREATE INDEX IBM14 ON SYSPLANAUTH (CREATOR ASC, NAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM107 ON SYSROUTINEAUTH (GRANTOR ASC, GRANTEE ASC, GRANTEETYPE ASC, ROUTINETYPE ASC, SCHEMA ASC, SPECIFICNAME ASC, TYPESCHEMA ASC, TYPENAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM87 ON SYSHIERARCHIES (METATYPE ASC, SUPER_SCHEMA ASC, SUPER_NAME ASC, SUB_SCHEMA ASC, SUB_NAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM13 ON SYSPLANAUTH (GRANTEE ASC, CREATOR ASC, NAME ASC, GRANTEETYPE ASC, GRANTOR ASC) PCTFREE 10;

CREATE INDEX IBM129 ON SYSTBSPACEAUTH (GRANTEE ASC, GRANTEETYPE ASC, TBSPACEID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM66 ON SYSTABLESPACES (TBSPACEID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM61 ON SYSNODEGROUPDEF (NGNAME ASC, NODENUM ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM165 ON SYSEVENTTABLES (EVMONNAME ASC, LOGICAL_GROUP ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM10 ON SYSSECTION (PLCREATOR ASC, PLNAME ASC, UNIQUE_ID ASC, SECTNO ASC) PCTFREE 10;

CREATE INDEX IBM122 ON SYSTRANSFORMS (TOSQL_FUNCID ASC) PCTFREE 10;

CREATE INDEX IBM143 ON SYSSERVEROPTIONS (WRAPNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM174 ON SYSXMLRSPROPERTIES (RELATIONSHIPID ASC, OPTION ASC) PCTFREE 10;

CREATE INDEX IBM32 ON SYSROUTINEPARMS (TYPENAME ASC, TYPESCHEMA ASC, SPECIFICNAME ASC, ROUTINESCHEMA ASC, ROWTYPE ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM42 ON SYSCOLAUTH (GRANTEE ASC, GRANTEETYPE ASC, CREATOR ASC, TNAME ASC, PRIVTYPE ASC, COLNAME ASC, GRANTOR ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM132 ON SYSJAROBJECTS (JARSCHEMA ASC, JAR_ID ASC) PCTFREE 10;

CREATE INDEX IBM184 ON SYSXMLSTATS (OBJECTID ASC, OBJECTTYPE ASC, STATISTICTYPE ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM148 ON SYSTBSPACEAUTH (GRANTEE ASC, GRANTEETYPE ASC, TBSPACE ASC, GRANTOR ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM60 ON SYSUSERAUTH (TABSCHEMA ASC, TABNAME ASC, GRANTEE ASC, GRANTEETYPE ASC) PCTFREE 10;

CREATE INDEX IBM147 ON SYSCOLUSE (TABSCHEMA ASC, TABNAME ASC, TYPE ASC, DIMENSION ASC, COLSEQ ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM100 ON SYSINDEXEXTENSIONMETHODS (IESCHEMA ASC, IENAME ASC, METHODNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM131 ON SYSJARCONTENTS (JARSCHEMA ASC, JAR_ID ASC, CLASS ASC) PCTFREE 10;

CREATE INDEX IBM151 ON SYSROUTINES (LIB_ID ASC, ORIGIN ASC) PCTFREE 10;

CREATE INDEX IBM28 ON SYSROUTINES (SOURCESCHEMA ASC, SOURCESPECIFIC ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM104 ON SYSPREDICATESPECS (FUNCID ASC, SPECID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM167 ON SYSEVENTTABLES (TABSCHEMA ASC, TABNAME ASC) PCTFREE 10;

CREATE INDEX IBM94 ON SYSFUNCMAPPINGS (SERVERNAME ASC) PCTFREE 10;

CREATE INDEX IBM138 ON SYSSERVERS (SERVERTYPE ASC, SERVERVERSION ASC, WRAPNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM34 ON SYSTABCONST (TBCREATOR ASC, TBNAME ASC, NAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM140 ON SYSVERSIONS (VERSIONNUMBER ASC, VERSION_TIMESTAMP ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM59 ON SYSSCHEMATA (NAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM135 ON SYSSEQUENCES (SEQID ASC) PCTFREE 10;

CREATE INDEX IBM70 ON SYSTABLESPACES (BUFFERPOOLID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM170 ON SYSXMLRELATIONSHIPS (RELATIONSHIPID DESC) PCTFREE 10;

CREATE UNIQUE INDEX IBM38 ON SYSCOLCHECKS (TBCREATOR ASC, TBNAME ASC, COLNAME ASC, CONSTNAME ASC) PCTFREE 10;

CREATE INDEX IBM95 ON SYSFUNCMAPPINGS (WRAPNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM44 ON SYSCONSTDEP (BCREATOR ASC, BNAME ASC, BTYPE ASC, DTBCREATOR ASC, DTBNAME ASC, DCONSTNAME ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM103 ON SYSPASSTHRUAUTH (GRANTOR ASC, GRANTEE ASC, GRANTEETYPE ASC, SERVERNAME ASC) PCTFREE 10;

CREATE INDEX IBM178 ON SYSXMLPHYSICALCOLLECTIONS (TBSPACEID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM03 ON SYSINDEXES (TBCREATOR ASC, TBNAME ASC, IID ASC) PCTFREE 10;

CREATE INDEX IBM50 ON SYSTABLESPACES (DEFINER ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM08 ON SYSPLANDEP (BCREATOR ASC, BNAME ASC, BTYPE ASC, DCREATOR ASC, DNAME ASC, DUNIQUE_ID ASC) PCTFREE 10;

CREATE UNIQUE INDEX IBM101 ON SYSINDEXEXTENSIONMETHODS (IESCHEMA ASC, IENAME ASC, METHODID ASC) PCTFREE 10;

ALTER TABLE RULETASKS ADD CONSTRAINT SQL040920153921980 PRIMARY KEY (ID);

ALTER TABLE CLASTASKS ADD CONSTRAINT SQL040920153920480 PRIMARY KEY (ID);

ALTER TABLE REGRESSIONMODELS ADD CONSTRAINT SQL040920153916710 PRIMARY KEY (MODELNAME);

ALTER TABLE RULESETTINGS ADD CONSTRAINT SQL040920153919660 PRIMARY KEY (ID);

ALTER TABLE RULEFILTERS ADD CONSTRAINT SQL051104145136400 PRIMARY KEY (ID);

ALTER TABLE REGTESTRESULTS ADD CONSTRAINT SQL040920153922540 PRIMARY KEY (ID);

ALTER TABLE CLUSTERMODELS ADD CONSTRAINT SQL040920153916120 PRIMARY KEY (MODELNAME);

ALTER TABLE AAA ADD CONSTRAINT AAA_PK PRIMARY KEY (CLIENT_ID);

ALTER TABLE CLUSTASKS ADD CONSTRAINT SQL040920153920150 PRIMARY KEY (ID);

ALTER TABLE CLASTESTRESULTS ADD CONSTRAINT SQL040920153922260 PRIMARY KEY (ID);

ALTER TABLE LOGICALDATASPECS ADD CONSTRAINT SQL040920153918300 PRIMARY KEY (ID);

ALTER TABLE IM_FINDRULES_015_IDMFRGIS ADD CONSTRAINT SQL051021175352510 PRIMARY KEY (TRANSID);

ALTER TABLE BANKCUSTOMERS ADD CONSTRAINT SQL040920153951670 PRIMARY KEY (CLIENT_ID);

ALTER TABLE CLASTESTTASKS ADD CONSTRAINT SQL040920153920760 PRIMARY KEY (ID);

ALTER TABLE REGSETTINGS ADD CONSTRAINT SQL040920153919380 PRIMARY KEY (ID);

ALTER TABLE CLASSETTINGS ADD CONSTRAINT SQL040920153919120 PRIMARY KEY (ID);

ALTER TABLE CLASSIFMODELS ADD CONSTRAINT SQL040920153915550 PRIMARY KEY (MODELNAME);

ALTER TABLE MININGDATA ADD CONSTRAINT SQL040920153918040 PRIMARY KEY (ID);

ALTER TABLE CLUSSETTINGS ADD CONSTRAINT SQL040920153918610 PRIMARY KEY (ID);

ALTER TABLE INSURANCE ADD CONSTRAINT SQL040920154334230 PRIMARY KEY (RECORDID);

ALTER TABLE IM_FINDRULES_032_IDMFRGIS ADD CONSTRAINT SQL050819103005640 PRIMARY KEY (TRANSID);

ALTER TABLE RULEMODELS ADD CONSTRAINT SQL040920153916400 PRIMARY KEY (MODELNAME);

ALTER TABLE CALLIDS ADD CONSTRAINT SQL040920153917180 PRIMARY KEY (MODELNAME, TERMINATED);

ALTER TABLE REGTASKS ADD CONSTRAINT SQL040920153921150 PRIMARY KEY (ID);

ALTER TABLE REGTESTTASKS ADD CONSTRAINT SQL040920153921700 PRIMARY KEY (ID);

ALTER TABLE IM_FINDRULES_07_IDMFRGIS ADD CONSTRAINT SQL050819104407310 PRIMARY KEY (TRANSID);

CREATE FUNCTION SNAPSHOT_LOCK (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, AGENT_ID BIGINT, TABLE_FILE_ID BIGINT, LOCK_OBJECT_TYPE BIGINT, LOCK_MODE BIGINT, LOCK_STATUS BIGINT, LOCK_OBJECT_NAME BIGINT, PARTITION_NUMBER SMALLINT, LOCK_ESCALATION SMALLINT, TABLE_NAME VARCHAR(35), TABLE_SCHEMA VARCHAR(32), TABLESPACE_NAME VARCHAR(128))
	SPECIFIC SNAPSHOT_LOCK
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_EXPCLUSMODEL (CLUSMODEL DM_CLUSTERINGMODEL AS LOCATOR)
	RETURNS CLOB(2147483647)
	SPECIFIC SQL051104145109801
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETSEQRULES (OBJ DM_RULEMODEL)
	RETURNS TABLE (RULEID INTEGER, BODYSEQID INTEGER, HEADSETID INTEGER, BODYSEQTEXT VARCHAR(4096), HEADSETTEXT VARCHAR(4096), LENGTH INTEGER, NBOFITEMS INTEGER, SUPPORT DOUBLE, CONFIDENCE DOUBLE, LIFT DOUBLE, MEANTIMEDIFF DOUBLE, STDDEVTIMEDIFF DOUBLE)
	SPECIFIC SQL051104145110900
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

--;

CREATE FUNCTION MOD (SMALLINT,
		SMALLINT)
	RETURNS SMALLINT
	SPECIFIC MOD2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETMDLQUALITY (OBJ DM_CLUSTERINGMODEL)
	RETURNS DOUBLE
	SPECIFIC SQL051104145109902
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION LOCATE (VARCHAR(4000),
		VARCHAR(4000),
		INTEGER)
	RETURNS INTEGER
	SPECIFIC LOCATE1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE GET_SWRD_SETTINGS (DBPGNAME VARCHAR(128),
		MATCHINGSPEC SMALLINT,
		OUT REDISTMETHOD SMALLINT,
		OUT PMAPFILE VARCHAR(255),
		OUT DISTFILE VARCHAR(255),
		OUT STEPSIZE BIGINT,
		OUT TOTALSTEPS SMALLINT,
		OUT STAGESIZE SMALLINT,
		OUT NEXTSTEP SMALLINT,
		OUT PROCESSSTATE SMALLINT,
		OUT PNUMBER VARCHAR(6000),
		OUT PWEIGHT VARCHAR(6000))
	SPECIFIC GET_SWRD_SETTINGS
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE BUILDREGVIEW (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		TARGETCOLUMN VARCHAR(128),
		OPTIONALPARAMETERS VARCHAR(32672))
	SPECIFIC SQL051104145140871
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION IDMMX.CLOBTORULESET (STRING CLOB(307200)) RETURNS IDMMX.DM_RULESETTINGS CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_RuleSettings()..xmldata(string);

CREATE FUNCTION DM_GETFIELDS (OBJ DM_CLUSTERINGMODEL)
	RETURNS TABLE (COLNAME VARCHAR(128), FIELDNAME VARCHAR(128), MININGTYPE SMALLINT, IMPORTANCE REAL)
	SPECIFIC SQL051104145109903
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCORRELATIONS (OBJ DM_RULEMODEL)
	RETURNS TABLE (FIELDNAME1 VARCHAR(128), FIELDNAME2 VARCHAR(128), CORRELATION REAL)
	SPECIFIC SQL051104145111003
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETPREDACCURACY (OBJ DM_REGRESSIONMODEL)
	RETURNS DOUBLE
	SPECIFIC SQL051104145110602
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_TESTREGMODELCMDD (TASKTABLENAME VARCHAR(300),
		TASKCOLNAME VARCHAR(128),
		TASKIDCOLNAME VARCHAR(128),
		TASKID VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		INPUTCOLUMN VARCHAR(128),
		INPUTIDCOLUMN VARCHAR(128),
		INPUTID VARCHAR(256),
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145133518
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE LIST_SRVR_NODES (WRAPPERNAME VARCHAR(128),
		SERVERTYPE VARCHAR(128),
		SERVERVERSION VARCHAR(128),
		OUT OUT_SQLCODE INTEGER)
	SPECIFIC LIST_SRVR_NODES
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE GENERAL WITH NULLS
	EXTERNAL;

CREATE FUNCTION HEALTH_DB_HI (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, HI_ID BIGINT, DB_NAME VARCHAR(8), HI_VALUE SMALLINT, HI_TIMESTAMP TIMESTAMP, HI_ALERT_STATE BIGINT, HI_ALERT_STATE_DETAIL VARCHAR(20), HI_FORMULA VARCHAR(2048), HI_ADDITIONAL_INFO VARCHAR(4096))
	SPECIFIC HEALTH_DB_HI
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.CLOBTOCLASTASK (STRING CLOB(512000)) RETURNS IDMMX.DM_CLASBLDTASK CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_ClasBldTask()..xmldata(string);

--;

CREATE FUNCTION DM_GETFIELDS (OBJ DM_MININGDATA)
	RETURNS TABLE (COLNAME VARCHAR(128), ALIAS VARCHAR(128), SQLTYPE VARCHAR(16))
	SPECIFIC SQL051104145116600
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCLUSTERS (OBJ DM_CLUSTERINGMODEL)
	RETURNS TABLE (ID INTEGER, NAME VARCHAR(128), SIZE BIGINT, HOMOGENEITY REAL, DESCRIPTION VARCHAR(1024))
	SPECIFIC SQL051104145109804
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETRULEIMRESID (OBJ DM_RULEMODEL)
	RETURNS INTEGER
	SPECIFIC SQL051104145110901
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION ABS (SMALLINT)
	RETURNS SMALLINT
	SPECIFIC ABS3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDCLASMODELSN (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145140259
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE PREDICTCOLVALUESN (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		TARGETCOLUMN VARCHAR(128),
		TARGETVALUE VARCHAR(1024),
		CLASSETTINGSNAME VARCHAR(256),
		REGSETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145142390
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_GETRELIABILITY (OBJ DM_CLASTESTRESULT)
	RETURNS DOUBLE
	SPECIFIC SQL051104145134900
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCLASERROR (OBJ DM_CLASTESTRESULT)
	RETURNS DOUBLE
	SPECIFIC SQL051104145134502
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETFIELDS (OBJ DM_REGRESSIONMODEL)
	RETURNS TABLE (COLNAME VARCHAR(128), FIELDNAME VARCHAR(128), MININGTYPE SMALLINT, IMPORTANCE REAL)
	SPECIFIC SQL051104145110705
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_APPLYCLASMODELA (MODELALIAS VARCHAR(256),
		APPLDATA VARCHAR(32672),
		RESSPEC DM_CLASRESULTSPEC)
	RETURNS DM_CLASRESULT
	SPECIFIC SQL051104145113501
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDRULEVIEWSN (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145141481
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION MONTHNAME (TIMESTAMP)
	RETURNS VARCHAR(100)
	SPECIFIC MONTHNAME2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION TIMESTAMPDIFF (INTEGER,
		CHAR(22))
	RETURNS INTEGER
	SPECIFIC TIMESTAMPDIFF
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_GETQUALITY(CLUSRESULT IDMMX.DM_CLUSRESULT) RETURNS DOUBLE LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<Q1>', CAST(clusResult AS VARCHAR(2048))) = 0 THEN NULL ELSE DOUBLE(LEFT(SUBSTR(CAST(clusResult AS VARCHAR(2048)), LOCATE('<Q1>', CAST(clusResult AS VARCHAR(2048))) + 4 ), LOCATE('</Q1>', CAST(clusResult AS VARCHAR(2048))) - LOCATE('<Q1>', CAST(clusResult AS VARCHAR(2048))) - 4 )    ) END;

CREATE FUNCTION IDMMX.DM_GETCONFIDENCE( CLASRESULT IDMMX.DM_CLASRESULT, CLASS      VARCHAR(256)) RETURNS DOUBLE LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<Confn ID="' || class || '">', CAST(clasResult AS VARCHAR(2048))) = 0 THEN NULL ELSE DOUBLE(LEFT(SUBSTR(CAST(clasResult AS VARCHAR(2048)), LOCATE('<Confn ID="' || class || '">', CAST(clasResult AS VARCHAR(2048))) + 13 + LENGTH(class) ), LOCATE('</Confn>', SUBSTR(CAST(clasResult AS VARCHAR(2048)), LOCATE('<Confn ID="' || class || '">', CAST(clasResult AS VARCHAR(2048))) + 13 + LENGTH(class)) ) - 1 )    ) END;

CREATE FUNCTION IDMMX.MINDATATOCLOB (A IDMMX.DM_MININGDATA) RETURNS CLOB(153600) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE PROCEDURE SETAUTOCOMMIT (AUTOCOMMIT SMALLINT)
	SPECIFIC SQL051104145109792
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION SNAPSHOT_RANGES (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, TABLESPACE_ID BIGINT, TABLESPACE_NAME VARCHAR(128), RANGE_NUMBER BIGINT, RANGE_STRIPE_SET_NUMBER BIGINT, RANGE_OFFSET BIGINT, RANGE_MAX_PAGE BIGINT, RANGE_MAX_EXTENT BIGINT, RANGE_START_STRIPE BIGINT, RANGE_END_STRIPE BIGINT, RANGE_ADJUSTMENT BIGINT, RANGE_NUM_CONTAINER BIGINT, RANGE_CONTAINER_ID BIGINT)
	SPECIFIC SNAPSHOT_RANGES
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDRULEMODELSN (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145141175
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE GETLASTERROR (MODELNAME VARCHAR(256),
		OUT ERRORMSG VARCHAR(1000),
		OUT ERRORCODE INTEGER,
		OUT SQLSTATE CHAR(5))
	SPECIFIC SQL051104145109790
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_GETERRORS (ROWCOUNT INTEGER)
	RETURNS TABLE (ROWCOUNT INTEGER, ERRMSG VARCHAR(1024), ERRDATE VARCHAR(12), ERRTIME VARCHAR(12), ERRTYPE CHAR(1), THREADID INTEGER, EVENT INTEGER)
	SPECIFIC SQL051104145109700
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_GETPREDCLASS(CLASRESULT IDMMX.DM_CLASRESULT) RETURNS VARCHAR(100) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<ClassId>', CAST(clasResult AS VARCHAR(2048))) = 0 THEN NULL ELSE LEFT(SUBSTR(CAST(clasResult AS VARCHAR(2048)), LOCATE('<ClassId>', CAST(clasResult AS VARCHAR(2048))) + 9 ), LOCATE('</ClassId>', CAST(clasResult AS VARCHAR(2048))) - LOCATE('<ClassId>', CAST(clasResult AS VARCHAR(2048))) - 9 ) END;

CREATE FUNCTION DAYOFYEAR (DATE)
	RETURNS INTEGER
	SPECIFIC DAYOFYEAR1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_TESTREGMODELCMDT (TASKTABLENAME VARCHAR(300),
		TASKCOLNAME VARCHAR(128),
		TASKIDCOLNAME VARCHAR(128),
		TASKID VARCHAR(256),
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145133516
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION DM_GETTREERULES (OBJ DM_CLASMODEL)
	RETURNS TABLE (NODEID VARCHAR(128), ISLEAF SMALLINT, CLASS VARCHAR(256), CONFIDENCE REAL, SIZE BIGINT, DEPTH SMALLINT, CONDITION VARCHAR(32672))
	SPECIFIC SQL051104145110003
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_BUILDRULEMODEL (RULETASK CLOB(512000),
		CALLID CHAR (19) FOR BIT DATA,
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145132799
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION SIGN (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC SIGN1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETFIELDS (OBJ DM_CLASMODEL)
	RETURNS TABLE (COLNAME VARCHAR(128), FIELDNAME VARCHAR(128), MININGTYPE SMALLINT, IMPORTANCE REAL)
	SPECIFIC SQL051104145110504
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.CLOBTOREGTASK (STRING CLOB(512000)) RETURNS IDMMX.DM_REGBLDTASK CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_RegBldTask()..xmldata(string);

CREATE FUNCTION RTRIM (CLOB(1048576))
	RETURNS CLOB(1048576)
	SPECIFIC RTRIM2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_APPLYCLASMODELA (MODELALIAS VARCHAR(256),
		APPLDATA VARCHAR(32672))
	RETURNS DM_CLASRESULT
	SPECIFIC SQL051104145113200
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.CLUSSETTOCLOB (A IDMMX.DM_CLUSSETTINGS) RETURNS CLOB(307200) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE FUNCTION POWER (BIGINT,
		BIGINT)
	RETURNS BIGINT
	SPECIFIC POWER4
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE SETTRACEFILE (TRACEFILE VARCHAR(256))
	SPECIFIC SQL051104145109794
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE EXPORTREGMODEL (MODELNAME VARCHAR(256),
		FILENAME VARCHAR(256))
	SPECIFIC SQL051104145109898
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_IMPRULEMODEL (MODEL CLOB(10485760))
	RETURNS DM_RULEMODEL
	SPECIFIC SQL051104145111108
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_TESTCLASMODELD (MININGDATA CLOB(153600),
		INPUTTABLE VARCHAR(300),
		INPUTCOLUMN VARCHAR(128),
		INPUTIDCOLUMN VARCHAR(128),
		INPUTID VARCHAR(256),
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145132702
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE DM_TESTREGMODELD (MININGDATA CLOB(153600),
		INPUTTABLE VARCHAR(300),
		INPUTCOLUMN VARCHAR(128),
		INPUTIDCOLUMN VARCHAR(128),
		INPUTID VARCHAR(256),
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145132703
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION DM_GETRULEMDLTYPE (OBJ DM_RULEMODEL)
	RETURNS VARCHAR(256)
	SPECIFIC SQL051104145110903
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE ANALYZE_LOG_SPACE (DBPGNAME VARCHAR(128),
		MAINTBSCHEMA VARCHAR(128),
		MAINTABLE VARCHAR(128),
		USETBTYPE SMALLINT,
		STMGTIMESTAMP VARCHAR(26),
		ADDDROPOPTION CHAR(1),
		ADDDROPLIST VARCHAR(6000),
		PNUMBER VARCHAR(6000),
		PWEIGHT VARCHAR(6000))
	SPECIFIC ANALYZE_LOG_SPACE
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION RIGHT (VARCHAR(4000),
		INTEGER)
	RETURNS VARCHAR(4000)
	SPECIFIC RIGHT1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DEGREES (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC DEGREES1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_OPENMODELP (REGMDL DM_REGRESSIONMODEL,
		MODELALIAS VARCHAR(256),
		PINNED INTEGER)
	RETURNS BIGINT
	SPECIFIC SQL051104145113702
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION VEBLOB_CP_SMALL (BLOB(500000),
		INTEGER,
		INTEGER,
		INTEGER)
	RETURNS BLOB(500000)
	SPECIFIC VEBLOB_CP_SMALL
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION CHR (INTEGER)
	RETURNS CHAR(1)
	SPECIFIC CHR
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDSEQRULEMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		SEQUENCECOLUMN VARCHAR(128),
		GROUPCOLUMN VARCHAR(128),
		MINSUPPORT DOUBLE,
		MINCONFIDENCE DOUBLE,
		MAXRULELENGTH INTEGER,
		OPTIONALPARAMETERS VARCHAR(32672))
	SPECIFIC SQL051104145141377
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE BUILDCLUSMODELSN (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145139753
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE GETTRACEFILE (OUT TRACEFILE VARCHAR(256))
	SPECIFIC SQL051104145109795
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_GETPREDACCURACY (OBJ DM_REGTESTRESULT)
	RETURNS DOUBLE
	SPECIFIC SQL051104145135001
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDSEQRULEVIEWSN (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145141584
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_IMPCLUSMODEL (CLUSMDL CLOB(10485760))
	RETURNS DM_CLUSTERINGMODEL
	SPECIFIC SQL051104145111102
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETRANGECONSTRS (OBJ DM_RULEFILTER)
	RETURNS TABLE (RESTRICTIONCRIT INTEGER, RESTRICTIONTEXT VARCHAR(128), LOWERBOUND DOUBLE, UPPERBOUND DOUBLE, OPERATOR INTEGER, OPERATORTEXT VARCHAR(128))
	SPECIFIC SQL051104145109004
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION HEALTH_TBS_HI (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, TABLESPACE_NAME VARCHAR(128), HI_ID BIGINT, HI_VALUE SMALLINT, HI_TIMESTAMP TIMESTAMP, HI_ALERT_STATE BIGINT, HI_ALERT_STATE_DETAIL VARCHAR(20), HI_FORMULA VARCHAR(2048), HI_ADDITIONAL_INFO VARCHAR(4096))
	SPECIFIC HEALTH_TBS_HI
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_IMPCLASMODEL (CLASMDL CLOB(10485760))
	RETURNS DM_CLASMODEL
	SPECIFIC SQL051104145111006
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE SPLITDATA (INPUTTABLE VARCHAR(300),
		TRAINVIEW VARCHAR(300),
		TESTVIEW VARCHAR(300),
		TESTSAMPLESIZE REAL,
		STRATSAMPLECOLUMN VARCHAR(128))
	SPECIFIC SQL051104145142810
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION ABS (BIGINT)
	RETURNS BIGINT
	SPECIFIC ABS4
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION SNAPSHOT_TBS (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, POOL_DATA_L_READS BIGINT, POOL_DATA_P_READS BIGINT, POOL_ASYNC_DATA_READS BIGINT, POOL_DATA_WRITES BIGINT, POOL_ASYNC_DATA_WRITES BIGINT, POOL_INDEX_L_READS BIGINT, POOL_INDEX_P_READS BIGINT, POOL_INDEX_WRITES BIGINT, POOL_ASYNC_INDEX_WRITES BIGINT, POOL_READ_TIME BIGINT, POOL_WRITE_TIME BIGINT, POOL_ASYNC_READ_TIME BIGINT, POOL_ASYNC_WRITE_TIME BIGINT, POOL_ASYNC_DATA_READ_REQS BIGINT, DIRECT_READS BIGINT, DIRECT_WRITES BIGINT, DIRECT_READ_REQS BIGINT, DIRECT_WRITE_REQS BIGINT, DIRECT_READ_TIME BIGINT, DIRECT_WRITE_TIME BIGINT, UNREAD_PREFETCH_PAGES BIGINT, POOL_ASYNC_INDEX_READS BIGINT, POOL_DATA_TO_ESTORE BIGINT, POOL_INDEX_TO_ESTORE BIGINT, POOL_INDEX_FROM_ESTORE BIGINT, POOL_DATA_FROM_ESTORE BIGINT, FILES_CLOSED BIGINT, TABLESPACE_NAME VARCHAR(128))
	SPECIFIC SNAPSHOT_TBS
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE EXPORTCLASMODEL (MODELNAME VARCHAR(256),
		FILENAME VARCHAR(256))
	SPECIFIC SQL051104145109896
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE GENERATE_DISTFILE (TBSCHEMA VARCHAR(128),
		TBNAME VARCHAR(128),
		INOUT FILENAME VARCHAR(255))
	SPECIFIC GEN_DISTFILE
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION SNAPSHOT_CONTAINER (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, TABLESPACE_ID BIGINT, TABLESPACE_NAME VARCHAR(128), CONTAINER_ID BIGINT, CONTAINER_NAME VARCHAR(256), CONTAINER_TYPE SMALLINT, TOTAL_PAGES BIGINT, USABLE_PAGES BIGINT, ACCESSIBLE BIGINT, STRIPE_SET BIGINT)
	SPECIFIC SNAPSHOT_CONTAINER
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DAYOFWEEK (VARCHAR(26))
	RETURNS INTEGER
	SPECIFIC DAYOFWEEK1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION HLP_GETERRORMSG (ERRORLEVEL SMALLINT,
		ERRORCODE INTEGER,
		MSGARG1 VARCHAR(300),
		MSGARG2 VARCHAR(300),
		MSGARG3 VARCHAR(300),
		MSGARG4 VARCHAR(300),
		MSGARG5 VARCHAR(300))
	RETURNS VARCHAR(1000)
	SPECIFIC SQL051104145109701
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION QUARTER (TIMESTAMP)
	RETURNS INTEGER
	SPECIFIC QUARTER2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_BUILDREGMODELCMD (TASKTABLENAME VARCHAR(300),
		TASKCOLNAME VARCHAR(128),
		TASKIDCOLNAME VARCHAR(128),
		TASKID VARCHAR(256),
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145133311
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE DM_TESTCLASMODELCMDT (TASKTABLENAME VARCHAR(300),
		TASKCOLNAME VARCHAR(128),
		TASKIDCOLNAME VARCHAR(128),
		TASKID VARCHAR(256),
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145133515
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION IDMMX.CLASSETTOCLOB (A IDMMX.DM_CLASSETTINGS) RETURNS CLOB(307200) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE FUNCTION IDMMX.HLP_GETSCHEMA( QUALIFIEDNAME VARCHAR(300) ) RETURNS VARCHAR(128) NO EXTERNAL ACTION RETURN CASE WHEN POSSTR(QUALIFIEDNAME,'.')>0 THEN SUBSTR(QUALIFIEDNAME,1,POSSTR(QUALIFIEDNAME,'.')-1) ELSE CURRENT SCHEMA END;

CREATE FUNCTION INSERT (VARCHAR(4000),
		INTEGER,
		INTEGER,
		VARCHAR(4000))
	RETURNS VARCHAR(4000)
	SPECIFIC INSERT1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_APPLYCLUSMODEL (CLUSMDL DM_CLUSTERINGMODEL,
		APPLDATA DM_APPLICATIONDATA,
		RESSPEC DM_CLUSRESULTSPEC)
	RETURNS DM_CLUSRESULT
	SPECIFIC SQL051104145115200
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION FLOOR (BIGINT)
	RETURNS BIGINT
	SPECIFIC FLOOR4
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDCLASMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		TARGETCOLUMN VARCHAR(128),
		OPTIONALPARAMETERS VARCHAR(32672))
	SPECIFIC SQL051104145140258
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION OLEDBSOURCES (VARCHAR(128))
	RETURNS TABLE (NAME VARCHAR(128), PROG_ID VARCHAR(128), DESCRIPTION VARCHAR(128), TYPE INTEGER, IS_PARENT SMALLINT)
	SPECIFIC OLEDBSOURCES
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE OLE
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.RULESETTOCLOB (A IDMMX.DM_RULESETTINGS) RETURNS CLOB(307200) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE FUNCTION ATAN2 (DOUBLE,
		DOUBLE)
	RETURNS DOUBLE
	SPECIFIC ATAN2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCORRELATIONS (OBJ DM_CLASMODEL)
	RETURNS TABLE (FIELDNAME1 VARCHAR(128), FIELDNAME2 VARCHAR(128), CORRELATION REAL)
	SPECIFIC SQL051104145110505
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_APPLYREGMODELA (MODELALIAS VARCHAR(256),
		APPLDATA VARCHAR(32672))
	RETURNS DM_REGRESULT
	SPECIFIC SQL051104145113500
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDREGMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		TARGETCOLUMN VARCHAR(128))
	SPECIFIC SQL051104145140465
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION OLEDBPROVIDERS ()
	RETURNS TABLE (NAME VARCHAR(128), PROG_ID VARCHAR(128), DESCRIPTION VARCHAR(128))
	SPECIFIC OLEDBPROVIDERS
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE OLE
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION ABSVAL (BIGINT)
	RETURNS BIGINT
	SPECIFIC ABSVAL4
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_GETCLUSTERID(CLUSRESULT IDMMX.DM_CLUSRESULT) RETURNS INTEGER LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<ClusID1>', CAST(clusResult AS VARCHAR(2048))) = 0 THEN NULL ELSE INTEGER(LEFT(SUBSTR(CAST(clusResult AS VARCHAR(2048)), LOCATE('<ClusID1>', CAST(clusResult AS VARCHAR(2048))) + 9 ), LOCATE('</ClusID1>', CAST(clusResult AS VARCHAR(2048))) - LOCATE('<ClusID1>', CAST(clusResult AS VARCHAR(2048))) - 9 )    ) END;

CREATE FUNCTION DM_APPLYREGMODEL (REGMDL DM_REGRESSIONMODEL,
		APPLDATA DM_APPLICATIONDATA)
	RETURNS DM_REGRESULT
	SPECIFIC SQL051104145115070
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_OPENMODELP (CLASMDL DM_CLASMODEL,
		MODELALIAS VARCHAR(256),
		PINNED INTEGER)
	RETURNS BIGINT
	SPECIFIC SQL051104145113700
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE CLUSTERTABLE (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		MINSIZE DOUBLE,
		MAXSIZE DOUBLE,
		OPTIONSSTRING VARCHAR(32672))
	SPECIFIC SQL051104145142495
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE GET_ROUTINE_SAR (OUT SAR BLOB(3145728),
		TYPE CHAR(2),
		NAME VARCHAR(257))
	SPECIFIC GET_SAR
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION ASCII (VARCHAR(4000))
	RETURNS INTEGER
	SPECIFIC ASCII2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_APPLYCLUSMODEL( MODELALIAS VARCHAR(256), APPLDATA VARCHAR(32672) ) RETURNS IDMMX.DM_CLUSRESULT LANGUAGE SQL READS SQL DATA EXTERNAL ACTION RETURN COALESCE( IDMMX.DM_applyClusModelA(modelAlias, applData), IDMMX.DM_applyClusModelA( (CASE WHEN IDMMX.DM_openModelP( (SELECT MODEL FROM IDMMX.CLUSTERMODELS WHERE MODELNAME = modelAlias), modelAlias, 0) IS NULL THEN NULL ELSE modelAlias END), appldata ), IDMMX.DM_applyClusModel( COALESCE((SELECT MODEL FROM IDMMX.CLUSTERMODELS WHERE MODELNAME = modelAlias), CAST (CAST('<NoModel/>' AS BLOB(20)) AS IDMMX.DM_ClusteringModel)), IDMMX.DM_impApplData(applData) ) );

CREATE FUNCTION DM_GETRELIABILITY (OBJ DM_REGRESSIONMODEL)
	RETURNS DOUBLE
	SPECIFIC SQL051104145110702
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE SQLCAMESSAGE (SQLCODE INTEGER,
		SQLERRML SMALLINT,
		SQLERRMC VARCHAR(70),
		SQLERRP CHAR(8),
		SQLERRD0 INTEGER,
		SQLERRD1 INTEGER,
		SQLERRD2 INTEGER,
		SQLERRD3 INTEGER,
		SQLERRD4 INTEGER,
		SQLERRD5 INTEGER,
		SQLWARN CHAR(11),
		SQLSTATE CHAR(5),
		MESSAGEFILENAME VARCHAR(20),
		INOUT LOCALE VARCHAR(33),
		OUT MESSAGE VARCHAR(4096),
		OUT RCODE INTEGER)
	SPECIFIC SQLCAMESSAGE
	NO SQL
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE GENERAL WITH NULLS
	EXTERNAL;

CREATE PROCEDURE EXPLAINCOLVALUESN (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		TARGETCOLUMN VARCHAR(128),
		TARGETVALUE VARCHAR(1024),
		MAXEXPLLENGTH SMALLINT,
		CLASSETTINGSNAME VARCHAR(256),
		RULESETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145142493
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_EXPCLASTESTRES (TSTRES DM_CLASTESTRESULT AS LOCATOR)
	RETURNS CLOB(2147483647)
	SPECIFIC SQL051104145134501
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION ABS (INTEGER)
	RETURNS INTEGER
	SPECIFIC ABS2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.CLASTASKTOCLOB (A IDMMX.DM_CLASBLDTASK) RETURNS CLOB(512000) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE PROCEDURE GETAUTOCOMMIT (OUT AUTOCOMMIT SMALLINT)
	SPECIFIC SQL051104145109793
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION WEEK (TIMESTAMP)
	RETURNS INTEGER
	SPECIFIC WEEK2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_APPLDATA (APPLDATA DM_APPLICATIONDATA,
		COLNAME VARCHAR(128),
		COLVALUE DOUBLE)
	RETURNS DM_APPLICATIONDATA
	SPECIFIC SQL051104145114703
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE CLUSTERTABLESN (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		MINSIZE DOUBLE,
		MAXSIZE DOUBLE,
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145142496
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_APPLYRULEMODEL (RULMDL DM_RULEMODEL,
		RECORD CLOB(512000))
	RETURNS TABLE (ID INTEGER, HEADNAME VARCHAR(1024), HEAD VARCHAR(1024), SUPPORT REAL, CONFIDENCE REAL, LIFT REAL, MATCHHEAD SMALLINT, MATCHBODY SMALLINT)
	SPECIFIC SQL051104145115080
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_APPLYCLASMODEL( MODELALIAS VARCHAR(256), APPLDATA VARCHAR(32672) ) RETURNS IDMMX.DM_CLASRESULT LANGUAGE SQL READS SQL DATA EXTERNAL ACTION RETURN COALESCE( IDMMX.DM_applyClasModelA(modelAlias, applData), IDMMX.DM_applyClasModelA( (CASE WHEN IDMMX.DM_openModelP( (SELECT MODEL FROM IDMMX.CLASSIFMODELS WHERE MODELNAME = modelAlias), modelAlias, 0) IS NULL THEN NULL ELSE modelAlias END), appldata ), IDMMX.DM_applyClasModel( COALESCE((SELECT MODEL FROM IDMMX.CLASSIFMODELS WHERE MODELNAME = modelAlias), CAST (CAST('<NoModel/>' AS BLOB(20)) AS IDMMX.DM_ClasModel)), IDMMX.DM_impApplData(applData) ) );

CREATE FUNCTION DM_GETMDLQUALITY (OBJ DM_CLASTESTRESULT)
	RETURNS DOUBLE
	SPECIFIC SQL051104145134800
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_APPLYCLUSMODELA (MODELALIAS VARCHAR(256),
		APPLDATA VARCHAR(32672),
		RESSPEC DM_CLUSRESULTSPEC)
	RETURNS DM_CLUSRESULT
	SPECIFIC SQL051104145113600
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION OLEDBTYPECONVERT (OLEDB_TYPE INTEGER,
		FLAGS INTEGER,
		LENGTH INTEGER,
		PRECISION INTEGER,
		SCALE INTEGER)
	RETURNS VARCHAR(128)
	SPECIFIC OLEDBTYPECONVERT
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE OLE
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE PUT_ROUTINE_SAR (SAR BLOB(3145728),
		OWNER VARCHAR(128),
		FLAG INTEGER)
	SPECIFIC PUT_SAR
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE BUILDCLUSVIEWSN (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145139956
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_GETSEQUENCES (OBJ DM_RULEMODEL)
	RETURNS TABLE (SEQUENCEID INTEGER, LENGTH INTEGER, NBOFITEMS INTEGER, SUPPORT DOUBLE, LIFT DOUBLE, MEANTIMEDIFF DOUBLE, STDDEVTIMEDIFF DOUBLE, SEQTEXT VARCHAR(4096))
	SPECIFIC SQL051104145110805
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE EXPLAINCOLVALUE (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		TARGETCOLUMN VARCHAR(128),
		TARGETVALUE VARCHAR(1024),
		MAXEXPLLENGTH SMALLINT)
	SPECIFIC SQL051104145142391
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_APPLYCLASMODEL (CLASMDL DM_CLASMODEL,
		APPLDATA DM_APPLICATIONDATA)
	RETURNS DM_CLASRESULT
	SPECIFIC SQL051104145115008
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.CLOBTOREGSET (STRING CLOB(307200)) RETURNS IDMMX.DM_REGSETTINGS CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_RegSettings()..xmldata(string);

CREATE FUNCTION IDMMX.DM_GETCLUSSCORE(CLUSRESULT IDMMX.DM_CLUSRESULT) RETURNS DOUBLE LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<Score1>', CAST(clusResult AS VARCHAR(2048))) = 0 THEN NULL ELSE DOUBLE(LEFT(SUBSTR(CAST(clusResult AS VARCHAR(2048)), LOCATE('<Score1>', CAST(clusResult AS VARCHAR(2048))) + 8 ), LOCATE('</Score1>', CAST(clusResult AS VARCHAR(2048))) - LOCATE('<Score1>', CAST(clusResult AS VARCHAR(2048))) - 8 )    ) END;

CREATE PROCEDURE STEPWISE_REDISTRIBUTE_DBPG (DBPGNAME VARCHAR(128),
		STARTINGPOINT SMALLINT,
		NUMSTEPS SMALLINT)
	SPECIFIC STEP_REDIST_DBPG
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE SETTASKSTOPPED (MODELNAME VARCHAR(256))
	SPECIFIC SQL051104145109791
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE BUILDREGVIEW (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		TARGETCOLUMN VARCHAR(128))
	SPECIFIC SQL051104145140870
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION IDMMX.CLASTESTTASKTOCLOB (A IDMMX.DM_CLASTESTTASK) RETURNS CLOB(512000) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE FUNCTION LOCATE (CLOB(1048576),
		CLOB(1048576),
		INTEGER)
	RETURNS INTEGER
	SPECIFIC LOCATE2C
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_IMPRULEFILEE (FILENAME VARCHAR(256),
		ENCODING VARCHAR(20))
	RETURNS DM_RULEMODEL
	SPECIFIC SQL051104145111107
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION RIGHT (CLOB(1048576),
		INTEGER)
	RETURNS CLOB(1048576)
	SPECIFIC RIGHT2C
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDCLASVIEW (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		TARGETCOLUMN VARCHAR(128),
		OPTIONALPARAMETERS VARCHAR(32672))
	SPECIFIC SQL051104145140363
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE DM_BUILDCLASMODEL (TASKTABLENAME VARCHAR(300),
		TASKCOLNAME VARCHAR(128),
		TASKIDCOLNAME VARCHAR(128),
		TASKID VARCHAR(256),
		CALLID CHAR (19) FOR BIT DATA,
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145132706
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE SQLSPECIALCOLUMNS (COLTYPE SMALLINT,
		CATALOG_NAME VARCHAR(128),
		SCHEMA_NAME VARCHAR(128),
		TABLE_NAME VARCHAR(128),
		SCOPE SMALLINT,
		NULLABLE SMALLINT,
		OPTIONS VARCHAR(4000))
	SPECIFIC SPECIALCOLUMNS
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	NOT FENCED
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION FLOOR (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC FLOOR1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION LOCATE (BLOB(1048576),
		BLOB(1048576))
	RETURNS INTEGER
	SPECIFIC LOCATE5
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION LEFT (BLOB(1048576),
		INTEGER)
	RETURNS BLOB(1048576)
	SPECIFIC LEFT2B
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION RADIANS (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC RADIANS1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE CLEANUPTASK (MODELNAME VARCHAR(256))
	SPECIFIC SQL051104145139650
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION IDMMX.DM_APPLDATA(COLNAME VARCHAR(128), COLVALUE TIME) RETURNS IDMMX.DM_APPLICATIONDATA  LANGUAGE SQL NO EXTERNAL ACTION NULL CALL RETURN IDMMX.DM_applData(colName, CHAR(colValue, ISO));

CREATE FUNCTION DM_GETNUMCLUSTERS (OBJ DM_CLUSTERINGMODEL)
	RETURNS INTEGER
	SPECIFIC SQL051104145109802
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDCLUSVIEW (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		OPTIONALPARAMETERS VARCHAR(32672))
	SPECIFIC SQL051104145139855
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE BUILDCLUSVIEW (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300))
	SPECIFIC SQL051104145139854
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE BUILDSEQRULEMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		SEQUENCECOLUMN VARCHAR(128),
		GROUPCOLUMN VARCHAR(128),
		MINSUPPORT DOUBLE,
		MINCONFIDENCE DOUBLE,
		MAXRULELENGTH INTEGER)
	SPECIFIC SQL051104145141176
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION CEIL (SMALLINT)
	RETURNS SMALLINT
	SPECIFIC CEIL3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_APPLDATA (APPLDATA DM_APPLICATIONDATA,
		COLNAME VARCHAR(128),
		COLVALUE VARCHAR(32672))
	RETURNS DM_APPLICATIONDATA
	SPECIFIC SQL051104145114900
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION CEIL (INTEGER)
	RETURNS INTEGER
	SPECIFIC CEIL2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION LN (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC LN
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION CHAR (DOUBLE)
	RETURNS CHAR(24)
	SPECIFIC DOUBLETOCHAR
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION RIGHT (BLOB(1048576),
		INTEGER)
	RETURNS BLOB(1048576)
	SPECIFIC RIGHT2B
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DAYOFYEAR (TIMESTAMP)
	RETURNS INTEGER
	SPECIFIC DAYOFYEAR2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE SQLCOLUMNS (CATALOG_NAME VARCHAR(128),
		SCHEMA_NAME VARCHAR(128),
		TABLE_NAME VARCHAR(128),
		COL_NAME VARCHAR(30),
		OPTIONS VARCHAR(4000))
	SPECIFIC COLUMNS
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	NOT FENCED
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION LEFT (VARCHAR(4000),
		INTEGER)
	RETURNS VARCHAR(4000)
	SPECIFIC LEFT1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDREGMODELSN (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145140467
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DAYOFWEEK_ISO (DATE)
	RETURNS INTEGER
	SPECIFIC DAYOFWEEK_ISO2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETRANKQUALITY (OBJ DM_REGRESSIONMODEL)
	RETURNS DOUBLE
	SPECIFIC SQL051104145110601
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION OLEDBDATASOURCES (VARCHAR(128))
	RETURNS TABLE (NAME VARCHAR(128), PROG_ID VARCHAR(128), DESCRIPTION VARCHAR(128))
	SPECIFIC OLEDBDATASOURCES
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE OLE
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE TESTCLASMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		TESTRESULTNAME VARCHAR(256))
	SPECIFIC SQL051104145140360
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION SNAPSHOT_TBS_CFG (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, TABLESPACE_ID BIGINT, TABLESPACE_NAME VARCHAR(128), TABLESPACE_TYPE SMALLINT, TABLESPACE_STATE BIGINT, NUM_QUIESCERS BIGINT, STATE_CHANGE_OBJ_ID BIGINT, STATE_CHANGE_TBS_ID BIGINT, MIN_RECOVERY_TIME TIMESTAMP, TBS_CONTENTS_TYPE SMALLINT, BUFFERPOOL_ID BIGINT, NEXT_BUFFERPOOL_ID BIGINT, PAGE_SIZE BIGINT, EXTENT_SIZE BIGINT, PREFETCH_SIZE BIGINT, TOTAL_PAGES BIGINT, USABLE_PAGES BIGINT, USED_PAGES BIGINT, FREE_PAGES BIGINT, PENDING_FREE_PAGES BIGINT, HIGH_WATER_MARK BIGINT, REBALANCER_MODE BIGINT, REBALANCER_EXTENTS_REMAINING BIGINT, REBALANCER_EXTENTS_PROCESSED BIGINT, REBALANCER_PRIORITY BIGINT, REBALANCER_START_TIME TIMESTAMP, REBALANCER_RESTART_TIME TIMESTAMP, LAST_EXTEND_MOVED BIGINT, NUM_RANGES BIGINT, NUM_CONTAINERS BIGINT)
	SPECIFIC SNAPSHOT_TBS_CFG
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE PREDICTCOLUMNSN (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		TARGETCOLUMN VARCHAR(128),
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145142087
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_OPENMODELP (CLUSMDL DM_CLUSTERINGMODEL,
		MODELALIAS VARCHAR(256),
		PINNED INTEGER)
	RETURNS BIGINT
	SPECIFIC SQL051104145113701
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION LTRIM (CLOB(1048576))
	RETURNS CLOB(1048576)
	SPECIFIC LTRIM2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION SNAPSHOT_TBREORG (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, TABLE_NAME VARCHAR(35), TABLE_SCHEMA VARCHAR(32), PAGE_REORGS BIGINT, REORG_PHASE BIGINT, REORG_MAX_PHASE INTEGER, REORG_CURRENT_COUNTER BIGINT, REORG_MAX_COUNTER BIGINT, REORG_TYPE INTEGER, REORG_STATUS SMALLINT, REORG_COMPLETION INTEGER, REORG_START TIMESTAMP, REORG_END TIMESTAMP, REORG_PHASE_START TIMESTAMP, REORG_INDEX_ID BIGINT, REORG_TBSPC_ID BIGINT, PARTITION_NUMBER SMALLINT)
	SPECIFIC SNAPSHOT_TBREORG
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETRELIABILITY (OBJ DM_CLASMODEL)
	RETURNS DOUBLE
	SPECIFIC SQL051104145110501
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_GETRBFREGIONID(REGRESULT IDMMX.DM_REGRESULT) RETURNS INTEGER LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<RegionID>', CAST(regResult AS VARCHAR(2048))) = 0 THEN NULL ELSE INTEGER(LEFT(SUBSTR(CAST(regResult AS VARCHAR(2048)), LOCATE('<RegionID>', CAST(regResult AS VARCHAR(2048))) + 10 ), LOCATE('</RegionID>', CAST(regResult AS VARCHAR(2048))) - LOCATE('<RegionID>', CAST(regResult AS VARCHAR(2048))) - 10 )    ) END;

CREATE PROCEDURE SQLCOLPRIVILEGES (CATALOG_NAME VARCHAR(128),
		SCHEMA_NAME VARCHAR(128),
		TABLE_NAME VARCHAR(128),
		COL_NAME VARCHAR(30),
		OPTIONS VARCHAR(4000))
	SPECIFIC COLPRIVILEGES
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	NOT FENCED
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION ROUND (DOUBLE,
		INTEGER)
	RETURNS DOUBLE
	SPECIFIC ROUND1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION TIMESTAMP_ISO (DATE)
	RETURNS TIMESTAMP
	SPECIFIC TIMESTAMP_ISO1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_EXPCLASMODEL (CLASMODEL DM_CLASMODEL AS LOCATOR)
	RETURNS CLOB(2147483647)
	SPECIFIC SQL051104145109905
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE SQLPROCEDURECOLS (CATALOG_NAME VARCHAR(128),
		SCHEMA_NAME VARCHAR(128),
		PROC_NAME VARCHAR(128),
		COL_NAME VARCHAR(128),
		OPTIONS VARCHAR(4000))
	SPECIFIC PROCEDURECOLS
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	NOT FENCED
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION DB_PARTITIONS ()
	RETURNS TABLE (PARTITION_NUMBER SMALLINT, HOST_NAME VARCHAR(128), PORT_NUMBER SMALLINT, SWITCH_NAME VARCHAR(128))
	SPECIFIC DB_PARTITIONS
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE CREATE_STORAGEMGMT_TABLES (TSNAME VARCHAR(128))
	SPECIFIC CREATE_STGMGMT_TAB
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE EXPORTSEQRULEMODEL (MODELNAME VARCHAR(256),
		FILENAME VARCHAR(256))
	SPECIFIC SQL051104145109800
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_GETPREDACCURACY (OBJ DM_CLASTESTRESULT,
		KEYNAME VARCHAR(128))
	RETURNS DOUBLE
	SPECIFIC SQL051104145134700
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETPREDERROR (OBJ DM_REGTESTRESULT)
	RETURNS DOUBLE
	SPECIFIC SQL051104145134903
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION SOUNDEX (VARCHAR(4000))
	RETURNS CHAR(4)
	SPECIFIC SOUNDEX
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETGAINSCHART (OBJ DM_REGRESSIONMODEL)
	RETURNS TABLE (ROWCOUNT BIGINT, SUMACTUAL REAL, THRESHOLD REAL)
	SPECIFIC SQL051104145110603
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.REGTESTTASKTOCLOB (A IDMMX.DM_REGTESTTASK) RETURNS CLOB(512000) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE FUNCTION SIGN (SMALLINT)
	RETURNS SMALLINT
	SPECIFIC SIGN3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDCLASVIEWSN (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145140464
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION SQLCACHE_SNAPSHOT ()
	RETURNS TABLE (NUM_EXECUTIONS INTEGER, NUM_COMPILATIONS INTEGER, PREP_TIME_WORST INTEGER, PREP_TIME_BEST INTEGER, INT_ROWS_DELETED INTEGER, INT_ROWS_INSERTED INTEGER, ROWS_READ INTEGER, INT_ROWS_UPDATED INTEGER, ROWS_WRITTEN INTEGER, STMT_SORTS INTEGER, TOTAL_EXEC_TIME_S INTEGER, TOTAL_EXEC_TIME_MS INTEGER, TOT_U_CPU_TIME_S INTEGER, TOT_U_CPU_TIME_MS INTEGER, TOT_S_CPU_TIME_S INTEGER, TOT_S_CPU_TIME_MS INTEGER, DB_NAME VARCHAR(8), STMT_TEXT CLOB(65536))
	SPECIFIC SQLCACHE_SNAPSHOT
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE FINDRULESSN (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		GROUPCOLUMN VARCHAR(128),
		NBRULES INTEGER,
		MINCONFIDENCE DOUBLE,
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145142602
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION IDMMX.DM_APPLDATA(COLNAME VARCHAR(128), COLVALUE TIMESTAMP) RETURNS IDMMX.DM_APPLICATIONDATA  LANGUAGE SQL NO EXTERNAL ACTION NULL CALL RETURN IDMMX.DM_applData(colName, CHAR(colValue));

CREATE FUNCTION SIGN (INTEGER)
	RETURNS INTEGER
	SPECIFIC SIGN2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDCLUSMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300))
	SPECIFIC SQL051104145139651
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE FINDDEVIATIONSSN (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145142599
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE DM_BUILDCLASMODELCMD (TASKTABLENAME VARCHAR(300),
		TASKCOLNAME VARCHAR(128),
		TASKIDCOLNAME VARCHAR(128),
		TASKID VARCHAR(256),
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145132910
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION DM_GETCLASCOSTRATE (OBJ DM_CLASMODEL)
	RETURNS DOUBLE
	SPECIFIC SQL051104145109906
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.CLOBTOLOGDATA (STRING CLOB(204800)) RETURNS IDMMX.DM_LOGICALDATASPEC CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_LogicalDataSpec()..xmldata(string);

CREATE FUNCTION SYSFUN.GROUPS()    RETURNS TABLE (GROUPNAME VARCHAR(30))    SPECIFIC GROUPS    LANGUAGE SQL    DETERMINISTIC    NO EXTERNAL ACTION    READS SQL DATA    RETURN SELECT T.NAME from TABLE(USERS_GROUPS(0,'')) as T;

CREATE FUNCTION SYSFUN.GROUPS_FOR_USER(USERNAME VARCHAR(30))    RETURNS TABLE (GROUPNAME VARCHAR(25))    SPECIFIC GROUPS_FOR_USER    LANGUAGE SQL    DETERMINISTIC    NO EXTERNAL ACTION    READS SQL DATA    RETURN SELECT T.NAME from TABLE(USERS_GROUPS(2,USERNAME)) as T;

CREATE FUNCTION DM_APPLYCLASMODEL (CLASMDL DM_CLASMODEL,
		APPLDATA DM_APPLICATIONDATA,
		RESSPEC DM_CLASRESULTSPEC)
	RETURNS DM_CLASRESULT
	SPECIFIC SQL051104145115090
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCLASMDLSPEC (OBJ DM_CLASMODEL)
	RETURNS DM_LOGICALDATASPEC
	SPECIFIC SQL051104145110401
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETNUMTRANSACTS (OBJ DM_RULEMODEL)
	RETURNS BIGINT
	SPECIFIC SQL051104145110802
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCLASMDLNAME (OBJ DM_CLASMODEL)
	RETURNS VARCHAR(256)
	SPECIFIC SQL051104145110400
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_GETQUALITY( CLUSRESULT IDMMX.DM_CLUSRESULT, CLUSTERID  INTEGER) RETURNS DOUBLE LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<Qn ID="' || RTRIM(CHAR(clusterid)) || '">', CAST(clusResult AS VARCHAR(2048))) = 0 THEN NULL ELSE DOUBLE(LEFT(SUBSTR(CAST(clusResult AS VARCHAR(2048)), LOCATE('<Qn ID="' || RTRIM(CHAR(clusterid)) || '">', CAST(clusResult AS VARCHAR(2048))) + 10 + LENGTH(RTRIM(CHAR(clusterid))) ), LOCATE('</Qn>', SUBSTR(CAST(clusResult AS VARCHAR(2048)), LOCATE('<Qn ID="' || RTRIM(CHAR(clusterid)) || '">', CAST(clusResult AS VARCHAR(2048))) + 10 + LENGTH(RTRIM(CHAR(clusterid)))) ) - 1 )    ) END;

CREATE PROCEDURE BUILDSEQRULEVIEW (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		SEQUENCECOLUMN VARCHAR(128),
		GROUPCOLUMN VARCHAR(128),
		MINSUPPORT DOUBLE,
		MINCONFIDENCE DOUBLE,
		MAXRULELENGTH INTEGER,
		OPTIONALPARAMETERS VARCHAR(32672))
	SPECIFIC SQL051104145141483
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION FLOOR (SMALLINT)
	RETURNS SMALLINT
	SPECIFIC FLOOR3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETMDLQUALITY (OBJ DM_REGRESSIONMODEL)
	RETURNS DOUBLE
	SPECIFIC SQL051104145110701
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION LCASE (VARCHAR(4000))
	RETURNS VARCHAR(4000)
	SPECIFIC LCASE1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION CEIL (BIGINT)
	RETURNS BIGINT
	SPECIFIC CEIL4
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_CLOSEMODEL (MODELID BIGINT)
	RETURNS INTEGER
	SPECIFIC SQL051104145113801
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION OLEDBLISTTABLES (VARCHAR(1024))
	RETURNS TABLE (CATALOG VARCHAR(128), SCHEMA VARCHAR(128), NAME VARCHAR(128), TYPE VARCHAR(128), DESCRIPTION VARCHAR(128), PROP_ID INTEGER, CREATED VARCHAR(128), MODIFIED VARCHAR(128))
	SPECIFIC OLEDBLISTTABLES
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE OLE
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDREGMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		TARGETCOLUMN VARCHAR(128),
		OPTIONALPARAMETERS VARCHAR(32672))
	SPECIFIC SQL051104145140466
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION IDMMX.HLP_GETNAME( QUALIFIEDNAME VARCHAR(300) ) RETURNS VARCHAR(128) NO EXTERNAL ACTION RETURN CASE WHEN POSSTR(QUALIFIEDNAME,'.')>0 THEN SUBSTR(QUALIFIEDNAME,POSSTR(QUALIFIEDNAME,'.')+1) ELSE QUALIFIEDNAME END;

CREATE FUNCTION SNAPSHOT_APPL_INFO (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, AGENT_ID BIGINT, APPL_STATUS BIGINT, CODEPAGE_ID BIGINT, NUM_ASSOC_AGENTS BIGINT, COORD_PARTITION_NUM SMALLINT, AUTHORITY_LVL BIGINT, CLIENT_PID BIGINT, COORD_AGENT_PID BIGINT, STATUS_CHANGE_TIME TIMESTAMP, CLIENT_PLATFORM SMALLINT, CLIENT_PROTOCOL SMALLINT, COUNTRY_CODE SMALLINT, APPL_NAME VARCHAR(255), APPL_ID VARCHAR(32), SEQUENCE_NO VARCHAR(4), AUTH_ID VARCHAR(30), CLIENT_NNAME VARCHAR(20), CLIENT_PRDID VARCHAR(20), INPUT_DB_ALIAS VARCHAR(20), CLIENT_DB_ALIAS VARCHAR(20), DB_NAME VARCHAR(8), DB_PATH VARCHAR(256), EXECUTION_ID VARCHAR(20), CORR_TOKEN VARCHAR(32), TPMON_CLIENT_USERID VARCHAR(20), TPMON_CLIENT_WKSTN VARCHAR(20), TPMON_CLIENT_APP VARCHAR(20), TPMON_ACC_STR VARCHAR(100))
	SPECIFIC SNAPSHOT_APPL_INFO
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_CANCELTASK (PROGRESSTABLENAME VARCHAR(300),
		CALLID CHAR (19) FOR BIT DATA)
	SPECIFIC SQL051104145133519
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE DM_BUILDCLUSMODEL (TASKTABLENAME VARCHAR(300),
		TASKCOLNAME VARCHAR(128),
		TASKIDCOLNAME VARCHAR(128),
		TASKID VARCHAR(256),
		CALLID CHAR (19) FOR BIT DATA,
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145132705
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE LIST_SRVR_OPTIONS (WRAPPERNAME VARCHAR(128),
		SERVERTYPE VARCHAR(128),
		SERVERVERSION VARCHAR(128),
		OUT OUT_SQLCODE INTEGER)
	SPECIFIC LIST_SRVR_OPTIONS
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE GENERAL WITH NULLS
	EXTERNAL;

CREATE PROCEDURE EXPLAINCOLVALUE (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		TARGETCOLUMN VARCHAR(128),
		TARGETVALUE VARCHAR(1024),
		MAXEXPLLENGTH SMALLINT,
		OPTIONSSTRING VARCHAR(32672))
	SPECIFIC SQL051104145142492
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DAYNAME (TIMESTAMP)
	RETURNS VARCHAR(100)
	SPECIFIC DAYNAME3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.CLOBTOMINDATA (STRING CLOB(153600)) RETURNS IDMMX.DM_MININGDATA CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_MiningData()..xmldata(string);

CREATE FUNCTION POWER (INTEGER,
		INTEGER)
	RETURNS INTEGER
	SPECIFIC POWER3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.RULETASKTOCLOB (A IDMMX.DM_RULEBLDTASK) RETURNS CLOB(512000) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE FUNCTION DM_GETMDLQUALITY (OBJ DM_RULEMODEL)
	RETURNS DOUBLE
	SPECIFIC SQL051104145111001
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE EXPORTCLUSMODEL (MODELNAME VARCHAR(256),
		FILENAME VARCHAR(256))
	SPECIFIC SQL051104145109897
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION TRUNCATE (INTEGER,
		INTEGER)
	RETURNS INTEGER
	SPECIFIC TRUNCATE2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETPREDDEV (REGRESULT DM_REGRESULT,
		CONF DOUBLE)
	RETURNS DOUBLE
	SPECIFIC SQL051104145111602
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_OPENMODELP (RULMDL DM_RULEMODEL,
		MODELALIAS VARCHAR(256),
		PINNED INTEGER)
	RETURNS BIGINT
	SPECIFIC SQL051104145113703
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION REPLACE (BLOB(1048576),
		BLOB(1048576),
		BLOB(1048576))
	RETURNS BLOB(1048576)
	SPECIFIC REPLACE2B
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION HEALTH_CONT_HI (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, CONTAINER_NAME VARCHAR(256), NODE_NUMBER INTEGER, HI_ID BIGINT, HI_VALUE SMALLINT, HI_TIMESTAMP TIMESTAMP, HI_ALERT_STATE BIGINT, HI_ALERT_STATE_DETAIL VARCHAR(20), HI_FORMULA VARCHAR(2048), HI_ADDITIONAL_INFO VARCHAR(4096))
	SPECIFIC HEALTH_CONT_HI
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_BUILDCLASMODEL (CLASTASK CLOB(512000),
		CALLID CHAR (19) FOR BIT DATA,
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145132797
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION MONTHNAME (VARCHAR(26))
	RETURNS VARCHAR(100)
	SPECIFIC MONTHNAME3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_GETPREDVALUE(REGRESULT IDMMX.DM_REGRESULT) RETURNS DOUBLE LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<predVal>', CAST(regResult AS VARCHAR(2048))) = 0 THEN NULL ELSE DOUBLE(LEFT(SUBSTR(CAST(regResult AS VARCHAR(2048)), LOCATE('<predVal>', CAST(regResult AS VARCHAR(2048))) + 9 ), LOCATE('</predVal>', CAST(regResult AS VARCHAR(2048))) - LOCATE('<predVal>', CAST(regResult AS VARCHAR(2048))) - 9 )    ) END;

CREATE FUNCTION JULIAN_DAY (TIMESTAMP)
	RETURNS INTEGER
	SPECIFIC JULIAN_DAY2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION MONTHNAME (DATE)
	RETURNS VARCHAR(100)
	SPECIFIC MONTHNAME1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION MOD (BIGINT,
		BIGINT)
	RETURNS BIGINT
	SPECIFIC MOD3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_IMPREGFILEE (FILENAME VARCHAR(256),
		ENCODING VARCHAR(20))
	RETURNS DM_REGRESSIONMODEL
	SPECIFIC SQL051104145111104
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE FINDSEQRULES (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		SEQUENCECOLUMN VARCHAR(128),
		GROUPCOLUMN VARCHAR(128),
		NBRULES INTEGER,
		MINCONFIDENCE DOUBLE,
		OPTIONSSTRING VARCHAR(32672))
	SPECIFIC SQL051104145142704
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION IDMMX.CLOBTOCLUSSET (STRING CLOB(307200)) RETURNS IDMMX.DM_CLUSSETTINGS CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_ClusSettings()..xmldata(string);

CREATE PROCEDURE BUILDREGVIEWSN (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145140972
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_GETRANKQUALITY (OBJ DM_CLASTESTRESULT,
		KEYNAME VARCHAR(128))
	RETURNS DOUBLE
	SPECIFIC SQL051104145134503
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_EXPRULEMODEL (RULEMODEL DM_RULEMODEL AS LOCATOR)
	RETURNS CLOB(2147483647)
	SPECIFIC SQL051104145110800
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_IMPREGMODEL (REGMDL CLOB(10485760))
	RETURNS DM_REGRESSIONMODEL
	SPECIFIC SQL051104145111105
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCLUSIMRESID (OBJ DM_CLUSTERINGMODEL)
	RETURNS INTEGER
	SPECIFIC SQL051104145109805
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.STRTOCLASRESSPEC (STRING VARCHAR(2048)) RETURNS IDMMX.DM_CLASRESULTSPEC CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_ClasResultSpec()..xmldata(string);

CREATE FUNCTION POWER (DOUBLE,
		DOUBLE)
	RETURNS DOUBLE
	SPECIFIC POWER1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE SET_SWRD_SETTINGS (DBPGNAME VARCHAR(128),
		OVERWRITESPEC SMALLINT,
		REDISTMETHOD SMALLINT,
		PMAPFILE VARCHAR(255),
		DISTFILE VARCHAR(255),
		STEPSIZE BIGINT,
		TOTALSTEPS SMALLINT,
		STAGESIZE SMALLINT,
		NEXTSTEP SMALLINT,
		PROCESSSTATE SMALLINT,
		PNUMBER VARCHAR(6000),
		PWEIGHT VARCHAR(6000))
	SPECIFIC SET_SWRD_SETTINGS
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION IDMMX.CLOBTOREGTESTTASK (STRING CLOB(512000)) RETURNS IDMMX.DM_REGTESTTASK CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_RegTestTask()..xmldata(string);

--;

CREATE FUNCTION HEALTH_DBM_INFO (INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, SERVER_INSTANCE_NAME VARCHAR(8), ROLLED_UP_ALERT_STATE BIGINT, ROLLED_UP_ALERT_STATE_DETAIL VARCHAR(20), DB2START_TIME TIMESTAMP, LAST_RESET TIMESTAMP, NUM_NODES_IN_DB2_INSTANCE INTEGER)
	SPECIFIC HEALTH_DBM_INFO
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE GETLASTERROR (OUT ERRORMSG VARCHAR(1000))
	SPECIFIC SQL051104145109787
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

create function SYSFUN.OID2PATH(OID bigint) returns table(PATH varchar(32300)) specific OID2PATH language sql reads sql data no external action deterministic return with paths (id,pname,level) as  (select parentid,'/'||linkedname,1   from sysibm.sysxmlrelationships where childid=oid2path.oid   UNION ALL   select r.parentid,'/'||r.linkedname||p.pname,p.level+1   from paths p,sysibm.sysxmlrelationships r   where p.id=r.childid and r.relationshiptype in ('H','S')   and p.level<2048 ) select pname from paths where id is null;

CREATE PROCEDURE FINDRULES (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		GROUPCOLUMN VARCHAR(128),
		NBRULES INTEGER,
		MINCONFIDENCE DOUBLE,
		OPTIONSSTRING VARCHAR(32672))
	SPECIFIC SQL051104145142501
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION ACOS (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC ACOS
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION JULIAN_DAY (VARCHAR(26))
	RETURNS INTEGER
	SPECIFIC JULIAN_DAY3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION HEALTH_DBM_HI (INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, HI_ID BIGINT, SERVER_INSTANCE_NAME VARCHAR(8), HI_VALUE SMALLINT, HI_TIMESTAMP TIMESTAMP, HI_ALERT_STATE BIGINT, HI_ALERT_STATE_DETAIL VARCHAR(20), HI_FORMULA VARCHAR(2048), HI_ADDITIONAL_INFO VARCHAR(4096))
	SPECIFIC HEALTH_DBM_HI
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION WEEK_ISO (VARCHAR(26))
	RETURNS INTEGER
	SPECIFIC WEEK_ISO3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION COS (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC COS
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.REGTASKTOCLOB (A IDMMX.DM_REGBLDTASK) RETURNS CLOB(512000) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE FUNCTION IDMMX.DM_OPENMODEL(REGMDL IDMMX.DM_REGRESSIONMODEL, MODELALIAS VARCHAR(256)) RETURNS BIGINT LANGUAGE SQL CALLED ON NULL INPUT NOT DETERMINISTIC EXTERNAL ACTION RETURN IDMMX.DM_openModelP(regMdl, modelAlias, 1);

CREATE PROCEDURE BUILDCLUSMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		OPTIONALPARAMETERS VARCHAR(32672))
	SPECIFIC SQL051104145139752
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION ABSVAL (INTEGER)
	RETURNS INTEGER
	SPECIFIC ABSVAL2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION ROUND (BIGINT,
		INTEGER)
	RETURNS BIGINT
	SPECIFIC ROUND5
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETRULEMDLNAME (OBJ DM_RULEMODEL)
	RETURNS VARCHAR(256)
	SPECIFIC SQL051104145110902
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCLUSMDLTYPE (OBJ DM_CLUSTERINGMODEL)
	RETURNS VARCHAR(256)
	SPECIFIC SQL051104145109900
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION ABSVAL (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC ABSVAL1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETMDLQUALITY (OBJ DM_CLASMODEL)
	RETURNS DOUBLE
	SPECIFIC SQL051104145110500
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDRULEVIEW (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		GROUPCOLUMN VARCHAR(128),
		MINSUPPORT DOUBLE,
		MINCONFIDENCE DOUBLE,
		MAXRULELENGTH INTEGER)
	SPECIFIC SQL051104145141379
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION IDMMX.CLUSRESSPECTOSTR (A IDMMX.DM_CLUSRESULTSPEC) RETURNS VARCHAR(2048) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE FUNCTION DAYOFWEEK (DATE)
	RETURNS INTEGER
	SPECIFIC DAYOFWEEK2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION ASCII (CLOB(1048576))
	RETURNS INTEGER
	SPECIFIC ASCII3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE APPLYCLUSMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		OUTPUTVIEW VARCHAR(300),
		CLUSTERIDCOLUMN VARCHAR(128),
		QUALITYCOLUMN VARCHAR(128),
		CONFIDENCECOLUMN VARCHAR(128))
	SPECIFIC SQL051104145115233
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_GETITEMSETS (OBJ DM_RULEMODEL)
	RETURNS TABLE (ITEMSETID INTEGER, SUPPORT DOUBLE, LIFT DOUBLE, ITEM VARCHAR(1024), ITEMNAME VARCHAR(1024))
	SPECIFIC SQL051104145110803
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDSEQRULEVIEW (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		SEQUENCECOLUMN VARCHAR(128),
		GROUPCOLUMN VARCHAR(128),
		MINSUPPORT DOUBLE,
		MINCONFIDENCE DOUBLE,
		MAXRULELENGTH INTEGER)
	SPECIFIC SQL051104145141482
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_GETRMSE (OBJ DM_REGRESSIONMODEL)
	RETURNS DOUBLE
	SPECIFIC SQL051104145110507
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCLASTARGET (OBJ DM_CLASMODEL)
	RETURNS VARCHAR(128)
	SPECIFIC SQL051104145110502
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCLASIMRESID (OBJ DM_CLASMODEL)
	RETURNS INTEGER
	SPECIFIC SQL051104145110004
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_IMPCLASFILEE (FILENAME VARCHAR(256),
		ENCODING VARCHAR(20))
	RETURNS DM_CLASMODEL
	SPECIFIC SQL051104145111005
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION ROUND (INTEGER,
		INTEGER)
	RETURNS INTEGER
	SPECIFIC ROUND2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION LTRIM (VARCHAR(4000))
	RETURNS VARCHAR(4000)
	SPECIFIC LTRIM1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_APPLDATA(APPLDATA IDMMX.DM_APPLICATIONDATA  , COLNAME VARCHAR(128), COLVALUE DATE) RETURNS IDMMX.DM_APPLICATIONDATA  LANGUAGE SQL NO EXTERNAL ACTION NULL CALL RETURN IDMMX.DM_applData(applData, colName, CHAR(colValue, ISO));

CREATE FUNCTION IDMMX.DM_APPLYREGMODEL( MODELALIAS VARCHAR(256), APPLDATA VARCHAR(32672) ) RETURNS IDMMX.DM_REGRESULT LANGUAGE SQL READS SQL DATA EXTERNAL ACTION RETURN COALESCE( IDMMX.DM_applyRegModelA(modelAlias, applData), IDMMX.DM_applyRegModelA( (CASE WHEN IDMMX.DM_openModelP( (SELECT MODEL FROM IDMMX.REGRESSIONMODELS WHERE MODELNAME = modelAlias), modelAlias, 0) IS NULL THEN NULL ELSE modelAlias END), appldata ), IDMMX.DM_applyRegModel( COALESCE((SELECT MODEL FROM IDMMX.REGRESSIONMODELS WHERE MODELNAME = modelAlias), CAST (CAST('<NoModel/>' AS BLOB(20)) AS IDMMX.DM_RegressionModel)), IDMMX.DM_impApplData(applData) ) );

--;

CREATE FUNCTION IDMMX.DM_GETTREENODEID(CLASRESULT IDMMX.DM_CLASRESULT) RETURNS VARCHAR(128) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<NodeId>', CAST(clasResult AS VARCHAR(2048))) = 0 THEN NULL ELSE LEFT(SUBSTR(CAST(clasResult AS VARCHAR(2048)), LOCATE('<NodeId>', CAST(clasResult AS VARCHAR(2048))) + 8 ), LOCATE('</NodeId>', CAST(clasResult AS VARCHAR(2048))) - LOCATE('<NodeId>', CAST(clasResult AS VARCHAR(2048))) - 8 ) END;

CREATE FUNCTION SNAPSHOT_SUBSECT (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, STMT_TEXT CLOB(65536), SS_EXEC_TIME BIGINT, TQ_TOT_SEND_SPILLS BIGINT, TQ_CUR_SEND_SPILLS BIGINT, TQ_MAX_SEND_SPILLS BIGINT, TQ_ROWS_READ BIGINT, TQ_ROWS_WRITTEN BIGINT, ROWS_READ BIGINT, ROWS_WRITTEN BIGINT, SS_USR_CPU_TIME BIGINT, SS_SYS_CPU_TIME BIGINT, SS_NUMBER INTEGER, SS_STATUS INTEGER, SS_PARTITION_NUMBER SMALLINT, TQ_PARTITION_WAITED_FOR SMALLINT, TQ_WAIT_FOR_ANY INTEGER, TQ_ID_WAITING_ON INTEGER)
	SPECIFIC SNAPSHOT_SUBSECT
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION TRUNCATE (DOUBLE,
		INTEGER)
	RETURNS DOUBLE
	SPECIFIC TRUNCATE1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE GET_WRAP_CFG_C (WRAPPERID VARCHAR(128),
		CLIENTLOCALE VARCHAR(128),
		OUT SERVERPLATFORM VARCHAR(128),
		OUT TRACELOG VARCHAR(2000),
		OUT OUT_SQLCODE INTEGER)
	SPECIFIC GET_WRAP_CFG_C
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE GENERAL WITH NULLS
	EXTERNAL;

CREATE FUNCTION LOCATE (CLOB(1048576),
		CLOB(1048576))
	RETURNS INTEGER
	SPECIFIC LOCATE4
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE FINDMOSTIMPFIELDS (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		TARGETCOLUMN VARCHAR(128),
		OPTIONSSTRING VARCHAR(32672))
	SPECIFIC SQL051104145142707
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION CEILING (BIGINT)
	RETURNS BIGINT
	SPECIFIC CEILING4
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDCLASVIEW (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		TARGETCOLUMN VARCHAR(128))
	SPECIFIC SQL051104145140362
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE TESTREGMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		TESTRESULTNAME VARCHAR(256))
	SPECIFIC SQL051104145140568
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_GETREGRSQUARED (OBJ DM_REGRESSIONMODEL)
	RETURNS DOUBLE
	SPECIFIC SQL051104145110600
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDRULEVIEW (VIEWNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		GROUPCOLUMN VARCHAR(128),
		MINSUPPORT DOUBLE,
		MINCONFIDENCE DOUBLE,
		MAXRULELENGTH INTEGER,
		OPTIONALPARAMETERS VARCHAR(32672))
	SPECIFIC SQL051104145141480
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION IDMMX.DM_OPENMODEL(RULMDL IDMMX.DM_RULEMODEL, MODELALIAS VARCHAR(256)) RETURNS BIGINT LANGUAGE SQL CALLED ON NULL INPUT NOT DETERMINISTIC EXTERNAL ACTION RETURN IDMMX.DM_openModelP(rulMdl, modelAlias, 1);

CREATE PROCEDURE DM_BUILDREGMODEL (TASKTABLENAME VARCHAR(300),
		TASKCOLNAME VARCHAR(128),
		TASKIDCOLNAME VARCHAR(128),
		TASKID VARCHAR(256),
		CALLID CHAR (19) FOR BIT DATA,
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145132907
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION DM_GETREGMDLSPEC (OBJ DM_REGRESSIONMODEL)
	RETURNS DM_LOGICALDATASPEC
	SPECIFIC SQL051104145110700
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_BUILDRULEMODEL (TASKTABLENAME VARCHAR(300),
		TASKCOLNAME VARCHAR(128),
		TASKIDCOLNAME VARCHAR(128),
		TASKID VARCHAR(256),
		CALLID CHAR (19) FOR BIT DATA,
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145132908
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION HEALTH_TBS_HI_HIS (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, TABLESPACE_NAME VARCHAR(128), HI_ID BIGINT, HI_TIMESTAMP TIMESTAMP, HI_VALUE SMALLINT, HI_ALERT_STATE BIGINT, HI_ALERT_STATE_DETAIL VARCHAR(20), HI_FORMULA VARCHAR(2048), HI_ADDITIONAL_INFO VARCHAR(4096))
	SPECIFIC HEALTH_TBS_HI_HIS
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_BUILDCLUSMODELCMD (TASKTABLENAME VARCHAR(300),
		TASKCOLNAME VARCHAR(128),
		TASKIDCOLNAME VARCHAR(128),
		TASKID VARCHAR(256),
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145132909
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION ASCII (CHAR(254))
	RETURNS INTEGER
	SPECIFIC ASCII1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION TIMESTAMP_ISO (TIME)
	RETURNS TIMESTAMP
	SPECIFIC TIMESTAMP_ISO2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE SQLTABLEPRIVILEGES (CATALOG_NAME VARCHAR(128),
		SCHEMA_NAME VARCHAR(128),
		TABLE_NAME VARCHAR(128),
		OPTIONS VARCHAR(4000))
	SPECIFIC TABLEPRIVILEGES
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	NOT FENCED
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION IDMMX.DM_IMPAPPLDATA(APPLDATA CLOB(512000)  ) RETURNS IDMMX.DM_APPLICATIONDATA  LANGUAGE SQL NO EXTERNAL ACTION NULL CALL RETURN CAST(applData AS IDMMX.DM_ApplicationData);

CREATE FUNCTION POWER (DOUBLE,
		INTEGER)
	RETURNS DOUBLE
	SPECIFIC POWER2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_GETLOWERQUANT(REGRESULT IDMMX.DM_REGRESULT) RETURNS DOUBLE LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<loQLabel>', CAST(regResult AS VARCHAR(2048))) = 0 THEN NULL ELSE DOUBLE(LEFT(SUBSTR(CAST(regResult AS VARCHAR(2048)), LOCATE('<loQLabel>', CAST(regResult AS VARCHAR(2048))) + 10 ), LOCATE('</loQLabel>', CAST(regResult AS VARCHAR(2048))) - LOCATE('<loQLabel>', CAST(regResult AS VARCHAR(2048))) - 10 )    ) END;

CREATE FUNCTION WEEK_ISO (TIMESTAMP)
	RETURNS INTEGER
	SPECIFIC WEEK_ISO2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_BUILDRULEMODELCMD (TASKTABLENAME VARCHAR(300),
		TASKCOLNAME VARCHAR(128),
		TASKIDCOLNAME VARCHAR(128),
		TASKID VARCHAR(256),
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145133412
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE CAPTURE_STORAGEMGMT_INFO (ROOTTYPE SMALLINT,
		ROOTSCHEMA VARCHAR(128),
		ROOTNAME VARCHAR(128))
	SPECIFIC CAPT_STGMGMT_INF
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE LIST_WRAP_OPTIONS (WRAPPERNAME VARCHAR(128),
		OUT OUT_SQLCODE INTEGER)
	SPECIFIC LIST_WRAP_OPTIONS
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE GENERAL WITH NULLS
	EXTERNAL;

CREATE PROCEDURE EXPORTRULEMODEL (MODELNAME VARCHAR(256),
		FILENAME VARCHAR(256))
	SPECIFIC SQL051104145109899
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION IDMMX.DM_APPLYCLASMODEL( MODELALIAS VARCHAR(256), APPLDATA VARCHAR(32672), RESSPEC IDMMX.DM_CLASRESULTSPEC ) RETURNS IDMMX.DM_CLASRESULT LANGUAGE SQL READS SQL DATA EXTERNAL ACTION RETURN COALESCE( IDMMX.DM_applyClasModelA(modelAlias, applData, resSpec), IDMMX.DM_applyClasModelA( (CASE WHEN IDMMX.DM_openModelP( (SELECT MODEL FROM IDMMX.CLASSIFMODELS WHERE MODELNAME = modelAlias), modelAlias, 0) IS NULL THEN NULL ELSE modelAlias END), appldata, resSpec ), IDMMX.DM_applyClasModel( COALESCE((SELECT MODEL FROM IDMMX.CLASSIFMODELS WHERE MODELNAME = modelAlias), CAST (CAST('<NoModel/>' AS BLOB(20)) AS IDMMX.DM_ClasModel)), IDMMX.DM_impApplData(applData), resSpec ) );

CREATE PROCEDURE DM_TESTCLASMODELT (TASKTABLENAME VARCHAR(300),
		TASKCOLNAME VARCHAR(128),
		TASKIDCOLNAME VARCHAR(128),
		TASKID VARCHAR(256),
		CALLID CHAR (19) FOR BIT DATA,
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145133413
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION LOCATE (BLOB(1048576),
		BLOB(1048576),
		INTEGER)
	RETURNS INTEGER
	SPECIFIC LOCATE2B
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETRELIABILITY (OBJ DM_REGTESTRESULT)
	RETURNS DOUBLE
	SPECIFIC SQL051104145135202
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION MOD (INTEGER,
		INTEGER)
	RETURNS INTEGER
	SPECIFIC MOD1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE SQLPRIMARYKEYS (CATALOG_NAME VARCHAR(128),
		SCHEMA_NAME VARCHAR(128),
		TABLE_NAME VARCHAR(128),
		OPTIONS VARCHAR(4000))
	SPECIFIC PRIMARYKEYS
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	NOT FENCED
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION DM_IMPREGFILE (FILENAME VARCHAR(256))
	RETURNS DM_REGRESSIONMODEL
	SPECIFIC SQL051104145111103
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION REPEAT (BLOB(1048576),
		INTEGER)
	RETURNS BLOB(1048576)
	SPECIFIC REPEAT2B
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_APPLYCLUSMODEL( MODELALIAS VARCHAR(256), APPLDATA VARCHAR(32672), RESSPEC IDMMX.DM_CLUSRESULTSPEC ) RETURNS IDMMX.DM_CLUSRESULT LANGUAGE SQL READS SQL DATA EXTERNAL ACTION RETURN COALESCE( IDMMX.DM_applyClusModelA(modelAlias, applData, resSpec), IDMMX.DM_applyClusModelA( (CASE WHEN IDMMX.DM_openModelP( (SELECT MODEL FROM IDMMX.CLUSTERMODELS WHERE MODELNAME = modelAlias), modelAlias, 0) IS NULL THEN NULL ELSE modelAlias END), appldata, resSpec ), IDMMX.DM_applyClusModel( COALESCE((SELECT MODEL FROM IDMMX.CLUSTERMODELS WHERE MODELNAME = modelAlias), CAST (CAST('<NoModel/>' AS BLOB(20)) AS IDMMX.DM_ClusteringModel)), IDMMX.DM_impApplData(applData), resSpec ) );

CREATE FUNCTION SNAPSHOT_APPL (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, AGENT_ID BIGINT, UOW_LOG_SPACE_USED BIGINT, ROWS_READ BIGINT, ROWS_WRITTEN BIGINT, POOL_DATA_L_READS BIGINT, POOL_DATA_P_READS BIGINT, POOL_DATA_WRITES BIGINT, POOL_INDEX_L_READS BIGINT, POOL_INDEX_P_READS BIGINT, POOL_INDEX_WRITES BIGINT, POOL_READ_TIME BIGINT, POOL_WRITE_TIME BIGINT, DIRECT_READS BIGINT, DIRECT_WRITES BIGINT, DIRECT_READ_REQS BIGINT, DIRECT_WRITE_REQS BIGINT, DIRECT_READ_TIME BIGINT, DIRECT_WRITE_TIME BIGINT, POOL_DATA_TO_ESTORE BIGINT, POOL_INDEX_TO_ESTORE BIGINT, POOL_INDEX_FROM_ESTORE BIGINT, POOL_DATA_FROM_ESTORE BIGINT, UNREAD_PREFETCH_PAGES BIGINT, LOCKS_HELD BIGINT, LOCK_WAITS BIGINT, LOCK_WAIT_TIME BIGINT, LOCK_ESCALS BIGINT, X_LOCK_ESCALS BIGINT, DEADLOCKS BIGINT, TOTAL_SORTS BIGINT, TOTAL_SORT_TIME BIGINT, SORT_OVERFLOWS BIGINT, COMMIT_SQL_STMTS BIGINT, ROLLBACK_SQL_STMTS BIGINT, DYNAMIC_SQL_STMTS BIGINT, STATIC_SQL_STMTS BIGINT, FAILED_SQL_STMTS BIGINT, SELECT_SQL_STMTS BIGINT, DDL_SQL_STMTS BIGINT, UID_SQL_STMTS BIGINT, INT_AUTO_REBINDS BIGINT, INT_ROWS_DELETED BIGINT, INT_ROWS_UPDATED BIGINT, INT_COMMITS BIGINT, INT_ROLLBACKS BIGINT, INT_DEADLOCK_ROLLBACKS BIGINT, ROWS_DELETED BIGINT, ROWS_INSERTED BIGINT, ROWS_UPDATED BIGINT, ROWS_SELECTED BIGINT, BINDS_PRECOMPILES BIGINT, OPEN_REM_CURS BIGINT, OPEN_REM_CURS_BLK BIGINT, REJ_CURS_BLK BIGINT, ACC_CURS_BLK BIGINT, SQL_REQS_SINCE_COMMIT BIGINT, LOCK_TIMEOUTS BIGINT, INT_ROWS_INSERTED BIGINT, OPEN_LOC_CURS BIGINT, OPEN_LOC_CURS_BLK BIGINT, PKG_CACHE_LOOKUPS BIGINT, PKG_CACHE_INSERTS BIGINT, CAT_CACHE_LOOKUPS BIGINT, CAT_CACHE_INSERTS BIGINT, CAT_CACHE_OVERFLOWS BIGINT, CAT_CACHE_HEAP_FULL BIGINT, NUM_AGENTS BIGINT, AGENTS_STOLEN BIGINT, ASSOCIATED_AGENTS_TOP BIGINT, APPL_PRIORITY BIGINT, APPL_PRIORITY_TYPE BIGINT, PREFETCH_WAIT_TIME BIGINT, APPL_SECTION_LOOKUPS BIGINT, APPL_SECTION_INSERTS BIGINT, LOCKS_WAITING BIGINT, TOTAL_HASH_JOINS BIGINT, TOTAL_HASH_LOOPS BIGINT, HASH_JOIN_OVERFLOWS BIGINT, HASH_JOIN_SMALL_OVERFLOWS BIGINT, APPL_IDLE_TIME BIGINT, UOW_LOCK_WAIT_TIME BIGINT, UOW_COMP_STATUS BIGINT, AGENT_USR_CPU_TIME_S BIGINT, AGENT_USR_CPU_TIME_MS BIGINT, AGENT_SYS_CPU_TIME_S BIGINT, AGENT_SYS_CPU_TIME_MS BIGINT, APPL_CON_TIME TIMESTAMP, CONN_COMPLETE_TIME TIMESTAMP, LAST_RESET TIMESTAMP, UOW_START_TIME TIMESTAMP, UOW_STOP_TIME TIMESTAMP, PREV_UOW_STOP_TIME TIMESTAMP, UOW_ELAPSED_TIME_S BIGINT, UOW_ELAPSED_TIME_MS BIGINT, ELAPSED_EXEC_TIME_S BIGINT, ELAPSED_EXEC_TIME_MS BIGINT, INBOUND_COMM_ADDRESS VARCHAR(32))
	SPECIFIC SNAPSHOT_APPL
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION RAND (INTEGER)
	RETURNS DOUBLE
	SPECIFIC RAND2
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION TRUNCATE (BIGINT,
		INTEGER)
	RETURNS BIGINT
	SPECIFIC TRUNCATE5
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE EXPORTREGTESTRESULT (TESTRESULTNAME VARCHAR(256),
		FILENAME VARCHAR(256))
	SPECIFIC SQL051104145140769
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION IDMDATASCAN (VARCHAR(256),
		VARCHAR(8),
		CLOB(512000),
		INTEGER)
	RETURNS VARCHAR(256)
	SPECIFIC SQL051104145133700
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION REPLACE (VARCHAR(4000),
		VARCHAR(4000),
		VARCHAR(4000))
	RETURNS VARCHAR(4000)
	SPECIFIC REPLACE1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETSEQDETAILS (OBJ DM_RULEMODEL)
	RETURNS TABLE (SEQUENCEID INTEGER, POSI INTEGER, SETID INTEGER, SETTEXT VARCHAR(4096), MEANTIMEDIFF DOUBLE, STDDEVTIMEDIFF DOUBLE)
	SPECIFIC SQL051104145110806
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCOUNTCONSTRS (OBJ DM_RULEFILTER)
	RETURNS TABLE (PREFERENCE INTEGER, RESTRICTIONCRIT INTEGER, RESTRICTIONTEXT VARCHAR(128), ORDERING VARCHAR(128))
	SPECIFIC SQL051104145109101
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCLUSTERNAME (OBJ DM_CLUSTERINGMODEL,
		POS INTEGER)
	RETURNS VARCHAR(128)
	SPECIFIC SQL051104145109803
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETGAINSCHART (OBJ DM_REGTESTRESULT)
	RETURNS TABLE (ROWCOUNT BIGINT, SUMACTUAL REAL, THRESHOLD REAL)
	SPECIFIC SQL051104145135200
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE GETLASTERROR (MODELNAME VARCHAR(256),
		OUT ERRORMSG VARCHAR(1000))
	SPECIFIC SQL051104145109789
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE DM_BUILDREGMODEL (RULETASK CLOB(512000),
		CALLID CHAR (19) FOR BIT DATA,
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145132798
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION RTRIM (VARCHAR(4000))
	RETURNS VARCHAR(4000)
	SPECIFIC RTRIM1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_TESTREGMODELT (TASKTABLENAME VARCHAR(300),
		TASKCOLNAME VARCHAR(128),
		TASKIDCOLNAME VARCHAR(128),
		TASKID VARCHAR(256),
		CALLID CHAR (19) FOR BIT DATA,
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145133514
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION IDMMX.DM_IMPAPPLDATA(APPLDATA VARCHAR(32672)) RETURNS IDMMX.DM_APPLICATIONDATA  LANGUAGE SQL NO EXTERNAL ACTION NULL CALL RETURN CAST(CAST(applData AS CLOB(512000)) AS IDMMX.DM_ApplicationData);

CREATE FUNCTION DM_GETCLUSMDLSPEC (OBJ DM_CLUSTERINGMODEL)
	RETURNS DM_LOGICALDATASPEC
	SPECIFIC SQL051104145109901
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETREGIMRESID (OBJ DM_REGRESSIONMODEL)
	RETURNS INTEGER
	SPECIFIC SQL051104145110604
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DROP_STORAGEMGMT_TABLES (DROPSPEC SMALLINT)
	SPECIFIC DROP_STGMGMT_TAB
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION DM_GETITEMCONSTRS (OBJ DM_RULEFILTER)
	RETURNS TABLE (ITEM VARCHAR(1024), CONSTRAINTTYPE INTEGER, CONSTRAINTTEXT VARCHAR(128), DISJUNCTIVEGROUP INTEGER)
	SPECIFIC SQL051104145109104
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION HEALTH_DB_INFO (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, DB_NAME VARCHAR(8), INPUT_DB_ALIAS VARCHAR(8), DB_PATH VARCHAR(256), DB_LOCATION INTEGER, SERVER_PLATFORM INTEGER, ROLLED_UP_ALERT_STATE BIGINT, ROLLED_UP_ALERT_STATE_DETAIL VARCHAR(20))
	SPECIFIC HEALTH_DB_INFO
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION WEEK (VARCHAR(26))
	RETURNS INTEGER
	SPECIFIC WEEK3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DAYNAME (VARCHAR(26))
	RETURNS VARCHAR(100)
	SPECIFIC DAYNAME1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_GETCLUSCONF(CLUSRESULT IDMMX.DM_CLUSRESULT) RETURNS DOUBLE LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<Conf>', CAST(clusResult AS VARCHAR(2048))) = 0 THEN NULL ELSE DOUBLE(LEFT(SUBSTR(CAST(clusResult AS VARCHAR(2048)), LOCATE('<Conf>', CAST(clusResult AS VARCHAR(2048))) + 6 ), LOCATE('</Conf>', CAST(clusResult AS VARCHAR(2048))) - LOCATE('<Conf>', CAST(clusResult AS VARCHAR(2048))) - 6 )    ) END;

CREATE PROCEDURE FINDSEQRULESSN (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		SEQUENCECOLUMN VARCHAR(128),
		GROUPCOLUMN VARCHAR(128),
		NBRULES INTEGER,
		MINCONFIDENCE DOUBLE,
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145142705
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_IMPRULEFILE (FILENAME VARCHAR(256))
	RETURNS DM_RULEMODEL
	SPECIFIC SQL051104145111106
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION LOCATE (VARCHAR(4000),
		VARCHAR(4000))
	RETURNS INTEGER
	SPECIFIC LOCATE3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION HEALTH_CONT_INFO (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, CONTAINER_NAME VARCHAR(256), TABLESPACE_NAME VARCHAR(128), NODE_NUMBER INTEGER, ROLLED_UP_ALERT_STATE BIGINT, ROLLED_UP_ALERT_STATE_DETAIL VARCHAR(20))
	SPECIFIC HEALTH_CONT_INFO
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.CLASRESSPECTOSTR (A IDMMX.DM_CLASRESULTSPEC) RETURNS VARCHAR(2048) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE PROCEDURE DM_ENABLEDB (OPTIONSSTRING VARCHAR(1024),
		OUT RETURNCODE INTEGER,
		OUT MSG VARCHAR(32672))
	SPECIFIC SQL051104145132395
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE SQL
	EXTERNAL;

CREATE PROCEDURE LIST_FILES_C (IN_FILEEXT VARCHAR(30),
		IN_SEARCHDIR VARCHAR(1000),
		OUT OUT_SQLCODE INTEGER)
	SPECIFIC LIST_FILES_C
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE GENERAL WITH NULLS
	EXTERNAL;

CREATE PROCEDURE LIST_WRAPPERS (OUT OUT_SQLCODE INTEGER)
	SPECIFIC LIST_WRAPPERS
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE GENERAL WITH NULLS
	EXTERNAL;

CREATE FUNCTION SNAPSHOT_LOCKWAIT (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, AGENT_ID BIGINT, SUBSECTION_NUMBER BIGINT, LOCK_MODE BIGINT, LOCK_OBJECT_TYPE BIGINT, AGENT_ID_HOLDING_LK BIGINT, LOCK_WAIT_START_TIME TIMESTAMP, LOCK_MODE_REQUESTED BIGINT, PARTITION_NUMBER SMALLINT, LOCK_ESCALLATION SMALLINT, TABLE_NAME VARCHAR(35), TABLE_SCHEMA VARCHAR(32), TABLESPACE_NAME VARCHAR(128), APPL_ID_HOLDING_LK VARCHAR(32))
	SPECIFIC SNAPSHOT_LOCKWAIT
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION INSERT (CLOB(1048576),
		INTEGER,
		INTEGER,
		CLOB(1048576))
	RETURNS CLOB(1048576)
	SPECIFIC INSERT2C
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE LIST_SRVR_VERSIONS (WRAPPERNAME VARCHAR(128),
		SERVERTYPE VARCHAR(128),
		OUT OUT_SQLCODE INTEGER)
	SPECIFIC LIST_SRVR_VERSIONS
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE GENERAL WITH NULLS
	EXTERNAL;

CREATE FUNCTION DM_GETRULES (DM_RULEMODEL)
	RETURNS TABLE (ID INTEGER, HEADNAME VARCHAR(1024), HEAD VARCHAR(1024), BODYID INTEGER, LENGTH SMALLINT, BODYTEXT VARCHAR(4096), SUPPORT REAL, CONFIDENCE REAL, LIFT REAL)
	SPECIFIC SQL050824092120705
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCORRELATIONS (OBJ DM_REGRESSIONMODEL)
	RETURNS TABLE (FIELDNAME1 VARCHAR(128), FIELDNAME2 VARCHAR(128), CORRELATION REAL)
	SPECIFIC SQL051104145110706
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.STRTOCLUSRESSPEC (STRING VARCHAR(2048)) RETURNS IDMMX.DM_CLUSRESULTSPEC CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_ClusResultSpec()..xmldata(string);

CREATE PROCEDURE SQLFOREIGNKEYS (PKCATALOG_NAME VARCHAR(128),
		PKSCHEMA_NAME VARCHAR(128),
		PKTABLE_NAME VARCHAR(128),
		FKCATALOG_NAME VARCHAR(128),
		FKSCHEMA_NAME VARCHAR(128),
		FKTABLE_NAME VARCHAR(128),
		OPTIONS VARCHAR(4000))
	SPECIFIC FOREIGNKEYS
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	NOT FENCED
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION ASIN (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC ASIN
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.CLOBTOCLASTESTTASK (STRING CLOB(512000)) RETURNS IDMMX.DM_CLASTESTTASK CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_ClasTestTask()..xmldata(string);

CREATE FUNCTION LOG (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC LOG
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

create function SYSFUN.PATH2OID(PATH varchar(3000)) returns bigint specific PATH2OID language sql reads sql data no external action deterministic return with oids (id,pname,level) as  (select childid,substr(path2oid.path,locate('/',path2oid.path,2)+1),1   from sysibm.sysxmlrelationships    where linkedname=substr(path2oid.path,2,nullif(locate('/',path2oid.path,2)-2,-2))   and parentid is null   and relationshiptype in ('H','S')   UNION ALL   select r.childid,substr(o.pname,posstr(pname,'/')+1),o.level+1   from oids o,sysibm.sysxmlrelationships r   where r.linkedname=substr(o.pname,1,posstr(o.pname,'/')-1)   and r.parentid=o.id   and r.relationshiptype in ('H','S')   and o.level<128   and posstr(o.pname,'/')<>0 ) select distinct  case locate('/',path2oid.path,2) when 0 then  (select s.childid from sysibm.sysxmlrelationships s where s.parentid is null   and s.relationshiptype in ('H','S') and s.linkedname=substr(path2oid.path,2)) else (select r.childid from oids o,sysibm.sysxmlrelationships r where r.parentid=o.id and o.pname=r.linkedname) end from sysibm.sysxmlrelationships;

CREATE FUNCTION DM_GETRULETASK (OBJ DM_RULEMODEL)
	RETURNS DM_RULEBLDTASK
	SPECIFIC SQL051104145134500
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCLASTASK (OBJ DM_CLASMODEL)
	RETURNS DM_CLASBLDTASK
	SPECIFIC SQL051104145133701
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETFIELDS (OBJ DM_RULEMODEL)
	RETURNS TABLE (COLNAME VARCHAR(128), FIELDNAME VARCHAR(128), MININGTYPE SMALLINT, IMPORTANCE REAL)
	SPECIFIC SQL051104145111002
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

--;

CREATE PROCEDURE SQLGETTYPEINFO (DATATYPE SMALLINT,
		OPTIONS VARCHAR(4000))
	SPECIFIC GETTYPEINFO
	READS SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	NOT FENCED
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE BUILDRULEMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		GROUPCOLUMN VARCHAR(128),
		MINSUPPORT DOUBLE,
		MINCONFIDENCE DOUBLE,
		MAXRULELENGTH INTEGER)
	SPECIFIC SQL051104145141073
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION IDMMX.DM_GETCONFIDENCE(CLASRESULT IDMMX.DM_CLASRESULT) RETURNS DOUBLE LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<Confidence>', CAST(clasResult AS VARCHAR(2048))) = 0 THEN NULL ELSE DOUBLE(LEFT(SUBSTR(CAST(clasResult AS VARCHAR(2048)), LOCATE('<Confidence>', CAST(clasResult AS VARCHAR(2048))) + 12 ), LOCATE('</Confidence>', CAST(clasResult AS VARCHAR(2048))) - LOCATE('<Confidence>', CAST(clasResult AS VARCHAR(2048))) - 12 )    ) END;

CREATE PROCEDURE BUILDRULEMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		GROUPCOLUMN VARCHAR(128),
		MINSUPPORT DOUBLE,
		MINCONFIDENCE DOUBLE,
		MAXRULELENGTH INTEGER,
		OPTIONALPARAMETERS VARCHAR(32672))
	SPECIFIC SQL051104145141074
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE FINDDEVIATIONS (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300))
	SPECIFIC SQL051104145142597
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

--CREATE FUNCTION UCASE (VARCHAR(4000))
--	RETURNS VARCHAR(0)
--	SPECIFIC UCASE
--	READS SQL DATA
--	NO EXTERNAL ACTION
--	DISALLOW PARALLEL
--	LANGUAGE 
--	EXTERNAL
--	FENCED THREADSAFE
--	PARAMETER STYLE ;

CREATE PROCEDURE PREDICTCOLVALUE (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		TARGETCOLUMN VARCHAR(128),
		TARGETVALUE VARCHAR(1024),
		OPTIONSSTRING VARCHAR(32672))
	SPECIFIC SQL051104145142189
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_GETCONFIDENCE (REGRESULT DM_REGRESULT,
		LOW DOUBLE,
		HIGH DOUBLE)
	RETURNS DOUBLE
	SPECIFIC SQL051104145111603
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION REPEAT (CLOB(1048576),
		INTEGER)
	RETURNS CLOB(1048576)
	SPECIFIC REPEAT2C
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION HEALTH_DBM_HI_HIS (INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, HI_ID BIGINT, SERVER_INSTANCE_NAME VARCHAR(8), HI_VALUE SMALLINT, HI_TIMESTAMP TIMESTAMP, HI_ALERT_STATE BIGINT, HI_ALERT_STATE_DETAIL VARCHAR(20), HI_FORMULA VARCHAR(2048), HI_ADDITIONAL_INFO VARCHAR(4096))
	SPECIFIC HEALTH_DBM_HI_HIS
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION SNAPSHOT_STATEMENT (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, AGENT_ID BIGINT, ROWS_READ BIGINT, ROWS_WRITTEN BIGINT, NUM_AGENTS BIGINT, AGENTS_TOP BIGINT, STMT_TYPE BIGINT, STMT_OPERATION BIGINT, SECTION_NUMBER BIGINT, QUERY_COST_ESTIMATE BIGINT, QUERY_CARD_ESTIMATE BIGINT, DEGREE_PARALLELISM BIGINT, STMT_SORTS BIGINT, TOTAL_SORT_TIME BIGINT, SORT_OVERFLOWS BIGINT, INT_ROWS_DELETED BIGINT, INT_ROWS_UPDATED BIGINT, INT_ROWS_INSERTED BIGINT, FETCH_COUNT BIGINT, STMT_START TIMESTAMP, STMT_STOP TIMESTAMP, STMT_USR_CPU_TIME_S BIGINT, STMT_USR_CPU_TIME_MS BIGINT, STMT_SYS_CPU_TIME_S BIGINT, STMT_SYS_CPU_TIME_MS BIGINT, STMT_ELAPSED_TIME_S BIGINT, STMT_ELAPSED_TIME_MS BIGINT, BLOCKING_CURSOR SMALLINT, STMT_PARTITION_NUMBER SMALLINT, CURSOR_NAME VARCHAR(31), CREATOR VARCHAR(32), PACKAGE_NAME VARCHAR(20), STMT_TEXT CLOB(65536))
	SPECIFIC SNAPSHOT_STATEMENT
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION LEFT (CLOB(1048576),
		INTEGER)
	RETURNS CLOB(1048576)
	SPECIFIC LEFT2C
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE APPLYRULEMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		OUTPUTVIEW VARCHAR(300),
		IDCOLUMN VARCHAR(128),
		HEADCOLUMN VARCHAR(128),
		HEADNAMECOLUMN VARCHAR(128),
		SUPPORTCOLUMN VARCHAR(128),
		CONFIDENCECOLUMN VARCHAR(128),
		LIFTCOLUMN VARCHAR(128),
		MATCHHEADCOLUMN VARCHAR(128),
		MATCHBODYCOLUMN VARCHAR(128))
	SPECIFIC SQL051104145115236
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION VEBLOB_CP_LARGE (BLOB(1000000),
		INTEGER,
		INTEGER,
		INTEGER)
	RETURNS BLOB(1000000)
	SPECIFIC VEBLOB_CP_LARGE
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION HEALTH_DB_HI_HIS (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, HI_ID BIGINT, DB_NAME VARCHAR(8), HI_VALUE SMALLINT, HI_TIMESTAMP TIMESTAMP, HI_ALERT_STATE BIGINT, HI_ALERT_STATE_DETAIL VARCHAR(20), HI_FORMULA VARCHAR(2048), HI_ADDITIONAL_INFO VARCHAR(4096))
	SPECIFIC HEALTH_DB_HI_HIS
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION TIMESTAMP_ISO (VARCHAR(26))
	RETURNS TIMESTAMP
	SPECIFIC TIMESTAMP_ISO4
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_CLOSEALLMODELS (PINNED INTEGER)
	SPECIFIC SQL051104145113813
	NO SQL
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION DM_GETNUMRULES (OBJ DM_RULEMODEL)
	RETURNS INTEGER
	SPECIFIC SQL051104145110801
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION LCASE (CLOB(1048576))
	RETURNS CLOB(1048576)
	SPECIFIC LCASE2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE FINDMOSTIMPFIELDS (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		TARGETCOLUMN VARCHAR(128))
	SPECIFIC SQL051104145142706
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE BUILDSEQRULEMODELSN (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145141378
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE APPLYSEQRULEMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		OUTPUTVIEW VARCHAR(300),
		IDCOLUMN VARCHAR(128),
		HEADCOLUMN VARCHAR(128),
		HEADNAMECOLUMN VARCHAR(128),
		SUPPORTCOLUMN VARCHAR(128),
		CONFIDENCECOLUMN VARCHAR(128),
		LIFTCOLUMN VARCHAR(128),
		MATCHHEADCOLUMN VARCHAR(128),
		MATCHBODYCOLUMN VARCHAR(128))
	SPECIFIC SQL051104145115237
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DAYOFWEEK (TIMESTAMP)
	RETURNS INTEGER
	SPECIFIC DAYOFWEEK3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_TESTCLASMODELCMDD (TASKTABLENAME VARCHAR(300),
		TASKCOLNAME VARCHAR(128),
		TASKIDCOLNAME VARCHAR(128),
		TASKID VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		INPUTCOLUMN VARCHAR(128),
		INPUTIDCOLUMN VARCHAR(128),
		INPUTID VARCHAR(256),
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145133517
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION DM_EXPREGMODEL (REGMODEL DM_REGRESSIONMODEL AS LOCATOR)
	RETURNS CLOB(2147483647)
	SPECIFIC SQL051104145110506
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE SQLTABLES (CATALOG_NAME VARCHAR(128),
		SCHEMA_NAME VARCHAR(128),
		TABLE_NAME VARCHAR(128),
		TABLE_TYPE VARCHAR(4000),
		OPTIONS VARCHAR(4000))
	SPECIFIC TABLES
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	NOT FENCED
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION IDMMX.DM_APPLDATA(APPLDATA IDMMX.DM_APPLICATIONDATA  , COLNAME VARCHAR(128), COLVALUE TIME) RETURNS IDMMX.DM_APPLICATIONDATA  LANGUAGE SQL NO EXTERNAL ACTION NULL CALL RETURN IDMMX.DM_applData(applData, colName, CHAR(colValue, ISO));

CREATE PROCEDURE EXPORTCLASTESTRESULT (TESTRESULTNAME VARCHAR(256),
		FILENAME VARCHAR(256))
	SPECIFIC SQL051104145140361
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_GETCLUSTASK (OBJ DM_CLUSTERINGMODEL)
	RETURNS DM_CLUSBLDTASK
	SPECIFIC SQL051104145134200
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETRANKQUALITY (OBJ DM_REGTESTRESULT)
	RETURNS DOUBLE
	SPECIFIC SQL051104145135000
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE ODBC_DISCOVERY (SERVERNAME VARCHAR(128),
		USERNAME VARCHAR(128),
		AUTHENTICATION VARCHAR(128),
		CATALOGNAMEOPERATOR VARCHAR(128),
		CATALOGNAMEPATTERN VARCHAR(128),
		SCHEMANAMEOPERATOR VARCHAR(128),
		SCHEMANAMEPATTERN VARCHAR(128),
		TABLENAMEOPERATOR VARCHAR(128),
		TABLENAMEPATTERN VARCHAR(128),
		OUT SQLCODE INTEGER,
		OUT SQLSTATE VARCHAR(5),
		OUT MESSAGETEXT VARCHAR(1024))
	SPECIFIC ODBC_DISCOVERY
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE GENERAL WITH NULLS
	EXTERNAL;

CREATE FUNCTION CEILING (INTEGER)
	RETURNS INTEGER
	SPECIFIC CEILING2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_GETENV (OUT LIST VARCHAR(32672))
	SPECIFIC SQL051104145109785
	NO SQL
	DETERMINISTIC
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION QUARTER (DATE)
	RETURNS INTEGER
	SPECIFIC QUARTER1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE BUILDCLASMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		TARGETCOLUMN VARCHAR(128))
	SPECIFIC SQL051104145140257
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_GETMDLQUALITY (OBJ DM_REGTESTRESULT)
	RETURNS DOUBLE
	SPECIFIC SQL051104145135201
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCONFMATRIX (OBJ DM_CLASTESTRESULT)
	RETURNS TABLE (ACTUAL VARCHAR(256), PREDICTED VARCHAR(256), COUNT BIGINT, COST DOUBLE)
	SPECIFIC SQL051104145134702
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION HLP_GETHASHCODE (STRING VARCHAR (1024) FOR BIT DATA)
	RETURNS INTEGER
	SPECIFIC SQL051104145139503
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_GETCLUSSCORE( CLUSRESULT IDMMX.DM_CLUSRESULT, CLUSTERID  INTEGER) RETURNS DOUBLE LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<Sn ID="' || RTRIM(CHAR(clusterid)) || '">', CAST(clusResult AS VARCHAR(2048))) = 0 THEN NULL ELSE DOUBLE(LEFT(SUBSTR(CAST(clusResult AS VARCHAR(2048)), LOCATE('<Sn ID="' || RTRIM(CHAR(clusterid)) || '">', CAST(clusResult AS VARCHAR(2048))) + 10 + LENGTH(RTRIM(CHAR(clusterid))) ), LOCATE('</Sn>', SUBSTR(CAST(clusResult AS VARCHAR(2048)), LOCATE('<Sn ID="' || RTRIM(CHAR(clusterid)) || '">', CAST(clusResult AS VARCHAR(2048))) + 10 + LENGTH(RTRIM(CHAR(clusterid)))) ) - 1 )    ) END;

CREATE FUNCTION RAND ()
	RETURNS DOUBLE
	SPECIFIC RAND1
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE SQLPROCEDURES (CATALOG_NAME VARCHAR(128),
		SCHEMA_NAME VARCHAR(128),
		PROC_NAME VARCHAR(128),
		OPTIONS VARCHAR(4000))
	SPECIFIC PROCEDURES
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	NOT FENCED
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE REMOTE_QUERY (SERVERNAME VARCHAR(128),
		SCHEMAOPERATOR VARCHAR(16),
		SCHEMAPATTERN VARCHAR(100),
		TABLEOPERATOR VARCHAR(16),
		TABLEPATTERN VARCHAR(100),
		PERFORMCOUNT SMALLINT,
		OUT REMOTESQL VARCHAR(300),
		OUT OUT_SQLCODE INTEGER)
	SPECIFIC REMOTE_QUERY
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE GENERAL WITH NULLS
	EXTERNAL;

CREATE PROCEDURE CANCELTASK (MODELNAME VARCHAR(256))
	SPECIFIC SQL051104145139649
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE LIST_SRVR_TYPES (WRAPPERNAME VARCHAR(128),
		OUT OUT_SQLCODE INTEGER)
	SPECIFIC LIST_SRVR_TYPES
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE GENERAL WITH NULLS
	EXTERNAL;

CREATE FUNCTION IDMMX.DM_APPLDATA(APPLDATA IDMMX.DM_APPLICATIONDATA  , COLNAME VARCHAR(128), COLVALUE TIMESTAMP) RETURNS IDMMX.DM_APPLICATIONDATA  LANGUAGE SQL NO EXTERNAL ACTION NULL CALL RETURN IDMMX.DM_applData(applData, colName, CHAR(colValue));

CREATE PROCEDURE DM_SETENV (VARIABLE VARCHAR(100),
		VALUE VARCHAR(1000))
	SPECIFIC SQL051104145109784
	NO SQL
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION DM_IMPCLASFILE (FILENAME VARCHAR(256))
	RETURNS DM_CLASMODEL
	SPECIFIC SQL051104145111004
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION WEEK (DATE)
	RETURNS INTEGER
	SPECIFIC WEEK1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION TRUNC (INTEGER,
		INTEGER)
	RETURNS INTEGER
	SPECIFIC TRUNC2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION LOG10 (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC LOG10
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_GETUPPERQUANT(REGRESULT IDMMX.DM_REGRESULT) RETURNS DOUBLE LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<hiQLabel>', CAST(regResult AS VARCHAR(2048))) = 0 THEN NULL ELSE DOUBLE(LEFT(SUBSTR(CAST(regResult AS VARCHAR(2048)), LOCATE('<hiQLabel>', CAST(regResult AS VARCHAR(2048))) + 10 ), LOCATE('</hiQLabel>', CAST(regResult AS VARCHAR(2048))) - LOCATE('<hiQLabel>', CAST(regResult AS VARCHAR(2048))) - 10 )    ) END;

CREATE FUNCTION MIDNIGHT_SECONDS (TIMESTAMP)
	RETURNS INTEGER
	SPECIFIC MIDNIGHT_SECONDS2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION COT (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC COT
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE LIST_SRVR_OPTVALS (WRAPPERNAME VARCHAR(128),
		SERVERTYPE VARCHAR(128),
		SERVERVERSION VARCHAR(128),
		OUT OUT_SQLCODE INTEGER)
	SPECIFIC LIST_SRVR_OPTVALS
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE GENERAL WITH NULLS
	EXTERNAL;

CREATE FUNCTION SQRT (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC SQRT
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.RULEFLTRTOCLOB (A IDMMX.DM_RULEFILTER) RETURNS CLOB(153600) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE PROCEDURE FINDSEQRULES (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		SEQUENCECOLUMN VARCHAR(128),
		GROUPCOLUMN VARCHAR(128),
		NBRULES INTEGER,
		MINCONFIDENCE DOUBLE)
	SPECIFIC SQL051104145142603
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_GETREGTASK (OBJ DM_REGRESSIONMODEL)
	RETURNS DM_REGBLDTASK
	SPECIFIC SQL051104145134300
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION ABS (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC ABS1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE APPLYREGMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		OUTPUTVIEW VARCHAR(300),
		PREDNUMCOLUMN VARCHAR(128),
		PREDSTDDEVCOLUMN VARCHAR(128))
	SPECIFIC SQL051104145115235
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE DM_BUILDCLUSMODEL (CLUSTASK CLOB(512000),
		CALLID CHAR (19) FOR BIT DATA,
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145132396
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION SIGN (BIGINT)
	RETURNS BIGINT
	SPECIFIC SIGN4
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_APPLDATA (COLNAME VARCHAR(128),
		COLVALUE DOUBLE)
	RETURNS DM_APPLICATIONDATA
	SPECIFIC SQL051104145115003
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.CLOBTORULETASK (STRING CLOB(512000)) RETURNS IDMMX.DM_RULEBLDTASK CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_RuleBldTask()..xmldata(string);

CREATE FUNCTION TRUNC (DOUBLE,
		INTEGER)
	RETURNS DOUBLE
	SPECIFIC TRUNC1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETGAINSCHART (OBJ DM_CLASMODEL,
		TARGETVALUE VARCHAR(1024))
	RETURNS TABLE (ROWCOUNT BIGINT, SUMACTUAL REAL, THRESHOLD REAL)
	SPECIFIC SQL051104145110002
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION FLOOR (INTEGER)
	RETURNS INTEGER
	SPECIFIC FLOOR2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETRULEBODIES (OBJ DM_RULEMODEL)
	RETURNS TABLE (BODYID INTEGER, ITEMNAME VARCHAR(1024), ITEM VARCHAR(1024))
	SPECIFIC SQL051104145110804
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DAYOFYEAR (VARCHAR(26))
	RETURNS INTEGER
	SPECIFIC DAYOFYEAR3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION SNAPSHOT_DATABASE (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, SEC_LOG_USED_TOP BIGINT, TOT_LOG_USED_TOP BIGINT, TOTAL_LOG_USED BIGINT, TOTAL_LOG_AVAILABLE BIGINT, ROWS_READ BIGINT, POOL_DATA_L_READS BIGINT, POOL_DATA_P_READS BIGINT, POOL_DATA_WRITES BIGINT, POOL_INDEX_L_READS BIGINT, POOL_INDEX_P_READS BIGINT, POOL_INDEX_WRITES BIGINT, POOL_READ_TIME BIGINT, POOL_WRITE_TIME BIGINT, POOL_ASYNC_INDEX_READS BIGINT, POOL_DATA_TO_ESTORE BIGINT, POOL_INDEX_TO_ESTORE BIGINT, POOL_INDEX_FROM_ESTORE BIGINT, POOL_DATA_FROM_ESTORE BIGINT, POOL_ASYNC_DATA_READS BIGINT, POOL_ASYNC_DATA_WRITES BIGINT, POOL_ASYNC_INDEX_WRITES BIGINT, POOL_ASYNC_READ_TIME BIGINT, POOL_ASYNC_WRITE_TIME BIGINT, POOL_ASYNC_DATA_READ_REQS BIGINT, DIRECT_READS BIGINT, DIRECT_WRITES BIGINT, DIRECT_READ_REQS BIGINT, DIRECT_WRITE_REQS BIGINT, DIRECT_READ_TIME BIGINT, DIRECT_WRITE_TIME BIGINT, UNREAD_PREFETCH_PAGES BIGINT, FILES_CLOSED BIGINT, POOL_LSN_GAP_CLNS BIGINT, POOL_DRTY_PG_STEAL_CLNS BIGINT, POOL_DRTY_PG_THRSH_CLNS BIGINT, LOCKS_HELD BIGINT, LOCK_WAITS BIGINT, LOCK_WAIT_TIME BIGINT, LOCK_LIST_IN_USE BIGINT, DEADLOCKS BIGINT, LOCK_ESCALS BIGINT, X_LOCK_ESCALS BIGINT, LOCKS_WAITING BIGINT, SORT_HEAP_ALLOCATED BIGINT, TOTAL_SORTS BIGINT, TOTAL_SORT_TIME BIGINT, SORT_OVERFLOWS BIGINT, ACTIVE_SORTS BIGINT, COMMIT_SQL_STMTS BIGINT, ROLLBACK_SQL_STMTS BIGINT, DYNAMIC_SQL_STMTS BIGINT, STATIC_SQL_STMTS BIGINT, FAILED_SQL_STMTS BIGINT, SELECT_SQL_STMTS BIGINT, DDL_SQL_STMTS BIGINT, UID_SQL_STMTS BIGINT, INT_AUTO_REBINDS BIGINT, INT_ROWS_DELETED BIGINT, INT_ROWS_UPDATED BIGINT, INT_COMMITS BIGINT, INT_ROLLBACKS BIGINT, INT_DEADLOCK_ROLLBACKS BIGINT, ROWS_DELETED BIGINT, ROWS_INSERTED BIGINT, ROWS_UPDATED BIGINT, ROWS_SELECTED BIGINT, BINDS_PRECOMPILES BIGINT, TOTAL_CONS BIGINT, APPLS_CUR_CONS BIGINT, APPLS_IN_DB2 BIGINT, SEC_LOGS_ALLOCATED BIGINT, DB_STATUS BIGINT, LOCK_TIMEOUTS BIGINT, CONNECTIONS_TOP BIGINT, DB_HEAP_TOP BIGINT, INT_ROWS_INSERTED BIGINT, LOG_READS BIGINT, LOG_WRITES BIGINT, PKG_CACHE_LOOKUPS BIGINT, PKG_CACHE_INSERTS BIGINT, CAT_CACHE_LOOKUPS BIGINT, CAT_CACHE_INSERTS BIGINT, CAT_CACHE_OVERFLOWS BIGINT, CAT_CACHE_HEAP_FULL BIGINT, CATALOG_PARTITION SMALLINT, TOTAL_SEC_CONS BIGINT, NUM_ASSOC_AGENTS BIGINT, AGENTS_TOP BIGINT, COORD_AGENTS_TOP BIGINT, PREFETCH_WAIT_TIME BIGINT, APPL_SECTION_LOOKUPS BIGINT, APPL_SECTION_INSERTS BIGINT, TOTAL_HASH_JOINS BIGINT, TOTAL_HASH_LOOPS BIGINT, HASH_JOIN_OVERFLOWS BIGINT, HASH_JOIN_SMALL_OVERFLOWS BIGINT, PKG_CACHE_NUM_OVERFLOWS BIGINT, PKG_CACHE_SIZE_TOP BIGINT, DB_CONN_TIME TIMESTAMP, SQLM_ELM_LAST_RESET TIMESTAMP, SQLM_ELM_LAST_BACKUP TIMESTAMP, APPL_CON_TIME TIMESTAMP, ELAPSED_EXEC_TIME_S BIGINT, ELAPSED_EXEC_TIME_MS BIGINT, DB_LOCATION INTEGER, SERVER_PLATFORM INTEGER, APPL_ID_OLDEST_XACT BIGINT, CATALOG_PARTITION_NAME VARCHAR(128), INPUT_DB_ALIAS VARCHAR(8), DB_NAME VARCHAR(8), DB_PATH VARCHAR(256))
	SPECIFIC SNAPSHOT_DATABASE
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION HEALTH_CONT_HI_HIS (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, CONTAINER_NAME VARCHAR(256), NODE_NUMBER INTEGER, HI_ID BIGINT, HI_TIMESTAMP TIMESTAMP, HI_VALUE SMALLINT, HI_ALERT_STATE BIGINT, HI_ALERT_STATE_DETAIL VARCHAR(20), HI_FORMULA VARCHAR(2048), HI_ADDITIONAL_INFO VARCHAR(4096))
	SPECIFIC HEALTH_CONT_HI_HIS
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION CEILING (SMALLINT)
	RETURNS SMALLINT
	SPECIFIC CEILING3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DOUBLE (VARCHAR(4000))
	RETURNS DOUBLE
	SPECIFIC CHARTODOUBLE
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DAYOFWEEK_ISO (TIMESTAMP)
	RETURNS INTEGER
	SPECIFIC DAYOFWEEK_ISO3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_APPLDATA(COLNAME VARCHAR(128), COLVALUE DATE) RETURNS IDMMX.DM_APPLICATIONDATA  LANGUAGE SQL NO EXTERNAL ACTION NULL CALL RETURN IDMMX.DM_applData(colName, CHAR(colValue, ISO));

CREATE PROCEDURE SNAPSHOT_FILEW (REQUESTTYPE SMALLINT,
		DBNAME VARCHAR(128),
		PARTITIONNUM SMALLINT)
	SPECIFIC SNAPSHOT_FILEW
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION OLEDBTESTCONNECT (VARCHAR(1024))
	RETURNS SMALLINT
	SPECIFIC OLEDBTESTCONNECT
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE OLE
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION ABSVAL (SMALLINT)
	RETURNS SMALLINT
	SPECIFIC ABSVAL3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCLUSMDLNAME (OBJ DM_CLUSTERINGMODEL)
	RETURNS VARCHAR(256)
	SPECIFIC SQL051104145109806
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETRANKQUALITY (OBJ DM_CLASMODEL,
		KEYNAME VARCHAR(128))
	RETURNS DOUBLE
	SPECIFIC SQL051104145110000
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION SNAPSHOT_AGENT (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, AGENT_ID BIGINT, AGENT_PID BIGINT)
	SPECIFIC SNAPSHOT_AGENT
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION EXP (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC EXP
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION TIMESTAMP_ISO (TIMESTAMP)
	RETURNS TIMESTAMP
	SPECIFIC TIMESTAMP_ISO3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE PREDICTCOLUMN (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		TARGETCOLUMN VARCHAR(128))
	SPECIFIC SQL051104145141585
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION SIN (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC SIN
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETRULEMDLSPEC (OBJ DM_RULEMODEL)
	RETURNS DM_LOGICALDATASPEC
	SPECIFIC SQL051104145111000
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETOPENMODELS ()
	RETURNS TABLE (MODELID BIGINT, MODELNAME VARCHAR(256), MODELALIAS VARCHAR(256), USER VARCHAR(128), LASTACCESS TIMESTAMP, PINNED INTEGER, SIZE INTEGER, USECOUNT INTEGER)
	SPECIFIC SQL051104145114700
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION OLEDBLISTCOLUMNS (VARCHAR(1024),
		VARCHAR(128))
	RETURNS TABLE (NAME VARCHAR(128), ORDINAL INTEGER, FLAGS INTEGER, COLUMNSIZE INTEGER, TYPE VARCHAR(128), DB2TYPE VARCHAR(128), PRECISION INTEGER, SCALE INTEGER, COLUMNID VARCHAR(128))
	SPECIFIC OLEDBLISTCOLUMNS
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE OLE
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETRMSE (OBJ DM_REGTESTRESULT)
	RETURNS DOUBLE
	SPECIFIC SQL051104145134902
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.CLOBTORULEFLTR (STRING CLOB(153600)) RETURNS IDMMX.DM_RULEFILTER CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_RuleFilter()..xmldata(string);

CREATE FUNCTION WEEK_ISO (DATE)
	RETURNS INTEGER
	SPECIFIC WEEK_ISO1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION SYSFUN.USERS()    RETURNS TABLE (USERNAME VARCHAR(30))    SPECIFIC USERS    LANGUAGE SQL    DETERMINISTIC    NO EXTERNAL ACTION    READS SQL DATA    RETURN SELECT T.NAME from TABLE(USERS_GROUPS(1,'')) as T;

CREATE FUNCTION IDMMX.DM_GETPREDSTDDEV(REGRESULT IDMMX.DM_REGRESULT) RETURNS DOUBLE LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN CASE WHEN LOCATE('<predStdDev>', CAST(regResult AS VARCHAR(2048))) = 0 THEN NULL ELSE DOUBLE(LEFT(SUBSTR(CAST(regResult AS VARCHAR(2048)), LOCATE('<predStdDev>', CAST(regResult AS VARCHAR(2048))) + 12 ), LOCATE('</predStdDev>', CAST(regResult AS VARCHAR(2048))) - LOCATE('<predStdDev>', CAST(regResult AS VARCHAR(2048))) - 12 )    ) END;

CREATE FUNCTION DM_IMPCLUSFILE (FILENAME VARCHAR(256))
	RETURNS DM_CLUSTERINGMODEL
	SPECIFIC SQL051104145111100
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_APPLDATA (COLNAME VARCHAR(128),
		COLVALUE VARCHAR(32672))
	RETURNS DM_APPLICATIONDATA
	SPECIFIC SQL051104145115004
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DAYOFWEEK_ISO (VARCHAR(26))
	RETURNS INTEGER
	SPECIFIC DAYOFWEEK_ISO1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE SQLSTATISTICS (CATALOG_NAME VARCHAR(128),
		SCHEMA_NAME VARCHAR(128),
		TABLE_NAME VARCHAR(128),
		UNIQUE SMALLINT,
		RESERVED SMALLINT,
		OPTIONS VARCHAR(4000))
	SPECIFIC STATISTICS
	MODIFIES SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	NOT FENCED
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION INSERT (BLOB(1048576),
		INTEGER,
		INTEGER,
		BLOB(1048576))
	RETURNS BLOB(1048576)
	SPECIFIC INSERT2B
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION SNAPSHOT_QUIESCERS (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, TABLESPACE_NAME VARCHAR(128), QUIESCER_TBS_ID BIGINT, QUIESCER_OBJ_ID BIGINT, QUIESCER_AUTH_ID BIGINT, QUIESCER_AGENT_ID BIGINT, QUIESCER_STATE BIGINT)
	SPECIFIC SNAPSHOT_QUIESCERS
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETREGMDLNAME (OBJ DM_REGRESSIONMODEL)
	RETURNS VARCHAR(256)
	SPECIFIC SQL051104145110605
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE SQLUDTS (CATALOG_NAME VARCHAR(128),
		SCHEMA_NAME VARCHAR(128),
		TYPE_NAME VARCHAR(128),
		TYPES VARCHAR(18),
		OPTIONS VARCHAR(4000))
	SPECIFIC UDTS
	READS SQL DATA
	DYNAMIC RESULT SETS 1
	LANGUAGE C
	NOT FENCED
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE PREDICTCOLVALUE (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		TARGETCOLUMN VARCHAR(128),
		TARGETVALUE VARCHAR(1024))
	SPECIFIC SQL051104145142088
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_EXPREGTESTRES (TSTRES DM_REGTESTRESULT AS LOCATOR)
	RETURNS CLOB(2147483647)
	SPECIFIC SQL051104145134901
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_APPLYCLUSMODELA (MODELALIAS VARCHAR(256),
		APPLDATA VARCHAR(32672))
	RETURNS DM_CLUSRESULT
	SPECIFIC SQL051104145113300
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION QUARTER (VARCHAR(26))
	RETURNS INTEGER
	SPECIFIC QUARTER3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DAYNAME (DATE)
	RETURNS VARCHAR(100)
	SPECIFIC DAYNAME2
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION JULIAN_DAY (DATE)
	RETURNS INTEGER
	SPECIFIC JULIAN_DAY1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE FINDRULES (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		GROUPCOLUMN VARCHAR(128),
		NBRULES INTEGER,
		MINCONFIDENCE DOUBLE)
	SPECIFIC SQL051104145142500
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION IDMMX.CLUSTASKTOCLOB (A IDMMX.DM_CLUSBLDTASK) RETURNS CLOB(512000) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE FUNCTION CEIL (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC CEIL1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_GETMININGDATA (TABLENAME VARCHAR(300),
		OUT DATACOLUMNS CLOB(153600))
	SPECIFIC SQL051104145132704
	MODIFIES SQL DATA
	DETERMINISTIC
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION SNAPSHOT_BP (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, POOL_DATA_L_READS BIGINT, POOL_DATA_P_READS BIGINT, POOL_DATA_WRITES BIGINT, POOL_INDEX_L_READS BIGINT, POOL_INDEX_P_READS BIGINT, POOL_INDEX_WRITES BIGINT, POOL_READ_TIME BIGINT, POOL_WRITE_TIME BIGINT, POOL_ASYNC_DATA_READS BIGINT, POOL_ASYNC_DATA_WRITES BIGINT, POOL_ASYNC_INDEX_WRITES BIGINT, POOL_ASYNC_READ_TIME BIGINT, POOL_ASYNC_WRITE_TIME BIGINT, POOL_ASYNC_DATA_READ_REQS BIGINT, DIRECT_READS BIGINT, DIRECT_WRITES BIGINT, DIRECT_READ_REQS BIGINT, DIRECT_WRITE_REQS BIGINT, DIRECT_READ_TIME BIGINT, DIRECT_WRITE_TIME BIGINT, POOL_ASYNC_INDEX_READS BIGINT, POOL_DATA_TO_ESTORE BIGINT, POOL_INDEX_TO_ESTORE BIGINT, POOL_INDEX_FROM_ESTORE BIGINT, POOL_DATA_FROM_ESTORE BIGINT, UNREAD_PREFETCH_PAGES BIGINT, FILES_CLOSED BIGINT, BP_NAME VARCHAR(20), DB_NAME VARCHAR(8), DB_PATH VARCHAR(256), INPUT_DB_ALIAS VARCHAR(8))
	SPECIFIC SNAPSHOT_BP
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE CLUSTERTABLE (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		MINSIZE DOUBLE,
		MAXSIZE DOUBLE)
	SPECIFIC SQL051104145142494
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_ISVALIDATED (OBJ DM_CLASMODEL)
	RETURNS SMALLINT
	SPECIFIC SQL051104145110503
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETGAINSCHART (OBJ DM_CLASTESTRESULT,
		TARGETVALUE VARCHAR(1024))
	RETURNS TABLE (ROWCOUNT BIGINT, SUMACTUAL REAL, THRESHOLD REAL)
	SPECIFIC SQL051104145134701
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION USERS_GROUPS (UG_TYPE INTEGER,
		UG_NAME VARCHAR(30))
	RETURNS TABLE (NAME VARCHAR(30))
	SPECIFIC USERS_GROUPS
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DIFFERENCE (VARCHAR(4000),
		VARCHAR(4000))
	RETURNS INTEGER
	SPECIFIC DIFFERENCE
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION SNAPSHOT_FCMNODE (INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, CONNECTION_STATUS BIGINT, TOTAL_BUFFERS_SENT BIGINT, TOTAL_BUFFERS_RCVD BIGINT, PARTITION_NUMBER SMALLINT)
	SPECIFIC SNAPSHOT_FCMNODE
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_OPENMODEL(CLASMDL IDMMX.DM_CLASMODEL, MODELALIAS VARCHAR(256)) RETURNS BIGINT LANGUAGE SQL CALLED ON NULL INPUT NOT DETERMINISTIC EXTERNAL ACTION RETURN IDMMX.DM_openModelP(clasMdl, modelAlias, 1);

CREATE PROCEDURE APPLYCLASMODEL (MODELNAME VARCHAR(256),
		TABLENAME VARCHAR(300),
		OUTPUTVIEW VARCHAR(300),
		PREDCLASCOLUMN VARCHAR(128),
		CONFIDENCECOLUMN VARCHAR(128))
	SPECIFIC SQL051104145115234
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE GET_ROUTINE_SAR (OUT SAR BLOB(3145728),
		TYPE CHAR(2),
		NAME VARCHAR(257),
		HIDE_BODY_FLAG INTEGER)
	SPECIFIC GET_SAR4PARM
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION DM_GETCONFMATRIX (OBJ DM_CLASMODEL,
		USETRAIN SMALLINT)
	RETURNS TABLE (ACTUAL VARCHAR(256), PREDICTED VARCHAR(256), COUNT BIGINT, COST DOUBLE)
	SPECIFIC SQL051104145133801
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION SPACE (INTEGER)
	RETURNS VARCHAR(4000)
	SPECIFIC SPACE
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION SNAPSHOT_FCM (INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, BUFF_FREE BIGINT, BUFF_FREE_BOTTOM BIGINT, MA_FREE BIGINT, MA_FREE_BOTTOM BIGINT, CE_FREE BIGINT, CE_FREE_BOTTOM BIGINT, RB_FREE BIGINT, RB_FREE_BOTTOM BIGINT, PARTITION_NUMBER SMALLINT)
	SPECIFIC SNAPSHOT_FCM
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_IMPCLUSFILEE (FILENAME VARCHAR(256),
		ENCODING VARCHAR(20))
	RETURNS DM_CLUSTERINGMODEL
	SPECIFIC SQL051104145111101
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE GETLASTERROR (OUT ERRORMSG VARCHAR(1000),
		OUT ERRORCODE INTEGER,
		OUT SQLSTATE CHAR(5))
	SPECIFIC SQL051104145109788
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE REBIND_ROUTINE_PACKAGE (TYPE CHAR(2),
		NAME VARCHAR(257),
		RESOLVE VARCHAR(12))
	SPECIFIC REBIND_ROUTINE
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION OLEDBINITPROPS (VARCHAR(128))
	RETURNS TABLE (PROPERTY_ID INTEGER, FLAGS INTEGER, TYPE INTEGER, VALUE VARCHAR(128), DESCRIPTION VARCHAR(128))
	SPECIFIC OLEDBINITPROPS
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE OLE
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION TRUNC (BIGINT,
		INTEGER)
	RETURNS BIGINT
	SPECIFIC TRUNC5
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.CLOBTOCLUSTASK (STRING CLOB(512000)) RETURNS IDMMX.DM_CLUSBLDTASK CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_ClusBldTask()..xmldata(string);

CREATE FUNCTION HEALTH_TBS_INFO (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, TABLESPACE_NAME VARCHAR(128), ROLLED_UP_ALERT_STATE BIGINT, ROLLED_UP_ALERT_STATE_DETAIL VARCHAR(20))
	SPECIFIC HEALTH_TBS_INFO
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION MIDNIGHT_SECONDS (TIME)
	RETURNS INTEGER
	SPECIFIC MIDNIGHT_SECONDS1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION SNAPSHOT_TABLE (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, ROWS_WRITTEN BIGINT, ROWS_READ BIGINT, OVERFLOW_ACCESSES BIGINT, TABLE_FILE_ID BIGINT, TABLE_TYPE BIGINT, PAGE_REORGS BIGINT, TABLE_NAME VARCHAR(35), TABLE_SCHEMA VARCHAR(32))
	SPECIFIC SNAPSHOT_TABLE
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION REPLACE (CLOB(1048576),
		CLOB(1048576),
		CLOB(1048576))
	RETURNS CLOB(1048576)
	SPECIFIC REPLACE2C
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.CLOBTOCLASSET (STRING CLOB(307200)) RETURNS IDMMX.DM_CLASSETTINGS CONTAINS SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES IDMMX.DM_ClasSettings()..xmldata(string);

CREATE FUNCTION DM_GETREGTARGET (OBJ DM_REGRESSIONMODEL)
	RETURNS VARCHAR(128)
	SPECIFIC SQL051104145110703
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION SNAPSHOT_SWITCHES (INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, UOW_SW_STATE SMALLINT, UOW_SW_TIME TIMESTAMP, STATEMENT_SW_STATE SMALLINT, STATEMENT_SW_TIME TIMESTAMP, TABLE_SW_STATE SMALLINT, TABLE_SW_TIME TIMESTAMP, BUFFPOOL_SW_STATE SMALLINT, BUFFPOOL_SW_TIME TIMESTAMP, LOCK_SW_STATE SMALLINT, LOCK_SW_TIME TIMESTAMP, SORT_SW_STATE SMALLINT, SORT_SW_TIME TIMESTAMP, PARTITION_NUMBER SMALLINT)
	SPECIFIC SNAPSHOT_SWITCHES
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.LOGDATATOCLOB (A IDMMX.DM_LOGICALDATASPEC) RETURNS CLOB(204800) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE PROCEDURE FINDDEVIATIONS (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		OPTIONSSTRING VARCHAR(32672))
	SPECIFIC SQL051104145142598
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE PROCEDURE PUT_ROUTINE_SAR (SAR BLOB(3145728))
	SPECIFIC PUT_SAR1PARM
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED NOT THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE PROCEDURE SPLITDATA (INPUTTABLE VARCHAR(300),
		TRAINVIEW VARCHAR(300),
		TESTVIEW VARCHAR(300),
		TESTSAMPLESIZE REAL)
	SPECIFIC SQL051104145142709
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_GETCONFMATRIX (OBJ DM_CLASMODEL)
	RETURNS TABLE (ACTUAL VARCHAR(256), PREDICTED VARCHAR(256), COUNT BIGINT, COST DOUBLE)
	SPECIFIC SQL051104145133800
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION TAN (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC TAN
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_TESTREGMODELT (CLASTASK CLOB(512000),
		CALLID CHAR (19) FOR BIT DATA,
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145132701
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION SNAPSHOT_DBM (INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, SORT_HEAP_ALLOCATED BIGINT, POST_THRESHOLD_SORTS BIGINT, PIPED_SORTS_REQUESTED BIGINT, PIPED_SORTS_ACCEPTED BIGINT, REM_CONS_IN BIGINT, REM_CONS_IN_EXEC BIGINT, LOCAL_CONS BIGINT, LOCAL_CONS_IN_EXEC BIGINT, CON_LOCAL_DBASES BIGINT, AGENTS_REGISTERED BIGINT, AGENTS_WAITING_ON_TOKEN BIGINT, DB2_STATUS BIGINT, AGENTS_REGISTERED_TOP BIGINT, AGENTS_WAITING_TOP BIGINT, COMM_PRIVATE_MEM BIGINT, IDLE_AGENTS BIGINT, AGENTS_FROM_POOL BIGINT, AGENTS_CREATED_EMPTY_POOL BIGINT, COORD_AGENTS_TOP BIGINT, MAX_AGENT_OVERFLOWS BIGINT, AGENTS_STOLEN BIGINT, GW_TOTAL_CONS BIGINT, GW_CUR_CONS BIGINT, GW_CONS_WAIT_HOST BIGINT, GW_CONS_WAIT_CLIENT BIGINT, POST_THRESHOLD_HASH_JOINS BIGINT, INACTIVE_GW_AGENTS BIGINT, NUM_GW_CONN_SWITCHES BIGINT, DB2START_TIME TIMESTAMP, LAST_RESET TIMESTAMP)
	SPECIFIC SNAPSHOT_DBM
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE FINDMOSTIMPFIELDSSN (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		TARGETCOLUMN VARCHAR(128),
		SETTINGSNAME VARCHAR(256))
	SPECIFIC SQL051104145142708
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION DM_APPLYCLUSMODEL (CLUSMDL DM_CLUSTERINGMODEL,
		APPLDATA DM_APPLICATIONDATA)
	RETURNS DM_CLUSRESULT
	SPECIFIC SQL051104145115009
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE PREDICTCOLUMN (VIEWNAME VARCHAR(256),
		INPUTTABLE VARCHAR(300),
		TARGETCOLUMN VARCHAR(128),
		OPTIONSSTRING VARCHAR(32672))
	SPECIFIC SQL051104145141686
	MODIFIES SQL DATA
	LANGUAGE JAVA
	FENCED THREADSAFE
	PARAMETER STYLE JAVA
	EXTERNAL;

CREATE FUNCTION MIDNIGHT_SECONDS (VARCHAR(26))
	RETURNS INTEGER
	SPECIFIC MIDNIGHT_SECONDS3
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION REPEAT (VARCHAR(4000),
		INTEGER)
	RETURNS VARCHAR(4000)
	SPECIFIC REPEAT1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.REGSETTOCLOB (A IDMMX.DM_REGSETTINGS) RETURNS CLOB(307200) LANGUAGE SQL NO EXTERNAL ACTION DETERMINISTIC RETURN VALUES (A..xmldata);

CREATE FUNCTION ATAN (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC ATAN
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE PROCEDURE DM_TESTCLASMODELT (CLASTASK CLOB(512000),
		CALLID CHAR (19) FOR BIT DATA,
		TABLENAME VARCHAR(300),
		MODELCOLNAME VARCHAR(128),
		IDCOLNAME VARCHAR(128),
		ID VARCHAR(256))
	SPECIFIC SQL051104145132700
	MODIFIES SQL DATA
	LANGUAGE C
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL
	EXTERNAL;

CREATE FUNCTION SNAPSHOT_DYN_SQL (VARCHAR(255),
		INTEGER)
	RETURNS TABLE (SNAPSHOT_TIMESTAMP TIMESTAMP, ROWS_READ BIGINT, ROWS_WRITTEN BIGINT, NUM_EXECUTIONS BIGINT, NUM_COMPILATIONS BIGINT, PREP_TIME_WORST BIGINT, PREP_TIME_BEST BIGINT, INT_ROWS_DELETED BIGINT, INT_ROWS_INSERTED BIGINT, INT_ROWS_UPDATED BIGINT, STMT_SORTS BIGINT, TOTAL_EXEC_TIME BIGINT, TOTAL_SYS_CPU_TIME BIGINT, TOTAL_USR_CPU_TIME BIGINT, STMT_TEXT CLOB(65536))
	SPECIFIC SNAPSHOT_DYN_SQL
	DETERMINISTIC
	NO SQL
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION IDMMX.DM_OPENMODEL(CLUSMDL IDMMX.DM_CLUSTERINGMODEL, MODELALIAS VARCHAR(256)) RETURNS BIGINT LANGUAGE SQL CALLED ON NULL INPUT NOT DETERMINISTIC EXTERNAL ACTION RETURN IDMMX.DM_openModelP(clusMdl, modelAlias, 1);

CREATE FUNCTION DM_ISVALIDATED (OBJ DM_REGRESSIONMODEL)
	RETURNS SMALLINT
	SPECIFIC SQL051104145110704
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETPREDACCURACY (OBJ DM_CLASMODEL,
		KEYNAME VARCHAR(128))
	RETURNS DOUBLE
	SPECIFIC SQL051104145110001
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION DM_GETCORRELATIONS (OBJ DM_CLUSTERINGMODEL)
	RETURNS TABLE (FIELDNAME1 VARCHAR(128), FIELDNAME2 VARCHAR(128), CORRELATION REAL)
	SPECIFIC SQL051104145109904
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

CREATE FUNCTION CEILING (DOUBLE)
	RETURNS DOUBLE
	SPECIFIC CEILING1
	DETERMINISTIC
	NO SQL
	NO EXTERNAL ACTION
	DISALLOW PARALLEL
	LANGUAGE C
	EXTERNAL
	FENCED THREADSAFE
	PARAMETER STYLE DB2SQL;

--;

